/* NOTE: Do not edit this file, it is generated by a script:
   Export.py --api gl 4.4 --api wgl 4.4 --api glx 4.4 --api cgl 1.4 --api egl 1.0 --outdir .
*/

/*
  Copyright (c) 2011-2013 NVIDIA Corporation
  Copyright (c) 2011-2013 Cass Everitt
  Copyright (c) 2012-2013 Scott Nations
  Copyright (c) 2012 Mathias Schott
  Copyright (c) 2012-2013 Nigel Stewart
  Copyright (c) 2012-2013 Google Inc.
  All rights reserved.

  Redistribution and use in source and binary forms, with or without modification,
  are permitted provided that the following conditions are met:

    Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.

    Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
  IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
  OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
  OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/*
  Intended formatting conventions:
  $ astyle --style=allman --indent=spaces=2 --indent-switches
*/

#include "pch.h" /* For MS precompiled header support */

#include "RegalUtil.h"

#if REGAL_ERROR

REGAL_GLOBAL_BEGIN

#include <string>
using namespace std;

#include "RegalLog.h"
#include "RegalBreak.h"
#include "RegalPush.h"
#include "RegalToken.h"
#include "RegalHelper.h"
#include "RegalPrivate.h"
#include "RegalContext.h"

REGAL_GLOBAL_END

REGAL_NAMESPACE_BEGIN

using namespace ::REGAL_NAMESPACE_INTERNAL::Logging;
using namespace ::REGAL_NAMESPACE_INTERNAL::Token;

// GL_VERSION_1_0

static void REGAL_CALL error_glAccum(GLenum op, GLfloat value)
{
  Internal("error_glAccum","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glAccum)(op, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glAccum : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glAlphaFunc(GLenum func, GLclampf ref)
{
  Internal("error_glAlphaFunc","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glAlphaFunc)(func, ref);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glAlphaFunc : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBegin(GLenum mode)
{
  Internal("error_glBegin","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _context->err.inBeginEnd = true;
_next->call(&_next->glBegin)(mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBegin : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBitmap(GLsizei width, GLsizei height, GLfloat xorig, GLfloat yorig, GLfloat xmove, GLfloat ymove, const GLubyte *bitmap)
{
  Internal("error_glBitmap","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBitmap)(width, height, xorig, yorig, xmove, ymove, bitmap);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBitmap : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBlendFunc(GLenum sfactor, GLenum dfactor)
{
  Internal("error_glBlendFunc","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendFunc)(sfactor, dfactor);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendFunc : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCallList(GLuint list)
{
  Internal("error_glCallList","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCallList)(list);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCallList : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCallLists(GLsizei n, GLenum type, const GLvoid *lists)
{
  Internal("error_glCallLists","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCallLists)(n, type, lists);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCallLists : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glClear(GLbitfield mask)
{
  Internal("error_glClear","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClear)(mask);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClear : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glClearAccum(GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha)
{
  Internal("error_glClearAccum","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClearAccum)(red, green, blue, alpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClearAccum : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glClearColor(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha)
{
  Internal("error_glClearColor","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClearColor)(red, green, blue, alpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClearColor : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glClearDepth(GLclampd depth)
{
  Internal("error_glClearDepth","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClearDepth)(depth);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClearDepth : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glClearIndex(GLfloat c)
{
  Internal("error_glClearIndex","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClearIndex)(c);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClearIndex : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glClearStencil(GLint s)
{
  Internal("error_glClearStencil","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClearStencil)(s);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClearStencil : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glClipPlane(GLenum plane, const GLdouble *equation)
{
  Internal("error_glClipPlane","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClipPlane)(plane, equation);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClipPlane : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor3b(GLbyte red, GLbyte green, GLbyte blue)
{
  Internal("error_glColor3b","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor3b)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor3b : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor3bv(const GLbyte *v)
{
  Internal("error_glColor3bv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor3bv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor3bv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor3d(GLdouble red, GLdouble green, GLdouble blue)
{
  Internal("error_glColor3d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor3d)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor3d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor3dv(const GLdouble *v)
{
  Internal("error_glColor3dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor3dv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor3dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor3f(GLfloat red, GLfloat green, GLfloat blue)
{
  Internal("error_glColor3f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor3f)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor3f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor3fv(const GLfloat *v)
{
  Internal("error_glColor3fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor3fv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor3fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor3i(GLint red, GLint green, GLint blue)
{
  Internal("error_glColor3i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor3i)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor3i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor3iv(const GLint *v)
{
  Internal("error_glColor3iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor3iv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor3iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor3s(GLshort red, GLshort green, GLshort blue)
{
  Internal("error_glColor3s","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor3s)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor3s : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor3sv(const GLshort *v)
{
  Internal("error_glColor3sv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor3sv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor3sv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor3ub(GLubyte red, GLubyte green, GLubyte blue)
{
  Internal("error_glColor3ub","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor3ub)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor3ub : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor3ubv(const GLubyte *v)
{
  Internal("error_glColor3ubv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor3ubv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor3ubv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor3ui(GLuint red, GLuint green, GLuint blue)
{
  Internal("error_glColor3ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor3ui)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor3ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor3uiv(const GLuint *v)
{
  Internal("error_glColor3uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor3uiv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor3uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor3us(GLushort red, GLushort green, GLushort blue)
{
  Internal("error_glColor3us","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor3us)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor3us : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor3usv(const GLushort *v)
{
  Internal("error_glColor3usv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor3usv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor3usv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor4b(GLbyte red, GLbyte green, GLbyte blue, GLbyte alpha)
{
  Internal("error_glColor4b","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor4b)(red, green, blue, alpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor4b : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor4bv(const GLbyte *v)
{
  Internal("error_glColor4bv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor4bv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor4bv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor4d(GLdouble red, GLdouble green, GLdouble blue, GLdouble alpha)
{
  Internal("error_glColor4d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor4d)(red, green, blue, alpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor4d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor4dv(const GLdouble *v)
{
  Internal("error_glColor4dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor4dv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor4dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor4f(GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha)
{
  Internal("error_glColor4f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor4f)(red, green, blue, alpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor4f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor4fv(const GLfloat *v)
{
  Internal("error_glColor4fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor4fv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor4fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor4i(GLint red, GLint green, GLint blue, GLint alpha)
{
  Internal("error_glColor4i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor4i)(red, green, blue, alpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor4i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor4iv(const GLint *v)
{
  Internal("error_glColor4iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor4iv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor4iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor4s(GLshort red, GLshort green, GLshort blue, GLshort alpha)
{
  Internal("error_glColor4s","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor4s)(red, green, blue, alpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor4s : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor4sv(const GLshort *v)
{
  Internal("error_glColor4sv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor4sv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor4sv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor4ub(GLubyte red, GLubyte green, GLubyte blue, GLubyte alpha)
{
  Internal("error_glColor4ub","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor4ub)(red, green, blue, alpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor4ub : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor4ubv(const GLubyte *v)
{
  Internal("error_glColor4ubv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor4ubv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor4ubv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor4ui(GLuint red, GLuint green, GLuint blue, GLuint alpha)
{
  Internal("error_glColor4ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor4ui)(red, green, blue, alpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor4ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor4uiv(const GLuint *v)
{
  Internal("error_glColor4uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor4uiv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor4uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor4us(GLushort red, GLushort green, GLushort blue, GLushort alpha)
{
  Internal("error_glColor4us","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor4us)(red, green, blue, alpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor4us : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor4usv(const GLushort *v)
{
  Internal("error_glColor4usv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor4usv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor4usv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColorMask(GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha)
{
  Internal("error_glColorMask","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColorMask)(red, green, blue, alpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColorMask : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColorMaterial(GLenum face, GLenum mode)
{
  Internal("error_glColorMaterial","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColorMaterial)(face, mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColorMaterial : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyPixels(GLint x, GLint y, GLsizei width, GLsizei height, GLenum type)
{
  Internal("error_glCopyPixels","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyPixels)(x, y, width, height, type);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyPixels : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCullFace(GLenum mode)
{
  Internal("error_glCullFace","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCullFace)(mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCullFace : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteLists(GLuint list, GLsizei range)
{
  Internal("error_glDeleteLists","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteLists)(list, range);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteLists : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDepthFunc(GLenum func)
{
  Internal("error_glDepthFunc","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDepthFunc)(func);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDepthFunc : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDepthMask(GLboolean flag)
{
  Internal("error_glDepthMask","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDepthMask)(flag);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDepthMask : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDepthRange(GLclampd zNear, GLclampd zFar)
{
  Internal("error_glDepthRange","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDepthRange)(zNear, zFar);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDepthRange : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDisable(GLenum cap)
{
  Internal("error_glDisable","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDisable)(cap);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDisable : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDrawBuffer(GLenum mode)
{
  Internal("error_glDrawBuffer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawBuffer)(mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawBuffer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDrawPixels(GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glDrawPixels","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawPixels)(width, height, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawPixels : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEdgeFlag(GLboolean flag)
{
  Internal("error_glEdgeFlag","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEdgeFlag)(flag);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEdgeFlag : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEdgeFlagv(const GLboolean *flag)
{
  Internal("error_glEdgeFlagv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEdgeFlagv)(flag);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEdgeFlagv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEnable(GLenum cap)
{
  Internal("error_glEnable","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEnable)(cap);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEnable : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEnd(void)
{
  Internal("error_glEnd","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEnd)();
_context->err.inBeginEnd = false;
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEnd : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEndList(void)
{
  Internal("error_glEndList","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEndList)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEndList : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEvalCoord1d(GLdouble u)
{
  Internal("error_glEvalCoord1d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEvalCoord1d)(u);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEvalCoord1d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEvalCoord1dv(const GLdouble *u)
{
  Internal("error_glEvalCoord1dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEvalCoord1dv)(u);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEvalCoord1dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEvalCoord1f(GLfloat u)
{
  Internal("error_glEvalCoord1f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEvalCoord1f)(u);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEvalCoord1f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEvalCoord1fv(const GLfloat *u)
{
  Internal("error_glEvalCoord1fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEvalCoord1fv)(u);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEvalCoord1fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEvalCoord2d(GLdouble u, GLdouble v)
{
  Internal("error_glEvalCoord2d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEvalCoord2d)(u, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEvalCoord2d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEvalCoord2dv(const GLdouble *u)
{
  Internal("error_glEvalCoord2dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEvalCoord2dv)(u);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEvalCoord2dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEvalCoord2f(GLfloat u, GLfloat v)
{
  Internal("error_glEvalCoord2f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEvalCoord2f)(u, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEvalCoord2f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEvalCoord2fv(const GLfloat *u)
{
  Internal("error_glEvalCoord2fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEvalCoord2fv)(u);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEvalCoord2fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEvalMesh1(GLenum mode, GLint i1, GLint i2)
{
  Internal("error_glEvalMesh1","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEvalMesh1)(mode, i1, i2);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEvalMesh1 : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEvalMesh2(GLenum mode, GLint i1, GLint i2, GLint j1, GLint j2)
{
  Internal("error_glEvalMesh2","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEvalMesh2)(mode, i1, i2, j1, j2);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEvalMesh2 : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEvalPoint1(GLint i)
{
  Internal("error_glEvalPoint1","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEvalPoint1)(i);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEvalPoint1 : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEvalPoint2(GLint i, GLint j)
{
  Internal("error_glEvalPoint2","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEvalPoint2)(i, j);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEvalPoint2 : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFeedbackBuffer(GLsizei size, GLenum type, GLfloat *buffer)
{
  Internal("error_glFeedbackBuffer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFeedbackBuffer)(size, type, buffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFeedbackBuffer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFinish(void)
{
  Internal("error_glFinish","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFinish)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFinish : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFlush(void)
{
  Internal("error_glFlush","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFlush)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFlush : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFogf(GLenum pname, GLfloat param)
{
  Internal("error_glFogf","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFogf)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFogf : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFogfv(GLenum pname, const GLfloat *params)
{
  Internal("error_glFogfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFogfv)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFogfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFogi(GLenum pname, GLint param)
{
  Internal("error_glFogi","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFogi)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFogi : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFogiv(GLenum pname, const GLint *params)
{
  Internal("error_glFogiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFogiv)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFogiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFrontFace(GLenum mode)
{
  Internal("error_glFrontFace","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFrontFace)(mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFrontFace : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFrustum(GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar)
{
  Internal("error_glFrustum","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFrustum)(left, right, bottom, top, zNear, zFar);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFrustum : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLuint REGAL_CALL error_glGenLists(GLsizei range)
{
  Internal("error_glGenLists","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint  ret = _next->call(&_next->glGenLists)(range);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenLists : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glGetBooleanv(GLenum pname, GLboolean *params)
{
  Internal("error_glGetBooleanv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetBooleanv)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetBooleanv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetClipPlane(GLenum plane, GLdouble *equation)
{
  Internal("error_glGetClipPlane","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetClipPlane)(plane, equation);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetClipPlane : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetDoublev(GLenum pname, GLdouble *params)
{
  Internal("error_glGetDoublev","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetDoublev)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetDoublev : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLenum REGAL_CALL error_glGetError(void)
{
  Internal("error_glGetError","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum error = _next->call(&_next->glGetError)();
  return error;
}

static void REGAL_CALL error_glGetFloatv(GLenum pname, GLfloat *params)
{
  Internal("error_glGetFloatv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetFloatv)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetFloatv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetIntegerv(GLenum pname, GLint *params)
{
  Internal("error_glGetIntegerv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetIntegerv)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetIntegerv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetLightfv(GLenum light, GLenum pname, GLfloat *params)
{
  Internal("error_glGetLightfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetLightfv)(light, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetLightfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetLightiv(GLenum light, GLenum pname, GLint *params)
{
  Internal("error_glGetLightiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetLightiv)(light, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetLightiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMapdv(GLenum target, GLenum query, GLdouble *v)
{
  Internal("error_glGetMapdv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMapdv)(target, query, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMapdv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMapfv(GLenum target, GLenum query, GLfloat *v)
{
  Internal("error_glGetMapfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMapfv)(target, query, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMapfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMapiv(GLenum target, GLenum query, GLint *v)
{
  Internal("error_glGetMapiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMapiv)(target, query, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMapiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMaterialfv(GLenum face, GLenum pname, GLfloat *params)
{
  Internal("error_glGetMaterialfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMaterialfv)(face, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMaterialfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMaterialiv(GLenum face, GLenum pname, GLint *params)
{
  Internal("error_glGetMaterialiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMaterialiv)(face, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMaterialiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPixelMapfv(GLenum map, GLfloat *values)
{
  Internal("error_glGetPixelMapfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPixelMapfv)(map, values);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPixelMapfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPixelMapuiv(GLenum map, GLuint *values)
{
  Internal("error_glGetPixelMapuiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPixelMapuiv)(map, values);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPixelMapuiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPixelMapusv(GLenum map, GLushort *values)
{
  Internal("error_glGetPixelMapusv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPixelMapusv)(map, values);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPixelMapusv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPolygonStipple(GLubyte *mask)
{
  Internal("error_glGetPolygonStipple","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPolygonStipple)(mask);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPolygonStipple : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static const GLubyte *REGAL_CALL error_glGetString(GLenum name)
{
  Internal("error_glGetString","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  const GLubyte * ret = _next->call(&_next->glGetString)(name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetString : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glGetTexEnvfv(GLenum target, GLenum pname, GLfloat *params)
{
  Internal("error_glGetTexEnvfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTexEnvfv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTexEnvfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTexEnviv(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetTexEnviv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTexEnviv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTexEnviv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTexGendv(GLenum coord, GLenum pname, GLdouble *params)
{
  Internal("error_glGetTexGendv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTexGendv)(coord, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTexGendv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTexGenfv(GLenum coord, GLenum pname, GLfloat *params)
{
  Internal("error_glGetTexGenfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTexGenfv)(coord, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTexGenfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTexGeniv(GLenum coord, GLenum pname, GLint *params)
{
  Internal("error_glGetTexGeniv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTexGeniv)(coord, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTexGeniv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTexImage(GLenum target, GLint level, GLenum format, GLenum type, GLvoid *pixels)
{
  Internal("error_glGetTexImage","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTexImage)(target, level, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTexImage : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTexLevelParameterfv(GLenum target, GLint level, GLenum pname, GLfloat *params)
{
  Internal("error_glGetTexLevelParameterfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTexLevelParameterfv)(target, level, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTexLevelParameterfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTexLevelParameteriv(GLenum target, GLint level, GLenum pname, GLint *params)
{
  Internal("error_glGetTexLevelParameteriv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTexLevelParameteriv)(target, level, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTexLevelParameteriv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTexParameterfv(GLenum target, GLenum pname, GLfloat *params)
{
  Internal("error_glGetTexParameterfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTexParameterfv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTexParameterfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTexParameteriv(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetTexParameteriv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTexParameteriv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTexParameteriv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glHint(GLenum target, GLenum mode)
{
  Internal("error_glHint","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glHint)(target, mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glHint : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glIndexMask(GLuint mask)
{
  Internal("error_glIndexMask","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glIndexMask)(mask);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIndexMask : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glIndexd(GLdouble c)
{
  Internal("error_glIndexd","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glIndexd)(c);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIndexd : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glIndexdv(const GLdouble *c)
{
  Internal("error_glIndexdv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glIndexdv)(c);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIndexdv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glIndexf(GLfloat c)
{
  Internal("error_glIndexf","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glIndexf)(c);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIndexf : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glIndexfv(const GLfloat *c)
{
  Internal("error_glIndexfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glIndexfv)(c);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIndexfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glIndexi(GLint c)
{
  Internal("error_glIndexi","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glIndexi)(c);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIndexi : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glIndexiv(const GLint *c)
{
  Internal("error_glIndexiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glIndexiv)(c);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIndexiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glIndexs(GLshort c)
{
  Internal("error_glIndexs","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glIndexs)(c);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIndexs : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glIndexsv(const GLshort *c)
{
  Internal("error_glIndexsv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glIndexsv)(c);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIndexsv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glInitNames(void)
{
  Internal("error_glInitNames","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glInitNames)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glInitNames : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsEnabled(GLenum cap)
{
  Internal("error_glIsEnabled","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsEnabled)(cap);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsEnabled : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLboolean REGAL_CALL error_glIsList(GLuint list)
{
  Internal("error_glIsList","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsList)(list);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsList : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glLightModelf(GLenum pname, GLfloat param)
{
  Internal("error_glLightModelf","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLightModelf)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLightModelf : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLightModelfv(GLenum pname, const GLfloat *params)
{
  Internal("error_glLightModelfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLightModelfv)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLightModelfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLightModeli(GLenum pname, GLint param)
{
  Internal("error_glLightModeli","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLightModeli)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLightModeli : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLightModeliv(GLenum pname, const GLint *params)
{
  Internal("error_glLightModeliv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLightModeliv)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLightModeliv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLightf(GLenum light, GLenum pname, GLfloat param)
{
  Internal("error_glLightf","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLightf)(light, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLightf : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLightfv(GLenum light, GLenum pname, const GLfloat *params)
{
  Internal("error_glLightfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLightfv)(light, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLightfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLighti(GLenum light, GLenum pname, GLint param)
{
  Internal("error_glLighti","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLighti)(light, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLighti : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLightiv(GLenum light, GLenum pname, const GLint *params)
{
  Internal("error_glLightiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLightiv)(light, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLightiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLineStipple(GLint factor, GLushort pattern)
{
  Internal("error_glLineStipple","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLineStipple)(factor, pattern);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLineStipple : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLineWidth(GLfloat width)
{
  Internal("error_glLineWidth","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLineWidth)(width);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLineWidth : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glListBase(GLuint base)
{
  Internal("error_glListBase","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glListBase)(base);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glListBase : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLoadIdentity(void)
{
  Internal("error_glLoadIdentity","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLoadIdentity)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLoadIdentity : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLoadMatrixd(const GLdouble *m)
{
  Internal("error_glLoadMatrixd","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLoadMatrixd)(m);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLoadMatrixd : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLoadMatrixf(const GLfloat *m)
{
  Internal("error_glLoadMatrixf","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLoadMatrixf)(m);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLoadMatrixf : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLoadName(GLuint name)
{
  Internal("error_glLoadName","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLoadName)(name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLoadName : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLogicOp(GLenum opcode)
{
  Internal("error_glLogicOp","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLogicOp)(opcode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLogicOp : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMap1d(GLenum target, GLdouble u1, GLdouble u2, GLint stride, GLint order, const GLdouble *points)
{
  Internal("error_glMap1d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMap1d)(target, u1, u2, stride, order, points);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMap1d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMap1f(GLenum target, GLfloat u1, GLfloat u2, GLint stride, GLint order, const GLfloat *points)
{
  Internal("error_glMap1f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMap1f)(target, u1, u2, stride, order, points);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMap1f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMap2d(GLenum target, GLdouble u1, GLdouble u2, GLint ustride, GLint uorder, GLdouble v1, GLdouble v2, GLint vstride, GLint vorder, const GLdouble *points)
{
  Internal("error_glMap2d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMap2d)(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMap2d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMap2f(GLenum target, GLfloat u1, GLfloat u2, GLint ustride, GLint uorder, GLfloat v1, GLfloat v2, GLint vstride, GLint vorder, const GLfloat *points)
{
  Internal("error_glMap2f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMap2f)(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMap2f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMapGrid1d(GLint un, GLdouble u1, GLdouble u2)
{
  Internal("error_glMapGrid1d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMapGrid1d)(un, u1, u2);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMapGrid1d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMapGrid1f(GLint un, GLfloat u1, GLfloat u2)
{
  Internal("error_glMapGrid1f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMapGrid1f)(un, u1, u2);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMapGrid1f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMapGrid2d(GLint un, GLdouble u1, GLdouble u2, GLint vn, GLdouble v1, GLdouble v2)
{
  Internal("error_glMapGrid2d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMapGrid2d)(un, u1, u2, vn, v1, v2);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMapGrid2d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMapGrid2f(GLint un, GLfloat u1, GLfloat u2, GLint vn, GLfloat v1, GLfloat v2)
{
  Internal("error_glMapGrid2f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMapGrid2f)(un, u1, u2, vn, v1, v2);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMapGrid2f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMaterialf(GLenum face, GLenum pname, GLfloat param)
{
  Internal("error_glMaterialf","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMaterialf)(face, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMaterialf : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMaterialfv(GLenum face, GLenum pname, const GLfloat *params)
{
  Internal("error_glMaterialfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMaterialfv)(face, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMaterialfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMateriali(GLenum face, GLenum pname, GLint param)
{
  Internal("error_glMateriali","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMateriali)(face, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMateriali : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMaterialiv(GLenum face, GLenum pname, const GLint *params)
{
  Internal("error_glMaterialiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMaterialiv)(face, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMaterialiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMatrixMode(GLenum mode)
{
  Internal("error_glMatrixMode","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMatrixMode)(mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMatrixMode : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultMatrixd(const GLdouble *m)
{
  Internal("error_glMultMatrixd","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultMatrixd)(m);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultMatrixd : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultMatrixf(const GLfloat *m)
{
  Internal("error_glMultMatrixf","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultMatrixf)(m);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultMatrixf : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNewList(GLuint list, GLenum mode)
{
  Internal("error_glNewList","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNewList)(list, mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNewList : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormal3b(GLbyte nx, GLbyte ny, GLbyte nz)
{
  Internal("error_glNormal3b","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormal3b)(nx, ny, nz);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormal3b : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormal3bv(const GLbyte *v)
{
  Internal("error_glNormal3bv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormal3bv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormal3bv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormal3d(GLdouble nx, GLdouble ny, GLdouble nz)
{
  Internal("error_glNormal3d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormal3d)(nx, ny, nz);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormal3d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormal3dv(const GLdouble *v)
{
  Internal("error_glNormal3dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormal3dv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormal3dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormal3f(GLfloat nx, GLfloat ny, GLfloat nz)
{
  Internal("error_glNormal3f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormal3f)(nx, ny, nz);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormal3f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormal3fv(const GLfloat *v)
{
  Internal("error_glNormal3fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormal3fv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormal3fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormal3i(GLint nx, GLint ny, GLint nz)
{
  Internal("error_glNormal3i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormal3i)(nx, ny, nz);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormal3i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormal3iv(const GLint *v)
{
  Internal("error_glNormal3iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormal3iv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormal3iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormal3s(GLshort nx, GLshort ny, GLshort nz)
{
  Internal("error_glNormal3s","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormal3s)(nx, ny, nz);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormal3s : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormal3sv(const GLshort *v)
{
  Internal("error_glNormal3sv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormal3sv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormal3sv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glOrtho(GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar)
{
  Internal("error_glOrtho","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glOrtho)(left, right, bottom, top, zNear, zFar);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glOrtho : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPassThrough(GLfloat token)
{
  Internal("error_glPassThrough","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPassThrough)(token);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPassThrough : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPixelMapfv(GLenum map, GLsizei mapsize, const GLfloat *values)
{
  Internal("error_glPixelMapfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPixelMapfv)(map, mapsize, values);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPixelMapfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPixelMapuiv(GLenum map, GLsizei mapsize, const GLuint *values)
{
  Internal("error_glPixelMapuiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPixelMapuiv)(map, mapsize, values);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPixelMapuiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPixelMapusv(GLenum map, GLsizei mapsize, const GLushort *values)
{
  Internal("error_glPixelMapusv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPixelMapusv)(map, mapsize, values);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPixelMapusv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPixelStoref(GLenum pname, GLfloat param)
{
  Internal("error_glPixelStoref","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPixelStoref)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPixelStoref : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPixelStorei(GLenum pname, GLint param)
{
  Internal("error_glPixelStorei","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPixelStorei)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPixelStorei : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPixelTransferf(GLenum pname, GLfloat param)
{
  Internal("error_glPixelTransferf","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPixelTransferf)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPixelTransferf : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPixelTransferi(GLenum pname, GLint param)
{
  Internal("error_glPixelTransferi","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPixelTransferi)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPixelTransferi : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPixelZoom(GLfloat xfactor, GLfloat yfactor)
{
  Internal("error_glPixelZoom","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPixelZoom)(xfactor, yfactor);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPixelZoom : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPointSize(GLfloat size)
{
  Internal("error_glPointSize","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPointSize)(size);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPointSize : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPolygonMode(GLenum face, GLenum mode)
{
  Internal("error_glPolygonMode","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPolygonMode)(face, mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPolygonMode : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPolygonStipple(const GLubyte *mask)
{
  Internal("error_glPolygonStipple","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPolygonStipple)(mask);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPolygonStipple : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPopAttrib(void)
{
  Internal("error_glPopAttrib","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPopAttrib)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPopAttrib : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPopMatrix(void)
{
  Internal("error_glPopMatrix","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPopMatrix)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPopMatrix : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPopName(void)
{
  Internal("error_glPopName","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPopName)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPopName : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPushAttrib(GLbitfield mask)
{
  Internal("error_glPushAttrib","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPushAttrib)(mask);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPushAttrib : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPushMatrix(void)
{
  Internal("error_glPushMatrix","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPushMatrix)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPushMatrix : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPushName(GLuint name)
{
  Internal("error_glPushName","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPushName)(name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPushName : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRasterPos2d(GLdouble x, GLdouble y)
{
  Internal("error_glRasterPos2d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRasterPos2d)(x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRasterPos2d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRasterPos2dv(const GLdouble *v)
{
  Internal("error_glRasterPos2dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRasterPos2dv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRasterPos2dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRasterPos2f(GLfloat x, GLfloat y)
{
  Internal("error_glRasterPos2f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRasterPos2f)(x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRasterPos2f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRasterPos2fv(const GLfloat *v)
{
  Internal("error_glRasterPos2fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRasterPos2fv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRasterPos2fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRasterPos2i(GLint x, GLint y)
{
  Internal("error_glRasterPos2i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRasterPos2i)(x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRasterPos2i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRasterPos2iv(const GLint *v)
{
  Internal("error_glRasterPos2iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRasterPos2iv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRasterPos2iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRasterPos2s(GLshort x, GLshort y)
{
  Internal("error_glRasterPos2s","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRasterPos2s)(x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRasterPos2s : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRasterPos2sv(const GLshort *v)
{
  Internal("error_glRasterPos2sv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRasterPos2sv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRasterPos2sv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRasterPos3d(GLdouble x, GLdouble y, GLdouble z)
{
  Internal("error_glRasterPos3d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRasterPos3d)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRasterPos3d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRasterPos3dv(const GLdouble *v)
{
  Internal("error_glRasterPos3dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRasterPos3dv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRasterPos3dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRasterPos3f(GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glRasterPos3f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRasterPos3f)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRasterPos3f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRasterPos3fv(const GLfloat *v)
{
  Internal("error_glRasterPos3fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRasterPos3fv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRasterPos3fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRasterPos3i(GLint x, GLint y, GLint z)
{
  Internal("error_glRasterPos3i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRasterPos3i)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRasterPos3i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRasterPos3iv(const GLint *v)
{
  Internal("error_glRasterPos3iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRasterPos3iv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRasterPos3iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRasterPos3s(GLshort x, GLshort y, GLshort z)
{
  Internal("error_glRasterPos3s","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRasterPos3s)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRasterPos3s : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRasterPos3sv(const GLshort *v)
{
  Internal("error_glRasterPos3sv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRasterPos3sv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRasterPos3sv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRasterPos4d(GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
  Internal("error_glRasterPos4d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRasterPos4d)(x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRasterPos4d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRasterPos4dv(const GLdouble *v)
{
  Internal("error_glRasterPos4dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRasterPos4dv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRasterPos4dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRasterPos4f(GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
  Internal("error_glRasterPos4f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRasterPos4f)(x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRasterPos4f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRasterPos4fv(const GLfloat *v)
{
  Internal("error_glRasterPos4fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRasterPos4fv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRasterPos4fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRasterPos4i(GLint x, GLint y, GLint z, GLint w)
{
  Internal("error_glRasterPos4i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRasterPos4i)(x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRasterPos4i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRasterPos4iv(const GLint *v)
{
  Internal("error_glRasterPos4iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRasterPos4iv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRasterPos4iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRasterPos4s(GLshort x, GLshort y, GLshort z, GLshort w)
{
  Internal("error_glRasterPos4s","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRasterPos4s)(x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRasterPos4s : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRasterPos4sv(const GLshort *v)
{
  Internal("error_glRasterPos4sv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRasterPos4sv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRasterPos4sv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReadBuffer(GLenum mode)
{
  Internal("error_glReadBuffer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReadBuffer)(mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReadBuffer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReadPixels(GLint x, GLint y, GLsizei width, GLsizei height, GLenum format, GLenum type, GLvoid *pixels)
{
  Internal("error_glReadPixels","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReadPixels)(x, y, width, height, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReadPixels : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRectd(GLdouble x1, GLdouble y1, GLdouble x2, GLdouble y2)
{
  Internal("error_glRectd","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRectd)(x1, y1, x2, y2);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRectd : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRectdv(const GLdouble *v1, const GLdouble *v2)
{
  Internal("error_glRectdv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRectdv)(v1, v2);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRectdv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRectf(GLfloat x1, GLfloat y1, GLfloat x2, GLfloat y2)
{
  Internal("error_glRectf","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRectf)(x1, y1, x2, y2);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRectf : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRectfv(const GLfloat *v1, const GLfloat *v2)
{
  Internal("error_glRectfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRectfv)(v1, v2);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRectfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRecti(GLint x1, GLint y1, GLint x2, GLint y2)
{
  Internal("error_glRecti","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRecti)(x1, y1, x2, y2);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRecti : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRectiv(const GLint *v1, const GLint *v2)
{
  Internal("error_glRectiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRectiv)(v1, v2);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRectiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRects(GLshort x1, GLshort y1, GLshort x2, GLshort y2)
{
  Internal("error_glRects","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRects)(x1, y1, x2, y2);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRects : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRectsv(const GLshort *v1, const GLshort *v2)
{
  Internal("error_glRectsv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRectsv)(v1, v2);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRectsv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLint REGAL_CALL error_glRenderMode(GLenum mode)
{
  Internal("error_glRenderMode","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLint  ret = _next->call(&_next->glRenderMode)(mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRenderMode : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glRotated(GLdouble angle, GLdouble x, GLdouble y, GLdouble z)
{
  Internal("error_glRotated","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRotated)(angle, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRotated : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRotatef(GLfloat angle, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glRotatef","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRotatef)(angle, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRotatef : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glScaled(GLdouble x, GLdouble y, GLdouble z)
{
  Internal("error_glScaled","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glScaled)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glScaled : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glScalef(GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glScalef","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glScalef)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glScalef : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glScissor(GLint x, GLint y, GLsizei width, GLsizei height)
{
  Internal("error_glScissor","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glScissor)(x, y, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glScissor : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSelectBuffer(GLsizei size, GLuint *buffer)
{
  Internal("error_glSelectBuffer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSelectBuffer)(size, buffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSelectBuffer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glShadeModel(GLenum mode)
{
  Internal("error_glShadeModel","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glShadeModel)(mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glShadeModel : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glStencilFunc(GLenum func, GLint ref, GLuint mask)
{
  Internal("error_glStencilFunc","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glStencilFunc)(func, ref, mask);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glStencilFunc : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glStencilMask(GLuint mask)
{
  Internal("error_glStencilMask","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glStencilMask)(mask);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glStencilMask : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glStencilOp(GLenum fail, GLenum zfail, GLenum zpass)
{
  Internal("error_glStencilOp","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glStencilOp)(fail, zfail, zpass);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glStencilOp : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord1d(GLdouble s)
{
  Internal("error_glTexCoord1d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord1d)(s);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord1d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord1dv(const GLdouble *v)
{
  Internal("error_glTexCoord1dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord1dv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord1dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord1f(GLfloat s)
{
  Internal("error_glTexCoord1f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord1f)(s);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord1f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord1fv(const GLfloat *v)
{
  Internal("error_glTexCoord1fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord1fv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord1fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord1i(GLint s)
{
  Internal("error_glTexCoord1i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord1i)(s);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord1i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord1iv(const GLint *v)
{
  Internal("error_glTexCoord1iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord1iv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord1iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord1s(GLshort s)
{
  Internal("error_glTexCoord1s","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord1s)(s);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord1s : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord1sv(const GLshort *v)
{
  Internal("error_glTexCoord1sv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord1sv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord1sv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord2d(GLdouble s, GLdouble t)
{
  Internal("error_glTexCoord2d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord2d)(s, t);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord2d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord2dv(const GLdouble *v)
{
  Internal("error_glTexCoord2dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord2dv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord2dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord2f(GLfloat s, GLfloat t)
{
  Internal("error_glTexCoord2f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord2f)(s, t);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord2f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord2fv(const GLfloat *v)
{
  Internal("error_glTexCoord2fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord2fv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord2fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord2i(GLint s, GLint t)
{
  Internal("error_glTexCoord2i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord2i)(s, t);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord2i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord2iv(const GLint *v)
{
  Internal("error_glTexCoord2iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord2iv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord2iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord2s(GLshort s, GLshort t)
{
  Internal("error_glTexCoord2s","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord2s)(s, t);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord2s : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord2sv(const GLshort *v)
{
  Internal("error_glTexCoord2sv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord2sv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord2sv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord3d(GLdouble s, GLdouble t, GLdouble r)
{
  Internal("error_glTexCoord3d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord3d)(s, t, r);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord3d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord3dv(const GLdouble *v)
{
  Internal("error_glTexCoord3dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord3dv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord3dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord3f(GLfloat s, GLfloat t, GLfloat r)
{
  Internal("error_glTexCoord3f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord3f)(s, t, r);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord3f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord3fv(const GLfloat *v)
{
  Internal("error_glTexCoord3fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord3fv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord3fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord3i(GLint s, GLint t, GLint r)
{
  Internal("error_glTexCoord3i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord3i)(s, t, r);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord3i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord3iv(const GLint *v)
{
  Internal("error_glTexCoord3iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord3iv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord3iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord3s(GLshort s, GLshort t, GLshort r)
{
  Internal("error_glTexCoord3s","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord3s)(s, t, r);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord3s : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord3sv(const GLshort *v)
{
  Internal("error_glTexCoord3sv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord3sv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord3sv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord4d(GLdouble s, GLdouble t, GLdouble r, GLdouble q)
{
  Internal("error_glTexCoord4d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord4d)(s, t, r, q);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord4d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord4dv(const GLdouble *v)
{
  Internal("error_glTexCoord4dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord4dv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord4dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord4f(GLfloat s, GLfloat t, GLfloat r, GLfloat q)
{
  Internal("error_glTexCoord4f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord4f)(s, t, r, q);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord4f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord4fv(const GLfloat *v)
{
  Internal("error_glTexCoord4fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord4fv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord4fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord4i(GLint s, GLint t, GLint r, GLint q)
{
  Internal("error_glTexCoord4i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord4i)(s, t, r, q);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord4i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord4iv(const GLint *v)
{
  Internal("error_glTexCoord4iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord4iv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord4iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord4s(GLshort s, GLshort t, GLshort r, GLshort q)
{
  Internal("error_glTexCoord4s","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord4s)(s, t, r, q);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord4s : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord4sv(const GLshort *v)
{
  Internal("error_glTexCoord4sv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord4sv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord4sv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexEnvf(GLenum target, GLenum pname, GLfloat param)
{
  Internal("error_glTexEnvf","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexEnvf)(target, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexEnvf : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexEnvfv(GLenum target, GLenum pname, const GLfloat *params)
{
  Internal("error_glTexEnvfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexEnvfv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexEnvfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexEnvi(GLenum target, GLenum pname, GLint param)
{
  Internal("error_glTexEnvi","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexEnvi)(target, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexEnvi : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexEnviv(GLenum target, GLenum pname, const GLint *params)
{
  Internal("error_glTexEnviv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexEnviv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexEnviv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexGend(GLenum coord, GLenum pname, GLdouble param)
{
  Internal("error_glTexGend","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexGend)(coord, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexGend : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexGendv(GLenum coord, GLenum pname, const GLdouble *params)
{
  Internal("error_glTexGendv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexGendv)(coord, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexGendv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexGenf(GLenum coord, GLenum pname, GLfloat param)
{
  Internal("error_glTexGenf","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexGenf)(coord, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexGenf : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexGenfv(GLenum coord, GLenum pname, const GLfloat *params)
{
  Internal("error_glTexGenfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexGenfv)(coord, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexGenfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexGeni(GLenum coord, GLenum pname, GLint param)
{
  Internal("error_glTexGeni","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexGeni)(coord, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexGeni : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexGeniv(GLenum coord, GLenum pname, const GLint *params)
{
  Internal("error_glTexGeniv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexGeniv)(coord, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexGeniv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexImage1D(GLenum target, GLint level, GLint internalformat, GLsizei width, GLint border, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glTexImage1D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexImage1D)(target, level, internalformat, width, border, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexImage1D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexImage2D(GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glTexImage2D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexImage2D)(target, level, internalformat, width, height, border, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexImage2D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexParameterf(GLenum target, GLenum pname, GLfloat param)
{
  Internal("error_glTexParameterf","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexParameterf)(target, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexParameterf : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexParameterfv(GLenum target, GLenum pname, const GLfloat *params)
{
  Internal("error_glTexParameterfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexParameterfv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexParameterfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexParameteri(GLenum target, GLenum pname, GLint param)
{
  Internal("error_glTexParameteri","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexParameteri)(target, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexParameteri : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexParameteriv(GLenum target, GLenum pname, const GLint *params)
{
  Internal("error_glTexParameteriv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexParameteriv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexParameteriv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTranslated(GLdouble x, GLdouble y, GLdouble z)
{
  Internal("error_glTranslated","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTranslated)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTranslated : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTranslatef(GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glTranslatef","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTranslatef)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTranslatef : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex2d(GLdouble x, GLdouble y)
{
  Internal("error_glVertex2d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex2d)(x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex2d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex2dv(const GLdouble *v)
{
  Internal("error_glVertex2dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex2dv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex2dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex2f(GLfloat x, GLfloat y)
{
  Internal("error_glVertex2f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex2f)(x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex2f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex2fv(const GLfloat *v)
{
  Internal("error_glVertex2fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex2fv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex2fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex2i(GLint x, GLint y)
{
  Internal("error_glVertex2i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex2i)(x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex2i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex2iv(const GLint *v)
{
  Internal("error_glVertex2iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex2iv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex2iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex2s(GLshort x, GLshort y)
{
  Internal("error_glVertex2s","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex2s)(x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex2s : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex2sv(const GLshort *v)
{
  Internal("error_glVertex2sv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex2sv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex2sv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex3d(GLdouble x, GLdouble y, GLdouble z)
{
  Internal("error_glVertex3d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex3d)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex3d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex3dv(const GLdouble *v)
{
  Internal("error_glVertex3dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex3dv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex3dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex3f(GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glVertex3f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex3f)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex3f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex3fv(const GLfloat *v)
{
  Internal("error_glVertex3fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex3fv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex3fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex3i(GLint x, GLint y, GLint z)
{
  Internal("error_glVertex3i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex3i)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex3i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex3iv(const GLint *v)
{
  Internal("error_glVertex3iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex3iv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex3iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex3s(GLshort x, GLshort y, GLshort z)
{
  Internal("error_glVertex3s","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex3s)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex3s : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex3sv(const GLshort *v)
{
  Internal("error_glVertex3sv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex3sv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex3sv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex4d(GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
  Internal("error_glVertex4d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex4d)(x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex4d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex4dv(const GLdouble *v)
{
  Internal("error_glVertex4dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex4dv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex4dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex4f(GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
  Internal("error_glVertex4f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex4f)(x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex4f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex4fv(const GLfloat *v)
{
  Internal("error_glVertex4fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex4fv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex4fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex4i(GLint x, GLint y, GLint z, GLint w)
{
  Internal("error_glVertex4i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex4i)(x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex4i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex4iv(const GLint *v)
{
  Internal("error_glVertex4iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex4iv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex4iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex4s(GLshort x, GLshort y, GLshort z, GLshort w)
{
  Internal("error_glVertex4s","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex4s)(x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex4s : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex4sv(const GLshort *v)
{
  Internal("error_glVertex4sv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex4sv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex4sv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glViewport(GLint x, GLint y, GLsizei width, GLsizei height)
{
  Internal("error_glViewport","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glViewport)(x, y, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glViewport : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_VERSION_1_1

static GLboolean REGAL_CALL error_glAreTexturesResident(GLsizei n, const GLuint *textures, GLboolean *residences)
{
  Internal("error_glAreTexturesResident","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glAreTexturesResident)(n, textures, residences);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glAreTexturesResident : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glArrayElement(GLint index)
{
  Internal("error_glArrayElement","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glArrayElement)(index);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glArrayElement : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBindTexture(GLenum target, GLuint texture)
{
  Internal("error_glBindTexture","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindTexture)(target, texture);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindTexture : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColorPointer(GLint size, GLenum type, GLsizei stride, const GLvoid *pointer)
{
  Internal("error_glColorPointer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColorPointer)(size, type, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColorPointer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyTexImage1D(GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLint border)
{
  Internal("error_glCopyTexImage1D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyTexImage1D)(target, level, internalformat, x, y, width, border);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyTexImage1D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyTexImage2D(GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border)
{
  Internal("error_glCopyTexImage2D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyTexImage2D)(target, level, internalformat, x, y, width, height, border);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyTexImage2D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyTexSubImage1D(GLenum target, GLint level, GLint xoffset, GLint x, GLint y, GLsizei width)
{
  Internal("error_glCopyTexSubImage1D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyTexSubImage1D)(target, level, xoffset, x, y, width);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyTexSubImage1D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyTexSubImage2D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height)
{
  Internal("error_glCopyTexSubImage2D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyTexSubImage2D)(target, level, xoffset, yoffset, x, y, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyTexSubImage2D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteTextures(GLsizei n, const GLuint *textures)
{
  Internal("error_glDeleteTextures","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteTextures)(n, textures);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteTextures : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDisableClientState(GLenum cap)
{
  Internal("error_glDisableClientState","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDisableClientState)(cap);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDisableClientState : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDrawArrays(GLenum mode, GLint first, GLsizei count)
{
  Internal("error_glDrawArrays","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawArrays)(mode, first, count);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawArrays : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDrawElements(GLenum mode, GLsizei count, GLenum type, const GLvoid *indices)
{
  Internal("error_glDrawElements","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawElements)(mode, count, type, indices);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawElements : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEdgeFlagPointer(GLsizei stride, const GLvoid *pointer)
{
  Internal("error_glEdgeFlagPointer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEdgeFlagPointer)(stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEdgeFlagPointer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEnableClientState(GLenum cap)
{
  Internal("error_glEnableClientState","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEnableClientState)(cap);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEnableClientState : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenTextures(GLsizei n, GLuint *textures)
{
  Internal("error_glGenTextures","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenTextures)(n, textures);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenTextures : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPointerv(GLenum pname, GLvoid **params)
{
  Internal("error_glGetPointerv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPointerv)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPointerv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glIndexPointer(GLenum type, GLsizei stride, const GLvoid *pointer)
{
  Internal("error_glIndexPointer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glIndexPointer)(type, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIndexPointer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glIndexub(GLubyte c)
{
  Internal("error_glIndexub","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glIndexub)(c);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIndexub : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glIndexubv(const GLubyte *c)
{
  Internal("error_glIndexubv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glIndexubv)(c);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIndexubv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glInterleavedArrays(GLenum format, GLsizei stride, const GLvoid *pointer)
{
  Internal("error_glInterleavedArrays","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glInterleavedArrays)(format, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glInterleavedArrays : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsTexture(GLuint texture)
{
  Internal("error_glIsTexture","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsTexture)(texture);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsTexture : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glNormalPointer(GLenum type, GLsizei stride, const GLvoid *pointer)
{
  Internal("error_glNormalPointer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormalPointer)(type, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormalPointer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPolygonOffset(GLfloat factor, GLfloat units)
{
  Internal("error_glPolygonOffset","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPolygonOffset)(factor, units);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPolygonOffset : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPopClientAttrib(void)
{
  Internal("error_glPopClientAttrib","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPopClientAttrib)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPopClientAttrib : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPrioritizeTextures(GLsizei n, const GLuint *textures, const GLclampf *priorities)
{
  Internal("error_glPrioritizeTextures","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPrioritizeTextures)(n, textures, priorities);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPrioritizeTextures : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPushClientAttrib(GLbitfield mask)
{
  Internal("error_glPushClientAttrib","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPushClientAttrib)(mask);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPushClientAttrib : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoordPointer(GLint size, GLenum type, GLsizei stride, const GLvoid *pointer)
{
  Internal("error_glTexCoordPointer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoordPointer)(size, type, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoordPointer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexSubImage1D(GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glTexSubImage1D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexSubImage1D)(target, level, xoffset, width, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexSubImage1D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexSubImage2D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glTexSubImage2D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexSubImage2D)(target, level, xoffset, yoffset, width, height, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexSubImage2D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexPointer(GLint size, GLenum type, GLsizei stride, const GLvoid *pointer)
{
  Internal("error_glVertexPointer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexPointer)(size, type, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexPointer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_VERSION_1_2

static void REGAL_CALL error_glBlendColor(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha)
{
  Internal("error_glBlendColor","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendColor)(red, green, blue, alpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendColor : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBlendEquation(GLenum mode)
{
  Internal("error_glBlendEquation","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendEquation)(mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendEquation : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyTexSubImage3D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height)
{
  Internal("error_glCopyTexSubImage3D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyTexSubImage3D)(target, level, xoffset, yoffset, zoffset, x, y, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyTexSubImage3D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDrawRangeElements(GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const GLvoid *indices)
{
  Internal("error_glDrawRangeElements","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawRangeElements)(mode, start, end, count, type, indices);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawRangeElements : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexImage3D(GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glTexImage3D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexImage3D)(target, level, internalformat, width, height, depth, border, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexImage3D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexSubImage3D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glTexSubImage3D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexSubImage3D)(target, level, xoffset, yoffset, zoffset, width, height, depth, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexSubImage3D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_VERSION_1_3

static void REGAL_CALL error_glActiveTexture(GLenum texture)
{
  Internal("error_glActiveTexture","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glActiveTexture)(texture);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glActiveTexture : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glClientActiveTexture(GLenum texture)
{
  Internal("error_glClientActiveTexture","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClientActiveTexture)(texture);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClientActiveTexture : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompressedTexImage1D(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLint border, GLsizei imageSize, const GLvoid *data)
{
  Internal("error_glCompressedTexImage1D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedTexImage1D)(target, level, internalformat, width, border, imageSize, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedTexImage1D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompressedTexImage2D(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const GLvoid *data)
{
  Internal("error_glCompressedTexImage2D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedTexImage2D)(target, level, internalformat, width, height, border, imageSize, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedTexImage2D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompressedTexImage3D(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const GLvoid *data)
{
  Internal("error_glCompressedTexImage3D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedTexImage3D)(target, level, internalformat, width, height, depth, border, imageSize, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedTexImage3D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompressedTexSubImage1D(GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLsizei imageSize, const GLvoid *data)
{
  Internal("error_glCompressedTexSubImage1D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedTexSubImage1D)(target, level, xoffset, width, format, imageSize, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedTexSubImage1D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompressedTexSubImage2D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const GLvoid *data)
{
  Internal("error_glCompressedTexSubImage2D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedTexSubImage2D)(target, level, xoffset, yoffset, width, height, format, imageSize, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedTexSubImage2D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompressedTexSubImage3D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const GLvoid *data)
{
  Internal("error_glCompressedTexSubImage3D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedTexSubImage3D)(target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedTexSubImage3D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetCompressedTexImage(GLenum target, GLint lod, GLvoid *img)
{
  Internal("error_glGetCompressedTexImage","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetCompressedTexImage)(target, lod, img);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetCompressedTexImage : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLoadTransposeMatrixd(const GLdouble *m)
{
  Internal("error_glLoadTransposeMatrixd","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLoadTransposeMatrixd)(m);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLoadTransposeMatrixd : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLoadTransposeMatrixf(const GLfloat *m)
{
  Internal("error_glLoadTransposeMatrixf","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLoadTransposeMatrixf)(m);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLoadTransposeMatrixf : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultTransposeMatrixd(const GLdouble *m)
{
  Internal("error_glMultTransposeMatrixd","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultTransposeMatrixd)(m);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultTransposeMatrixd : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultTransposeMatrixf(const GLfloat *m)
{
  Internal("error_glMultTransposeMatrixf","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultTransposeMatrixf)(m);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultTransposeMatrixf : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord1d(GLenum target, GLdouble s)
{
  Internal("error_glMultiTexCoord1d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord1d)(target, s);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord1d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord1dv(GLenum target, const GLdouble *v)
{
  Internal("error_glMultiTexCoord1dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord1dv)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord1dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord1f(GLenum target, GLfloat s)
{
  Internal("error_glMultiTexCoord1f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord1f)(target, s);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord1f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord1fv(GLenum target, const GLfloat *v)
{
  Internal("error_glMultiTexCoord1fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord1fv)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord1fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord1i(GLenum target, GLint s)
{
  Internal("error_glMultiTexCoord1i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord1i)(target, s);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord1i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord1iv(GLenum target, const GLint *v)
{
  Internal("error_glMultiTexCoord1iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord1iv)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord1iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord1s(GLenum target, GLshort s)
{
  Internal("error_glMultiTexCoord1s","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord1s)(target, s);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord1s : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord1sv(GLenum target, const GLshort *v)
{
  Internal("error_glMultiTexCoord1sv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord1sv)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord1sv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord2d(GLenum target, GLdouble s, GLdouble t)
{
  Internal("error_glMultiTexCoord2d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord2d)(target, s, t);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord2d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord2dv(GLenum target, const GLdouble *v)
{
  Internal("error_glMultiTexCoord2dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord2dv)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord2dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord2f(GLenum target, GLfloat s, GLfloat t)
{
  Internal("error_glMultiTexCoord2f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord2f)(target, s, t);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord2f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord2fv(GLenum target, const GLfloat *v)
{
  Internal("error_glMultiTexCoord2fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord2fv)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord2fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord2i(GLenum target, GLint s, GLint t)
{
  Internal("error_glMultiTexCoord2i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord2i)(target, s, t);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord2i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord2iv(GLenum target, const GLint *v)
{
  Internal("error_glMultiTexCoord2iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord2iv)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord2iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord2s(GLenum target, GLshort s, GLshort t)
{
  Internal("error_glMultiTexCoord2s","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord2s)(target, s, t);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord2s : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord2sv(GLenum target, const GLshort *v)
{
  Internal("error_glMultiTexCoord2sv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord2sv)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord2sv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord3d(GLenum target, GLdouble s, GLdouble t, GLdouble r)
{
  Internal("error_glMultiTexCoord3d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord3d)(target, s, t, r);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord3d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord3dv(GLenum target, const GLdouble *v)
{
  Internal("error_glMultiTexCoord3dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord3dv)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord3dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord3f(GLenum target, GLfloat s, GLfloat t, GLfloat r)
{
  Internal("error_glMultiTexCoord3f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord3f)(target, s, t, r);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord3f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord3fv(GLenum target, const GLfloat *v)
{
  Internal("error_glMultiTexCoord3fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord3fv)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord3fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord3i(GLenum target, GLint s, GLint t, GLint r)
{
  Internal("error_glMultiTexCoord3i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord3i)(target, s, t, r);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord3i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord3iv(GLenum target, const GLint *v)
{
  Internal("error_glMultiTexCoord3iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord3iv)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord3iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord3s(GLenum target, GLshort s, GLshort t, GLshort r)
{
  Internal("error_glMultiTexCoord3s","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord3s)(target, s, t, r);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord3s : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord3sv(GLenum target, const GLshort *v)
{
  Internal("error_glMultiTexCoord3sv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord3sv)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord3sv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord4d(GLenum target, GLdouble s, GLdouble t, GLdouble r, GLdouble q)
{
  Internal("error_glMultiTexCoord4d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord4d)(target, s, t, r, q);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord4d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord4dv(GLenum target, const GLdouble *v)
{
  Internal("error_glMultiTexCoord4dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord4dv)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord4dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord4f(GLenum target, GLfloat s, GLfloat t, GLfloat r, GLfloat q)
{
  Internal("error_glMultiTexCoord4f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord4f)(target, s, t, r, q);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord4f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord4fv(GLenum target, const GLfloat *v)
{
  Internal("error_glMultiTexCoord4fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord4fv)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord4fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord4i(GLenum target, GLint s, GLint t, GLint r, GLint q)
{
  Internal("error_glMultiTexCoord4i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord4i)(target, s, t, r, q);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord4i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord4iv(GLenum target, const GLint *v)
{
  Internal("error_glMultiTexCoord4iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord4iv)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord4iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord4s(GLenum target, GLshort s, GLshort t, GLshort r, GLshort q)
{
  Internal("error_glMultiTexCoord4s","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord4s)(target, s, t, r, q);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord4s : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord4sv(GLenum target, const GLshort *v)
{
  Internal("error_glMultiTexCoord4sv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord4sv)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord4sv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSampleCoverage(GLclampf value, GLboolean invert)
{
  Internal("error_glSampleCoverage","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSampleCoverage)(value, invert);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSampleCoverage : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_VERSION_1_4

static void REGAL_CALL error_glBlendFuncSeparate(GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha)
{
  Internal("error_glBlendFuncSeparate","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendFuncSeparate)(sfactorRGB, dfactorRGB, sfactorAlpha, dfactorAlpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendFuncSeparate : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFogCoordPointer(GLenum type, GLsizei stride, const GLvoid *pointer)
{
  Internal("error_glFogCoordPointer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFogCoordPointer)(type, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFogCoordPointer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFogCoordd(GLdouble coord)
{
  Internal("error_glFogCoordd","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFogCoordd)(coord);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFogCoordd : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFogCoorddv(const GLdouble *coord)
{
  Internal("error_glFogCoorddv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFogCoorddv)(coord);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFogCoorddv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFogCoordf(GLfloat coord)
{
  Internal("error_glFogCoordf","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFogCoordf)(coord);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFogCoordf : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFogCoordfv(const GLfloat *coord)
{
  Internal("error_glFogCoordfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFogCoordfv)(coord);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFogCoordfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiDrawArrays(GLenum mode, const GLint *first, const GLsizei *count, GLsizei primcount)
{
  Internal("error_glMultiDrawArrays","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiDrawArrays)(mode, first, count, primcount);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiDrawArrays : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiDrawElements(GLenum mode, const GLsizei *count, GLenum type, const GLvoid * const *indices, GLsizei primcount)
{
  Internal("error_glMultiDrawElements","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiDrawElements)(mode, count, type, indices, primcount);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiDrawElements : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPointParameterf(GLenum pname, GLfloat param)
{
  Internal("error_glPointParameterf","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPointParameterf)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPointParameterf : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPointParameterfv(GLenum pname, const GLfloat *params)
{
  Internal("error_glPointParameterfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPointParameterfv)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPointParameterfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPointParameteri(GLenum pname, GLint param)
{
  Internal("error_glPointParameteri","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPointParameteri)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPointParameteri : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPointParameteriv(GLenum pname, const GLint *params)
{
  Internal("error_glPointParameteriv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPointParameteriv)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPointParameteriv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3b(GLbyte red, GLbyte green, GLbyte blue)
{
  Internal("error_glSecondaryColor3b","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3b)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3b : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3bv(const GLbyte *v)
{
  Internal("error_glSecondaryColor3bv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3bv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3bv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3d(GLdouble red, GLdouble green, GLdouble blue)
{
  Internal("error_glSecondaryColor3d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3d)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3dv(const GLdouble *v)
{
  Internal("error_glSecondaryColor3dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3dv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3f(GLfloat red, GLfloat green, GLfloat blue)
{
  Internal("error_glSecondaryColor3f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3f)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3fv(const GLfloat *v)
{
  Internal("error_glSecondaryColor3fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3fv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3i(GLint red, GLint green, GLint blue)
{
  Internal("error_glSecondaryColor3i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3i)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3iv(const GLint *v)
{
  Internal("error_glSecondaryColor3iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3iv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3s(GLshort red, GLshort green, GLshort blue)
{
  Internal("error_glSecondaryColor3s","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3s)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3s : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3sv(const GLshort *v)
{
  Internal("error_glSecondaryColor3sv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3sv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3sv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3ub(GLubyte red, GLubyte green, GLubyte blue)
{
  Internal("error_glSecondaryColor3ub","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3ub)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3ub : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3ubv(const GLubyte *v)
{
  Internal("error_glSecondaryColor3ubv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3ubv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3ubv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3ui(GLuint red, GLuint green, GLuint blue)
{
  Internal("error_glSecondaryColor3ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3ui)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3uiv(const GLuint *v)
{
  Internal("error_glSecondaryColor3uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3uiv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3us(GLushort red, GLushort green, GLushort blue)
{
  Internal("error_glSecondaryColor3us","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3us)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3us : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3usv(const GLushort *v)
{
  Internal("error_glSecondaryColor3usv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3usv)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3usv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColorPointer(GLint size, GLenum type, GLsizei stride, const GLvoid *pointer)
{
  Internal("error_glSecondaryColorPointer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColorPointer)(size, type, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColorPointer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos2d(GLdouble x, GLdouble y)
{
  Internal("error_glWindowPos2d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos2d)(x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos2d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos2dv(const GLdouble *p)
{
  Internal("error_glWindowPos2dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos2dv)(p);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos2dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos2f(GLfloat x, GLfloat y)
{
  Internal("error_glWindowPos2f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos2f)(x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos2f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos2fv(const GLfloat *p)
{
  Internal("error_glWindowPos2fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos2fv)(p);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos2fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos2i(GLint x, GLint y)
{
  Internal("error_glWindowPos2i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos2i)(x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos2i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos2iv(const GLint *p)
{
  Internal("error_glWindowPos2iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos2iv)(p);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos2iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos2s(GLshort x, GLshort y)
{
  Internal("error_glWindowPos2s","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos2s)(x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos2s : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos2sv(const GLshort *p)
{
  Internal("error_glWindowPos2sv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos2sv)(p);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos2sv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos3d(GLdouble x, GLdouble y, GLdouble z)
{
  Internal("error_glWindowPos3d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos3d)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos3d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos3dv(const GLdouble *p)
{
  Internal("error_glWindowPos3dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos3dv)(p);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos3dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos3f(GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glWindowPos3f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos3f)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos3f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos3fv(const GLfloat *p)
{
  Internal("error_glWindowPos3fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos3fv)(p);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos3fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos3i(GLint x, GLint y, GLint z)
{
  Internal("error_glWindowPos3i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos3i)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos3i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos3iv(const GLint *p)
{
  Internal("error_glWindowPos3iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos3iv)(p);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos3iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos3s(GLshort x, GLshort y, GLshort z)
{
  Internal("error_glWindowPos3s","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos3s)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos3s : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos3sv(const GLshort *p)
{
  Internal("error_glWindowPos3sv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos3sv)(p);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos3sv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_VERSION_1_5

static void REGAL_CALL error_glBeginQuery(GLenum target, GLuint id)
{
  Internal("error_glBeginQuery","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBeginQuery)(target, id);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBeginQuery : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBindBuffer(GLenum target, GLuint buffer)
{
  Internal("error_glBindBuffer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindBuffer)(target, buffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindBuffer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBufferData(GLenum target, GLsizeiptr size, const GLvoid *data, GLenum usage)
{
  Internal("error_glBufferData","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBufferData)(target, size, data, usage);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBufferData : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBufferSubData(GLenum target, GLintptr offset, GLsizeiptr size, const GLvoid *data)
{
  Internal("error_glBufferSubData","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBufferSubData)(target, offset, size, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBufferSubData : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteBuffers(GLsizei n, const GLuint *buffers)
{
  Internal("error_glDeleteBuffers","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteBuffers)(n, buffers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteBuffers : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteQueries(GLsizei n, const GLuint *ids)
{
  Internal("error_glDeleteQueries","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteQueries)(n, ids);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteQueries : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEndQuery(GLenum target)
{
  Internal("error_glEndQuery","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEndQuery)(target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEndQuery : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenBuffers(GLsizei n, GLuint *buffers)
{
  Internal("error_glGenBuffers","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenBuffers)(n, buffers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenBuffers : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenQueries(GLsizei n, GLuint *ids)
{
  Internal("error_glGenQueries","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenQueries)(n, ids);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenQueries : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetBufferParameteriv(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetBufferParameteriv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetBufferParameteriv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetBufferParameteriv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetBufferPointerv(GLenum target, GLenum pname, GLvoid **params)
{
  Internal("error_glGetBufferPointerv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetBufferPointerv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetBufferPointerv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetBufferSubData(GLenum target, GLintptr offset, GLsizeiptr size, GLvoid *data)
{
  Internal("error_glGetBufferSubData","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetBufferSubData)(target, offset, size, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetBufferSubData : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetQueryObjectiv(GLuint id, GLenum pname, GLint *params)
{
  Internal("error_glGetQueryObjectiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetQueryObjectiv)(id, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetQueryObjectiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetQueryObjectuiv(GLuint id, GLenum pname, GLuint *params)
{
  Internal("error_glGetQueryObjectuiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetQueryObjectuiv)(id, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetQueryObjectuiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetQueryiv(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetQueryiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetQueryiv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetQueryiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsBuffer(GLuint buffer)
{
  Internal("error_glIsBuffer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsBuffer)(buffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsBuffer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLboolean REGAL_CALL error_glIsQuery(GLuint id)
{
  Internal("error_glIsQuery","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsQuery)(id);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsQuery : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLvoid *REGAL_CALL error_glMapBuffer(GLenum target, GLenum access)
{
  Internal("error_glMapBuffer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLvoid * ret = _next->call(&_next->glMapBuffer)(target, access);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMapBuffer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLboolean REGAL_CALL error_glUnmapBuffer(GLenum target)
{
  Internal("error_glUnmapBuffer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glUnmapBuffer)(target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUnmapBuffer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

// GL_VERSION_2_0

static void REGAL_CALL error_glAttachShader(GLuint program, GLuint shader)
{
  Internal("error_glAttachShader","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glAttachShader)(program, shader);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glAttachShader : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBindAttribLocation(GLuint program, GLuint index, const GLchar *name)
{
  Internal("error_glBindAttribLocation","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindAttribLocation)(program, index, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindAttribLocation : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBlendEquationSeparate(GLenum modeRGB, GLenum modeAlpha)
{
  Internal("error_glBlendEquationSeparate","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendEquationSeparate)(modeRGB, modeAlpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendEquationSeparate : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompileShader(GLuint shader)
{
  Internal("error_glCompileShader","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompileShader)(shader);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompileShader : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLuint REGAL_CALL error_glCreateProgram(void)
{
  Internal("error_glCreateProgram","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint  ret = _next->call(&_next->glCreateProgram)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCreateProgram : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLuint REGAL_CALL error_glCreateShader(GLenum type)
{
  Internal("error_glCreateShader","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint  ret = _next->call(&_next->glCreateShader)(type);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCreateShader : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glDeleteProgram(GLuint program)
{
  Internal("error_glDeleteProgram","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteProgram)(program);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteProgram : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteShader(GLuint shader)
{
  Internal("error_glDeleteShader","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteShader)(shader);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteShader : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDetachShader(GLuint program, GLuint shader)
{
  Internal("error_glDetachShader","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDetachShader)(program, shader);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDetachShader : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDisableVertexAttribArray(GLuint index)
{
  Internal("error_glDisableVertexAttribArray","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDisableVertexAttribArray)(index);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDisableVertexAttribArray : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDrawBuffers(GLsizei n, const GLenum *bufs)
{
  Internal("error_glDrawBuffers","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawBuffers)(n, bufs);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawBuffers : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEnableVertexAttribArray(GLuint index)
{
  Internal("error_glEnableVertexAttribArray","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEnableVertexAttribArray)(index);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEnableVertexAttribArray : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetActiveAttrib(GLuint program, GLuint index, GLsizei bufSize, GLsizei *length, GLint *size, GLenum *type, GLchar *name)
{
  Internal("error_glGetActiveAttrib","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetActiveAttrib)(program, index, bufSize, length, size, type, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetActiveAttrib : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetActiveUniform(GLuint program, GLuint index, GLsizei bufSize, GLsizei *length, GLint *size, GLenum *type, GLchar *name)
{
  Internal("error_glGetActiveUniform","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetActiveUniform)(program, index, bufSize, length, size, type, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetActiveUniform : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetAttachedShaders(GLuint program, GLsizei maxCount, GLsizei *count, GLuint *shaders)
{
  Internal("error_glGetAttachedShaders","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetAttachedShaders)(program, maxCount, count, shaders);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetAttachedShaders : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLint REGAL_CALL error_glGetAttribLocation(GLuint program, const GLchar *name)
{
  Internal("error_glGetAttribLocation","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLint  ret = _next->call(&_next->glGetAttribLocation)(program, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetAttribLocation : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glGetProgramInfoLog(GLuint program, GLsizei bufSize, GLsizei *length, GLchar *infoLog)
{
  Internal("error_glGetProgramInfoLog","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramInfoLog)(program, bufSize, length, infoLog);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramInfoLog : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetProgramiv(GLuint program, GLenum pname, GLint *params)
{
  Internal("error_glGetProgramiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramiv)(program, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetShaderInfoLog(GLuint shader, GLsizei bufSize, GLsizei *length, GLchar *infoLog)
{
  Internal("error_glGetShaderInfoLog","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetShaderInfoLog)(shader, bufSize, length, infoLog);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetShaderInfoLog : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetShaderSource(GLuint shader, GLsizei bufSize, GLsizei *length, GLchar *source)
{
  Internal("error_glGetShaderSource","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetShaderSource)(shader, bufSize, length, source);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetShaderSource : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetShaderiv(GLuint shader, GLenum pname, GLint *params)
{
  Internal("error_glGetShaderiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetShaderiv)(shader, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetShaderiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLint REGAL_CALL error_glGetUniformLocation(GLuint program, const GLchar *name)
{
  Internal("error_glGetUniformLocation","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLint  ret = _next->call(&_next->glGetUniformLocation)(program, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetUniformLocation : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glGetUniformfv(GLuint program, GLint location, GLfloat *params)
{
  Internal("error_glGetUniformfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetUniformfv)(program, location, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetUniformfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetUniformiv(GLuint program, GLint location, GLint *params)
{
  Internal("error_glGetUniformiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetUniformiv)(program, location, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetUniformiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVertexAttribPointerv(GLuint index, GLenum pname, GLvoid **pointer)
{
  Internal("error_glGetVertexAttribPointerv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexAttribPointerv)(index, pname, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexAttribPointerv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVertexAttribdv(GLuint index, GLenum pname, GLdouble *params)
{
  Internal("error_glGetVertexAttribdv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexAttribdv)(index, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexAttribdv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVertexAttribfv(GLuint index, GLenum pname, GLfloat *params)
{
  Internal("error_glGetVertexAttribfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexAttribfv)(index, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexAttribfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVertexAttribiv(GLuint index, GLenum pname, GLint *params)
{
  Internal("error_glGetVertexAttribiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexAttribiv)(index, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexAttribiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsProgram(GLuint program)
{
  Internal("error_glIsProgram","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsProgram)(program);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsProgram : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLboolean REGAL_CALL error_glIsShader(GLuint shader)
{
  Internal("error_glIsShader","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsShader)(shader);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsShader : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glLinkProgram(GLuint program)
{
  Internal("error_glLinkProgram","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLinkProgram)(program);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLinkProgram : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glShaderSource(GLuint shader, GLsizei count, const GLchar * const *string, const GLint *length)
{
  Internal("error_glShaderSource","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glShaderSource)(shader, count, string, length);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glShaderSource : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glStencilFuncSeparate(GLenum face, GLenum func, GLint ref, GLuint mask)
{
  Internal("error_glStencilFuncSeparate","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glStencilFuncSeparate)(face, func, ref, mask);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glStencilFuncSeparate : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glStencilMaskSeparate(GLenum face, GLuint mask)
{
  Internal("error_glStencilMaskSeparate","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glStencilMaskSeparate)(face, mask);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glStencilMaskSeparate : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glStencilOpSeparate(GLenum face, GLenum fail, GLenum zfail, GLenum zpass)
{
  Internal("error_glStencilOpSeparate","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glStencilOpSeparate)(face, fail, zfail, zpass);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glStencilOpSeparate : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform1f(GLint location, GLfloat v0)
{
  Internal("error_glUniform1f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform1f)(location, v0);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform1f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform1fv(GLint location, GLsizei count, const GLfloat *value)
{
  Internal("error_glUniform1fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform1fv)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform1fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform1i(GLint location, GLint v0)
{
  Internal("error_glUniform1i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform1i)(location, v0);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform1i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform1iv(GLint location, GLsizei count, const GLint *value)
{
  Internal("error_glUniform1iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform1iv)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform1iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform2f(GLint location, GLfloat v0, GLfloat v1)
{
  Internal("error_glUniform2f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform2f)(location, v0, v1);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform2f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform2fv(GLint location, GLsizei count, const GLfloat *value)
{
  Internal("error_glUniform2fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform2fv)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform2fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform2i(GLint location, GLint v0, GLint v1)
{
  Internal("error_glUniform2i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform2i)(location, v0, v1);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform2i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform2iv(GLint location, GLsizei count, const GLint *value)
{
  Internal("error_glUniform2iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform2iv)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform2iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform3f(GLint location, GLfloat v0, GLfloat v1, GLfloat v2)
{
  Internal("error_glUniform3f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform3f)(location, v0, v1, v2);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform3f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform3fv(GLint location, GLsizei count, const GLfloat *value)
{
  Internal("error_glUniform3fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform3fv)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform3fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform3i(GLint location, GLint v0, GLint v1, GLint v2)
{
  Internal("error_glUniform3i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform3i)(location, v0, v1, v2);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform3i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform3iv(GLint location, GLsizei count, const GLint *value)
{
  Internal("error_glUniform3iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform3iv)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform3iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform4f(GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3)
{
  Internal("error_glUniform4f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform4f)(location, v0, v1, v2, v3);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform4f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform4fv(GLint location, GLsizei count, const GLfloat *value)
{
  Internal("error_glUniform4fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform4fv)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform4fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform4i(GLint location, GLint v0, GLint v1, GLint v2, GLint v3)
{
  Internal("error_glUniform4i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform4i)(location, v0, v1, v2, v3);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform4i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform4iv(GLint location, GLsizei count, const GLint *value)
{
  Internal("error_glUniform4iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform4iv)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform4iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformMatrix2fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glUniformMatrix2fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix2fv)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix2fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformMatrix3fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glUniformMatrix3fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix3fv)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix3fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformMatrix4fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glUniformMatrix4fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix4fv)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix4fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUseProgram(GLuint program)
{
  Internal("error_glUseProgram","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUseProgram)(program);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUseProgram : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glValidateProgram(GLuint program)
{
  Internal("error_glValidateProgram","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glValidateProgram)(program);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glValidateProgram : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib1d(GLuint index, GLdouble x)
{
  Internal("error_glVertexAttrib1d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib1d)(index, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib1d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib1dv(GLuint index, const GLdouble *v)
{
  Internal("error_glVertexAttrib1dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib1dv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib1dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib1f(GLuint index, GLfloat x)
{
  Internal("error_glVertexAttrib1f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib1f)(index, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib1f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib1fv(GLuint index, const GLfloat *v)
{
  Internal("error_glVertexAttrib1fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib1fv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib1fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib1s(GLuint index, GLshort x)
{
  Internal("error_glVertexAttrib1s","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib1s)(index, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib1s : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib1sv(GLuint index, const GLshort *v)
{
  Internal("error_glVertexAttrib1sv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib1sv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib1sv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib2d(GLuint index, GLdouble x, GLdouble y)
{
  Internal("error_glVertexAttrib2d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib2d)(index, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib2d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib2dv(GLuint index, const GLdouble *v)
{
  Internal("error_glVertexAttrib2dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib2dv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib2dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib2f(GLuint index, GLfloat x, GLfloat y)
{
  Internal("error_glVertexAttrib2f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib2f)(index, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib2f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib2fv(GLuint index, const GLfloat *v)
{
  Internal("error_glVertexAttrib2fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib2fv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib2fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib2s(GLuint index, GLshort x, GLshort y)
{
  Internal("error_glVertexAttrib2s","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib2s)(index, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib2s : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib2sv(GLuint index, const GLshort *v)
{
  Internal("error_glVertexAttrib2sv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib2sv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib2sv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib3d(GLuint index, GLdouble x, GLdouble y, GLdouble z)
{
  Internal("error_glVertexAttrib3d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib3d)(index, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib3d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib3dv(GLuint index, const GLdouble *v)
{
  Internal("error_glVertexAttrib3dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib3dv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib3dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib3f(GLuint index, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glVertexAttrib3f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib3f)(index, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib3f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib3fv(GLuint index, const GLfloat *v)
{
  Internal("error_glVertexAttrib3fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib3fv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib3fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib3s(GLuint index, GLshort x, GLshort y, GLshort z)
{
  Internal("error_glVertexAttrib3s","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib3s)(index, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib3s : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib3sv(GLuint index, const GLshort *v)
{
  Internal("error_glVertexAttrib3sv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib3sv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib3sv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4Nbv(GLuint index, const GLbyte *v)
{
  Internal("error_glVertexAttrib4Nbv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4Nbv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4Nbv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4Niv(GLuint index, const GLint *v)
{
  Internal("error_glVertexAttrib4Niv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4Niv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4Niv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4Nsv(GLuint index, const GLshort *v)
{
  Internal("error_glVertexAttrib4Nsv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4Nsv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4Nsv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4Nub(GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w)
{
  Internal("error_glVertexAttrib4Nub","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4Nub)(index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4Nub : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4Nubv(GLuint index, const GLubyte *v)
{
  Internal("error_glVertexAttrib4Nubv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4Nubv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4Nubv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4Nuiv(GLuint index, const GLuint *v)
{
  Internal("error_glVertexAttrib4Nuiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4Nuiv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4Nuiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4Nusv(GLuint index, const GLushort *v)
{
  Internal("error_glVertexAttrib4Nusv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4Nusv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4Nusv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4bv(GLuint index, const GLbyte *v)
{
  Internal("error_glVertexAttrib4bv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4bv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4bv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4d(GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
  Internal("error_glVertexAttrib4d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4d)(index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4dv(GLuint index, const GLdouble *v)
{
  Internal("error_glVertexAttrib4dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4dv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4f(GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
  Internal("error_glVertexAttrib4f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4f)(index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4fv(GLuint index, const GLfloat *v)
{
  Internal("error_glVertexAttrib4fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4fv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4iv(GLuint index, const GLint *v)
{
  Internal("error_glVertexAttrib4iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4iv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4s(GLuint index, GLshort x, GLshort y, GLshort z, GLshort w)
{
  Internal("error_glVertexAttrib4s","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4s)(index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4s : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4sv(GLuint index, const GLshort *v)
{
  Internal("error_glVertexAttrib4sv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4sv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4sv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4ubv(GLuint index, const GLubyte *v)
{
  Internal("error_glVertexAttrib4ubv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4ubv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4ubv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4uiv(GLuint index, const GLuint *v)
{
  Internal("error_glVertexAttrib4uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4uiv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4usv(GLuint index, const GLushort *v)
{
  Internal("error_glVertexAttrib4usv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4usv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4usv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribPointer(GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, const GLvoid *pointer)
{
  Internal("error_glVertexAttribPointer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribPointer)(index, size, type, normalized, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribPointer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_VERSION_2_1

static void REGAL_CALL error_glUniformMatrix2x3fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glUniformMatrix2x3fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix2x3fv)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix2x3fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformMatrix2x4fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glUniformMatrix2x4fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix2x4fv)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix2x4fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformMatrix3x2fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glUniformMatrix3x2fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix3x2fv)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix3x2fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformMatrix3x4fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glUniformMatrix3x4fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix3x4fv)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix3x4fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformMatrix4x2fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glUniformMatrix4x2fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix4x2fv)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix4x2fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformMatrix4x3fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glUniformMatrix4x3fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix4x3fv)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix4x3fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_VERSION_3_0

static void REGAL_CALL error_glBeginConditionalRender(GLuint id, GLenum mode)
{
  Internal("error_glBeginConditionalRender","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBeginConditionalRender)(id, mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBeginConditionalRender : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBeginTransformFeedback(GLenum primitiveMode)
{
  Internal("error_glBeginTransformFeedback","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBeginTransformFeedback)(primitiveMode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBeginTransformFeedback : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBindFragDataLocation(GLuint program, GLuint color, const GLchar *name)
{
  Internal("error_glBindFragDataLocation","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindFragDataLocation)(program, color, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindFragDataLocation : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glClampColor(GLenum target, GLenum clamp)
{
  Internal("error_glClampColor","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClampColor)(target, clamp);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClampColor : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glClearBufferfi(GLenum buffer, GLint drawbuffer, GLfloat depth, GLint stencil)
{
  Internal("error_glClearBufferfi","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClearBufferfi)(buffer, drawbuffer, depth, stencil);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClearBufferfi : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glClearBufferfv(GLenum buffer, GLint drawbuffer, const GLfloat *value)
{
  Internal("error_glClearBufferfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClearBufferfv)(buffer, drawbuffer, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClearBufferfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glClearBufferiv(GLenum buffer, GLint drawbuffer, const GLint *value)
{
  Internal("error_glClearBufferiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClearBufferiv)(buffer, drawbuffer, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClearBufferiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glClearBufferuiv(GLenum buffer, GLint drawbuffer, const GLuint *value)
{
  Internal("error_glClearBufferuiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClearBufferuiv)(buffer, drawbuffer, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClearBufferuiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColorMaski(GLuint index, GLboolean r, GLboolean g, GLboolean b, GLboolean a)
{
  Internal("error_glColorMaski","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColorMaski)(index, r, g, b, a);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColorMaski : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDisablei(GLenum cap, GLuint index)
{
  Internal("error_glDisablei","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDisablei)(cap, index);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDisablei : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEnablei(GLenum cap, GLuint index)
{
  Internal("error_glEnablei","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEnablei)(cap, index);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEnablei : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEndConditionalRender(void)
{
  Internal("error_glEndConditionalRender","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEndConditionalRender)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEndConditionalRender : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEndTransformFeedback(void)
{
  Internal("error_glEndTransformFeedback","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEndTransformFeedback)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEndTransformFeedback : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetBooleani_v(GLenum target, GLuint index, GLboolean *data)
{
  Internal("error_glGetBooleani_v","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetBooleani_v)(target, index, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetBooleani_v : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLint REGAL_CALL error_glGetFragDataLocation(GLuint program, const GLchar *name)
{
  Internal("error_glGetFragDataLocation","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLint  ret = _next->call(&_next->glGetFragDataLocation)(program, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetFragDataLocation : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static const GLubyte *REGAL_CALL error_glGetStringi(GLenum name, GLuint index)
{
  Internal("error_glGetStringi","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  const GLubyte * ret = _next->call(&_next->glGetStringi)(name, index);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetStringi : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glGetTexParameterIiv(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetTexParameterIiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTexParameterIiv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTexParameterIiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTexParameterIuiv(GLenum target, GLenum pname, GLuint *params)
{
  Internal("error_glGetTexParameterIuiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTexParameterIuiv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTexParameterIuiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTransformFeedbackVarying(GLuint program, GLuint index, GLsizei bufSize, GLsizei *length, GLsizei *size, GLenum *type, GLchar *name)
{
  Internal("error_glGetTransformFeedbackVarying","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTransformFeedbackVarying)(program, index, bufSize, length, size, type, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTransformFeedbackVarying : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetUniformuiv(GLuint program, GLint location, GLuint *params)
{
  Internal("error_glGetUniformuiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetUniformuiv)(program, location, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetUniformuiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVertexAttribIiv(GLuint index, GLenum pname, GLint *params)
{
  Internal("error_glGetVertexAttribIiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexAttribIiv)(index, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexAttribIiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVertexAttribIuiv(GLuint index, GLenum pname, GLuint *params)
{
  Internal("error_glGetVertexAttribIuiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexAttribIuiv)(index, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexAttribIuiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsEnabledi(GLenum target, GLuint index)
{
  Internal("error_glIsEnabledi","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsEnabledi)(target, index);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsEnabledi : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glTexParameterIiv(GLenum target, GLenum pname, const GLint *params)
{
  Internal("error_glTexParameterIiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexParameterIiv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexParameterIiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexParameterIuiv(GLenum target, GLenum pname, const GLuint *params)
{
  Internal("error_glTexParameterIuiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexParameterIuiv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexParameterIuiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTransformFeedbackVaryings(GLuint program, GLsizei count, const GLchar * const *varyings, GLenum bufferMode)
{
  Internal("error_glTransformFeedbackVaryings","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTransformFeedbackVaryings)(program, count, varyings, bufferMode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTransformFeedbackVaryings : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform1ui(GLint location, GLuint v0)
{
  Internal("error_glUniform1ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform1ui)(location, v0);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform1ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform1uiv(GLint location, GLsizei count, const GLuint *value)
{
  Internal("error_glUniform1uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform1uiv)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform1uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform2ui(GLint location, GLuint v0, GLuint v1)
{
  Internal("error_glUniform2ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform2ui)(location, v0, v1);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform2ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform2uiv(GLint location, GLsizei count, const GLuint *value)
{
  Internal("error_glUniform2uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform2uiv)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform2uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform3ui(GLint location, GLuint v0, GLuint v1, GLuint v2)
{
  Internal("error_glUniform3ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform3ui)(location, v0, v1, v2);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform3ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform3uiv(GLint location, GLsizei count, const GLuint *value)
{
  Internal("error_glUniform3uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform3uiv)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform3uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform4ui(GLint location, GLuint v0, GLuint v1, GLuint v2, GLuint v3)
{
  Internal("error_glUniform4ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform4ui)(location, v0, v1, v2, v3);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform4ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform4uiv(GLint location, GLsizei count, const GLuint *value)
{
  Internal("error_glUniform4uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform4uiv)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform4uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI1i(GLuint index, GLint x)
{
  Internal("error_glVertexAttribI1i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI1i)(index, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI1i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI1iv(GLuint index, const GLint *v)
{
  Internal("error_glVertexAttribI1iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI1iv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI1iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI1ui(GLuint index, GLuint x)
{
  Internal("error_glVertexAttribI1ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI1ui)(index, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI1ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI1uiv(GLuint index, const GLuint *v)
{
  Internal("error_glVertexAttribI1uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI1uiv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI1uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI2i(GLuint index, GLint x, GLint y)
{
  Internal("error_glVertexAttribI2i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI2i)(index, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI2i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI2iv(GLuint index, const GLint *v)
{
  Internal("error_glVertexAttribI2iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI2iv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI2iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI2ui(GLuint index, GLuint x, GLuint y)
{
  Internal("error_glVertexAttribI2ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI2ui)(index, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI2ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI2uiv(GLuint index, const GLuint *v)
{
  Internal("error_glVertexAttribI2uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI2uiv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI2uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI3i(GLuint index, GLint x, GLint y, GLint z)
{
  Internal("error_glVertexAttribI3i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI3i)(index, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI3i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI3iv(GLuint index, const GLint *v)
{
  Internal("error_glVertexAttribI3iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI3iv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI3iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI3ui(GLuint index, GLuint x, GLuint y, GLuint z)
{
  Internal("error_glVertexAttribI3ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI3ui)(index, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI3ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI3uiv(GLuint index, const GLuint *v)
{
  Internal("error_glVertexAttribI3uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI3uiv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI3uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI4bv(GLuint index, const GLbyte *v)
{
  Internal("error_glVertexAttribI4bv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI4bv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI4bv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI4i(GLuint index, GLint x, GLint y, GLint z, GLint w)
{
  Internal("error_glVertexAttribI4i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI4i)(index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI4i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI4iv(GLuint index, const GLint *v)
{
  Internal("error_glVertexAttribI4iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI4iv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI4iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI4sv(GLuint index, const GLshort *v)
{
  Internal("error_glVertexAttribI4sv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI4sv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI4sv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI4ubv(GLuint index, const GLubyte *v)
{
  Internal("error_glVertexAttribI4ubv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI4ubv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI4ubv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI4ui(GLuint index, GLuint x, GLuint y, GLuint z, GLuint w)
{
  Internal("error_glVertexAttribI4ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI4ui)(index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI4ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI4uiv(GLuint index, const GLuint *v)
{
  Internal("error_glVertexAttribI4uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI4uiv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI4uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI4usv(GLuint index, const GLushort *v)
{
  Internal("error_glVertexAttribI4usv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI4usv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI4usv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribIPointer(GLuint index, GLint size, GLenum type, GLsizei stride, const GLvoid *pointer)
{
  Internal("error_glVertexAttribIPointer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribIPointer)(index, size, type, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribIPointer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_VERSION_3_1

static void REGAL_CALL error_glDrawArraysInstanced(GLenum mode, GLint start, GLsizei count, GLsizei primcount)
{
  Internal("error_glDrawArraysInstanced","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawArraysInstanced)(mode, start, count, primcount);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawArraysInstanced : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDrawElementsInstanced(GLenum mode, GLsizei count, GLenum type, const GLvoid *indices, GLsizei primcount)
{
  Internal("error_glDrawElementsInstanced","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawElementsInstanced)(mode, count, type, indices, primcount);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawElementsInstanced : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPrimitiveRestartIndex(GLuint index)
{
  Internal("error_glPrimitiveRestartIndex","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPrimitiveRestartIndex)(index);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPrimitiveRestartIndex : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexBuffer(GLenum target, GLenum internalformat, GLuint buffer)
{
  Internal("error_glTexBuffer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexBuffer)(target, internalformat, buffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexBuffer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_VERSION_3_2

static void REGAL_CALL error_glFramebufferTexture(GLenum target, GLenum attachment, GLuint texture, GLint level)
{
  Internal("error_glFramebufferTexture","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFramebufferTexture)(target, attachment, texture, level);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFramebufferTexture : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetBufferParameteri64v(GLenum target, GLenum pname, GLint64 *params)
{
  Internal("error_glGetBufferParameteri64v","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetBufferParameteri64v)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetBufferParameteri64v : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetInteger64i_v(GLenum target, GLuint index, GLint64 *data)
{
  Internal("error_glGetInteger64i_v","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetInteger64i_v)(target, index, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetInteger64i_v : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_VERSION_3_3

static void REGAL_CALL error_glVertexAttribDivisor(GLuint index, GLuint divisor)
{
  Internal("error_glVertexAttribDivisor","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribDivisor)(index, divisor);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribDivisor : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_VERSION_4_0

static void REGAL_CALL error_glBlendEquationSeparatei(GLuint buf, GLenum modeRGB, GLenum modeAlpha)
{
  Internal("error_glBlendEquationSeparatei","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendEquationSeparatei)(buf, modeRGB, modeAlpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendEquationSeparatei : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBlendEquationi(GLuint buf, GLenum mode)
{
  Internal("error_glBlendEquationi","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendEquationi)(buf, mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendEquationi : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBlendFuncSeparatei(GLuint buf, GLenum srcRGB, GLenum dstRGB, GLenum srcAlpha, GLenum dstAlpha)
{
  Internal("error_glBlendFuncSeparatei","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendFuncSeparatei)(buf, srcRGB, dstRGB, srcAlpha, dstAlpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendFuncSeparatei : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBlendFunci(GLuint buf, GLenum src, GLenum dst)
{
  Internal("error_glBlendFunci","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendFunci)(buf, src, dst);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendFunci : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_3DFX_tbuffer

static void REGAL_CALL error_glTbufferMask3DFX(GLuint mask)
{
  Internal("error_glTbufferMask3DFX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTbufferMask3DFX)(mask);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTbufferMask3DFX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_AMD_debug_output

static void REGAL_CALL error_glDebugMessageCallbackAMD(GLDEBUGPROCAMD callback, void *userParam)
{
  Internal("error_glDebugMessageCallbackAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDebugMessageCallbackAMD)(callback, userParam);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDebugMessageCallbackAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDebugMessageEnableAMD(GLenum category, GLenum severity, GLsizei count, const GLuint *ids, GLboolean enabled)
{
  Internal("error_glDebugMessageEnableAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDebugMessageEnableAMD)(category, severity, count, ids, enabled);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDebugMessageEnableAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDebugMessageInsertAMD(GLenum category, GLenum severity, GLuint id, GLsizei length, const GLchar *buf)
{
  Internal("error_glDebugMessageInsertAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDebugMessageInsertAMD)(category, severity, id, length, buf);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDebugMessageInsertAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLuint REGAL_CALL error_glGetDebugMessageLogAMD(GLuint count, GLsizei bufsize, GLenum *categories, GLuint *severities, GLuint *ids, GLsizei *lengths, GLchar *message)
{
  Internal("error_glGetDebugMessageLogAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint  ret = _next->call(&_next->glGetDebugMessageLogAMD)(count, bufsize, categories, severities, ids, lengths, message);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetDebugMessageLogAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

// GL_AMD_draw_buffers_blend

static void REGAL_CALL error_glBlendEquationIndexedAMD(GLuint buf, GLenum mode)
{
  Internal("error_glBlendEquationIndexedAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendEquationIndexedAMD)(buf, mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendEquationIndexedAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBlendEquationSeparateIndexedAMD(GLuint buf, GLenum modeRGB, GLenum modeAlpha)
{
  Internal("error_glBlendEquationSeparateIndexedAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendEquationSeparateIndexedAMD)(buf, modeRGB, modeAlpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendEquationSeparateIndexedAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBlendFuncIndexedAMD(GLuint buf, GLenum src, GLenum dst)
{
  Internal("error_glBlendFuncIndexedAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendFuncIndexedAMD)(buf, src, dst);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendFuncIndexedAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBlendFuncSeparateIndexedAMD(GLuint buf, GLenum srcRGB, GLenum dstRGB, GLenum srcAlpha, GLenum dstAlpha)
{
  Internal("error_glBlendFuncSeparateIndexedAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendFuncSeparateIndexedAMD)(buf, srcRGB, dstRGB, srcAlpha, dstAlpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendFuncSeparateIndexedAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_AMD_interleaved_elements

static void REGAL_CALL error_glVertexAttribParameteriAMD(GLuint index, GLenum pname, GLint param)
{
  Internal("error_glVertexAttribParameteriAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribParameteriAMD)(index, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribParameteriAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_AMD_multi_draw_indirect

static void REGAL_CALL error_glMultiDrawArraysIndirectAMD(GLenum mode, const GLvoid *indirect, GLsizei primcount, GLsizei stride)
{
  Internal("error_glMultiDrawArraysIndirectAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiDrawArraysIndirectAMD)(mode, indirect, primcount, stride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiDrawArraysIndirectAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiDrawElementsIndirectAMD(GLenum mode, GLenum type, const GLvoid *indirect, GLsizei primcount, GLsizei stride)
{
  Internal("error_glMultiDrawElementsIndirectAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiDrawElementsIndirectAMD)(mode, type, indirect, primcount, stride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiDrawElementsIndirectAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_AMD_name_gen_delete

static void REGAL_CALL error_glDeleteNamesAMD(GLenum identifier, GLuint num, const GLuint *names)
{
  Internal("error_glDeleteNamesAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteNamesAMD)(identifier, num, names);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteNamesAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenNamesAMD(GLenum identifier, GLuint num, GLuint *names)
{
  Internal("error_glGenNamesAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenNamesAMD)(identifier, num, names);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenNamesAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsNameAMD(GLenum identifier, GLuint name)
{
  Internal("error_glIsNameAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsNameAMD)(identifier, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsNameAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

// GL_AMD_performance_monitor

static void REGAL_CALL error_glBeginPerfMonitorAMD(GLuint monitor)
{
  Internal("error_glBeginPerfMonitorAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBeginPerfMonitorAMD)(monitor);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBeginPerfMonitorAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeletePerfMonitorsAMD(GLsizei n, GLuint *monitors)
{
  Internal("error_glDeletePerfMonitorsAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeletePerfMonitorsAMD)(n, monitors);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeletePerfMonitorsAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEndPerfMonitorAMD(GLuint monitor)
{
  Internal("error_glEndPerfMonitorAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEndPerfMonitorAMD)(monitor);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEndPerfMonitorAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenPerfMonitorsAMD(GLsizei n, GLuint *monitors)
{
  Internal("error_glGenPerfMonitorsAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenPerfMonitorsAMD)(n, monitors);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenPerfMonitorsAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPerfMonitorCounterDataAMD(GLuint monitor, GLenum pname, GLsizei dataSize, GLuint *data, GLint *bytesWritten)
{
  Internal("error_glGetPerfMonitorCounterDataAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPerfMonitorCounterDataAMD)(monitor, pname, dataSize, data, bytesWritten);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPerfMonitorCounterDataAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPerfMonitorCounterInfoAMD(GLuint group, GLuint counter, GLenum pname, GLvoid *data)
{
  Internal("error_glGetPerfMonitorCounterInfoAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPerfMonitorCounterInfoAMD)(group, counter, pname, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPerfMonitorCounterInfoAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPerfMonitorCounterStringAMD(GLuint group, GLuint counter, GLsizei bufSize, GLsizei *length, GLchar *counterString)
{
  Internal("error_glGetPerfMonitorCounterStringAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPerfMonitorCounterStringAMD)(group, counter, bufSize, length, counterString);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPerfMonitorCounterStringAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPerfMonitorCountersAMD(GLuint group, GLint *numCounters, GLint *maxActiveCounters, GLsizei countersSize, GLuint *counters)
{
  Internal("error_glGetPerfMonitorCountersAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPerfMonitorCountersAMD)(group, numCounters, maxActiveCounters, countersSize, counters);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPerfMonitorCountersAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPerfMonitorGroupStringAMD(GLuint group, GLsizei bufSize, GLsizei *length, GLchar *groupString)
{
  Internal("error_glGetPerfMonitorGroupStringAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPerfMonitorGroupStringAMD)(group, bufSize, length, groupString);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPerfMonitorGroupStringAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPerfMonitorGroupsAMD(GLint *numGroups, GLsizei groupsSize, GLuint *groups)
{
  Internal("error_glGetPerfMonitorGroupsAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPerfMonitorGroupsAMD)(numGroups, groupsSize, groups);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPerfMonitorGroupsAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSelectPerfMonitorCountersAMD(GLuint monitor, GLboolean enable, GLuint group, GLint numCounters, GLuint *counterList)
{
  Internal("error_glSelectPerfMonitorCountersAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSelectPerfMonitorCountersAMD)(monitor, enable, group, numCounters, counterList);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSelectPerfMonitorCountersAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_AMD_sample_positions

static void REGAL_CALL error_glSetMultisamplefvAMD(GLenum pname, GLuint index, const GLfloat *val)
{
  Internal("error_glSetMultisamplefvAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSetMultisamplefvAMD)(pname, index, val);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSetMultisamplefvAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_AMD_sparse_texture

static void REGAL_CALL error_glTexStorageSparseAMD(GLenum target, GLenum internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLsizei layers, GLbitfield flags)
{
  Internal("error_glTexStorageSparseAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexStorageSparseAMD)(target, internalFormat, width, height, depth, layers, flags);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexStorageSparseAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureStorageSparseAMD(GLuint texture, GLenum target, GLenum internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLsizei layers, GLbitfield flags)
{
  Internal("error_glTextureStorageSparseAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureStorageSparseAMD)(texture, target, internalFormat, width, height, depth, layers, flags);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureStorageSparseAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_AMD_stencil_operation_extended

static void REGAL_CALL error_glStencilOpValueAMD(GLenum face, GLuint value)
{
  Internal("error_glStencilOpValueAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glStencilOpValueAMD)(face, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glStencilOpValueAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_AMD_vertex_shader_tessellator

static void REGAL_CALL error_glTessellationFactorAMD(GLfloat factor)
{
  Internal("error_glTessellationFactorAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTessellationFactorAMD)(factor);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTessellationFactorAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTessellationModeAMD(GLenum mode)
{
  Internal("error_glTessellationModeAMD","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTessellationModeAMD)(mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTessellationModeAMD : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ANGLE_framebuffer_blit

static void REGAL_CALL error_glBlitFramebufferANGLE(GLint srcX0, GLint srcY0, GLint srcX1, GLint srcY1, GLint dstX0, GLint dstY0, GLint dstX1, GLint dstY1, GLbitfield mask, GLenum filter)
{
  Internal("error_glBlitFramebufferANGLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlitFramebufferANGLE)(srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlitFramebufferANGLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ANGLE_framebuffer_multisample

static void REGAL_CALL error_glRenderbufferStorageMultisampleANGLE(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height)
{
  Internal("error_glRenderbufferStorageMultisampleANGLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRenderbufferStorageMultisampleANGLE)(target, samples, internalformat, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRenderbufferStorageMultisampleANGLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ANGLE_instanced_arrays

static void REGAL_CALL error_glDrawArraysInstancedANGLE(GLenum mode, GLint first, GLsizei count, GLsizei primcount)
{
  Internal("error_glDrawArraysInstancedANGLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawArraysInstancedANGLE)(mode, first, count, primcount);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawArraysInstancedANGLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDrawElementsInstancedANGLE(GLenum mode, GLsizei count, GLenum type, const GLvoid *indices, GLsizei primcount)
{
  Internal("error_glDrawElementsInstancedANGLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawElementsInstancedANGLE)(mode, count, type, indices, primcount);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawElementsInstancedANGLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribDivisorANGLE(GLuint index, GLuint divisor)
{
  Internal("error_glVertexAttribDivisorANGLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribDivisorANGLE)(index, divisor);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribDivisorANGLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ANGLE_timer_query

static void REGAL_CALL error_glBeginQueryANGLE(GLenum target, GLuint id)
{
  Internal("error_glBeginQueryANGLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBeginQueryANGLE)(target, id);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBeginQueryANGLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteQueriesANGLE(GLsizei n, const GLuint *ids)
{
  Internal("error_glDeleteQueriesANGLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteQueriesANGLE)(n, ids);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteQueriesANGLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEndQueryANGLE(GLenum target)
{
  Internal("error_glEndQueryANGLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEndQueryANGLE)(target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEndQueryANGLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenQueriesANGLE(GLsizei n, GLuint *ids)
{
  Internal("error_glGenQueriesANGLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenQueriesANGLE)(n, ids);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenQueriesANGLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetQueryObjecti64vANGLE(GLuint id, GLenum pname, GLint64 *params)
{
  Internal("error_glGetQueryObjecti64vANGLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetQueryObjecti64vANGLE)(id, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetQueryObjecti64vANGLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetQueryObjectivANGLE(GLuint id, GLenum pname, GLint *params)
{
  Internal("error_glGetQueryObjectivANGLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetQueryObjectivANGLE)(id, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetQueryObjectivANGLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetQueryObjectui64vANGLE(GLuint id, GLenum pname, GLuint64 *params)
{
  Internal("error_glGetQueryObjectui64vANGLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetQueryObjectui64vANGLE)(id, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetQueryObjectui64vANGLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetQueryObjectuivANGLE(GLuint id, GLenum pname, GLuint *params)
{
  Internal("error_glGetQueryObjectuivANGLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetQueryObjectuivANGLE)(id, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetQueryObjectuivANGLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetQueryivANGLE(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetQueryivANGLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetQueryivANGLE)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetQueryivANGLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsQueryANGLE(GLuint id)
{
  Internal("error_glIsQueryANGLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsQueryANGLE)(id);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsQueryANGLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glQueryCounterANGLE(GLuint id, GLenum target)
{
  Internal("error_glQueryCounterANGLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glQueryCounterANGLE)(id, target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glQueryCounterANGLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ANGLE_translated_shader_source

static void REGAL_CALL error_glGetTranslatedShaderSourceANGLE(GLuint shader, GLsizei bufsize, GLsizei *length, GLchar *source)
{
  Internal("error_glGetTranslatedShaderSourceANGLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTranslatedShaderSourceANGLE)(shader, bufsize, length, source);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTranslatedShaderSourceANGLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_APPLE_copy_texture_levels

static void REGAL_CALL error_glCopyTextureLevelsAPPLE(GLuint destinationTexture, GLuint sourceTexture, GLint sourceBaseLevel, GLsizei sourceLevelCount)
{
  Internal("error_glCopyTextureLevelsAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyTextureLevelsAPPLE)(destinationTexture, sourceTexture, sourceBaseLevel, sourceLevelCount);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyTextureLevelsAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_APPLE_element_array

static void REGAL_CALL error_glDrawElementArrayAPPLE(GLenum mode, GLint first, GLsizei count)
{
  Internal("error_glDrawElementArrayAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawElementArrayAPPLE)(mode, first, count);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawElementArrayAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDrawRangeElementArrayAPPLE(GLenum mode, GLuint start, GLuint end, GLint first, GLsizei count)
{
  Internal("error_glDrawRangeElementArrayAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawRangeElementArrayAPPLE)(mode, start, end, first, count);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawRangeElementArrayAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glElementPointerAPPLE(GLenum type, const GLvoid *pointer)
{
  Internal("error_glElementPointerAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glElementPointerAPPLE)(type, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glElementPointerAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiDrawElementArrayAPPLE(GLenum mode, const GLint *first, const GLsizei *count, GLsizei primcount)
{
  Internal("error_glMultiDrawElementArrayAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiDrawElementArrayAPPLE)(mode, first, count, primcount);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiDrawElementArrayAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiDrawRangeElementArrayAPPLE(GLenum mode, GLuint start, GLuint end, const GLint *first, const GLsizei *count, GLsizei primcount)
{
  Internal("error_glMultiDrawRangeElementArrayAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiDrawRangeElementArrayAPPLE)(mode, start, end, first, count, primcount);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiDrawRangeElementArrayAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_APPLE_fence

static void REGAL_CALL error_glDeleteFencesAPPLE(GLsizei n, const GLuint *fences)
{
  Internal("error_glDeleteFencesAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteFencesAPPLE)(n, fences);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteFencesAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFinishFenceAPPLE(GLuint fence)
{
  Internal("error_glFinishFenceAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFinishFenceAPPLE)(fence);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFinishFenceAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFinishObjectAPPLE(GLenum object, GLint name)
{
  Internal("error_glFinishObjectAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFinishObjectAPPLE)(object, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFinishObjectAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenFencesAPPLE(GLsizei n, GLuint *fences)
{
  Internal("error_glGenFencesAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenFencesAPPLE)(n, fences);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenFencesAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsFenceAPPLE(GLuint fence)
{
  Internal("error_glIsFenceAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsFenceAPPLE)(fence);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsFenceAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glSetFenceAPPLE(GLuint fence)
{
  Internal("error_glSetFenceAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSetFenceAPPLE)(fence);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSetFenceAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glTestFenceAPPLE(GLuint fence)
{
  Internal("error_glTestFenceAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glTestFenceAPPLE)(fence);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTestFenceAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLboolean REGAL_CALL error_glTestObjectAPPLE(GLenum object, GLuint name)
{
  Internal("error_glTestObjectAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glTestObjectAPPLE)(object, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTestObjectAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

// GL_APPLE_flush_buffer_range

static void REGAL_CALL error_glBufferParameteriAPPLE(GLenum target, GLenum pname, GLint param)
{
  Internal("error_glBufferParameteriAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBufferParameteriAPPLE)(target, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBufferParameteriAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFlushMappedBufferRangeAPPLE(GLenum target, GLintptr offset, GLsizeiptr size)
{
  Internal("error_glFlushMappedBufferRangeAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFlushMappedBufferRangeAPPLE)(target, offset, size);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFlushMappedBufferRangeAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_APPLE_flush_render

static void REGAL_CALL error_glFinishRenderAPPLE(void)
{
  Internal("error_glFinishRenderAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFinishRenderAPPLE)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFinishRenderAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFlushRenderAPPLE(void)
{
  Internal("error_glFlushRenderAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFlushRenderAPPLE)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFlushRenderAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSwapAPPLE(void)
{
  Internal("error_glSwapAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSwapAPPLE)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSwapAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_APPLE_framebuffer_multisample

static void REGAL_CALL error_glRenderbufferStorageMultisampleAPPLE(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height)
{
  Internal("error_glRenderbufferStorageMultisampleAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRenderbufferStorageMultisampleAPPLE)(target, samples, internalformat, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRenderbufferStorageMultisampleAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glResolveMultisampleFramebufferAPPLE(void)
{
  Internal("error_glResolveMultisampleFramebufferAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glResolveMultisampleFramebufferAPPLE)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glResolveMultisampleFramebufferAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_APPLE_object_purgeable

static void REGAL_CALL error_glGetObjectParameterivAPPLE(GLenum objectType, GLuint name, GLenum pname, GLint *params)
{
  Internal("error_glGetObjectParameterivAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetObjectParameterivAPPLE)(objectType, name, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetObjectParameterivAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLenum REGAL_CALL error_glObjectPurgeableAPPLE(GLenum objectType, GLuint name, GLenum option)
{
  Internal("error_glObjectPurgeableAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLenum  ret = _next->call(&_next->glObjectPurgeableAPPLE)(objectType, name, option);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glObjectPurgeableAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLenum REGAL_CALL error_glObjectUnpurgeableAPPLE(GLenum objectType, GLuint name, GLenum option)
{
  Internal("error_glObjectUnpurgeableAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLenum  ret = _next->call(&_next->glObjectUnpurgeableAPPLE)(objectType, name, option);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glObjectUnpurgeableAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

// GL_APPLE_sync

static GLenum REGAL_CALL error_glClientWaitSyncAPPLE(GLsync sync, GLbitfield flags, GLuint64 timeout)
{
  Internal("error_glClientWaitSyncAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLenum  ret = _next->call(&_next->glClientWaitSyncAPPLE)(sync, flags, timeout);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClientWaitSyncAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glDeleteSyncAPPLE(GLsync sync)
{
  Internal("error_glDeleteSyncAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteSyncAPPLE)(sync);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteSyncAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLsync REGAL_CALL error_glFenceSyncAPPLE(GLenum condition, GLbitfield flags)
{
  Internal("error_glFenceSyncAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLsync  ret = _next->call(&_next->glFenceSyncAPPLE)(condition, flags);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFenceSyncAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glGetInteger64vAPPLE(GLenum pname, GLint64 *params)
{
  Internal("error_glGetInteger64vAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetInteger64vAPPLE)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetInteger64vAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetSyncivAPPLE(GLsync sync, GLenum pname, GLsizei bufSize, GLsizei *length, GLint *values)
{
  Internal("error_glGetSyncivAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetSyncivAPPLE)(sync, pname, bufSize, length, values);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetSyncivAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsSyncAPPLE(GLsync sync)
{
  Internal("error_glIsSyncAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsSyncAPPLE)(sync);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsSyncAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glWaitSyncAPPLE(GLsync sync, GLbitfield flags, GLuint64 timeout)
{
  Internal("error_glWaitSyncAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWaitSyncAPPLE)(sync, flags, timeout);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWaitSyncAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_APPLE_texture_range

static void REGAL_CALL error_glGetTexParameterPointervAPPLE(GLenum target, GLenum pname, GLvoid **params)
{
  Internal("error_glGetTexParameterPointervAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTexParameterPointervAPPLE)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTexParameterPointervAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureRangeAPPLE(GLenum target, GLsizei length, const GLvoid *pointer)
{
  Internal("error_glTextureRangeAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureRangeAPPLE)(target, length, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureRangeAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_APPLE_vertex_array_object

static void REGAL_CALL error_glBindVertexArrayAPPLE(GLuint array)
{
  Internal("error_glBindVertexArrayAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindVertexArrayAPPLE)(array);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindVertexArrayAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteVertexArraysAPPLE(GLsizei n, const GLuint *arrays)
{
  Internal("error_glDeleteVertexArraysAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteVertexArraysAPPLE)(n, arrays);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteVertexArraysAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenVertexArraysAPPLE(GLsizei n, GLuint *arrays)
{
  Internal("error_glGenVertexArraysAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenVertexArraysAPPLE)(n, arrays);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenVertexArraysAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsVertexArrayAPPLE(GLuint array)
{
  Internal("error_glIsVertexArrayAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsVertexArrayAPPLE)(array);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsVertexArrayAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

// GL_APPLE_vertex_array_range

static void REGAL_CALL error_glFlushVertexArrayRangeAPPLE(GLsizei length, GLvoid *pointer)
{
  Internal("error_glFlushVertexArrayRangeAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFlushVertexArrayRangeAPPLE)(length, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFlushVertexArrayRangeAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexArrayParameteriAPPLE(GLenum pname, GLint param)
{
  Internal("error_glVertexArrayParameteriAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexArrayParameteriAPPLE)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexArrayParameteriAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexArrayRangeAPPLE(GLsizei length, GLvoid *pointer)
{
  Internal("error_glVertexArrayRangeAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexArrayRangeAPPLE)(length, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexArrayRangeAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_APPLE_vertex_program_evaluators

static void REGAL_CALL error_glDisableVertexAttribAPPLE(GLuint index, GLenum pname)
{
  Internal("error_glDisableVertexAttribAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDisableVertexAttribAPPLE)(index, pname);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDisableVertexAttribAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEnableVertexAttribAPPLE(GLuint index, GLenum pname)
{
  Internal("error_glEnableVertexAttribAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEnableVertexAttribAPPLE)(index, pname);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEnableVertexAttribAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsVertexAttribEnabledAPPLE(GLuint index, GLenum pname)
{
  Internal("error_glIsVertexAttribEnabledAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsVertexAttribEnabledAPPLE)(index, pname);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsVertexAttribEnabledAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glMapVertexAttrib1dAPPLE(GLuint index, GLuint size, GLdouble u1, GLdouble u2, GLint stride, GLint order, const GLdouble *points)
{
  Internal("error_glMapVertexAttrib1dAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMapVertexAttrib1dAPPLE)(index, size, u1, u2, stride, order, points);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMapVertexAttrib1dAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMapVertexAttrib1fAPPLE(GLuint index, GLuint size, GLfloat u1, GLfloat u2, GLint stride, GLint order, const GLfloat *points)
{
  Internal("error_glMapVertexAttrib1fAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMapVertexAttrib1fAPPLE)(index, size, u1, u2, stride, order, points);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMapVertexAttrib1fAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMapVertexAttrib2dAPPLE(GLuint index, GLuint size, GLdouble u1, GLdouble u2, GLint ustride, GLint uorder, GLdouble v1, GLdouble v2, GLint vstride, GLint vorder, const GLdouble *points)
{
  Internal("error_glMapVertexAttrib2dAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMapVertexAttrib2dAPPLE)(index, size, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMapVertexAttrib2dAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMapVertexAttrib2fAPPLE(GLuint index, GLuint size, GLfloat u1, GLfloat u2, GLint ustride, GLint uorder, GLfloat v1, GLfloat v2, GLint vstride, GLint vorder, const GLfloat *points)
{
  Internal("error_glMapVertexAttrib2fAPPLE","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMapVertexAttrib2fAPPLE)(index, size, u1, u2, ustride, uorder, v1, v2, vstride, vorder, points);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMapVertexAttrib2fAPPLE : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_ES2_compatibility

static void REGAL_CALL error_glClearDepthf(GLclampf d)
{
  Internal("error_glClearDepthf","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClearDepthf)(d);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClearDepthf : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDepthRangef(GLclampf n, GLclampf f)
{
  Internal("error_glDepthRangef","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDepthRangef)(n, f);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDepthRangef : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetShaderPrecisionFormat(GLenum shadertype, GLenum precisiontype, GLint *range, GLint *precision)
{
  Internal("error_glGetShaderPrecisionFormat","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetShaderPrecisionFormat)(shadertype, precisiontype, range, precision);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetShaderPrecisionFormat : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReleaseShaderCompiler(void)
{
  Internal("error_glReleaseShaderCompiler","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReleaseShaderCompiler)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReleaseShaderCompiler : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glShaderBinary(GLsizei count, const GLuint *shaders, GLenum binaryformat, const GLvoid *binary, GLsizei length)
{
  Internal("error_glShaderBinary","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glShaderBinary)(count, shaders, binaryformat, binary, length);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glShaderBinary : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_base_instance

static void REGAL_CALL error_glDrawArraysInstancedBaseInstance(GLenum mode, GLint first, GLsizei count, GLsizei primcount, GLuint baseinstance)
{
  Internal("error_glDrawArraysInstancedBaseInstance","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawArraysInstancedBaseInstance)(mode, first, count, primcount, baseinstance);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawArraysInstancedBaseInstance : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDrawElementsInstancedBaseInstance(GLenum mode, GLsizei count, GLenum type, const GLvoid *indices, GLsizei primcount, GLuint baseinstance)
{
  Internal("error_glDrawElementsInstancedBaseInstance","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawElementsInstancedBaseInstance)(mode, count, type, indices, primcount, baseinstance);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawElementsInstancedBaseInstance : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDrawElementsInstancedBaseVertexBaseInstance(GLenum mode, GLsizei count, GLenum type, const GLvoid *indices, GLsizei primcount, GLint basevertex, GLuint baseinstance)
{
  Internal("error_glDrawElementsInstancedBaseVertexBaseInstance","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawElementsInstancedBaseVertexBaseInstance)(mode, count, type, indices, primcount, basevertex, baseinstance);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawElementsInstancedBaseVertexBaseInstance : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_bindless_texture

static GLuint64 REGAL_CALL error_glGetImageHandleARB(GLuint texture, GLint level, GLboolean layered, GLint layer, GLenum format)
{
  Internal("error_glGetImageHandleARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint64  ret = _next->call(&_next->glGetImageHandleARB)(texture, level, layered, layer, format);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetImageHandleARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLuint64 REGAL_CALL error_glGetTextureHandleARB(GLuint texture)
{
  Internal("error_glGetTextureHandleARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint64  ret = _next->call(&_next->glGetTextureHandleARB)(texture);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTextureHandleARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLuint64 REGAL_CALL error_glGetTextureSamplerHandleARB(GLuint texture, GLuint sampler)
{
  Internal("error_glGetTextureSamplerHandleARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint64  ret = _next->call(&_next->glGetTextureSamplerHandleARB)(texture, sampler);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTextureSamplerHandleARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glGetVertexAttribLui64vARB(GLuint index, GLenum pname, GLuint64EXT *params)
{
  Internal("error_glGetVertexAttribLui64vARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexAttribLui64vARB)(index, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexAttribLui64vARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsImageHandleResidentARB(GLuint64 handle)
{
  Internal("error_glIsImageHandleResidentARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsImageHandleResidentARB)(handle);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsImageHandleResidentARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLboolean REGAL_CALL error_glIsTextureHandleResidentARB(GLuint64 handle)
{
  Internal("error_glIsTextureHandleResidentARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsTextureHandleResidentARB)(handle);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsTextureHandleResidentARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glMakeImageHandleNonResidentARB(GLuint64 handle)
{
  Internal("error_glMakeImageHandleNonResidentARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMakeImageHandleNonResidentARB)(handle);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMakeImageHandleNonResidentARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMakeImageHandleResidentARB(GLuint64 handle, GLenum access)
{
  Internal("error_glMakeImageHandleResidentARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMakeImageHandleResidentARB)(handle, access);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMakeImageHandleResidentARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMakeTextureHandleNonResidentARB(GLuint64 handle)
{
  Internal("error_glMakeTextureHandleNonResidentARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMakeTextureHandleNonResidentARB)(handle);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMakeTextureHandleNonResidentARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMakeTextureHandleResidentARB(GLuint64 handle)
{
  Internal("error_glMakeTextureHandleResidentARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMakeTextureHandleResidentARB)(handle);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMakeTextureHandleResidentARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformHandleui64ARB(GLuint program, GLint location, GLuint64 value)
{
  Internal("error_glProgramUniformHandleui64ARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformHandleui64ARB)(program, location, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformHandleui64ARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformHandleui64vARB(GLuint program, GLint location, GLsizei count, const GLuint64 *values)
{
  Internal("error_glProgramUniformHandleui64vARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformHandleui64vARB)(program, location, count, values);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformHandleui64vARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformHandleui64ARB(GLint location, GLuint64 value)
{
  Internal("error_glUniformHandleui64ARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformHandleui64ARB)(location, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformHandleui64ARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformHandleui64vARB(GLint location, GLsizei count, const GLuint64 *value)
{
  Internal("error_glUniformHandleui64vARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformHandleui64vARB)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformHandleui64vARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL1ui64ARB(GLuint index, GLuint64EXT x)
{
  Internal("error_glVertexAttribL1ui64ARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL1ui64ARB)(index, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL1ui64ARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL1ui64vARB(GLuint index, const GLuint64EXT *v)
{
  Internal("error_glVertexAttribL1ui64vARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL1ui64vARB)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL1ui64vARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_blend_func_extended

static void REGAL_CALL error_glBindFragDataLocationIndexed(GLuint program, GLuint colorNumber, GLuint index, const GLchar *name)
{
  Internal("error_glBindFragDataLocationIndexed","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindFragDataLocationIndexed)(program, colorNumber, index, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindFragDataLocationIndexed : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLint REGAL_CALL error_glGetFragDataIndex(GLuint program, const GLchar *name)
{
  Internal("error_glGetFragDataIndex","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLint  ret = _next->call(&_next->glGetFragDataIndex)(program, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetFragDataIndex : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

// GL_ARB_buffer_storage

static void REGAL_CALL error_glBufferStorage(GLenum target, GLsizeiptr size, const GLvoid *data, GLbitfield flags)
{
  Internal("error_glBufferStorage","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBufferStorage)(target, size, data, flags);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBufferStorage : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedBufferStorageEXT(GLuint buffer, GLsizeiptr size, const GLvoid *data, GLbitfield flags)
{
  Internal("error_glNamedBufferStorageEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedBufferStorageEXT)(buffer, size, data, flags);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedBufferStorageEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_cl_event

static GLsync REGAL_CALL error_glCreateSyncFromCLeventARB(cl_context context, cl_event event, GLbitfield flags)
{
  Internal("error_glCreateSyncFromCLeventARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLsync  ret = _next->call(&_next->glCreateSyncFromCLeventARB)(context, event, flags);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCreateSyncFromCLeventARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

// GL_ARB_clear_buffer_object

static void REGAL_CALL error_glClearBufferData(GLenum target, GLenum internalformat, GLenum format, GLenum type, const GLvoid *data)
{
  Internal("error_glClearBufferData","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClearBufferData)(target, internalformat, format, type, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClearBufferData : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glClearBufferSubData(GLenum target, GLenum internalformat, GLintptr offset, GLsizeiptr size, GLenum format, GLenum type, const GLvoid *data)
{
  Internal("error_glClearBufferSubData","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClearBufferSubData)(target, internalformat, offset, size, format, type, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClearBufferSubData : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glClearNamedBufferDataEXT(GLuint buffer, GLenum internalformat, GLenum format, GLenum type, const GLvoid *data)
{
  Internal("error_glClearNamedBufferDataEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClearNamedBufferDataEXT)(buffer, internalformat, format, type, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClearNamedBufferDataEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glClearNamedBufferSubDataEXT(GLuint buffer, GLenum internalformat, GLintptr offset, GLsizeiptr size, GLenum format, GLenum type, const GLvoid *data)
{
  Internal("error_glClearNamedBufferSubDataEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClearNamedBufferSubDataEXT)(buffer, internalformat, offset, size, format, type, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClearNamedBufferSubDataEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_clear_texture

static void REGAL_CALL error_glClearTexImage(GLuint texture, GLint level, GLenum format, GLenum type, const GLvoid *data)
{
  Internal("error_glClearTexImage","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClearTexImage)(texture, level, format, type, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClearTexImage : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glClearTexSubImage(GLuint texture, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const GLvoid *data)
{
  Internal("error_glClearTexSubImage","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClearTexSubImage)(texture, level, xoffset, yoffset, zoffset, width, height, depth, format, type, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClearTexSubImage : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_color_buffer_float

static void REGAL_CALL error_glClampColorARB(GLenum target, GLenum clamp)
{
  Internal("error_glClampColorARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClampColorARB)(target, clamp);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClampColorARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_compute_shader

static void REGAL_CALL error_glDispatchCompute(GLuint num_groups_x, GLuint num_groups_y, GLuint num_groups_z)
{
  Internal("error_glDispatchCompute","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDispatchCompute)(num_groups_x, num_groups_y, num_groups_z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDispatchCompute : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDispatchComputeIndirect(GLintptr indirect)
{
  Internal("error_glDispatchComputeIndirect","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDispatchComputeIndirect)(indirect);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDispatchComputeIndirect : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_compute_variable_group_size

static void REGAL_CALL error_glDispatchComputeGroupSizeARB(GLuint num_groups_x, GLuint num_groups_y, GLuint num_groups_z, GLuint group_size_x, GLuint group_size_y, GLuint group_size_z)
{
  Internal("error_glDispatchComputeGroupSizeARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDispatchComputeGroupSizeARB)(num_groups_x, num_groups_y, num_groups_z, group_size_x, group_size_y, group_size_z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDispatchComputeGroupSizeARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_copy_buffer

static void REGAL_CALL error_glCopyBufferSubData(GLenum readtarget, GLenum writetarget, GLintptr readoffset, GLintptr writeoffset, GLsizeiptr size)
{
  Internal("error_glCopyBufferSubData","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyBufferSubData)(readtarget, writetarget, readoffset, writeoffset, size);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyBufferSubData : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_copy_image

static void REGAL_CALL error_glCopyImageSubData(GLuint srcName, GLenum srcTarget, GLint srcLevel, GLint srcX, GLint srcY, GLint srcZ, GLuint dstName, GLenum dstTarget, GLint dstLevel, GLint dstX, GLint dstY, GLint dstZ, GLsizei srcWidth, GLsizei srcHeight, GLsizei srcDepth)
{
  Internal("error_glCopyImageSubData","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyImageSubData)(srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, srcWidth, srcHeight, srcDepth);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyImageSubData : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_debug_output

static void REGAL_CALL error_glDebugMessageCallbackARB(GLDEBUGPROCARB callback, const void *userParam)
{
  Internal("error_glDebugMessageCallbackARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDebugMessageCallbackARB)(callback, userParam);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDebugMessageCallbackARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDebugMessageControlARB(GLenum source, GLenum type, GLenum severity, GLsizei count, const GLuint *ids, GLboolean enabled)
{
  Internal("error_glDebugMessageControlARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDebugMessageControlARB)(source, type, severity, count, ids, enabled);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDebugMessageControlARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDebugMessageInsertARB(GLenum source, GLenum type, GLuint id, GLenum severity, GLsizei length, const GLchar *buf)
{
  Internal("error_glDebugMessageInsertARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDebugMessageInsertARB)(source, type, id, severity, length, buf);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDebugMessageInsertARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLuint REGAL_CALL error_glGetDebugMessageLogARB(GLuint count, GLsizei bufsize, GLenum *sources, GLenum *types, GLuint *ids, GLenum *severities, GLsizei *lengths, GLchar *messageLog)
{
  Internal("error_glGetDebugMessageLogARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint  ret = _next->call(&_next->glGetDebugMessageLogARB)(count, bufsize, sources, types, ids, severities, lengths, messageLog);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetDebugMessageLogARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

// GL_ARB_draw_buffers

static void REGAL_CALL error_glDrawBuffersARB(GLsizei n, const GLenum *bufs)
{
  Internal("error_glDrawBuffersARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawBuffersARB)(n, bufs);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawBuffersARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_draw_buffers_blend

static void REGAL_CALL error_glBlendEquationSeparateiARB(GLuint buf, GLenum modeRGB, GLenum modeAlpha)
{
  Internal("error_glBlendEquationSeparateiARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendEquationSeparateiARB)(buf, modeRGB, modeAlpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendEquationSeparateiARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBlendEquationiARB(GLuint buf, GLenum mode)
{
  Internal("error_glBlendEquationiARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendEquationiARB)(buf, mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendEquationiARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBlendFuncSeparateiARB(GLuint buf, GLenum srcRGB, GLenum dstRGB, GLenum srcAlpha, GLenum dstAlpha)
{
  Internal("error_glBlendFuncSeparateiARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendFuncSeparateiARB)(buf, srcRGB, dstRGB, srcAlpha, dstAlpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendFuncSeparateiARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBlendFunciARB(GLuint buf, GLenum src, GLenum dst)
{
  Internal("error_glBlendFunciARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendFunciARB)(buf, src, dst);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendFunciARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_draw_elements_base_vertex

static void REGAL_CALL error_glDrawElementsBaseVertex(GLenum mode, GLsizei count, GLenum type, const GLvoid *indices, GLint basevertex)
{
  Internal("error_glDrawElementsBaseVertex","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawElementsBaseVertex)(mode, count, type, indices, basevertex);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawElementsBaseVertex : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDrawElementsInstancedBaseVertex(GLenum mode, GLsizei count, GLenum type, const GLvoid *indices, GLsizei primcount, GLint basevertex)
{
  Internal("error_glDrawElementsInstancedBaseVertex","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawElementsInstancedBaseVertex)(mode, count, type, indices, primcount, basevertex);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawElementsInstancedBaseVertex : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDrawRangeElementsBaseVertex(GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const GLvoid *indices, GLint basevertex)
{
  Internal("error_glDrawRangeElementsBaseVertex","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawRangeElementsBaseVertex)(mode, start, end, count, type, indices, basevertex);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawRangeElementsBaseVertex : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiDrawElementsBaseVertex(GLenum mode, const GLsizei *count, GLenum type, const GLvoid * const *indices, GLsizei primcount, const GLint *basevertex)
{
  Internal("error_glMultiDrawElementsBaseVertex","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiDrawElementsBaseVertex)(mode, count, type, indices, primcount, basevertex);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiDrawElementsBaseVertex : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_draw_indirect

static void REGAL_CALL error_glDrawArraysIndirect(GLenum mode, const GLvoid *indirect)
{
  Internal("error_glDrawArraysIndirect","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawArraysIndirect)(mode, indirect);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawArraysIndirect : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDrawElementsIndirect(GLenum mode, GLenum type, const GLvoid *indirect)
{
  Internal("error_glDrawElementsIndirect","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawElementsIndirect)(mode, type, indirect);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawElementsIndirect : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_draw_instanced

static void REGAL_CALL error_glDrawArraysInstancedARB(GLenum mode, GLint start, GLsizei count, GLsizei primcount)
{
  Internal("error_glDrawArraysInstancedARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawArraysInstancedARB)(mode, start, count, primcount);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawArraysInstancedARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDrawElementsInstancedARB(GLenum mode, GLsizei count, GLenum type, const GLvoid *indices, GLsizei primcount)
{
  Internal("error_glDrawElementsInstancedARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawElementsInstancedARB)(mode, count, type, indices, primcount);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawElementsInstancedARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_framebuffer_no_attachments

static void REGAL_CALL error_glFramebufferParameteri(GLenum target, GLenum pname, GLint param)
{
  Internal("error_glFramebufferParameteri","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFramebufferParameteri)(target, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFramebufferParameteri : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetFramebufferParameteriv(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetFramebufferParameteriv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetFramebufferParameteriv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetFramebufferParameteriv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetNamedFramebufferParameterivEXT(GLuint framebuffer, GLenum pname, GLint *params)
{
  Internal("error_glGetNamedFramebufferParameterivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetNamedFramebufferParameterivEXT)(framebuffer, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetNamedFramebufferParameterivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedFramebufferParameteriEXT(GLuint framebuffer, GLenum pname, GLint param)
{
  Internal("error_glNamedFramebufferParameteriEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedFramebufferParameteriEXT)(framebuffer, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedFramebufferParameteriEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_framebuffer_object

static void REGAL_CALL error_glBindFramebuffer(GLenum target, GLuint framebuffer)
{
  Internal("error_glBindFramebuffer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindFramebuffer)(target, framebuffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindFramebuffer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBindRenderbuffer(GLenum target, GLuint renderbuffer)
{
  Internal("error_glBindRenderbuffer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindRenderbuffer)(target, renderbuffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindRenderbuffer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBlitFramebuffer(GLint srcX0, GLint srcY0, GLint srcX1, GLint srcY1, GLint dstX0, GLint dstY0, GLint dstX1, GLint dstY1, GLbitfield mask, GLenum filter)
{
  Internal("error_glBlitFramebuffer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlitFramebuffer)(srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlitFramebuffer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLenum REGAL_CALL error_glCheckFramebufferStatus(GLenum target)
{
  Internal("error_glCheckFramebufferStatus","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLenum  ret = _next->call(&_next->glCheckFramebufferStatus)(target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCheckFramebufferStatus : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glDeleteFramebuffers(GLsizei n, const GLuint *framebuffers)
{
  Internal("error_glDeleteFramebuffers","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteFramebuffers)(n, framebuffers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteFramebuffers : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteRenderbuffers(GLsizei n, const GLuint *renderbuffers)
{
  Internal("error_glDeleteRenderbuffers","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteRenderbuffers)(n, renderbuffers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteRenderbuffers : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFramebufferRenderbuffer(GLenum target, GLenum attachment, GLenum renderbuffertarget, GLuint renderbuffer)
{
  Internal("error_glFramebufferRenderbuffer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFramebufferRenderbuffer)(target, attachment, renderbuffertarget, renderbuffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFramebufferRenderbuffer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFramebufferTexture1D(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level)
{
  Internal("error_glFramebufferTexture1D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFramebufferTexture1D)(target, attachment, textarget, texture, level);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFramebufferTexture1D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFramebufferTexture2D(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level)
{
  Internal("error_glFramebufferTexture2D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFramebufferTexture2D)(target, attachment, textarget, texture, level);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFramebufferTexture2D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFramebufferTexture3D(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLint layer)
{
  Internal("error_glFramebufferTexture3D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFramebufferTexture3D)(target, attachment, textarget, texture, level, layer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFramebufferTexture3D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFramebufferTextureLayer(GLenum target, GLenum attachment, GLuint texture, GLint level, GLint layer)
{
  Internal("error_glFramebufferTextureLayer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFramebufferTextureLayer)(target, attachment, texture, level, layer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFramebufferTextureLayer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenFramebuffers(GLsizei n, GLuint *framebuffers)
{
  Internal("error_glGenFramebuffers","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenFramebuffers)(n, framebuffers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenFramebuffers : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenRenderbuffers(GLsizei n, GLuint *renderbuffers)
{
  Internal("error_glGenRenderbuffers","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenRenderbuffers)(n, renderbuffers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenRenderbuffers : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenerateMipmap(GLenum target)
{
  Internal("error_glGenerateMipmap","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenerateMipmap)(target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenerateMipmap : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetFramebufferAttachmentParameteriv(GLenum target, GLenum attachment, GLenum pname, GLint *params)
{
  Internal("error_glGetFramebufferAttachmentParameteriv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetFramebufferAttachmentParameteriv)(target, attachment, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetFramebufferAttachmentParameteriv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetRenderbufferParameteriv(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetRenderbufferParameteriv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetRenderbufferParameteriv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetRenderbufferParameteriv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsFramebuffer(GLuint framebuffer)
{
  Internal("error_glIsFramebuffer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsFramebuffer)(framebuffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsFramebuffer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLboolean REGAL_CALL error_glIsRenderbuffer(GLuint renderbuffer)
{
  Internal("error_glIsRenderbuffer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsRenderbuffer)(renderbuffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsRenderbuffer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glRenderbufferStorage(GLenum target, GLenum internalformat, GLsizei width, GLsizei height)
{
  Internal("error_glRenderbufferStorage","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRenderbufferStorage)(target, internalformat, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRenderbufferStorage : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRenderbufferStorageMultisample(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height)
{
  Internal("error_glRenderbufferStorageMultisample","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRenderbufferStorageMultisample)(target, samples, internalformat, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRenderbufferStorageMultisample : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_geometry_shader4

static void REGAL_CALL error_glFramebufferTextureARB(GLenum target, GLenum attachment, GLuint texture, GLint level)
{
  Internal("error_glFramebufferTextureARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFramebufferTextureARB)(target, attachment, texture, level);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFramebufferTextureARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFramebufferTextureFaceARB(GLenum target, GLenum attachment, GLuint texture, GLint level, GLenum face)
{
  Internal("error_glFramebufferTextureFaceARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFramebufferTextureFaceARB)(target, attachment, texture, level, face);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFramebufferTextureFaceARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFramebufferTextureLayerARB(GLenum target, GLenum attachment, GLuint texture, GLint level, GLint layer)
{
  Internal("error_glFramebufferTextureLayerARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFramebufferTextureLayerARB)(target, attachment, texture, level, layer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFramebufferTextureLayerARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramParameteriARB(GLuint program, GLenum pname, GLint value)
{
  Internal("error_glProgramParameteriARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramParameteriARB)(program, pname, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramParameteriARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_get_program_binary

static void REGAL_CALL error_glGetProgramBinary(GLuint program, GLsizei bufSize, GLsizei *length, GLenum *binaryFormat, GLvoid *binary)
{
  Internal("error_glGetProgramBinary","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramBinary)(program, bufSize, length, binaryFormat, binary);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramBinary : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramBinary(GLuint program, GLenum binaryFormat, const GLvoid *binary, GLsizei length)
{
  Internal("error_glProgramBinary","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramBinary)(program, binaryFormat, binary, length);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramBinary : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramParameteri(GLuint program, GLenum pname, GLint value)
{
  Internal("error_glProgramParameteri","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramParameteri)(program, pname, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramParameteri : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_gpu_shader_fp64

static void REGAL_CALL error_glGetUniformdv(GLuint program, GLint location, GLdouble *params)
{
  Internal("error_glGetUniformdv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetUniformdv)(program, location, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetUniformdv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform1d(GLint location, GLdouble x)
{
  Internal("error_glUniform1d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform1d)(location, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform1d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform1dv(GLint location, GLsizei count, const GLdouble *value)
{
  Internal("error_glUniform1dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform1dv)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform1dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform2d(GLint location, GLdouble x, GLdouble y)
{
  Internal("error_glUniform2d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform2d)(location, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform2d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform2dv(GLint location, GLsizei count, const GLdouble *value)
{
  Internal("error_glUniform2dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform2dv)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform2dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform3d(GLint location, GLdouble x, GLdouble y, GLdouble z)
{
  Internal("error_glUniform3d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform3d)(location, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform3d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform3dv(GLint location, GLsizei count, const GLdouble *value)
{
  Internal("error_glUniform3dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform3dv)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform3dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform4d(GLint location, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
  Internal("error_glUniform4d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform4d)(location, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform4d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform4dv(GLint location, GLsizei count, const GLdouble *value)
{
  Internal("error_glUniform4dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform4dv)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform4dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformMatrix2dv(GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glUniformMatrix2dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix2dv)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix2dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformMatrix2x3dv(GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glUniformMatrix2x3dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix2x3dv)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix2x3dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformMatrix2x4dv(GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glUniformMatrix2x4dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix2x4dv)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix2x4dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformMatrix3dv(GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glUniformMatrix3dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix3dv)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix3dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformMatrix3x2dv(GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glUniformMatrix3x2dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix3x2dv)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix3x2dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformMatrix3x4dv(GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glUniformMatrix3x4dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix3x4dv)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix3x4dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformMatrix4dv(GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glUniformMatrix4dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix4dv)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix4dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformMatrix4x2dv(GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glUniformMatrix4x2dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix4x2dv)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix4x2dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformMatrix4x3dv(GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glUniformMatrix4x3dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix4x3dv)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix4x3dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_imaging

static void REGAL_CALL error_glColorSubTable(GLenum target, GLsizei start, GLsizei count, GLenum format, GLenum type, const GLvoid *data)
{
  Internal("error_glColorSubTable","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColorSubTable)(target, start, count, format, type, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColorSubTable : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColorTable(GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const GLvoid *table)
{
  Internal("error_glColorTable","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColorTable)(target, internalformat, width, format, type, table);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColorTable : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColorTableParameterfv(GLenum target, GLenum pname, const GLfloat *params)
{
  Internal("error_glColorTableParameterfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColorTableParameterfv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColorTableParameterfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColorTableParameteriv(GLenum target, GLenum pname, const GLint *params)
{
  Internal("error_glColorTableParameteriv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColorTableParameteriv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColorTableParameteriv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glConvolutionFilter1D(GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const GLvoid *image)
{
  Internal("error_glConvolutionFilter1D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glConvolutionFilter1D)(target, internalformat, width, format, type, image);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glConvolutionFilter1D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glConvolutionFilter2D(GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *image)
{
  Internal("error_glConvolutionFilter2D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glConvolutionFilter2D)(target, internalformat, width, height, format, type, image);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glConvolutionFilter2D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glConvolutionParameterf(GLenum target, GLenum pname, GLfloat params)
{
  Internal("error_glConvolutionParameterf","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glConvolutionParameterf)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glConvolutionParameterf : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glConvolutionParameterfv(GLenum target, GLenum pname, const GLfloat *params)
{
  Internal("error_glConvolutionParameterfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glConvolutionParameterfv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glConvolutionParameterfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glConvolutionParameteri(GLenum target, GLenum pname, GLint params)
{
  Internal("error_glConvolutionParameteri","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glConvolutionParameteri)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glConvolutionParameteri : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glConvolutionParameteriv(GLenum target, GLenum pname, const GLint *params)
{
  Internal("error_glConvolutionParameteriv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glConvolutionParameteriv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glConvolutionParameteriv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyColorSubTable(GLenum target, GLsizei start, GLint x, GLint y, GLsizei width)
{
  Internal("error_glCopyColorSubTable","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyColorSubTable)(target, start, x, y, width);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyColorSubTable : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyColorTable(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width)
{
  Internal("error_glCopyColorTable","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyColorTable)(target, internalformat, x, y, width);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyColorTable : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyConvolutionFilter1D(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width)
{
  Internal("error_glCopyConvolutionFilter1D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyConvolutionFilter1D)(target, internalformat, x, y, width);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyConvolutionFilter1D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyConvolutionFilter2D(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height)
{
  Internal("error_glCopyConvolutionFilter2D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyConvolutionFilter2D)(target, internalformat, x, y, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyConvolutionFilter2D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetColorTable(GLenum target, GLenum format, GLenum type, GLvoid *table)
{
  Internal("error_glGetColorTable","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetColorTable)(target, format, type, table);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetColorTable : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetColorTableParameterfv(GLenum target, GLenum pname, GLfloat *params)
{
  Internal("error_glGetColorTableParameterfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetColorTableParameterfv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetColorTableParameterfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetColorTableParameteriv(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetColorTableParameteriv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetColorTableParameteriv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetColorTableParameteriv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetConvolutionFilter(GLenum target, GLenum format, GLenum type, GLvoid *image)
{
  Internal("error_glGetConvolutionFilter","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetConvolutionFilter)(target, format, type, image);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetConvolutionFilter : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetConvolutionParameterfv(GLenum target, GLenum pname, GLfloat *params)
{
  Internal("error_glGetConvolutionParameterfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetConvolutionParameterfv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetConvolutionParameterfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetConvolutionParameteriv(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetConvolutionParameteriv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetConvolutionParameteriv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetConvolutionParameteriv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetHistogram(GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid *values)
{
  Internal("error_glGetHistogram","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetHistogram)(target, reset, format, type, values);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetHistogram : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetHistogramParameterfv(GLenum target, GLenum pname, GLfloat *params)
{
  Internal("error_glGetHistogramParameterfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetHistogramParameterfv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetHistogramParameterfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetHistogramParameteriv(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetHistogramParameteriv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetHistogramParameteriv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetHistogramParameteriv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMinmax(GLenum target, GLboolean reset, GLenum format, GLenum types, GLvoid *values)
{
  Internal("error_glGetMinmax","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMinmax)(target, reset, format, types, values);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMinmax : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMinmaxParameterfv(GLenum target, GLenum pname, GLfloat *params)
{
  Internal("error_glGetMinmaxParameterfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMinmaxParameterfv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMinmaxParameterfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMinmaxParameteriv(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetMinmaxParameteriv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMinmaxParameteriv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMinmaxParameteriv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetSeparableFilter(GLenum target, GLenum format, GLenum type, GLvoid *row, GLvoid *column, GLvoid *span)
{
  Internal("error_glGetSeparableFilter","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetSeparableFilter)(target, format, type, row, column, span);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetSeparableFilter : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glHistogram(GLenum target, GLsizei width, GLenum internalformat, GLboolean sink)
{
  Internal("error_glHistogram","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glHistogram)(target, width, internalformat, sink);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glHistogram : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMinmax(GLenum target, GLenum internalformat, GLboolean sink)
{
  Internal("error_glMinmax","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMinmax)(target, internalformat, sink);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMinmax : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glResetHistogram(GLenum target)
{
  Internal("error_glResetHistogram","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glResetHistogram)(target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glResetHistogram : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glResetMinmax(GLenum target)
{
  Internal("error_glResetMinmax","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glResetMinmax)(target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glResetMinmax : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSeparableFilter2D(GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *row, const GLvoid *column)
{
  Internal("error_glSeparableFilter2D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSeparableFilter2D)(target, internalformat, width, height, format, type, row, column);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSeparableFilter2D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_indirect_parameters

static void REGAL_CALL error_glMultiDrawArraysIndirectCountARB(GLenum mode, const GLvoid *indirect, GLintptr drawcount, GLsizei maxdrawcount, GLsizei stride)
{
  Internal("error_glMultiDrawArraysIndirectCountARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiDrawArraysIndirectCountARB)(mode, indirect, drawcount, maxdrawcount, stride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiDrawArraysIndirectCountARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiDrawElementsIndirectCountARB(GLenum mode, GLenum type, const GLvoid *indirect, GLintptr drawcount, GLsizei maxdrawcount, GLsizei stride)
{
  Internal("error_glMultiDrawElementsIndirectCountARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiDrawElementsIndirectCountARB)(mode, type, indirect, drawcount, maxdrawcount, stride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiDrawElementsIndirectCountARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_instanced_arrays

static void REGAL_CALL error_glVertexAttribDivisorARB(GLuint index, GLuint divisor)
{
  Internal("error_glVertexAttribDivisorARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribDivisorARB)(index, divisor);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribDivisorARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_internalformat_query

static void REGAL_CALL error_glGetInternalformativ(GLenum target, GLenum internalformat, GLenum pname, GLsizei bufSize, GLint *params)
{
  Internal("error_glGetInternalformativ","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetInternalformativ)(target, internalformat, pname, bufSize, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetInternalformativ : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_internalformat_query2

static void REGAL_CALL error_glGetInternalformati64v(GLenum target, GLenum internalformat, GLenum pname, GLsizei bufSize, GLint64 *params)
{
  Internal("error_glGetInternalformati64v","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetInternalformati64v)(target, internalformat, pname, bufSize, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetInternalformati64v : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_invalidate_subdata

static void REGAL_CALL error_glInvalidateBufferData(GLuint buffer)
{
  Internal("error_glInvalidateBufferData","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glInvalidateBufferData)(buffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glInvalidateBufferData : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glInvalidateBufferSubData(GLuint buffer, GLintptr offset, GLsizeiptr length)
{
  Internal("error_glInvalidateBufferSubData","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glInvalidateBufferSubData)(buffer, offset, length);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glInvalidateBufferSubData : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glInvalidateFramebuffer(GLenum target, GLsizei numAttachments, const GLenum *attachments)
{
  Internal("error_glInvalidateFramebuffer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glInvalidateFramebuffer)(target, numAttachments, attachments);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glInvalidateFramebuffer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glInvalidateSubFramebuffer(GLenum target, GLsizei numAttachments, const GLenum *attachments, GLint x, GLint y, GLsizei width, GLsizei height)
{
  Internal("error_glInvalidateSubFramebuffer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glInvalidateSubFramebuffer)(target, numAttachments, attachments, x, y, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glInvalidateSubFramebuffer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glInvalidateTexImage(GLuint texture, GLint level)
{
  Internal("error_glInvalidateTexImage","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glInvalidateTexImage)(texture, level);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glInvalidateTexImage : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glInvalidateTexSubImage(GLuint texture, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth)
{
  Internal("error_glInvalidateTexSubImage","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glInvalidateTexSubImage)(texture, level, xoffset, yoffset, zoffset, width, height, depth);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glInvalidateTexSubImage : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_map_buffer_range

static void REGAL_CALL error_glFlushMappedBufferRange(GLenum target, GLintptr offset, GLsizeiptr length)
{
  Internal("error_glFlushMappedBufferRange","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFlushMappedBufferRange)(target, offset, length);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFlushMappedBufferRange : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLvoid *REGAL_CALL error_glMapBufferRange(GLenum target, GLintptr offset, GLsizeiptr length, GLbitfield access)
{
  Internal("error_glMapBufferRange","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLvoid * ret = _next->call(&_next->glMapBufferRange)(target, offset, length, access);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMapBufferRange : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

// GL_ARB_matrix_palette

static void REGAL_CALL error_glCurrentPaletteMatrixARB(GLint index)
{
  Internal("error_glCurrentPaletteMatrixARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCurrentPaletteMatrixARB)(index);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCurrentPaletteMatrixARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMatrixIndexPointerARB(GLint size, GLenum type, GLsizei stride, const GLvoid *pointer)
{
  Internal("error_glMatrixIndexPointerARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMatrixIndexPointerARB)(size, type, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMatrixIndexPointerARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMatrixIndexubvARB(GLint size, const GLubyte *indices)
{
  Internal("error_glMatrixIndexubvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMatrixIndexubvARB)(size, indices);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMatrixIndexubvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMatrixIndexuivARB(GLint size, const GLuint *indices)
{
  Internal("error_glMatrixIndexuivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMatrixIndexuivARB)(size, indices);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMatrixIndexuivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMatrixIndexusvARB(GLint size, const GLushort *indices)
{
  Internal("error_glMatrixIndexusvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMatrixIndexusvARB)(size, indices);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMatrixIndexusvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_multi_bind

static void REGAL_CALL error_glBindBuffersBase(GLenum target, GLuint first, GLsizei count, const GLuint *buffers)
{
  Internal("error_glBindBuffersBase","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindBuffersBase)(target, first, count, buffers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindBuffersBase : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBindBuffersRange(GLenum target, GLuint first, GLsizei count, const GLuint *buffers, const GLintptr *offsets, const GLsizeiptr *sizes)
{
  Internal("error_glBindBuffersRange","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindBuffersRange)(target, first, count, buffers, offsets, sizes);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindBuffersRange : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBindImageTextures(GLuint first, GLsizei count, const GLuint *textures)
{
  Internal("error_glBindImageTextures","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindImageTextures)(first, count, textures);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindImageTextures : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBindSamplers(GLuint first, GLsizei count, const GLuint *samplers)
{
  Internal("error_glBindSamplers","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindSamplers)(first, count, samplers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindSamplers : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBindTextures(GLuint first, GLsizei count, const GLuint *textures)
{
  Internal("error_glBindTextures","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindTextures)(first, count, textures);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindTextures : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBindVertexBuffers(GLuint first, GLsizei count, const GLuint *buffers, const GLintptr *offsets, const GLsizei *strides)
{
  Internal("error_glBindVertexBuffers","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindVertexBuffers)(first, count, buffers, offsets, strides);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindVertexBuffers : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_multi_draw_indirect

static void REGAL_CALL error_glMultiDrawArraysIndirect(GLenum mode, const GLvoid *indirect, GLsizei primcount, GLsizei stride)
{
  Internal("error_glMultiDrawArraysIndirect","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiDrawArraysIndirect)(mode, indirect, primcount, stride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiDrawArraysIndirect : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiDrawElementsIndirect(GLenum mode, GLenum type, const GLvoid *indirect, GLsizei primcount, GLsizei stride)
{
  Internal("error_glMultiDrawElementsIndirect","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiDrawElementsIndirect)(mode, type, indirect, primcount, stride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiDrawElementsIndirect : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_multisample

static void REGAL_CALL error_glSampleCoverageARB(GLclampf value, GLboolean invert)
{
  Internal("error_glSampleCoverageARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSampleCoverageARB)(value, invert);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSampleCoverageARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_multitexture

static void REGAL_CALL error_glActiveTextureARB(GLenum texture)
{
  Internal("error_glActiveTextureARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glActiveTextureARB)(texture);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glActiveTextureARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glClientActiveTextureARB(GLenum texture)
{
  Internal("error_glClientActiveTextureARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClientActiveTextureARB)(texture);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClientActiveTextureARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord1dARB(GLenum target, GLdouble s)
{
  Internal("error_glMultiTexCoord1dARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord1dARB)(target, s);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord1dARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord1dvARB(GLenum target, const GLdouble *v)
{
  Internal("error_glMultiTexCoord1dvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord1dvARB)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord1dvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord1fARB(GLenum target, GLfloat s)
{
  Internal("error_glMultiTexCoord1fARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord1fARB)(target, s);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord1fARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord1fvARB(GLenum target, const GLfloat *v)
{
  Internal("error_glMultiTexCoord1fvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord1fvARB)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord1fvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord1iARB(GLenum target, GLint s)
{
  Internal("error_glMultiTexCoord1iARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord1iARB)(target, s);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord1iARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord1ivARB(GLenum target, const GLint *v)
{
  Internal("error_glMultiTexCoord1ivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord1ivARB)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord1ivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord1sARB(GLenum target, GLshort s)
{
  Internal("error_glMultiTexCoord1sARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord1sARB)(target, s);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord1sARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord1svARB(GLenum target, const GLshort *v)
{
  Internal("error_glMultiTexCoord1svARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord1svARB)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord1svARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord2dARB(GLenum target, GLdouble s, GLdouble t)
{
  Internal("error_glMultiTexCoord2dARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord2dARB)(target, s, t);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord2dARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord2dvARB(GLenum target, const GLdouble *v)
{
  Internal("error_glMultiTexCoord2dvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord2dvARB)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord2dvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord2fARB(GLenum target, GLfloat s, GLfloat t)
{
  Internal("error_glMultiTexCoord2fARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord2fARB)(target, s, t);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord2fARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord2fvARB(GLenum target, const GLfloat *v)
{
  Internal("error_glMultiTexCoord2fvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord2fvARB)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord2fvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord2iARB(GLenum target, GLint s, GLint t)
{
  Internal("error_glMultiTexCoord2iARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord2iARB)(target, s, t);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord2iARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord2ivARB(GLenum target, const GLint *v)
{
  Internal("error_glMultiTexCoord2ivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord2ivARB)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord2ivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord2sARB(GLenum target, GLshort s, GLshort t)
{
  Internal("error_glMultiTexCoord2sARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord2sARB)(target, s, t);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord2sARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord2svARB(GLenum target, const GLshort *v)
{
  Internal("error_glMultiTexCoord2svARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord2svARB)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord2svARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord3dARB(GLenum target, GLdouble s, GLdouble t, GLdouble r)
{
  Internal("error_glMultiTexCoord3dARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord3dARB)(target, s, t, r);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord3dARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord3dvARB(GLenum target, const GLdouble *v)
{
  Internal("error_glMultiTexCoord3dvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord3dvARB)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord3dvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord3fARB(GLenum target, GLfloat s, GLfloat t, GLfloat r)
{
  Internal("error_glMultiTexCoord3fARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord3fARB)(target, s, t, r);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord3fARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord3fvARB(GLenum target, const GLfloat *v)
{
  Internal("error_glMultiTexCoord3fvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord3fvARB)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord3fvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord3iARB(GLenum target, GLint s, GLint t, GLint r)
{
  Internal("error_glMultiTexCoord3iARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord3iARB)(target, s, t, r);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord3iARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord3ivARB(GLenum target, const GLint *v)
{
  Internal("error_glMultiTexCoord3ivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord3ivARB)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord3ivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord3sARB(GLenum target, GLshort s, GLshort t, GLshort r)
{
  Internal("error_glMultiTexCoord3sARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord3sARB)(target, s, t, r);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord3sARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord3svARB(GLenum target, const GLshort *v)
{
  Internal("error_glMultiTexCoord3svARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord3svARB)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord3svARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord4dARB(GLenum target, GLdouble s, GLdouble t, GLdouble r, GLdouble q)
{
  Internal("error_glMultiTexCoord4dARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord4dARB)(target, s, t, r, q);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord4dARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord4dvARB(GLenum target, const GLdouble *v)
{
  Internal("error_glMultiTexCoord4dvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord4dvARB)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord4dvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord4fARB(GLenum target, GLfloat s, GLfloat t, GLfloat r, GLfloat q)
{
  Internal("error_glMultiTexCoord4fARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord4fARB)(target, s, t, r, q);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord4fARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord4fvARB(GLenum target, const GLfloat *v)
{
  Internal("error_glMultiTexCoord4fvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord4fvARB)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord4fvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord4iARB(GLenum target, GLint s, GLint t, GLint r, GLint q)
{
  Internal("error_glMultiTexCoord4iARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord4iARB)(target, s, t, r, q);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord4iARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord4ivARB(GLenum target, const GLint *v)
{
  Internal("error_glMultiTexCoord4ivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord4ivARB)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord4ivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord4sARB(GLenum target, GLshort s, GLshort t, GLshort r, GLshort q)
{
  Internal("error_glMultiTexCoord4sARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord4sARB)(target, s, t, r, q);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord4sARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord4svARB(GLenum target, const GLshort *v)
{
  Internal("error_glMultiTexCoord4svARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord4svARB)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord4svARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_occlusion_query

static void REGAL_CALL error_glBeginQueryARB(GLenum target, GLuint id)
{
  Internal("error_glBeginQueryARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBeginQueryARB)(target, id);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBeginQueryARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteQueriesARB(GLsizei n, const GLuint *ids)
{
  Internal("error_glDeleteQueriesARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteQueriesARB)(n, ids);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteQueriesARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEndQueryARB(GLenum target)
{
  Internal("error_glEndQueryARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEndQueryARB)(target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEndQueryARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenQueriesARB(GLsizei n, GLuint *ids)
{
  Internal("error_glGenQueriesARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenQueriesARB)(n, ids);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenQueriesARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetQueryObjectivARB(GLuint id, GLenum pname, GLint *params)
{
  Internal("error_glGetQueryObjectivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetQueryObjectivARB)(id, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetQueryObjectivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetQueryObjectuivARB(GLuint id, GLenum pname, GLuint *params)
{
  Internal("error_glGetQueryObjectuivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetQueryObjectuivARB)(id, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetQueryObjectuivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetQueryivARB(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetQueryivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetQueryivARB)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetQueryivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsQueryARB(GLuint id)
{
  Internal("error_glIsQueryARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsQueryARB)(id);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsQueryARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

// GL_ARB_point_parameters

static void REGAL_CALL error_glPointParameterfARB(GLenum pname, GLfloat param)
{
  Internal("error_glPointParameterfARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPointParameterfARB)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPointParameterfARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPointParameterfvARB(GLenum pname, const GLfloat *params)
{
  Internal("error_glPointParameterfvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPointParameterfvARB)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPointParameterfvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_program_interface_query

static void REGAL_CALL error_glGetProgramInterfaceiv(GLuint program, GLenum programInterface, GLenum pname, GLint *params)
{
  Internal("error_glGetProgramInterfaceiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramInterfaceiv)(program, programInterface, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramInterfaceiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLuint REGAL_CALL error_glGetProgramResourceIndex(GLuint program, GLenum programInterface, const GLchar *name)
{
  Internal("error_glGetProgramResourceIndex","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint  ret = _next->call(&_next->glGetProgramResourceIndex)(program, programInterface, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramResourceIndex : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLint REGAL_CALL error_glGetProgramResourceLocation(GLuint program, GLenum programInterface, const GLchar *name)
{
  Internal("error_glGetProgramResourceLocation","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLint  ret = _next->call(&_next->glGetProgramResourceLocation)(program, programInterface, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramResourceLocation : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLint REGAL_CALL error_glGetProgramResourceLocationIndex(GLuint program, GLenum programInterface, const GLchar *name)
{
  Internal("error_glGetProgramResourceLocationIndex","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLint  ret = _next->call(&_next->glGetProgramResourceLocationIndex)(program, programInterface, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramResourceLocationIndex : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glGetProgramResourceName(GLuint program, GLenum programInterface, GLuint index, GLsizei bufSize, GLsizei *length, GLchar *name)
{
  Internal("error_glGetProgramResourceName","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramResourceName)(program, programInterface, index, bufSize, length, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramResourceName : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetProgramResourceiv(GLuint program, GLenum programInterface, GLuint index, GLsizei propCount, const GLenum *props, GLsizei bufSize, GLsizei *length, GLint *params)
{
  Internal("error_glGetProgramResourceiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramResourceiv)(program, programInterface, index, propCount, props, bufSize, length, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramResourceiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_provoking_vertex

static void REGAL_CALL error_glProvokingVertex(GLenum mode)
{
  Internal("error_glProvokingVertex","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProvokingVertex)(mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProvokingVertex : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_robustness

static GLenum REGAL_CALL error_glGetGraphicsResetStatusARB(void)
{
  Internal("error_glGetGraphicsResetStatusARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLenum  ret = _next->call(&_next->glGetGraphicsResetStatusARB)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetGraphicsResetStatusARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glGetnColorTableARB(GLenum target, GLenum format, GLenum type, GLsizei bufSize, GLvoid *table)
{
  Internal("error_glGetnColorTableARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetnColorTableARB)(target, format, type, bufSize, table);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetnColorTableARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetnCompressedTexImageARB(GLenum target, GLint lod, GLsizei bufSize, GLvoid *img)
{
  Internal("error_glGetnCompressedTexImageARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetnCompressedTexImageARB)(target, lod, bufSize, img);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetnCompressedTexImageARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetnConvolutionFilterARB(GLenum target, GLenum format, GLenum type, GLsizei bufSize, GLvoid *image)
{
  Internal("error_glGetnConvolutionFilterARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetnConvolutionFilterARB)(target, format, type, bufSize, image);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetnConvolutionFilterARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetnHistogramARB(GLenum target, GLboolean reset, GLenum format, GLenum type, GLsizei bufSize, GLvoid *values)
{
  Internal("error_glGetnHistogramARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetnHistogramARB)(target, reset, format, type, bufSize, values);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetnHistogramARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetnMapdvARB(GLenum target, GLenum query, GLsizei bufSize, GLdouble *v)
{
  Internal("error_glGetnMapdvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetnMapdvARB)(target, query, bufSize, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetnMapdvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetnMapfvARB(GLenum target, GLenum query, GLsizei bufSize, GLfloat *v)
{
  Internal("error_glGetnMapfvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetnMapfvARB)(target, query, bufSize, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetnMapfvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetnMapivARB(GLenum target, GLenum query, GLsizei bufSize, GLint *v)
{
  Internal("error_glGetnMapivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetnMapivARB)(target, query, bufSize, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetnMapivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetnMinmaxARB(GLenum target, GLboolean reset, GLenum format, GLenum type, GLsizei bufSize, GLvoid *values)
{
  Internal("error_glGetnMinmaxARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetnMinmaxARB)(target, reset, format, type, bufSize, values);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetnMinmaxARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetnPixelMapfvARB(GLenum map, GLsizei bufSize, GLfloat *values)
{
  Internal("error_glGetnPixelMapfvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetnPixelMapfvARB)(map, bufSize, values);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetnPixelMapfvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetnPixelMapuivARB(GLenum map, GLsizei bufSize, GLuint *values)
{
  Internal("error_glGetnPixelMapuivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetnPixelMapuivARB)(map, bufSize, values);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetnPixelMapuivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetnPixelMapusvARB(GLenum map, GLsizei bufSize, GLushort *values)
{
  Internal("error_glGetnPixelMapusvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetnPixelMapusvARB)(map, bufSize, values);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetnPixelMapusvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetnPolygonStippleARB(GLsizei bufSize, GLubyte *pattern)
{
  Internal("error_glGetnPolygonStippleARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetnPolygonStippleARB)(bufSize, pattern);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetnPolygonStippleARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetnSeparableFilterARB(GLenum target, GLenum format, GLenum type, GLsizei rowBufSize, GLvoid *row, GLsizei columnBufSize, GLvoid *column, GLvoid *span)
{
  Internal("error_glGetnSeparableFilterARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetnSeparableFilterARB)(target, format, type, rowBufSize, row, columnBufSize, column, span);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetnSeparableFilterARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetnTexImageARB(GLenum target, GLint level, GLenum format, GLenum type, GLsizei bufSize, GLvoid *img)
{
  Internal("error_glGetnTexImageARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetnTexImageARB)(target, level, format, type, bufSize, img);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetnTexImageARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetnUniformdvARB(GLuint program, GLint location, GLsizei bufSize, GLdouble *params)
{
  Internal("error_glGetnUniformdvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetnUniformdvARB)(program, location, bufSize, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetnUniformdvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetnUniformfvARB(GLuint program, GLint location, GLsizei bufSize, GLfloat *params)
{
  Internal("error_glGetnUniformfvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetnUniformfvARB)(program, location, bufSize, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetnUniformfvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetnUniformivARB(GLuint program, GLint location, GLsizei bufSize, GLint *params)
{
  Internal("error_glGetnUniformivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetnUniformivARB)(program, location, bufSize, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetnUniformivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetnUniformuivARB(GLuint program, GLint location, GLsizei bufSize, GLuint *params)
{
  Internal("error_glGetnUniformuivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetnUniformuivARB)(program, location, bufSize, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetnUniformuivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReadnPixelsARB(GLint x, GLint y, GLsizei width, GLsizei height, GLenum format, GLenum type, GLsizei bufSize, GLvoid *data)
{
  Internal("error_glReadnPixelsARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReadnPixelsARB)(x, y, width, height, format, type, bufSize, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReadnPixelsARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_sample_shading

static void REGAL_CALL error_glMinSampleShading(GLclampf value)
{
  Internal("error_glMinSampleShading","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMinSampleShading)(value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMinSampleShading : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMinSampleShadingARB(GLclampf value)
{
  Internal("error_glMinSampleShadingARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMinSampleShadingARB)(value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMinSampleShadingARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_sampler_objects

static void REGAL_CALL error_glBindSampler(GLuint unit, GLuint sampler)
{
  Internal("error_glBindSampler","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindSampler)(unit, sampler);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindSampler : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteSamplers(GLsizei count, const GLuint *samplers)
{
  Internal("error_glDeleteSamplers","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteSamplers)(count, samplers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteSamplers : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenSamplers(GLsizei count, GLuint *samplers)
{
  Internal("error_glGenSamplers","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenSamplers)(count, samplers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenSamplers : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetSamplerParameterIiv(GLuint sampler, GLenum pname, GLint *params)
{
  Internal("error_glGetSamplerParameterIiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetSamplerParameterIiv)(sampler, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetSamplerParameterIiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetSamplerParameterIuiv(GLuint sampler, GLenum pname, GLuint *params)
{
  Internal("error_glGetSamplerParameterIuiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetSamplerParameterIuiv)(sampler, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetSamplerParameterIuiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetSamplerParameterfv(GLuint sampler, GLenum pname, GLfloat *params)
{
  Internal("error_glGetSamplerParameterfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetSamplerParameterfv)(sampler, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetSamplerParameterfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetSamplerParameteriv(GLuint sampler, GLenum pname, GLint *params)
{
  Internal("error_glGetSamplerParameteriv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetSamplerParameteriv)(sampler, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetSamplerParameteriv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsSampler(GLuint sampler)
{
  Internal("error_glIsSampler","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsSampler)(sampler);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsSampler : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glSamplerParameterIiv(GLuint sampler, GLenum pname, const GLint *params)
{
  Internal("error_glSamplerParameterIiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSamplerParameterIiv)(sampler, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSamplerParameterIiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSamplerParameterIuiv(GLuint sampler, GLenum pname, const GLuint *params)
{
  Internal("error_glSamplerParameterIuiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSamplerParameterIuiv)(sampler, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSamplerParameterIuiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSamplerParameterf(GLuint sampler, GLenum pname, GLfloat param)
{
  Internal("error_glSamplerParameterf","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSamplerParameterf)(sampler, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSamplerParameterf : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSamplerParameterfv(GLuint sampler, GLenum pname, const GLfloat *params)
{
  Internal("error_glSamplerParameterfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSamplerParameterfv)(sampler, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSamplerParameterfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSamplerParameteri(GLuint sampler, GLenum pname, GLint param)
{
  Internal("error_glSamplerParameteri","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSamplerParameteri)(sampler, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSamplerParameteri : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSamplerParameteriv(GLuint sampler, GLenum pname, const GLint *params)
{
  Internal("error_glSamplerParameteriv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSamplerParameteriv)(sampler, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSamplerParameteriv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_separate_shader_objects

static void REGAL_CALL error_glActiveShaderProgram(GLuint pipeline, GLuint program)
{
  Internal("error_glActiveShaderProgram","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glActiveShaderProgram)(pipeline, program);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glActiveShaderProgram : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBindProgramPipeline(GLuint pipeline)
{
  Internal("error_glBindProgramPipeline","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindProgramPipeline)(pipeline);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindProgramPipeline : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLuint REGAL_CALL error_glCreateShaderProgramv(GLenum type, GLsizei count, const GLchar * const *strings)
{
  Internal("error_glCreateShaderProgramv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint  ret = _next->call(&_next->glCreateShaderProgramv)(type, count, strings);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCreateShaderProgramv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glDeleteProgramPipelines(GLsizei n, const GLuint *pipelines)
{
  Internal("error_glDeleteProgramPipelines","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteProgramPipelines)(n, pipelines);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteProgramPipelines : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenProgramPipelines(GLsizei n, GLuint *pipelines)
{
  Internal("error_glGenProgramPipelines","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenProgramPipelines)(n, pipelines);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenProgramPipelines : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetProgramPipelineInfoLog(GLuint pipeline, GLsizei bufSize, GLsizei *length, GLchar *infoLog)
{
  Internal("error_glGetProgramPipelineInfoLog","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramPipelineInfoLog)(pipeline, bufSize, length, infoLog);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramPipelineInfoLog : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetProgramPipelineiv(GLuint pipeline, GLenum pname, GLint *params)
{
  Internal("error_glGetProgramPipelineiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramPipelineiv)(pipeline, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramPipelineiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsProgramPipeline(GLuint pipeline)
{
  Internal("error_glIsProgramPipeline","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsProgramPipeline)(pipeline);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsProgramPipeline : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glProgramUniform1d(GLuint program, GLint location, GLdouble x)
{
  Internal("error_glProgramUniform1d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform1d)(program, location, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform1d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform1dv(GLuint program, GLint location, GLsizei count, const GLdouble *value)
{
  Internal("error_glProgramUniform1dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform1dv)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform1dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform1f(GLuint program, GLint location, GLfloat x)
{
  Internal("error_glProgramUniform1f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform1f)(program, location, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform1f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform1fv(GLuint program, GLint location, GLsizei count, const GLfloat *value)
{
  Internal("error_glProgramUniform1fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform1fv)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform1fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform1i(GLuint program, GLint location, GLint x)
{
  Internal("error_glProgramUniform1i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform1i)(program, location, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform1i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform1iv(GLuint program, GLint location, GLsizei count, const GLint *value)
{
  Internal("error_glProgramUniform1iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform1iv)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform1iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform1ui(GLuint program, GLint location, GLuint v0)
{
  Internal("error_glProgramUniform1ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform1ui)(program, location, v0);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform1ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform1uiv(GLuint program, GLint location, GLsizei count, const GLuint *value)
{
  Internal("error_glProgramUniform1uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform1uiv)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform1uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform2d(GLuint program, GLint location, GLdouble x, GLdouble y)
{
  Internal("error_glProgramUniform2d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform2d)(program, location, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform2d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform2dv(GLuint program, GLint location, GLsizei count, const GLdouble *value)
{
  Internal("error_glProgramUniform2dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform2dv)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform2dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform2f(GLuint program, GLint location, GLfloat x, GLfloat y)
{
  Internal("error_glProgramUniform2f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform2f)(program, location, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform2f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform2fv(GLuint program, GLint location, GLsizei count, const GLfloat *value)
{
  Internal("error_glProgramUniform2fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform2fv)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform2fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform2i(GLuint program, GLint location, GLint x, GLint y)
{
  Internal("error_glProgramUniform2i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform2i)(program, location, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform2i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform2iv(GLuint program, GLint location, GLsizei count, const GLint *value)
{
  Internal("error_glProgramUniform2iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform2iv)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform2iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform2ui(GLuint program, GLint location, GLuint x, GLuint y)
{
  Internal("error_glProgramUniform2ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform2ui)(program, location, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform2ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform2uiv(GLuint program, GLint location, GLsizei count, const GLuint *value)
{
  Internal("error_glProgramUniform2uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform2uiv)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform2uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform3d(GLuint program, GLint location, GLdouble x, GLdouble y, GLdouble z)
{
  Internal("error_glProgramUniform3d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform3d)(program, location, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform3d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform3dv(GLuint program, GLint location, GLsizei count, const GLdouble *value)
{
  Internal("error_glProgramUniform3dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform3dv)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform3dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform3f(GLuint program, GLint location, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glProgramUniform3f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform3f)(program, location, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform3f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform3fv(GLuint program, GLint location, GLsizei count, const GLfloat *value)
{
  Internal("error_glProgramUniform3fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform3fv)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform3fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform3i(GLuint program, GLint location, GLint x, GLint y, GLint z)
{
  Internal("error_glProgramUniform3i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform3i)(program, location, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform3i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform3iv(GLuint program, GLint location, GLsizei count, const GLint *value)
{
  Internal("error_glProgramUniform3iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform3iv)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform3iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform3ui(GLuint program, GLint location, GLuint x, GLuint y, GLuint z)
{
  Internal("error_glProgramUniform3ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform3ui)(program, location, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform3ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform3uiv(GLuint program, GLint location, GLsizei count, const GLuint *value)
{
  Internal("error_glProgramUniform3uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform3uiv)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform3uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform4d(GLuint program, GLint location, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
  Internal("error_glProgramUniform4d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform4d)(program, location, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform4d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform4dv(GLuint program, GLint location, GLsizei count, const GLdouble *value)
{
  Internal("error_glProgramUniform4dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform4dv)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform4dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform4f(GLuint program, GLint location, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
  Internal("error_glProgramUniform4f","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform4f)(program, location, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform4f : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform4fv(GLuint program, GLint location, GLsizei count, const GLfloat *value)
{
  Internal("error_glProgramUniform4fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform4fv)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform4fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform4i(GLuint program, GLint location, GLint x, GLint y, GLint z, GLint w)
{
  Internal("error_glProgramUniform4i","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform4i)(program, location, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform4i : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform4iv(GLuint program, GLint location, GLsizei count, const GLint *value)
{
  Internal("error_glProgramUniform4iv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform4iv)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform4iv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform4ui(GLuint program, GLint location, GLuint x, GLuint y, GLuint z, GLuint w)
{
  Internal("error_glProgramUniform4ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform4ui)(program, location, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform4ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform4uiv(GLuint program, GLint location, GLsizei count, const GLuint *value)
{
  Internal("error_glProgramUniform4uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform4uiv)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform4uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix2dv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glProgramUniformMatrix2dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix2dv)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix2dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix2fv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glProgramUniformMatrix2fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix2fv)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix2fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix2x3dv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glProgramUniformMatrix2x3dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix2x3dv)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix2x3dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix2x3fv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glProgramUniformMatrix2x3fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix2x3fv)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix2x3fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix2x4dv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glProgramUniformMatrix2x4dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix2x4dv)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix2x4dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix2x4fv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glProgramUniformMatrix2x4fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix2x4fv)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix2x4fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix3dv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glProgramUniformMatrix3dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix3dv)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix3dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix3fv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glProgramUniformMatrix3fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix3fv)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix3fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix3x2dv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glProgramUniformMatrix3x2dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix3x2dv)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix3x2dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix3x2fv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glProgramUniformMatrix3x2fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix3x2fv)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix3x2fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix3x4dv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glProgramUniformMatrix3x4dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix3x4dv)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix3x4dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix3x4fv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glProgramUniformMatrix3x4fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix3x4fv)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix3x4fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix4dv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glProgramUniformMatrix4dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix4dv)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix4dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix4fv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glProgramUniformMatrix4fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix4fv)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix4fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix4x2dv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glProgramUniformMatrix4x2dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix4x2dv)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix4x2dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix4x2fv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glProgramUniformMatrix4x2fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix4x2fv)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix4x2fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix4x3dv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glProgramUniformMatrix4x3dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix4x3dv)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix4x3dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix4x3fv(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glProgramUniformMatrix4x3fv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix4x3fv)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix4x3fv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUseProgramStages(GLuint pipeline, GLbitfield stages, GLuint program)
{
  Internal("error_glUseProgramStages","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUseProgramStages)(pipeline, stages, program);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUseProgramStages : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glValidateProgramPipeline(GLuint pipeline)
{
  Internal("error_glValidateProgramPipeline","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glValidateProgramPipeline)(pipeline);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glValidateProgramPipeline : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_shader_atomic_counters

static void REGAL_CALL error_glGetActiveAtomicCounterBufferiv(GLuint program, GLuint bufferIndex, GLenum pname, GLint *params)
{
  Internal("error_glGetActiveAtomicCounterBufferiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetActiveAtomicCounterBufferiv)(program, bufferIndex, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetActiveAtomicCounterBufferiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_shader_image_load_store

static void REGAL_CALL error_glBindImageTexture(GLuint unit, GLuint texture, GLint level, GLboolean layered, GLint layer, GLenum access, GLenum format)
{
  Internal("error_glBindImageTexture","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindImageTexture)(unit, texture, level, layered, layer, access, format);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindImageTexture : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMemoryBarrier(GLbitfield barriers)
{
  Internal("error_glMemoryBarrier","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMemoryBarrier)(barriers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMemoryBarrier : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_shader_objects

static void REGAL_CALL error_glAttachObjectARB(GLhandleARB containerObj, GLhandleARB obj)
{
  Internal("error_glAttachObjectARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glAttachObjectARB)(containerObj, obj);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glAttachObjectARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompileShaderARB(GLhandleARB shaderObj)
{
  Internal("error_glCompileShaderARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompileShaderARB)(shaderObj);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompileShaderARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLhandleARB REGAL_CALL error_glCreateProgramObjectARB(void)
{
  Internal("error_glCreateProgramObjectARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLhandleARB  ret = _next->call(&_next->glCreateProgramObjectARB)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCreateProgramObjectARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLhandleARB REGAL_CALL error_glCreateShaderObjectARB(GLenum shaderType)
{
  Internal("error_glCreateShaderObjectARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLhandleARB  ret = _next->call(&_next->glCreateShaderObjectARB)(shaderType);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCreateShaderObjectARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glDeleteObjectARB(GLhandleARB obj)
{
  Internal("error_glDeleteObjectARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteObjectARB)(obj);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteObjectARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDetachObjectARB(GLhandleARB containerObj, GLhandleARB attachedObj)
{
  Internal("error_glDetachObjectARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDetachObjectARB)(containerObj, attachedObj);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDetachObjectARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetActiveUniformARB(GLhandleARB programObj, GLuint index, GLsizei maxLength, GLsizei *length, GLint *size, GLenum *type, GLcharARB *name)
{
  Internal("error_glGetActiveUniformARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetActiveUniformARB)(programObj, index, maxLength, length, size, type, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetActiveUniformARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetAttachedObjectsARB(GLhandleARB containerObj, GLsizei maxCount, GLsizei *count, GLhandleARB *obj)
{
  Internal("error_glGetAttachedObjectsARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetAttachedObjectsARB)(containerObj, maxCount, count, obj);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetAttachedObjectsARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLhandleARB REGAL_CALL error_glGetHandleARB(GLenum pname)
{
  Internal("error_glGetHandleARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLhandleARB  ret = _next->call(&_next->glGetHandleARB)(pname);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetHandleARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glGetInfoLogARB(GLhandleARB obj, GLsizei maxLength, GLsizei *length, GLcharARB *infoLog)
{
  Internal("error_glGetInfoLogARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetInfoLogARB)(obj, maxLength, length, infoLog);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetInfoLogARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetObjectParameterfvARB(GLhandleARB obj, GLenum pname, GLfloat *params)
{
  Internal("error_glGetObjectParameterfvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetObjectParameterfvARB)(obj, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetObjectParameterfvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetObjectParameterivARB(GLhandleARB obj, GLenum pname, GLint *params)
{
  Internal("error_glGetObjectParameterivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetObjectParameterivARB)(obj, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetObjectParameterivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetShaderSourceARB(GLhandleARB obj, GLsizei maxLength, GLsizei *length, GLcharARB *source)
{
  Internal("error_glGetShaderSourceARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetShaderSourceARB)(obj, maxLength, length, source);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetShaderSourceARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLint REGAL_CALL error_glGetUniformLocationARB(GLhandleARB programObj, const GLcharARB *name)
{
  Internal("error_glGetUniformLocationARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLint  ret = _next->call(&_next->glGetUniformLocationARB)(programObj, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetUniformLocationARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glGetUniformfvARB(GLhandleARB programObj, GLint location, GLfloat *params)
{
  Internal("error_glGetUniformfvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetUniformfvARB)(programObj, location, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetUniformfvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetUniformivARB(GLhandleARB programObj, GLint location, GLint *params)
{
  Internal("error_glGetUniformivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetUniformivARB)(programObj, location, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetUniformivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLinkProgramARB(GLhandleARB programObj)
{
  Internal("error_glLinkProgramARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLinkProgramARB)(programObj);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLinkProgramARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glShaderSourceARB(GLhandleARB shaderObj, GLsizei count, const GLcharARB ** const string, const GLint *length)
{
  Internal("error_glShaderSourceARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glShaderSourceARB)(shaderObj, count, string, length);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glShaderSourceARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform1fARB(GLint location, GLfloat v0)
{
  Internal("error_glUniform1fARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform1fARB)(location, v0);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform1fARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform1fvARB(GLint location, GLsizei count, const GLfloat *value)
{
  Internal("error_glUniform1fvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform1fvARB)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform1fvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform1iARB(GLint location, GLint v0)
{
  Internal("error_glUniform1iARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform1iARB)(location, v0);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform1iARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform1ivARB(GLint location, GLsizei count, const GLint *value)
{
  Internal("error_glUniform1ivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform1ivARB)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform1ivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform2fARB(GLint location, GLfloat v0, GLfloat v1)
{
  Internal("error_glUniform2fARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform2fARB)(location, v0, v1);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform2fARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform2fvARB(GLint location, GLsizei count, const GLfloat *value)
{
  Internal("error_glUniform2fvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform2fvARB)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform2fvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform2iARB(GLint location, GLint v0, GLint v1)
{
  Internal("error_glUniform2iARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform2iARB)(location, v0, v1);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform2iARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform2ivARB(GLint location, GLsizei count, const GLint *value)
{
  Internal("error_glUniform2ivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform2ivARB)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform2ivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform3fARB(GLint location, GLfloat v0, GLfloat v1, GLfloat v2)
{
  Internal("error_glUniform3fARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform3fARB)(location, v0, v1, v2);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform3fARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform3fvARB(GLint location, GLsizei count, const GLfloat *value)
{
  Internal("error_glUniform3fvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform3fvARB)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform3fvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform3iARB(GLint location, GLint v0, GLint v1, GLint v2)
{
  Internal("error_glUniform3iARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform3iARB)(location, v0, v1, v2);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform3iARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform3ivARB(GLint location, GLsizei count, const GLint *value)
{
  Internal("error_glUniform3ivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform3ivARB)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform3ivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform4fARB(GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3)
{
  Internal("error_glUniform4fARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform4fARB)(location, v0, v1, v2, v3);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform4fARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform4fvARB(GLint location, GLsizei count, const GLfloat *value)
{
  Internal("error_glUniform4fvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform4fvARB)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform4fvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform4iARB(GLint location, GLint v0, GLint v1, GLint v2, GLint v3)
{
  Internal("error_glUniform4iARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform4iARB)(location, v0, v1, v2, v3);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform4iARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform4ivARB(GLint location, GLsizei count, const GLint *value)
{
  Internal("error_glUniform4ivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform4ivARB)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform4ivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformMatrix2fvARB(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glUniformMatrix2fvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix2fvARB)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix2fvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformMatrix3fvARB(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glUniformMatrix3fvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix3fvARB)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix3fvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformMatrix4fvARB(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glUniformMatrix4fvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix4fvARB)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix4fvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUseProgramObjectARB(GLhandleARB programObj)
{
  Internal("error_glUseProgramObjectARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUseProgramObjectARB)(programObj);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUseProgramObjectARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glValidateProgramARB(GLhandleARB programObj)
{
  Internal("error_glValidateProgramARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glValidateProgramARB)(programObj);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glValidateProgramARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_shader_storage_buffer_object

static void REGAL_CALL error_glShaderStorageBlockBinding(GLuint program, GLuint storageBlockIndex, GLuint storageBlockBinding)
{
  Internal("error_glShaderStorageBlockBinding","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glShaderStorageBlockBinding)(program, storageBlockIndex, storageBlockBinding);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glShaderStorageBlockBinding : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_shader_subroutine

static void REGAL_CALL error_glGetActiveSubroutineName(GLuint program, GLenum shaderType, GLuint index, GLsizei bufSize, GLsizei *length, GLchar *name)
{
  Internal("error_glGetActiveSubroutineName","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetActiveSubroutineName)(program, shaderType, index, bufSize, length, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetActiveSubroutineName : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetActiveSubroutineUniformName(GLuint program, GLenum shaderType, GLuint index, GLsizei bufSize, GLsizei *length, GLchar *name)
{
  Internal("error_glGetActiveSubroutineUniformName","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetActiveSubroutineUniformName)(program, shaderType, index, bufSize, length, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetActiveSubroutineUniformName : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetActiveSubroutineUniformiv(GLuint program, GLenum shaderType, GLuint index, GLenum pname, GLint *values)
{
  Internal("error_glGetActiveSubroutineUniformiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetActiveSubroutineUniformiv)(program, shaderType, index, pname, values);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetActiveSubroutineUniformiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetProgramStageiv(GLuint program, GLenum shaderType, GLenum pname, GLint *values)
{
  Internal("error_glGetProgramStageiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramStageiv)(program, shaderType, pname, values);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramStageiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetProgramSubroutineParameteruivNV(GLenum target, GLuint index, GLuint *params)
{
  Internal("error_glGetProgramSubroutineParameteruivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramSubroutineParameteruivNV)(target, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramSubroutineParameteruivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLuint REGAL_CALL error_glGetSubroutineIndex(GLuint program, GLenum shaderType, const GLchar *name)
{
  Internal("error_glGetSubroutineIndex","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint  ret = _next->call(&_next->glGetSubroutineIndex)(program, shaderType, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetSubroutineIndex : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLint REGAL_CALL error_glGetSubroutineUniformLocation(GLuint program, GLenum shaderType, const GLchar *name)
{
  Internal("error_glGetSubroutineUniformLocation","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLint  ret = _next->call(&_next->glGetSubroutineUniformLocation)(program, shaderType, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetSubroutineUniformLocation : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glGetUniformSubroutineuiv(GLenum shaderType, GLint location, GLuint *params)
{
  Internal("error_glGetUniformSubroutineuiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetUniformSubroutineuiv)(shaderType, location, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetUniformSubroutineuiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramSubroutineParametersuivNV(GLenum target, GLsizei count, const GLuint *params)
{
  Internal("error_glProgramSubroutineParametersuivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramSubroutineParametersuivNV)(target, count, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramSubroutineParametersuivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformSubroutinesuiv(GLenum shaderType, GLsizei count, const GLuint *indices)
{
  Internal("error_glUniformSubroutinesuiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformSubroutinesuiv)(shaderType, count, indices);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformSubroutinesuiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_shading_language_include

static void REGAL_CALL error_glCompileShaderIncludeARB(GLuint shader, GLsizei count, const GLchar * const *path, const GLint *length)
{
  Internal("error_glCompileShaderIncludeARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompileShaderIncludeARB)(shader, count, path, length);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompileShaderIncludeARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteNamedStringARB(GLint namelen, const GLchar *name)
{
  Internal("error_glDeleteNamedStringARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteNamedStringARB)(namelen, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteNamedStringARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetNamedStringARB(GLint namelen, const GLchar *name, GLsizei bufSize, GLint *stringlen, GLchar *string)
{
  Internal("error_glGetNamedStringARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetNamedStringARB)(namelen, name, bufSize, stringlen, string);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetNamedStringARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetNamedStringivARB(GLint namelen, const GLchar *name, GLenum pname, GLint *params)
{
  Internal("error_glGetNamedStringivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetNamedStringivARB)(namelen, name, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetNamedStringivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsNamedStringARB(GLint namelen, const GLchar *name)
{
  Internal("error_glIsNamedStringARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsNamedStringARB)(namelen, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsNamedStringARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glNamedStringARB(GLenum type, GLint namelen, const GLchar *name, GLint stringlen, const GLchar *string)
{
  Internal("error_glNamedStringARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedStringARB)(type, namelen, name, stringlen, string);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedStringARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_sparse_texture

static void REGAL_CALL error_glTexPageCommitmentARB(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLboolean commit)
{
  Internal("error_glTexPageCommitmentARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexPageCommitmentARB)(target, level, xoffset, yoffset, zoffset, width, height, depth, commit);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexPageCommitmentARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexturePageCommitmentEXT(GLuint texture, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLboolean commit)
{
  Internal("error_glTexturePageCommitmentEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexturePageCommitmentEXT)(texture, target, level, xoffset, yoffset, zoffset, width, height, depth, commit);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexturePageCommitmentEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_sync

static GLenum REGAL_CALL error_glClientWaitSync(GLsync sync, GLbitfield flags, GLuint64 timeout)
{
  Internal("error_glClientWaitSync","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLenum  ret = _next->call(&_next->glClientWaitSync)(sync, flags, timeout);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClientWaitSync : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glDeleteSync(GLsync sync)
{
  Internal("error_glDeleteSync","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteSync)(sync);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteSync : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLsync REGAL_CALL error_glFenceSync(GLenum condition, GLbitfield flags)
{
  Internal("error_glFenceSync","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLsync  ret = _next->call(&_next->glFenceSync)(condition, flags);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFenceSync : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glGetInteger64v(GLenum pname, GLint64 *params)
{
  Internal("error_glGetInteger64v","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetInteger64v)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetInteger64v : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetSynciv(GLsync sync, GLenum pname, GLsizei bufSize, GLsizei *length, GLint *values)
{
  Internal("error_glGetSynciv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetSynciv)(sync, pname, bufSize, length, values);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetSynciv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsSync(GLsync sync)
{
  Internal("error_glIsSync","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsSync)(sync);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsSync : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glWaitSync(GLsync sync, GLbitfield flags, GLuint64 timeout)
{
  Internal("error_glWaitSync","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWaitSync)(sync, flags, timeout);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWaitSync : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_tessellation_shader

static void REGAL_CALL error_glPatchParameterfv(GLenum pname, const GLfloat *values)
{
  Internal("error_glPatchParameterfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPatchParameterfv)(pname, values);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPatchParameterfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPatchParameteri(GLenum pname, GLint value)
{
  Internal("error_glPatchParameteri","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPatchParameteri)(pname, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPatchParameteri : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_texture_buffer_object

static void REGAL_CALL error_glTexBufferARB(GLenum target, GLenum internalformat, GLuint buffer)
{
  Internal("error_glTexBufferARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexBufferARB)(target, internalformat, buffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexBufferARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_texture_buffer_range

static void REGAL_CALL error_glTexBufferRange(GLenum target, GLenum internalformat, GLuint buffer, GLintptr offset, GLsizeiptr size)
{
  Internal("error_glTexBufferRange","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexBufferRange)(target, internalformat, buffer, offset, size);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexBufferRange : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureBufferRangeEXT(GLuint texture, GLenum target, GLenum internalformat, GLuint buffer, GLintptr offset, GLsizeiptr size)
{
  Internal("error_glTextureBufferRangeEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureBufferRangeEXT)(texture, target, internalformat, buffer, offset, size);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureBufferRangeEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_texture_compression

static void REGAL_CALL error_glCompressedTexImage1DARB(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLint border, GLsizei imageSize, const GLvoid *data)
{
  Internal("error_glCompressedTexImage1DARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedTexImage1DARB)(target, level, internalformat, width, border, imageSize, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedTexImage1DARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompressedTexImage2DARB(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const GLvoid *data)
{
  Internal("error_glCompressedTexImage2DARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedTexImage2DARB)(target, level, internalformat, width, height, border, imageSize, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedTexImage2DARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompressedTexImage3DARB(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const GLvoid *data)
{
  Internal("error_glCompressedTexImage3DARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedTexImage3DARB)(target, level, internalformat, width, height, depth, border, imageSize, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedTexImage3DARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompressedTexSubImage1DARB(GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLsizei imageSize, const GLvoid *data)
{
  Internal("error_glCompressedTexSubImage1DARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedTexSubImage1DARB)(target, level, xoffset, width, format, imageSize, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedTexSubImage1DARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompressedTexSubImage2DARB(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const GLvoid *data)
{
  Internal("error_glCompressedTexSubImage2DARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedTexSubImage2DARB)(target, level, xoffset, yoffset, width, height, format, imageSize, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedTexSubImage2DARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompressedTexSubImage3DARB(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const GLvoid *data)
{
  Internal("error_glCompressedTexSubImage3DARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedTexSubImage3DARB)(target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedTexSubImage3DARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetCompressedTexImageARB(GLenum target, GLint lod, GLvoid *img)
{
  Internal("error_glGetCompressedTexImageARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetCompressedTexImageARB)(target, lod, img);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetCompressedTexImageARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_texture_multisample

static void REGAL_CALL error_glGetMultisamplefv(GLenum pname, GLuint index, GLfloat *val)
{
  Internal("error_glGetMultisamplefv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMultisamplefv)(pname, index, val);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMultisamplefv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSampleMaski(GLuint index, GLbitfield mask)
{
  Internal("error_glSampleMaski","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSampleMaski)(index, mask);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSampleMaski : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexImage2DMultisample(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height, GLboolean fixedsamplelocations)
{
  Internal("error_glTexImage2DMultisample","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexImage2DMultisample)(target, samples, internalformat, width, height, fixedsamplelocations);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexImage2DMultisample : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexImage3DMultisample(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLboolean fixedsamplelocations)
{
  Internal("error_glTexImage3DMultisample","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexImage3DMultisample)(target, samples, internalformat, width, height, depth, fixedsamplelocations);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexImage3DMultisample : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_texture_storage

static void REGAL_CALL error_glTexStorage1D(GLenum target, GLsizei levels, GLenum internalformat, GLsizei width)
{
  Internal("error_glTexStorage1D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexStorage1D)(target, levels, internalformat, width);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexStorage1D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexStorage2D(GLenum target, GLsizei levels, GLenum internalformat, GLsizei width, GLsizei height)
{
  Internal("error_glTexStorage2D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexStorage2D)(target, levels, internalformat, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexStorage2D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexStorage3D(GLenum target, GLsizei levels, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth)
{
  Internal("error_glTexStorage3D","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexStorage3D)(target, levels, internalformat, width, height, depth);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexStorage3D : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureStorage1DEXT(GLuint texture, GLenum target, GLsizei levels, GLenum internalformat, GLsizei width)
{
  Internal("error_glTextureStorage1DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureStorage1DEXT)(texture, target, levels, internalformat, width);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureStorage1DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureStorage2DEXT(GLuint texture, GLenum target, GLsizei levels, GLenum internalformat, GLsizei width, GLsizei height)
{
  Internal("error_glTextureStorage2DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureStorage2DEXT)(texture, target, levels, internalformat, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureStorage2DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureStorage3DEXT(GLuint texture, GLenum target, GLsizei levels, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth)
{
  Internal("error_glTextureStorage3DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureStorage3DEXT)(texture, target, levels, internalformat, width, height, depth);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureStorage3DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_texture_storage_multisample

static void REGAL_CALL error_glTexStorage2DMultisample(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height, GLboolean fixedsamplelocations)
{
  Internal("error_glTexStorage2DMultisample","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexStorage2DMultisample)(target, samples, internalformat, width, height, fixedsamplelocations);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexStorage2DMultisample : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexStorage3DMultisample(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLboolean fixedsamplelocations)
{
  Internal("error_glTexStorage3DMultisample","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexStorage3DMultisample)(target, samples, internalformat, width, height, depth, fixedsamplelocations);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexStorage3DMultisample : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureStorage2DMultisampleEXT(GLuint texture, GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height, GLboolean fixedsamplelocations)
{
  Internal("error_glTextureStorage2DMultisampleEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureStorage2DMultisampleEXT)(texture, target, samples, internalformat, width, height, fixedsamplelocations);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureStorage2DMultisampleEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureStorage3DMultisampleEXT(GLuint texture, GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLboolean fixedsamplelocations)
{
  Internal("error_glTextureStorage3DMultisampleEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureStorage3DMultisampleEXT)(texture, target, samples, internalformat, width, height, depth, fixedsamplelocations);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureStorage3DMultisampleEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_texture_view

static void REGAL_CALL error_glTextureView(GLuint texture, GLenum target, GLuint origtexture, GLenum internalformat, GLuint minlevel, GLuint numlevels, GLuint minlayer, GLuint numlayers)
{
  Internal("error_glTextureView","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureView)(texture, target, origtexture, internalformat, minlevel, numlevels, minlayer, numlayers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureView : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_timer_query

static void REGAL_CALL error_glGetQueryObjecti64v(GLuint id, GLenum pname, GLint64 *params)
{
  Internal("error_glGetQueryObjecti64v","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetQueryObjecti64v)(id, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetQueryObjecti64v : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetQueryObjectui64v(GLuint id, GLenum pname, GLuint64 *params)
{
  Internal("error_glGetQueryObjectui64v","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetQueryObjectui64v)(id, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetQueryObjectui64v : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glQueryCounter(GLuint id, GLenum target)
{
  Internal("error_glQueryCounter","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glQueryCounter)(id, target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glQueryCounter : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_transform_feedback2

static void REGAL_CALL error_glBindTransformFeedback(GLenum target, GLuint id)
{
  Internal("error_glBindTransformFeedback","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindTransformFeedback)(target, id);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindTransformFeedback : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteTransformFeedbacks(GLsizei n, const GLuint *ids)
{
  Internal("error_glDeleteTransformFeedbacks","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteTransformFeedbacks)(n, ids);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteTransformFeedbacks : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDrawTransformFeedback(GLenum mode, GLuint name)
{
  Internal("error_glDrawTransformFeedback","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawTransformFeedback)(mode, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawTransformFeedback : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenTransformFeedbacks(GLsizei n, GLuint *ids)
{
  Internal("error_glGenTransformFeedbacks","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenTransformFeedbacks)(n, ids);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenTransformFeedbacks : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsTransformFeedback(GLuint id)
{
  Internal("error_glIsTransformFeedback","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsTransformFeedback)(id);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsTransformFeedback : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glPauseTransformFeedback(void)
{
  Internal("error_glPauseTransformFeedback","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPauseTransformFeedback)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPauseTransformFeedback : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glResumeTransformFeedback(void)
{
  Internal("error_glResumeTransformFeedback","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glResumeTransformFeedback)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glResumeTransformFeedback : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_transform_feedback3

static void REGAL_CALL error_glBeginQueryIndexed(GLenum target, GLuint index, GLuint id)
{
  Internal("error_glBeginQueryIndexed","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBeginQueryIndexed)(target, index, id);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBeginQueryIndexed : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDrawTransformFeedbackStream(GLenum mode, GLuint id, GLuint stream)
{
  Internal("error_glDrawTransformFeedbackStream","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawTransformFeedbackStream)(mode, id, stream);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawTransformFeedbackStream : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEndQueryIndexed(GLenum target, GLuint index)
{
  Internal("error_glEndQueryIndexed","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEndQueryIndexed)(target, index);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEndQueryIndexed : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetQueryIndexediv(GLenum target, GLuint index, GLenum pname, GLint *params)
{
  Internal("error_glGetQueryIndexediv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetQueryIndexediv)(target, index, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetQueryIndexediv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_transform_feedback_instanced

static void REGAL_CALL error_glDrawTransformFeedbackInstanced(GLenum mode, GLuint id, GLsizei primcount)
{
  Internal("error_glDrawTransformFeedbackInstanced","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawTransformFeedbackInstanced)(mode, id, primcount);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawTransformFeedbackInstanced : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDrawTransformFeedbackStreamInstanced(GLenum mode, GLuint id, GLuint stream, GLsizei primcount)
{
  Internal("error_glDrawTransformFeedbackStreamInstanced","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawTransformFeedbackStreamInstanced)(mode, id, stream, primcount);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawTransformFeedbackStreamInstanced : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_transpose_matrix

static void REGAL_CALL error_glLoadTransposeMatrixdARB(const GLdouble *m)
{
  Internal("error_glLoadTransposeMatrixdARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLoadTransposeMatrixdARB)(m);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLoadTransposeMatrixdARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLoadTransposeMatrixfARB(const GLfloat *m)
{
  Internal("error_glLoadTransposeMatrixfARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLoadTransposeMatrixfARB)(m);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLoadTransposeMatrixfARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultTransposeMatrixdARB(const GLdouble *m)
{
  Internal("error_glMultTransposeMatrixdARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultTransposeMatrixdARB)(m);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultTransposeMatrixdARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultTransposeMatrixfARB(const GLfloat *m)
{
  Internal("error_glMultTransposeMatrixfARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultTransposeMatrixfARB)(m);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultTransposeMatrixfARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_uniform_buffer_object

static void REGAL_CALL error_glBindBufferBase(GLenum target, GLuint index, GLuint buffer)
{
  Internal("error_glBindBufferBase","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindBufferBase)(target, index, buffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindBufferBase : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBindBufferRange(GLenum target, GLuint index, GLuint buffer, GLintptr offset, GLsizeiptr size)
{
  Internal("error_glBindBufferRange","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindBufferRange)(target, index, buffer, offset, size);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindBufferRange : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetActiveUniformBlockName(GLuint program, GLuint uniformBlockIndex, GLsizei bufSize, GLsizei *length, GLchar *uniformBlockName)
{
  Internal("error_glGetActiveUniformBlockName","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetActiveUniformBlockName)(program, uniformBlockIndex, bufSize, length, uniformBlockName);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetActiveUniformBlockName : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetActiveUniformBlockiv(GLuint program, GLuint uniformBlockIndex, GLenum pname, GLint *params)
{
  Internal("error_glGetActiveUniformBlockiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetActiveUniformBlockiv)(program, uniformBlockIndex, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetActiveUniformBlockiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetActiveUniformName(GLuint program, GLuint uniformIndex, GLsizei bufSize, GLsizei *length, GLchar *uniformName)
{
  Internal("error_glGetActiveUniformName","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetActiveUniformName)(program, uniformIndex, bufSize, length, uniformName);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetActiveUniformName : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetActiveUniformsiv(GLuint program, GLsizei uniformCount, const GLuint *uniformIndices, GLenum pname, GLint *params)
{
  Internal("error_glGetActiveUniformsiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetActiveUniformsiv)(program, uniformCount, uniformIndices, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetActiveUniformsiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetIntegeri_v(GLenum target, GLuint index, GLint *data)
{
  Internal("error_glGetIntegeri_v","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetIntegeri_v)(target, index, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetIntegeri_v : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLuint REGAL_CALL error_glGetUniformBlockIndex(GLuint program, const GLchar *uniformBlockName)
{
  Internal("error_glGetUniformBlockIndex","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint  ret = _next->call(&_next->glGetUniformBlockIndex)(program, uniformBlockName);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetUniformBlockIndex : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glGetUniformIndices(GLuint program, GLsizei uniformCount, const GLchar * const *uniformNames, GLuint *uniformIndices)
{
  Internal("error_glGetUniformIndices","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetUniformIndices)(program, uniformCount, uniformNames, uniformIndices);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetUniformIndices : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformBlockBinding(GLuint program, GLuint uniformBlockIndex, GLuint uniformBlockBinding)
{
  Internal("error_glUniformBlockBinding","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformBlockBinding)(program, uniformBlockIndex, uniformBlockBinding);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformBlockBinding : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_vertex_array_object

static void REGAL_CALL error_glBindVertexArray(GLuint array)
{
  Internal("error_glBindVertexArray","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindVertexArray)(array);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindVertexArray : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteVertexArrays(GLsizei n, const GLuint *arrays)
{
  Internal("error_glDeleteVertexArrays","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteVertexArrays)(n, arrays);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteVertexArrays : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenVertexArrays(GLsizei n, GLuint *arrays)
{
  Internal("error_glGenVertexArrays","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenVertexArrays)(n, arrays);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenVertexArrays : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsVertexArray(GLuint array)
{
  Internal("error_glIsVertexArray","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsVertexArray)(array);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsVertexArray : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

// GL_ARB_vertex_attrib_64bit

static void REGAL_CALL error_glGetVertexAttribLdv(GLuint index, GLenum pname, GLdouble *params)
{
  Internal("error_glGetVertexAttribLdv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexAttribLdv)(index, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexAttribLdv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL1d(GLuint index, GLdouble x)
{
  Internal("error_glVertexAttribL1d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL1d)(index, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL1d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL1dv(GLuint index, const GLdouble *v)
{
  Internal("error_glVertexAttribL1dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL1dv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL1dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL2d(GLuint index, GLdouble x, GLdouble y)
{
  Internal("error_glVertexAttribL2d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL2d)(index, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL2d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL2dv(GLuint index, const GLdouble *v)
{
  Internal("error_glVertexAttribL2dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL2dv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL2dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL3d(GLuint index, GLdouble x, GLdouble y, GLdouble z)
{
  Internal("error_glVertexAttribL3d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL3d)(index, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL3d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL3dv(GLuint index, const GLdouble *v)
{
  Internal("error_glVertexAttribL3dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL3dv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL3dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL4d(GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
  Internal("error_glVertexAttribL4d","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL4d)(index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL4d : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL4dv(GLuint index, const GLdouble *v)
{
  Internal("error_glVertexAttribL4dv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL4dv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL4dv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribLPointer(GLuint index, GLint size, GLenum type, GLsizei stride, const GLvoid *pointer)
{
  Internal("error_glVertexAttribLPointer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribLPointer)(index, size, type, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribLPointer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_vertex_attrib_binding

static void REGAL_CALL error_glBindVertexBuffer(GLuint bindingindex, GLuint buffer, GLintptr offset, GLsizei stride)
{
  Internal("error_glBindVertexBuffer","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindVertexBuffer)(bindingindex, buffer, offset, stride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindVertexBuffer : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexArrayBindVertexBufferEXT(GLuint vaobj, GLuint bindingindex, GLuint buffer, GLintptr offset, GLsizei stride)
{
  Internal("error_glVertexArrayBindVertexBufferEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexArrayBindVertexBufferEXT)(vaobj, bindingindex, buffer, offset, stride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexArrayBindVertexBufferEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexArrayVertexAttribBindingEXT(GLuint vaobj, GLuint attribindex, GLuint bindingindex)
{
  Internal("error_glVertexArrayVertexAttribBindingEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexArrayVertexAttribBindingEXT)(vaobj, attribindex, bindingindex);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexArrayVertexAttribBindingEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexArrayVertexAttribFormatEXT(GLuint vaobj, GLuint attribindex, GLint size, GLenum type, GLboolean normalized, GLuint relativeoffset)
{
  Internal("error_glVertexArrayVertexAttribFormatEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexArrayVertexAttribFormatEXT)(vaobj, attribindex, size, type, normalized, relativeoffset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexArrayVertexAttribFormatEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexArrayVertexAttribIFormatEXT(GLuint vaobj, GLuint attribindex, GLint size, GLenum type, GLuint relativeoffset)
{
  Internal("error_glVertexArrayVertexAttribIFormatEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexArrayVertexAttribIFormatEXT)(vaobj, attribindex, size, type, relativeoffset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexArrayVertexAttribIFormatEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexArrayVertexAttribLFormatEXT(GLuint vaobj, GLuint attribindex, GLint size, GLenum type, GLuint relativeoffset)
{
  Internal("error_glVertexArrayVertexAttribLFormatEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexArrayVertexAttribLFormatEXT)(vaobj, attribindex, size, type, relativeoffset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexArrayVertexAttribLFormatEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexArrayVertexBindingDivisorEXT(GLuint vaobj, GLuint bindingindex, GLuint divisor)
{
  Internal("error_glVertexArrayVertexBindingDivisorEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexArrayVertexBindingDivisorEXT)(vaobj, bindingindex, divisor);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexArrayVertexBindingDivisorEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribBinding(GLuint attribindex, GLuint bindingindex)
{
  Internal("error_glVertexAttribBinding","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribBinding)(attribindex, bindingindex);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribBinding : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribFormat(GLuint attribindex, GLint size, GLenum type, GLboolean normalized, GLuint relativeoffset)
{
  Internal("error_glVertexAttribFormat","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribFormat)(attribindex, size, type, normalized, relativeoffset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribFormat : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribIFormat(GLuint attribindex, GLint size, GLenum type, GLuint relativeoffset)
{
  Internal("error_glVertexAttribIFormat","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribIFormat)(attribindex, size, type, relativeoffset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribIFormat : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribLFormat(GLuint attribindex, GLint size, GLenum type, GLuint relativeoffset)
{
  Internal("error_glVertexAttribLFormat","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribLFormat)(attribindex, size, type, relativeoffset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribLFormat : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexBindingDivisor(GLuint bindingindex, GLuint divisor)
{
  Internal("error_glVertexBindingDivisor","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexBindingDivisor)(bindingindex, divisor);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexBindingDivisor : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_vertex_blend

static void REGAL_CALL error_glVertexBlendARB(GLint count)
{
  Internal("error_glVertexBlendARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexBlendARB)(count);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexBlendARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWeightPointerARB(GLint size, GLenum type, GLsizei stride, const GLvoid *pointer)
{
  Internal("error_glWeightPointerARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWeightPointerARB)(size, type, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWeightPointerARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWeightbvARB(GLint size, const GLbyte *weights)
{
  Internal("error_glWeightbvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWeightbvARB)(size, weights);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWeightbvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWeightdvARB(GLint size, const GLdouble *weights)
{
  Internal("error_glWeightdvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWeightdvARB)(size, weights);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWeightdvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWeightfvARB(GLint size, const GLfloat *weights)
{
  Internal("error_glWeightfvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWeightfvARB)(size, weights);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWeightfvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWeightivARB(GLint size, const GLint *weights)
{
  Internal("error_glWeightivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWeightivARB)(size, weights);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWeightivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWeightsvARB(GLint size, const GLshort *weights)
{
  Internal("error_glWeightsvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWeightsvARB)(size, weights);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWeightsvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWeightubvARB(GLint size, const GLubyte *weights)
{
  Internal("error_glWeightubvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWeightubvARB)(size, weights);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWeightubvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWeightuivARB(GLint size, const GLuint *weights)
{
  Internal("error_glWeightuivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWeightuivARB)(size, weights);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWeightuivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWeightusvARB(GLint size, const GLushort *weights)
{
  Internal("error_glWeightusvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWeightusvARB)(size, weights);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWeightusvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_vertex_buffer_object

static void REGAL_CALL error_glBindBufferARB(GLenum target, GLuint buffer)
{
  Internal("error_glBindBufferARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindBufferARB)(target, buffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindBufferARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBufferDataARB(GLenum target, GLsizeiptrARB size, const GLvoid *data, GLenum usage)
{
  Internal("error_glBufferDataARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBufferDataARB)(target, size, data, usage);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBufferDataARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBufferSubDataARB(GLenum target, GLintptrARB offset, GLsizeiptrARB size, const GLvoid *data)
{
  Internal("error_glBufferSubDataARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBufferSubDataARB)(target, offset, size, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBufferSubDataARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteBuffersARB(GLsizei n, const GLuint *buffers)
{
  Internal("error_glDeleteBuffersARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteBuffersARB)(n, buffers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteBuffersARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenBuffersARB(GLsizei n, GLuint *buffers)
{
  Internal("error_glGenBuffersARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenBuffersARB)(n, buffers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenBuffersARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetBufferParameterivARB(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetBufferParameterivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetBufferParameterivARB)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetBufferParameterivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetBufferPointervARB(GLenum target, GLenum pname, GLvoid **params)
{
  Internal("error_glGetBufferPointervARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetBufferPointervARB)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetBufferPointervARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetBufferSubDataARB(GLenum target, GLintptrARB offset, GLsizeiptrARB size, GLvoid *data)
{
  Internal("error_glGetBufferSubDataARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetBufferSubDataARB)(target, offset, size, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetBufferSubDataARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsBufferARB(GLuint buffer)
{
  Internal("error_glIsBufferARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsBufferARB)(buffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsBufferARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLvoid *REGAL_CALL error_glMapBufferARB(GLenum target, GLenum access)
{
  Internal("error_glMapBufferARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLvoid * ret = _next->call(&_next->glMapBufferARB)(target, access);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMapBufferARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLboolean REGAL_CALL error_glUnmapBufferARB(GLenum target)
{
  Internal("error_glUnmapBufferARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glUnmapBufferARB)(target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUnmapBufferARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

// GL_ARB_vertex_program

static void REGAL_CALL error_glBindProgramARB(GLenum target, GLuint program)
{
  Internal("error_glBindProgramARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindProgramARB)(target, program);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindProgramARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteProgramsARB(GLsizei n, const GLuint *programs)
{
  Internal("error_glDeleteProgramsARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteProgramsARB)(n, programs);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteProgramsARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDisableVertexAttribArrayARB(GLuint index)
{
  Internal("error_glDisableVertexAttribArrayARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDisableVertexAttribArrayARB)(index);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDisableVertexAttribArrayARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEnableVertexAttribArrayARB(GLuint index)
{
  Internal("error_glEnableVertexAttribArrayARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEnableVertexAttribArrayARB)(index);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEnableVertexAttribArrayARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenProgramsARB(GLsizei n, GLuint *programs)
{
  Internal("error_glGenProgramsARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenProgramsARB)(n, programs);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenProgramsARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetProgramEnvParameterdvARB(GLenum target, GLuint index, GLdouble *params)
{
  Internal("error_glGetProgramEnvParameterdvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramEnvParameterdvARB)(target, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramEnvParameterdvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetProgramEnvParameterfvARB(GLenum target, GLuint index, GLfloat *params)
{
  Internal("error_glGetProgramEnvParameterfvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramEnvParameterfvARB)(target, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramEnvParameterfvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetProgramLocalParameterdvARB(GLenum target, GLuint index, GLdouble *params)
{
  Internal("error_glGetProgramLocalParameterdvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramLocalParameterdvARB)(target, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramLocalParameterdvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetProgramLocalParameterfvARB(GLenum target, GLuint index, GLfloat *params)
{
  Internal("error_glGetProgramLocalParameterfvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramLocalParameterfvARB)(target, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramLocalParameterfvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetProgramStringARB(GLenum target, GLenum pname, GLvoid *string)
{
  Internal("error_glGetProgramStringARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramStringARB)(target, pname, string);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramStringARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetProgramivARB(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetProgramivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramivARB)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVertexAttribPointervARB(GLuint index, GLenum pname, GLvoid **pointer)
{
  Internal("error_glGetVertexAttribPointervARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexAttribPointervARB)(index, pname, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexAttribPointervARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVertexAttribdvARB(GLuint index, GLenum pname, GLdouble *params)
{
  Internal("error_glGetVertexAttribdvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexAttribdvARB)(index, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexAttribdvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVertexAttribfvARB(GLuint index, GLenum pname, GLfloat *params)
{
  Internal("error_glGetVertexAttribfvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexAttribfvARB)(index, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexAttribfvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVertexAttribivARB(GLuint index, GLenum pname, GLint *params)
{
  Internal("error_glGetVertexAttribivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexAttribivARB)(index, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexAttribivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsProgramARB(GLuint program)
{
  Internal("error_glIsProgramARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsProgramARB)(program);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsProgramARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glProgramEnvParameter4dARB(GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
  Internal("error_glProgramEnvParameter4dARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramEnvParameter4dARB)(target, index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramEnvParameter4dARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramEnvParameter4dvARB(GLenum target, GLuint index, const GLdouble *params)
{
  Internal("error_glProgramEnvParameter4dvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramEnvParameter4dvARB)(target, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramEnvParameter4dvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramEnvParameter4fARB(GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
  Internal("error_glProgramEnvParameter4fARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramEnvParameter4fARB)(target, index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramEnvParameter4fARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramEnvParameter4fvARB(GLenum target, GLuint index, const GLfloat *params)
{
  Internal("error_glProgramEnvParameter4fvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramEnvParameter4fvARB)(target, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramEnvParameter4fvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramLocalParameter4dARB(GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
  Internal("error_glProgramLocalParameter4dARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramLocalParameter4dARB)(target, index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramLocalParameter4dARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramLocalParameter4dvARB(GLenum target, GLuint index, const GLdouble *params)
{
  Internal("error_glProgramLocalParameter4dvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramLocalParameter4dvARB)(target, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramLocalParameter4dvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramLocalParameter4fARB(GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
  Internal("error_glProgramLocalParameter4fARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramLocalParameter4fARB)(target, index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramLocalParameter4fARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramLocalParameter4fvARB(GLenum target, GLuint index, const GLfloat *params)
{
  Internal("error_glProgramLocalParameter4fvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramLocalParameter4fvARB)(target, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramLocalParameter4fvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramStringARB(GLenum target, GLenum format, GLsizei len, const GLvoid *string)
{
  Internal("error_glProgramStringARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramStringARB)(target, format, len, string);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramStringARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib1dARB(GLuint index, GLdouble x)
{
  Internal("error_glVertexAttrib1dARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib1dARB)(index, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib1dARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib1dvARB(GLuint index, const GLdouble *v)
{
  Internal("error_glVertexAttrib1dvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib1dvARB)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib1dvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib1fARB(GLuint index, GLfloat x)
{
  Internal("error_glVertexAttrib1fARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib1fARB)(index, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib1fARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib1fvARB(GLuint index, const GLfloat *v)
{
  Internal("error_glVertexAttrib1fvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib1fvARB)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib1fvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib1sARB(GLuint index, GLshort x)
{
  Internal("error_glVertexAttrib1sARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib1sARB)(index, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib1sARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib1svARB(GLuint index, const GLshort *v)
{
  Internal("error_glVertexAttrib1svARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib1svARB)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib1svARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib2dARB(GLuint index, GLdouble x, GLdouble y)
{
  Internal("error_glVertexAttrib2dARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib2dARB)(index, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib2dARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib2dvARB(GLuint index, const GLdouble *v)
{
  Internal("error_glVertexAttrib2dvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib2dvARB)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib2dvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib2fARB(GLuint index, GLfloat x, GLfloat y)
{
  Internal("error_glVertexAttrib2fARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib2fARB)(index, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib2fARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib2fvARB(GLuint index, const GLfloat *v)
{
  Internal("error_glVertexAttrib2fvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib2fvARB)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib2fvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib2sARB(GLuint index, GLshort x, GLshort y)
{
  Internal("error_glVertexAttrib2sARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib2sARB)(index, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib2sARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib2svARB(GLuint index, const GLshort *v)
{
  Internal("error_glVertexAttrib2svARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib2svARB)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib2svARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib3dARB(GLuint index, GLdouble x, GLdouble y, GLdouble z)
{
  Internal("error_glVertexAttrib3dARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib3dARB)(index, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib3dARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib3dvARB(GLuint index, const GLdouble *v)
{
  Internal("error_glVertexAttrib3dvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib3dvARB)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib3dvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib3fARB(GLuint index, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glVertexAttrib3fARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib3fARB)(index, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib3fARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib3fvARB(GLuint index, const GLfloat *v)
{
  Internal("error_glVertexAttrib3fvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib3fvARB)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib3fvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib3sARB(GLuint index, GLshort x, GLshort y, GLshort z)
{
  Internal("error_glVertexAttrib3sARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib3sARB)(index, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib3sARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib3svARB(GLuint index, const GLshort *v)
{
  Internal("error_glVertexAttrib3svARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib3svARB)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib3svARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4NbvARB(GLuint index, const GLbyte *v)
{
  Internal("error_glVertexAttrib4NbvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4NbvARB)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4NbvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4NivARB(GLuint index, const GLint *v)
{
  Internal("error_glVertexAttrib4NivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4NivARB)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4NivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4NsvARB(GLuint index, const GLshort *v)
{
  Internal("error_glVertexAttrib4NsvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4NsvARB)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4NsvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4NubARB(GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w)
{
  Internal("error_glVertexAttrib4NubARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4NubARB)(index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4NubARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4NubvARB(GLuint index, const GLubyte *v)
{
  Internal("error_glVertexAttrib4NubvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4NubvARB)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4NubvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4NuivARB(GLuint index, const GLuint *v)
{
  Internal("error_glVertexAttrib4NuivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4NuivARB)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4NuivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4NusvARB(GLuint index, const GLushort *v)
{
  Internal("error_glVertexAttrib4NusvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4NusvARB)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4NusvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4bvARB(GLuint index, const GLbyte *v)
{
  Internal("error_glVertexAttrib4bvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4bvARB)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4bvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4dARB(GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
  Internal("error_glVertexAttrib4dARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4dARB)(index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4dARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4dvARB(GLuint index, const GLdouble *v)
{
  Internal("error_glVertexAttrib4dvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4dvARB)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4dvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4fARB(GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
  Internal("error_glVertexAttrib4fARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4fARB)(index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4fARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4fvARB(GLuint index, const GLfloat *v)
{
  Internal("error_glVertexAttrib4fvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4fvARB)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4fvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4ivARB(GLuint index, const GLint *v)
{
  Internal("error_glVertexAttrib4ivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4ivARB)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4ivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4sARB(GLuint index, GLshort x, GLshort y, GLshort z, GLshort w)
{
  Internal("error_glVertexAttrib4sARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4sARB)(index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4sARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4svARB(GLuint index, const GLshort *v)
{
  Internal("error_glVertexAttrib4svARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4svARB)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4svARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4ubvARB(GLuint index, const GLubyte *v)
{
  Internal("error_glVertexAttrib4ubvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4ubvARB)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4ubvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4uivARB(GLuint index, const GLuint *v)
{
  Internal("error_glVertexAttrib4uivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4uivARB)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4uivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4usvARB(GLuint index, const GLushort *v)
{
  Internal("error_glVertexAttrib4usvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4usvARB)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4usvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribPointerARB(GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, const GLvoid *pointer)
{
  Internal("error_glVertexAttribPointerARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribPointerARB)(index, size, type, normalized, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribPointerARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_vertex_shader

static void REGAL_CALL error_glBindAttribLocationARB(GLhandleARB programObj, GLuint index, const GLcharARB *name)
{
  Internal("error_glBindAttribLocationARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindAttribLocationARB)(programObj, index, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindAttribLocationARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetActiveAttribARB(GLhandleARB programObj, GLuint index, GLsizei maxLength, GLsizei *length, GLint *size, GLenum *type, GLcharARB *name)
{
  Internal("error_glGetActiveAttribARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetActiveAttribARB)(programObj, index, maxLength, length, size, type, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetActiveAttribARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLint REGAL_CALL error_glGetAttribLocationARB(GLhandleARB programObj, const GLcharARB *name)
{
  Internal("error_glGetAttribLocationARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLint  ret = _next->call(&_next->glGetAttribLocationARB)(programObj, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetAttribLocationARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

// GL_ARB_vertex_type_2_10_10_10_rev

static void REGAL_CALL error_glColorP3ui(GLenum type, GLuint color)
{
  Internal("error_glColorP3ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColorP3ui)(type, color);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColorP3ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColorP3uiv(GLenum type, const GLuint *color)
{
  Internal("error_glColorP3uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColorP3uiv)(type, color);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColorP3uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColorP4ui(GLenum type, GLuint color)
{
  Internal("error_glColorP4ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColorP4ui)(type, color);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColorP4ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColorP4uiv(GLenum type, const GLuint *color)
{
  Internal("error_glColorP4uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColorP4uiv)(type, color);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColorP4uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoordP1ui(GLenum texture, GLenum type, GLuint coords)
{
  Internal("error_glMultiTexCoordP1ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoordP1ui)(texture, type, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoordP1ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoordP1uiv(GLenum texture, GLenum type, const GLuint *coords)
{
  Internal("error_glMultiTexCoordP1uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoordP1uiv)(texture, type, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoordP1uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoordP2ui(GLenum texture, GLenum type, GLuint coords)
{
  Internal("error_glMultiTexCoordP2ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoordP2ui)(texture, type, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoordP2ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoordP2uiv(GLenum texture, GLenum type, const GLuint *coords)
{
  Internal("error_glMultiTexCoordP2uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoordP2uiv)(texture, type, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoordP2uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoordP3ui(GLenum texture, GLenum type, GLuint coords)
{
  Internal("error_glMultiTexCoordP3ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoordP3ui)(texture, type, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoordP3ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoordP3uiv(GLenum texture, GLenum type, const GLuint *coords)
{
  Internal("error_glMultiTexCoordP3uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoordP3uiv)(texture, type, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoordP3uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoordP4ui(GLenum texture, GLenum type, GLuint coords)
{
  Internal("error_glMultiTexCoordP4ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoordP4ui)(texture, type, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoordP4ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoordP4uiv(GLenum texture, GLenum type, const GLuint *coords)
{
  Internal("error_glMultiTexCoordP4uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoordP4uiv)(texture, type, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoordP4uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormalP3ui(GLenum type, GLuint coords)
{
  Internal("error_glNormalP3ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormalP3ui)(type, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormalP3ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormalP3uiv(GLenum type, const GLuint *coords)
{
  Internal("error_glNormalP3uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormalP3uiv)(type, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormalP3uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColorP3ui(GLenum type, GLuint color)
{
  Internal("error_glSecondaryColorP3ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColorP3ui)(type, color);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColorP3ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColorP3uiv(GLenum type, const GLuint *color)
{
  Internal("error_glSecondaryColorP3uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColorP3uiv)(type, color);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColorP3uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoordP1ui(GLenum type, GLuint coords)
{
  Internal("error_glTexCoordP1ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoordP1ui)(type, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoordP1ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoordP1uiv(GLenum type, const GLuint *coords)
{
  Internal("error_glTexCoordP1uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoordP1uiv)(type, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoordP1uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoordP2ui(GLenum type, GLuint coords)
{
  Internal("error_glTexCoordP2ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoordP2ui)(type, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoordP2ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoordP2uiv(GLenum type, const GLuint *coords)
{
  Internal("error_glTexCoordP2uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoordP2uiv)(type, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoordP2uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoordP3ui(GLenum type, GLuint coords)
{
  Internal("error_glTexCoordP3ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoordP3ui)(type, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoordP3ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoordP3uiv(GLenum type, const GLuint *coords)
{
  Internal("error_glTexCoordP3uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoordP3uiv)(type, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoordP3uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoordP4ui(GLenum type, GLuint coords)
{
  Internal("error_glTexCoordP4ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoordP4ui)(type, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoordP4ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoordP4uiv(GLenum type, const GLuint *coords)
{
  Internal("error_glTexCoordP4uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoordP4uiv)(type, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoordP4uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribP1ui(GLuint index, GLenum type, GLboolean normalized, GLuint value)
{
  Internal("error_glVertexAttribP1ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribP1ui)(index, type, normalized, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribP1ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribP1uiv(GLuint index, GLenum type, GLboolean normalized, const GLuint *value)
{
  Internal("error_glVertexAttribP1uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribP1uiv)(index, type, normalized, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribP1uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribP2ui(GLuint index, GLenum type, GLboolean normalized, GLuint value)
{
  Internal("error_glVertexAttribP2ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribP2ui)(index, type, normalized, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribP2ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribP2uiv(GLuint index, GLenum type, GLboolean normalized, const GLuint *value)
{
  Internal("error_glVertexAttribP2uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribP2uiv)(index, type, normalized, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribP2uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribP3ui(GLuint index, GLenum type, GLboolean normalized, GLuint value)
{
  Internal("error_glVertexAttribP3ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribP3ui)(index, type, normalized, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribP3ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribP3uiv(GLuint index, GLenum type, GLboolean normalized, const GLuint *value)
{
  Internal("error_glVertexAttribP3uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribP3uiv)(index, type, normalized, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribP3uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribP4ui(GLuint index, GLenum type, GLboolean normalized, GLuint value)
{
  Internal("error_glVertexAttribP4ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribP4ui)(index, type, normalized, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribP4ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribP4uiv(GLuint index, GLenum type, GLboolean normalized, const GLuint *value)
{
  Internal("error_glVertexAttribP4uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribP4uiv)(index, type, normalized, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribP4uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexP2ui(GLenum type, GLuint coords)
{
  Internal("error_glVertexP2ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexP2ui)(type, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexP2ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexP2uiv(GLenum type, const GLuint *coords)
{
  Internal("error_glVertexP2uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexP2uiv)(type, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexP2uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexP3ui(GLenum type, GLuint coords)
{
  Internal("error_glVertexP3ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexP3ui)(type, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexP3ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexP3uiv(GLenum type, const GLuint *coords)
{
  Internal("error_glVertexP3uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexP3uiv)(type, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexP3uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexP4ui(GLenum type, GLuint coords)
{
  Internal("error_glVertexP4ui","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexP4ui)(type, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexP4ui : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexP4uiv(GLenum type, const GLuint *coords)
{
  Internal("error_glVertexP4uiv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexP4uiv)(type, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexP4uiv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_viewport_array

static void REGAL_CALL error_glDepthRangeArrayv(GLuint first, GLsizei count, const GLclampd *v)
{
  Internal("error_glDepthRangeArrayv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDepthRangeArrayv)(first, count, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDepthRangeArrayv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDepthRangeIndexed(GLuint index, GLclampd n, GLclampd f)
{
  Internal("error_glDepthRangeIndexed","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDepthRangeIndexed)(index, n, f);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDepthRangeIndexed : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetDoublei_v(GLenum target, GLuint index, GLdouble *v)
{
  Internal("error_glGetDoublei_v","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetDoublei_v)(target, index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetDoublei_v : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetFloati_v(GLenum target, GLuint index, GLfloat *v)
{
  Internal("error_glGetFloati_v","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetFloati_v)(target, index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetFloati_v : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glScissorArrayv(GLuint first, GLsizei count, const GLint *v)
{
  Internal("error_glScissorArrayv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glScissorArrayv)(first, count, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glScissorArrayv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glScissorIndexed(GLuint index, GLint left, GLint bottom, GLint width, GLint height)
{
  Internal("error_glScissorIndexed","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glScissorIndexed)(index, left, bottom, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glScissorIndexed : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glScissorIndexedv(GLuint index, const GLint *v)
{
  Internal("error_glScissorIndexedv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glScissorIndexedv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glScissorIndexedv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glViewportArrayv(GLuint first, GLsizei count, const GLfloat *v)
{
  Internal("error_glViewportArrayv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glViewportArrayv)(first, count, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glViewportArrayv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glViewportIndexedf(GLuint index, GLfloat x, GLfloat y, GLfloat w, GLfloat h)
{
  Internal("error_glViewportIndexedf","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glViewportIndexedf)(index, x, y, w, h);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glViewportIndexedf : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glViewportIndexedfv(GLuint index, const GLfloat *v)
{
  Internal("error_glViewportIndexedfv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glViewportIndexedfv)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glViewportIndexedfv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ARB_window_pos

static void REGAL_CALL error_glWindowPos2dARB(GLdouble x, GLdouble y)
{
  Internal("error_glWindowPos2dARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos2dARB)(x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos2dARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos2dvARB(const GLdouble *p)
{
  Internal("error_glWindowPos2dvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos2dvARB)(p);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos2dvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos2fARB(GLfloat x, GLfloat y)
{
  Internal("error_glWindowPos2fARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos2fARB)(x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos2fARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos2fvARB(const GLfloat *p)
{
  Internal("error_glWindowPos2fvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos2fvARB)(p);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos2fvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos2iARB(GLint x, GLint y)
{
  Internal("error_glWindowPos2iARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos2iARB)(x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos2iARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos2ivARB(const GLint *p)
{
  Internal("error_glWindowPos2ivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos2ivARB)(p);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos2ivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos2sARB(GLshort x, GLshort y)
{
  Internal("error_glWindowPos2sARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos2sARB)(x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos2sARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos2svARB(const GLshort *p)
{
  Internal("error_glWindowPos2svARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos2svARB)(p);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos2svARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos3dARB(GLdouble x, GLdouble y, GLdouble z)
{
  Internal("error_glWindowPos3dARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos3dARB)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos3dARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos3dvARB(const GLdouble *p)
{
  Internal("error_glWindowPos3dvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos3dvARB)(p);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos3dvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos3fARB(GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glWindowPos3fARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos3fARB)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos3fARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos3fvARB(const GLfloat *p)
{
  Internal("error_glWindowPos3fvARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos3fvARB)(p);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos3fvARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos3iARB(GLint x, GLint y, GLint z)
{
  Internal("error_glWindowPos3iARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos3iARB)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos3iARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos3ivARB(const GLint *p)
{
  Internal("error_glWindowPos3ivARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos3ivARB)(p);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos3ivARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos3sARB(GLshort x, GLshort y, GLshort z)
{
  Internal("error_glWindowPos3sARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos3sARB)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos3sARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos3svARB(const GLshort *p)
{
  Internal("error_glWindowPos3svARB","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos3svARB)(p);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos3svARB : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ATI_draw_buffers

static void REGAL_CALL error_glDrawBuffersATI(GLsizei n, const GLenum *bufs)
{
  Internal("error_glDrawBuffersATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawBuffersATI)(n, bufs);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawBuffersATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ATI_element_array

static void REGAL_CALL error_glDrawElementArrayATI(GLenum mode, GLsizei count)
{
  Internal("error_glDrawElementArrayATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawElementArrayATI)(mode, count);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawElementArrayATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDrawRangeElementArrayATI(GLenum mode, GLuint start, GLuint end, GLsizei count)
{
  Internal("error_glDrawRangeElementArrayATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawRangeElementArrayATI)(mode, start, end, count);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawRangeElementArrayATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glElementPointerATI(GLenum type, const GLvoid *pointer)
{
  Internal("error_glElementPointerATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glElementPointerATI)(type, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glElementPointerATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ATI_envmap_bumpmap

static void REGAL_CALL error_glGetTexBumpParameterfvATI(GLenum pname, GLfloat *param)
{
  Internal("error_glGetTexBumpParameterfvATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTexBumpParameterfvATI)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTexBumpParameterfvATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTexBumpParameterivATI(GLenum pname, GLint *param)
{
  Internal("error_glGetTexBumpParameterivATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTexBumpParameterivATI)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTexBumpParameterivATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexBumpParameterfvATI(GLenum pname, const GLfloat *param)
{
  Internal("error_glTexBumpParameterfvATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexBumpParameterfvATI)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexBumpParameterfvATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexBumpParameterivATI(GLenum pname, const GLint *param)
{
  Internal("error_glTexBumpParameterivATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexBumpParameterivATI)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexBumpParameterivATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ATI_fragment_shader

static void REGAL_CALL error_glAlphaFragmentOp1ATI(GLenum op, GLuint dst, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod)
{
  Internal("error_glAlphaFragmentOp1ATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glAlphaFragmentOp1ATI)(op, dst, dstMod, arg1, arg1Rep, arg1Mod);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glAlphaFragmentOp1ATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glAlphaFragmentOp2ATI(GLenum op, GLuint dst, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod)
{
  Internal("error_glAlphaFragmentOp2ATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glAlphaFragmentOp2ATI)(op, dst, dstMod, arg1, arg1Rep, arg1Mod, arg2, arg2Rep, arg2Mod);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glAlphaFragmentOp2ATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glAlphaFragmentOp3ATI(GLenum op, GLuint dst, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod, GLuint arg3, GLuint arg3Rep, GLuint arg3Mod)
{
  Internal("error_glAlphaFragmentOp3ATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glAlphaFragmentOp3ATI)(op, dst, dstMod, arg1, arg1Rep, arg1Mod, arg2, arg2Rep, arg2Mod, arg3, arg3Rep, arg3Mod);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glAlphaFragmentOp3ATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBeginFragmentShaderATI(void)
{
  Internal("error_glBeginFragmentShaderATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBeginFragmentShaderATI)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBeginFragmentShaderATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBindFragmentShaderATI(GLuint id)
{
  Internal("error_glBindFragmentShaderATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindFragmentShaderATI)(id);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindFragmentShaderATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColorFragmentOp1ATI(GLenum op, GLuint dst, GLuint dstMask, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod)
{
  Internal("error_glColorFragmentOp1ATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColorFragmentOp1ATI)(op, dst, dstMask, dstMod, arg1, arg1Rep, arg1Mod);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColorFragmentOp1ATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColorFragmentOp2ATI(GLenum op, GLuint dst, GLuint dstMask, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod)
{
  Internal("error_glColorFragmentOp2ATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColorFragmentOp2ATI)(op, dst, dstMask, dstMod, arg1, arg1Rep, arg1Mod, arg2, arg2Rep, arg2Mod);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColorFragmentOp2ATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColorFragmentOp3ATI(GLenum op, GLuint dst, GLuint dstMask, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod, GLuint arg3, GLuint arg3Rep, GLuint arg3Mod)
{
  Internal("error_glColorFragmentOp3ATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColorFragmentOp3ATI)(op, dst, dstMask, dstMod, arg1, arg1Rep, arg1Mod, arg2, arg2Rep, arg2Mod, arg3, arg3Rep, arg3Mod);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColorFragmentOp3ATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteFragmentShaderATI(GLuint id)
{
  Internal("error_glDeleteFragmentShaderATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteFragmentShaderATI)(id);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteFragmentShaderATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEndFragmentShaderATI(void)
{
  Internal("error_glEndFragmentShaderATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEndFragmentShaderATI)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEndFragmentShaderATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLuint REGAL_CALL error_glGenFragmentShadersATI(GLuint range)
{
  Internal("error_glGenFragmentShadersATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint  ret = _next->call(&_next->glGenFragmentShadersATI)(range);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenFragmentShadersATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glPassTexCoordATI(GLuint dst, GLuint coord, GLenum swizzle)
{
  Internal("error_glPassTexCoordATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPassTexCoordATI)(dst, coord, swizzle);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPassTexCoordATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSampleMapATI(GLuint dst, GLuint interp, GLenum swizzle)
{
  Internal("error_glSampleMapATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSampleMapATI)(dst, interp, swizzle);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSampleMapATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSetFragmentShaderConstantATI(GLuint dst, const GLfloat *value)
{
  Internal("error_glSetFragmentShaderConstantATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSetFragmentShaderConstantATI)(dst, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSetFragmentShaderConstantATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ATI_map_object_buffer

static GLvoid *REGAL_CALL error_glMapObjectBufferATI(GLuint buffer)
{
  Internal("error_glMapObjectBufferATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLvoid * ret = _next->call(&_next->glMapObjectBufferATI)(buffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMapObjectBufferATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glUnmapObjectBufferATI(GLuint buffer)
{
  Internal("error_glUnmapObjectBufferATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUnmapObjectBufferATI)(buffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUnmapObjectBufferATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ATI_pn_triangles

static void REGAL_CALL error_glPNTrianglesfATI(GLenum pname, GLfloat param)
{
  Internal("error_glPNTrianglesfATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPNTrianglesfATI)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPNTrianglesfATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPNTrianglesiATI(GLenum pname, GLint param)
{
  Internal("error_glPNTrianglesiATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPNTrianglesiATI)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPNTrianglesiATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ATI_separate_stencil

static void REGAL_CALL error_glStencilFuncSeparateATI(GLenum frontfunc, GLenum backfunc, GLint ref, GLuint mask)
{
  Internal("error_glStencilFuncSeparateATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glStencilFuncSeparateATI)(frontfunc, backfunc, ref, mask);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glStencilFuncSeparateATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glStencilOpSeparateATI(GLenum face, GLenum sfail, GLenum dpfail, GLenum dppass)
{
  Internal("error_glStencilOpSeparateATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glStencilOpSeparateATI)(face, sfail, dpfail, dppass);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glStencilOpSeparateATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ATI_vertex_array_object

static void REGAL_CALL error_glArrayObjectATI(GLenum array, GLint size, GLenum type, GLsizei stride, GLuint buffer, GLuint offset)
{
  Internal("error_glArrayObjectATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glArrayObjectATI)(array, size, type, stride, buffer, offset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glArrayObjectATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFreeObjectBufferATI(GLuint buffer)
{
  Internal("error_glFreeObjectBufferATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFreeObjectBufferATI)(buffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFreeObjectBufferATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetArrayObjectfvATI(GLenum array, GLenum pname, GLfloat *params)
{
  Internal("error_glGetArrayObjectfvATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetArrayObjectfvATI)(array, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetArrayObjectfvATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetArrayObjectivATI(GLenum array, GLenum pname, GLint *params)
{
  Internal("error_glGetArrayObjectivATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetArrayObjectivATI)(array, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetArrayObjectivATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetObjectBufferfvATI(GLuint buffer, GLenum pname, GLfloat *params)
{
  Internal("error_glGetObjectBufferfvATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetObjectBufferfvATI)(buffer, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetObjectBufferfvATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetObjectBufferivATI(GLuint buffer, GLenum pname, GLint *params)
{
  Internal("error_glGetObjectBufferivATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetObjectBufferivATI)(buffer, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetObjectBufferivATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVariantArrayObjectfvATI(GLuint id, GLenum pname, GLfloat *params)
{
  Internal("error_glGetVariantArrayObjectfvATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVariantArrayObjectfvATI)(id, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVariantArrayObjectfvATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVariantArrayObjectivATI(GLuint id, GLenum pname, GLint *params)
{
  Internal("error_glGetVariantArrayObjectivATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVariantArrayObjectivATI)(id, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVariantArrayObjectivATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsObjectBufferATI(GLuint buffer)
{
  Internal("error_glIsObjectBufferATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsObjectBufferATI)(buffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsObjectBufferATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLuint REGAL_CALL error_glNewObjectBufferATI(GLsizei size, const GLvoid *pointer, GLenum usage)
{
  Internal("error_glNewObjectBufferATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint  ret = _next->call(&_next->glNewObjectBufferATI)(size, pointer, usage);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNewObjectBufferATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glUpdateObjectBufferATI(GLuint buffer, GLuint offset, GLsizei size, const GLvoid *pointer, GLenum preserve)
{
  Internal("error_glUpdateObjectBufferATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUpdateObjectBufferATI)(buffer, offset, size, pointer, preserve);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUpdateObjectBufferATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVariantArrayObjectATI(GLuint id, GLenum type, GLsizei stride, GLuint buffer, GLuint offset)
{
  Internal("error_glVariantArrayObjectATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVariantArrayObjectATI)(id, type, stride, buffer, offset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVariantArrayObjectATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ATI_vertex_attrib_array_object

static void REGAL_CALL error_glGetVertexAttribArrayObjectfvATI(GLuint index, GLenum pname, GLfloat *params)
{
  Internal("error_glGetVertexAttribArrayObjectfvATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexAttribArrayObjectfvATI)(index, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexAttribArrayObjectfvATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVertexAttribArrayObjectivATI(GLuint index, GLenum pname, GLint *params)
{
  Internal("error_glGetVertexAttribArrayObjectivATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexAttribArrayObjectivATI)(index, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexAttribArrayObjectivATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribArrayObjectATI(GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, GLuint buffer, GLuint offset)
{
  Internal("error_glVertexAttribArrayObjectATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribArrayObjectATI)(index, size, type, normalized, stride, buffer, offset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribArrayObjectATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_ATI_vertex_streams

static void REGAL_CALL error_glClientActiveVertexStreamATI(GLenum stream)
{
  Internal("error_glClientActiveVertexStreamATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClientActiveVertexStreamATI)(stream);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClientActiveVertexStreamATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormalStream3bATI(GLenum stream, GLbyte x, GLbyte y, GLbyte z)
{
  Internal("error_glNormalStream3bATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormalStream3bATI)(stream, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormalStream3bATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormalStream3bvATI(GLenum stream, const GLbyte *coords)
{
  Internal("error_glNormalStream3bvATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormalStream3bvATI)(stream, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormalStream3bvATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormalStream3dATI(GLenum stream, GLdouble x, GLdouble y, GLdouble z)
{
  Internal("error_glNormalStream3dATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormalStream3dATI)(stream, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormalStream3dATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormalStream3dvATI(GLenum stream, const GLdouble *coords)
{
  Internal("error_glNormalStream3dvATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormalStream3dvATI)(stream, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormalStream3dvATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormalStream3fATI(GLenum stream, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glNormalStream3fATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormalStream3fATI)(stream, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormalStream3fATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormalStream3fvATI(GLenum stream, const GLfloat *coords)
{
  Internal("error_glNormalStream3fvATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormalStream3fvATI)(stream, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormalStream3fvATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormalStream3iATI(GLenum stream, GLint x, GLint y, GLint z)
{
  Internal("error_glNormalStream3iATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormalStream3iATI)(stream, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormalStream3iATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormalStream3ivATI(GLenum stream, const GLint *coords)
{
  Internal("error_glNormalStream3ivATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormalStream3ivATI)(stream, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormalStream3ivATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormalStream3sATI(GLenum stream, GLshort x, GLshort y, GLshort z)
{
  Internal("error_glNormalStream3sATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormalStream3sATI)(stream, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormalStream3sATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormalStream3svATI(GLenum stream, const GLshort *coords)
{
  Internal("error_glNormalStream3svATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormalStream3svATI)(stream, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormalStream3svATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexBlendEnvfATI(GLenum pname, GLfloat param)
{
  Internal("error_glVertexBlendEnvfATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexBlendEnvfATI)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexBlendEnvfATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexBlendEnviATI(GLenum pname, GLint param)
{
  Internal("error_glVertexBlendEnviATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexBlendEnviATI)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexBlendEnviATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream1dATI(GLenum stream, GLdouble x)
{
  Internal("error_glVertexStream1dATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream1dATI)(stream, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream1dATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream1dvATI(GLenum stream, const GLdouble *coords)
{
  Internal("error_glVertexStream1dvATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream1dvATI)(stream, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream1dvATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream1fATI(GLenum stream, GLfloat x)
{
  Internal("error_glVertexStream1fATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream1fATI)(stream, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream1fATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream1fvATI(GLenum stream, const GLfloat *coords)
{
  Internal("error_glVertexStream1fvATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream1fvATI)(stream, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream1fvATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream1iATI(GLenum stream, GLint x)
{
  Internal("error_glVertexStream1iATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream1iATI)(stream, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream1iATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream1ivATI(GLenum stream, const GLint *coords)
{
  Internal("error_glVertexStream1ivATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream1ivATI)(stream, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream1ivATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream1sATI(GLenum stream, GLshort x)
{
  Internal("error_glVertexStream1sATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream1sATI)(stream, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream1sATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream1svATI(GLenum stream, const GLshort *coords)
{
  Internal("error_glVertexStream1svATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream1svATI)(stream, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream1svATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream2dATI(GLenum stream, GLdouble x, GLdouble y)
{
  Internal("error_glVertexStream2dATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream2dATI)(stream, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream2dATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream2dvATI(GLenum stream, const GLdouble *coords)
{
  Internal("error_glVertexStream2dvATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream2dvATI)(stream, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream2dvATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream2fATI(GLenum stream, GLfloat x, GLfloat y)
{
  Internal("error_glVertexStream2fATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream2fATI)(stream, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream2fATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream2fvATI(GLenum stream, const GLfloat *coords)
{
  Internal("error_glVertexStream2fvATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream2fvATI)(stream, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream2fvATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream2iATI(GLenum stream, GLint x, GLint y)
{
  Internal("error_glVertexStream2iATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream2iATI)(stream, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream2iATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream2ivATI(GLenum stream, const GLint *coords)
{
  Internal("error_glVertexStream2ivATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream2ivATI)(stream, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream2ivATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream2sATI(GLenum stream, GLshort x, GLshort y)
{
  Internal("error_glVertexStream2sATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream2sATI)(stream, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream2sATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream2svATI(GLenum stream, const GLshort *coords)
{
  Internal("error_glVertexStream2svATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream2svATI)(stream, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream2svATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream3dATI(GLenum stream, GLdouble x, GLdouble y, GLdouble z)
{
  Internal("error_glVertexStream3dATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream3dATI)(stream, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream3dATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream3dvATI(GLenum stream, const GLdouble *coords)
{
  Internal("error_glVertexStream3dvATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream3dvATI)(stream, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream3dvATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream3fATI(GLenum stream, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glVertexStream3fATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream3fATI)(stream, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream3fATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream3fvATI(GLenum stream, const GLfloat *coords)
{
  Internal("error_glVertexStream3fvATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream3fvATI)(stream, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream3fvATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream3iATI(GLenum stream, GLint x, GLint y, GLint z)
{
  Internal("error_glVertexStream3iATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream3iATI)(stream, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream3iATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream3ivATI(GLenum stream, const GLint *coords)
{
  Internal("error_glVertexStream3ivATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream3ivATI)(stream, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream3ivATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream3sATI(GLenum stream, GLshort x, GLshort y, GLshort z)
{
  Internal("error_glVertexStream3sATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream3sATI)(stream, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream3sATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream3svATI(GLenum stream, const GLshort *coords)
{
  Internal("error_glVertexStream3svATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream3svATI)(stream, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream3svATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream4dATI(GLenum stream, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
  Internal("error_glVertexStream4dATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream4dATI)(stream, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream4dATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream4dvATI(GLenum stream, const GLdouble *coords)
{
  Internal("error_glVertexStream4dvATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream4dvATI)(stream, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream4dvATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream4fATI(GLenum stream, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
  Internal("error_glVertexStream4fATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream4fATI)(stream, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream4fATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream4fvATI(GLenum stream, const GLfloat *coords)
{
  Internal("error_glVertexStream4fvATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream4fvATI)(stream, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream4fvATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream4iATI(GLenum stream, GLint x, GLint y, GLint z, GLint w)
{
  Internal("error_glVertexStream4iATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream4iATI)(stream, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream4iATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream4ivATI(GLenum stream, const GLint *coords)
{
  Internal("error_glVertexStream4ivATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream4ivATI)(stream, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream4ivATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream4sATI(GLenum stream, GLshort x, GLshort y, GLshort z, GLshort w)
{
  Internal("error_glVertexStream4sATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream4sATI)(stream, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream4sATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexStream4svATI(GLenum stream, const GLshort *coords)
{
  Internal("error_glVertexStream4svATI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexStream4svATI)(stream, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexStream4svATI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_bindable_uniform

static GLint REGAL_CALL error_glGetUniformBufferSizeEXT(GLuint program, GLint location)
{
  Internal("error_glGetUniformBufferSizeEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLint  ret = _next->call(&_next->glGetUniformBufferSizeEXT)(program, location);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetUniformBufferSizeEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLintptr REGAL_CALL error_glGetUniformOffsetEXT(GLuint program, GLint location)
{
  Internal("error_glGetUniformOffsetEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLintptr  ret = _next->call(&_next->glGetUniformOffsetEXT)(program, location);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetUniformOffsetEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glUniformBufferEXT(GLuint program, GLint location, GLuint buffer)
{
  Internal("error_glUniformBufferEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformBufferEXT)(program, location, buffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformBufferEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_blend_color

static void REGAL_CALL error_glBlendColorEXT(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha)
{
  Internal("error_glBlendColorEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendColorEXT)(red, green, blue, alpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendColorEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_blend_equation_separate

static void REGAL_CALL error_glBlendEquationSeparateEXT(GLenum modeRGB, GLenum modeAlpha)
{
  Internal("error_glBlendEquationSeparateEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendEquationSeparateEXT)(modeRGB, modeAlpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendEquationSeparateEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_blend_func_separate

static void REGAL_CALL error_glBlendFuncSeparateEXT(GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha)
{
  Internal("error_glBlendFuncSeparateEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendFuncSeparateEXT)(sfactorRGB, dfactorRGB, sfactorAlpha, dfactorAlpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendFuncSeparateEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_blend_minmax

static void REGAL_CALL error_glBlendEquationEXT(GLenum mode)
{
  Internal("error_glBlendEquationEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendEquationEXT)(mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendEquationEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_color_subtable

static void REGAL_CALL error_glColorSubTableEXT(GLenum target, GLsizei start, GLsizei count, GLenum format, GLenum type, const GLvoid *table)
{
  Internal("error_glColorSubTableEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColorSubTableEXT)(target, start, count, format, type, table);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColorSubTableEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyColorSubTableEXT(GLenum target, GLsizei start, GLint x, GLint y, GLsizei width)
{
  Internal("error_glCopyColorSubTableEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyColorSubTableEXT)(target, start, x, y, width);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyColorSubTableEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_compiled_vertex_array

static void REGAL_CALL error_glLockArraysEXT(GLint first, GLsizei count)
{
  Internal("error_glLockArraysEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLockArraysEXT)(first, count);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLockArraysEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUnlockArraysEXT(void)
{
  Internal("error_glUnlockArraysEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUnlockArraysEXT)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUnlockArraysEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_convolution

static void REGAL_CALL error_glConvolutionFilter1DEXT(GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const GLvoid *image)
{
  Internal("error_glConvolutionFilter1DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glConvolutionFilter1DEXT)(target, internalformat, width, format, type, image);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glConvolutionFilter1DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glConvolutionFilter2DEXT(GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *image)
{
  Internal("error_glConvolutionFilter2DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glConvolutionFilter2DEXT)(target, internalformat, width, height, format, type, image);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glConvolutionFilter2DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glConvolutionParameterfEXT(GLenum target, GLenum pname, GLfloat param)
{
  Internal("error_glConvolutionParameterfEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glConvolutionParameterfEXT)(target, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glConvolutionParameterfEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glConvolutionParameterfvEXT(GLenum target, GLenum pname, const GLfloat *params)
{
  Internal("error_glConvolutionParameterfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glConvolutionParameterfvEXT)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glConvolutionParameterfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glConvolutionParameteriEXT(GLenum target, GLenum pname, GLint param)
{
  Internal("error_glConvolutionParameteriEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glConvolutionParameteriEXT)(target, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glConvolutionParameteriEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glConvolutionParameterivEXT(GLenum target, GLenum pname, const GLint *params)
{
  Internal("error_glConvolutionParameterivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glConvolutionParameterivEXT)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glConvolutionParameterivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyConvolutionFilter1DEXT(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width)
{
  Internal("error_glCopyConvolutionFilter1DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyConvolutionFilter1DEXT)(target, internalformat, x, y, width);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyConvolutionFilter1DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyConvolutionFilter2DEXT(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height)
{
  Internal("error_glCopyConvolutionFilter2DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyConvolutionFilter2DEXT)(target, internalformat, x, y, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyConvolutionFilter2DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetConvolutionFilterEXT(GLenum target, GLenum format, GLenum type, GLvoid *image)
{
  Internal("error_glGetConvolutionFilterEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetConvolutionFilterEXT)(target, format, type, image);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetConvolutionFilterEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetConvolutionParameterfvEXT(GLenum target, GLenum pname, GLfloat *params)
{
  Internal("error_glGetConvolutionParameterfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetConvolutionParameterfvEXT)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetConvolutionParameterfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetConvolutionParameterivEXT(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetConvolutionParameterivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetConvolutionParameterivEXT)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetConvolutionParameterivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetSeparableFilterEXT(GLenum target, GLenum format, GLenum type, GLvoid *row, GLvoid *column, GLvoid *span)
{
  Internal("error_glGetSeparableFilterEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetSeparableFilterEXT)(target, format, type, row, column, span);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetSeparableFilterEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSeparableFilter2DEXT(GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *row, const GLvoid *column)
{
  Internal("error_glSeparableFilter2DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSeparableFilter2DEXT)(target, internalformat, width, height, format, type, row, column);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSeparableFilter2DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_coordinate_frame

static void REGAL_CALL error_glBinormal3bEXT(GLbyte bx, GLbyte by, GLbyte bz)
{
  Internal("error_glBinormal3bEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBinormal3bEXT)(bx, by, bz);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBinormal3bEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBinormal3bvEXT(const GLbyte *v)
{
  Internal("error_glBinormal3bvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBinormal3bvEXT)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBinormal3bvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBinormal3dEXT(GLdouble bx, GLdouble by, GLdouble bz)
{
  Internal("error_glBinormal3dEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBinormal3dEXT)(bx, by, bz);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBinormal3dEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBinormal3dvEXT(const GLdouble *v)
{
  Internal("error_glBinormal3dvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBinormal3dvEXT)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBinormal3dvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBinormal3fEXT(GLfloat bx, GLfloat by, GLfloat bz)
{
  Internal("error_glBinormal3fEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBinormal3fEXT)(bx, by, bz);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBinormal3fEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBinormal3fvEXT(const GLfloat *v)
{
  Internal("error_glBinormal3fvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBinormal3fvEXT)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBinormal3fvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBinormal3iEXT(GLint bx, GLint by, GLint bz)
{
  Internal("error_glBinormal3iEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBinormal3iEXT)(bx, by, bz);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBinormal3iEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBinormal3ivEXT(const GLint *v)
{
  Internal("error_glBinormal3ivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBinormal3ivEXT)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBinormal3ivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBinormal3sEXT(GLshort bx, GLshort by, GLshort bz)
{
  Internal("error_glBinormal3sEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBinormal3sEXT)(bx, by, bz);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBinormal3sEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBinormal3svEXT(const GLshort *v)
{
  Internal("error_glBinormal3svEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBinormal3svEXT)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBinormal3svEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBinormalPointerEXT(GLenum type, GLsizei stride, const GLvoid *pointer)
{
  Internal("error_glBinormalPointerEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBinormalPointerEXT)(type, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBinormalPointerEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTangent3bEXT(GLbyte tx, GLbyte ty, GLbyte tz)
{
  Internal("error_glTangent3bEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTangent3bEXT)(tx, ty, tz);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTangent3bEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTangent3bvEXT(const GLbyte *v)
{
  Internal("error_glTangent3bvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTangent3bvEXT)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTangent3bvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTangent3dEXT(GLdouble tx, GLdouble ty, GLdouble tz)
{
  Internal("error_glTangent3dEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTangent3dEXT)(tx, ty, tz);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTangent3dEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTangent3dvEXT(const GLdouble *v)
{
  Internal("error_glTangent3dvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTangent3dvEXT)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTangent3dvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTangent3fEXT(GLfloat tx, GLfloat ty, GLfloat tz)
{
  Internal("error_glTangent3fEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTangent3fEXT)(tx, ty, tz);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTangent3fEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTangent3fvEXT(const GLfloat *v)
{
  Internal("error_glTangent3fvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTangent3fvEXT)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTangent3fvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTangent3iEXT(GLint tx, GLint ty, GLint tz)
{
  Internal("error_glTangent3iEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTangent3iEXT)(tx, ty, tz);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTangent3iEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTangent3ivEXT(const GLint *v)
{
  Internal("error_glTangent3ivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTangent3ivEXT)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTangent3ivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTangent3sEXT(GLshort tx, GLshort ty, GLshort tz)
{
  Internal("error_glTangent3sEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTangent3sEXT)(tx, ty, tz);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTangent3sEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTangent3svEXT(const GLshort *v)
{
  Internal("error_glTangent3svEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTangent3svEXT)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTangent3svEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTangentPointerEXT(GLenum type, GLsizei stride, const GLvoid *pointer)
{
  Internal("error_glTangentPointerEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTangentPointerEXT)(type, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTangentPointerEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_copy_texture

static void REGAL_CALL error_glCopyTexImage1DEXT(GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLint border)
{
  Internal("error_glCopyTexImage1DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyTexImage1DEXT)(target, level, internalformat, x, y, width, border);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyTexImage1DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyTexImage2DEXT(GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border)
{
  Internal("error_glCopyTexImage2DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyTexImage2DEXT)(target, level, internalformat, x, y, width, height, border);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyTexImage2DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyTexSubImage1DEXT(GLenum target, GLint level, GLint xoffset, GLint x, GLint y, GLsizei width)
{
  Internal("error_glCopyTexSubImage1DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyTexSubImage1DEXT)(target, level, xoffset, x, y, width);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyTexSubImage1DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyTexSubImage2DEXT(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height)
{
  Internal("error_glCopyTexSubImage2DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyTexSubImage2DEXT)(target, level, xoffset, yoffset, x, y, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyTexSubImage2DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyTexSubImage3DEXT(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height)
{
  Internal("error_glCopyTexSubImage3DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyTexSubImage3DEXT)(target, level, xoffset, yoffset, zoffset, x, y, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyTexSubImage3DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_cull_vertex

static void REGAL_CALL error_glCullParameterdvEXT(GLenum pname, GLdouble *params)
{
  Internal("error_glCullParameterdvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCullParameterdvEXT)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCullParameterdvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCullParameterfvEXT(GLenum pname, GLfloat *params)
{
  Internal("error_glCullParameterfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCullParameterfvEXT)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCullParameterfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_debug_label

static void REGAL_CALL error_glGetObjectLabelEXT(GLenum type, GLuint object, GLsizei bufSize, GLsizei *length, GLchar *label)
{
  Internal("error_glGetObjectLabelEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetObjectLabelEXT)(type, object, bufSize, length, label);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetObjectLabelEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLabelObjectEXT(GLenum type, GLuint object, GLsizei length, const GLchar *label)
{
  Internal("error_glLabelObjectEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLabelObjectEXT)(type, object, length, label);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLabelObjectEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_debug_marker

static void REGAL_CALL error_glInsertEventMarkerEXT(GLsizei length, const GLchar *marker)
{
  Internal("error_glInsertEventMarkerEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glInsertEventMarkerEXT)(length, marker);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glInsertEventMarkerEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPopGroupMarkerEXT(void)
{
  Internal("error_glPopGroupMarkerEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPopGroupMarkerEXT)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPopGroupMarkerEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPushGroupMarkerEXT(GLsizei length, const GLchar *marker)
{
  Internal("error_glPushGroupMarkerEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPushGroupMarkerEXT)(length, marker);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPushGroupMarkerEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_depth_bounds_test

static void REGAL_CALL error_glDepthBoundsEXT(GLclampd zmin, GLclampd zmax)
{
  Internal("error_glDepthBoundsEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDepthBoundsEXT)(zmin, zmax);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDepthBoundsEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_direct_state_access

static void REGAL_CALL error_glBindMultiTextureEXT(GLenum texunit, GLenum target, GLuint texture)
{
  Internal("error_glBindMultiTextureEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindMultiTextureEXT)(texunit, target, texture);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindMultiTextureEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLenum REGAL_CALL error_glCheckNamedFramebufferStatusEXT(GLuint framebuffer, GLenum target)
{
  Internal("error_glCheckNamedFramebufferStatusEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLenum  ret = _next->call(&_next->glCheckNamedFramebufferStatusEXT)(framebuffer, target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCheckNamedFramebufferStatusEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glClientAttribDefaultEXT(GLbitfield mask)
{
  Internal("error_glClientAttribDefaultEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClientAttribDefaultEXT)(mask);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClientAttribDefaultEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompressedMultiTexImage1DEXT(GLenum texunit, GLenum target, GLint level, GLenum internalformat, GLsizei width, GLint border, GLsizei imageSize, const GLvoid *data)
{
  Internal("error_glCompressedMultiTexImage1DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedMultiTexImage1DEXT)(texunit, target, level, internalformat, width, border, imageSize, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedMultiTexImage1DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompressedMultiTexImage2DEXT(GLenum texunit, GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const GLvoid *bits)
{
  Internal("error_glCompressedMultiTexImage2DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedMultiTexImage2DEXT)(texunit, target, level, internalformat, width, height, border, imageSize, bits);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedMultiTexImage2DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompressedMultiTexImage3DEXT(GLenum texunit, GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const GLvoid *bits)
{
  Internal("error_glCompressedMultiTexImage3DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedMultiTexImage3DEXT)(texunit, target, level, internalformat, width, height, depth, border, imageSize, bits);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedMultiTexImage3DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompressedMultiTexSubImage1DEXT(GLenum texunit, GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLsizei imageSize, const GLvoid *data)
{
  Internal("error_glCompressedMultiTexSubImage1DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedMultiTexSubImage1DEXT)(texunit, target, level, xoffset, width, format, imageSize, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedMultiTexSubImage1DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompressedMultiTexSubImage2DEXT(GLenum texunit, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const GLvoid *data)
{
  Internal("error_glCompressedMultiTexSubImage2DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedMultiTexSubImage2DEXT)(texunit, target, level, xoffset, yoffset, width, height, format, imageSize, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedMultiTexSubImage2DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompressedMultiTexSubImage3DEXT(GLenum texunit, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const GLvoid *data)
{
  Internal("error_glCompressedMultiTexSubImage3DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedMultiTexSubImage3DEXT)(texunit, target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedMultiTexSubImage3DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompressedTextureImage1DEXT(GLuint texture, GLenum target, GLint level, GLenum internalformat, GLsizei width, GLint border, GLsizei imageSize, const GLvoid *bits)
{
  Internal("error_glCompressedTextureImage1DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedTextureImage1DEXT)(texture, target, level, internalformat, width, border, imageSize, bits);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedTextureImage1DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompressedTextureImage2DEXT(GLuint texture, GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const GLvoid *bits)
{
  Internal("error_glCompressedTextureImage2DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedTextureImage2DEXT)(texture, target, level, internalformat, width, height, border, imageSize, bits);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedTextureImage2DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompressedTextureImage3DEXT(GLuint texture, GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const GLvoid *bits)
{
  Internal("error_glCompressedTextureImage3DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedTextureImage3DEXT)(texture, target, level, internalformat, width, height, depth, border, imageSize, bits);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedTextureImage3DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompressedTextureSubImage1DEXT(GLuint texture, GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLsizei imageSize, const GLvoid *bits)
{
  Internal("error_glCompressedTextureSubImage1DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedTextureSubImage1DEXT)(texture, target, level, xoffset, width, format, imageSize, bits);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedTextureSubImage1DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompressedTextureSubImage2DEXT(GLuint texture, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const GLvoid *bits)
{
  Internal("error_glCompressedTextureSubImage2DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedTextureSubImage2DEXT)(texture, target, level, xoffset, yoffset, width, height, format, imageSize, bits);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedTextureSubImage2DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompressedTextureSubImage3DEXT(GLuint texture, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const GLvoid *bits)
{
  Internal("error_glCompressedTextureSubImage3DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedTextureSubImage3DEXT)(texture, target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, bits);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedTextureSubImage3DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyMultiTexImage1DEXT(GLenum texunit, GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLint border)
{
  Internal("error_glCopyMultiTexImage1DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyMultiTexImage1DEXT)(texunit, target, level, internalformat, x, y, width, border);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyMultiTexImage1DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyMultiTexImage2DEXT(GLenum texunit, GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border)
{
  Internal("error_glCopyMultiTexImage2DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyMultiTexImage2DEXT)(texunit, target, level, internalformat, x, y, width, height, border);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyMultiTexImage2DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyMultiTexSubImage1DEXT(GLenum texunit, GLenum target, GLint level, GLint xoffset, GLint x, GLint y, GLsizei width)
{
  Internal("error_glCopyMultiTexSubImage1DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyMultiTexSubImage1DEXT)(texunit, target, level, xoffset, x, y, width);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyMultiTexSubImage1DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyMultiTexSubImage2DEXT(GLenum texunit, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height)
{
  Internal("error_glCopyMultiTexSubImage2DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyMultiTexSubImage2DEXT)(texunit, target, level, xoffset, yoffset, x, y, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyMultiTexSubImage2DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyMultiTexSubImage3DEXT(GLenum texunit, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height)
{
  Internal("error_glCopyMultiTexSubImage3DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyMultiTexSubImage3DEXT)(texunit, target, level, xoffset, yoffset, zoffset, x, y, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyMultiTexSubImage3DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyTextureImage1DEXT(GLuint texture, GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLint border)
{
  Internal("error_glCopyTextureImage1DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyTextureImage1DEXT)(texture, target, level, internalformat, x, y, width, border);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyTextureImage1DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyTextureImage2DEXT(GLuint texture, GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border)
{
  Internal("error_glCopyTextureImage2DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyTextureImage2DEXT)(texture, target, level, internalformat, x, y, width, height, border);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyTextureImage2DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyTextureSubImage1DEXT(GLuint texture, GLenum target, GLint level, GLint xoffset, GLint x, GLint y, GLsizei width)
{
  Internal("error_glCopyTextureSubImage1DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyTextureSubImage1DEXT)(texture, target, level, xoffset, x, y, width);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyTextureSubImage1DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyTextureSubImage2DEXT(GLuint texture, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height)
{
  Internal("error_glCopyTextureSubImage2DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyTextureSubImage2DEXT)(texture, target, level, xoffset, yoffset, x, y, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyTextureSubImage2DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyTextureSubImage3DEXT(GLuint texture, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height)
{
  Internal("error_glCopyTextureSubImage3DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyTextureSubImage3DEXT)(texture, target, level, xoffset, yoffset, zoffset, x, y, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyTextureSubImage3DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDisableClientStateIndexedEXT(GLenum array, GLuint index)
{
  Internal("error_glDisableClientStateIndexedEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDisableClientStateIndexedEXT)(array, index);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDisableClientStateIndexedEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDisableClientStateiEXT(GLenum array, GLuint index)
{
  Internal("error_glDisableClientStateiEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDisableClientStateiEXT)(array, index);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDisableClientStateiEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDisableVertexArrayAttribEXT(GLuint vaobj, GLenum array)
{
  Internal("error_glDisableVertexArrayAttribEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDisableVertexArrayAttribEXT)(vaobj, array);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDisableVertexArrayAttribEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDisableVertexArrayEXT(GLuint vaobj, GLenum array)
{
  Internal("error_glDisableVertexArrayEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDisableVertexArrayEXT)(vaobj, array);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDisableVertexArrayEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEnableClientStateIndexedEXT(GLenum array, GLuint index)
{
  Internal("error_glEnableClientStateIndexedEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEnableClientStateIndexedEXT)(array, index);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEnableClientStateIndexedEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEnableClientStateiEXT(GLenum array, GLuint index)
{
  Internal("error_glEnableClientStateiEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEnableClientStateiEXT)(array, index);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEnableClientStateiEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEnableVertexArrayAttribEXT(GLuint vaobj, GLenum array)
{
  Internal("error_glEnableVertexArrayAttribEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEnableVertexArrayAttribEXT)(vaobj, array);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEnableVertexArrayAttribEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEnableVertexArrayEXT(GLuint vaobj, GLenum array)
{
  Internal("error_glEnableVertexArrayEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEnableVertexArrayEXT)(vaobj, array);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEnableVertexArrayEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFlushMappedNamedBufferRangeEXT(GLuint buffer, GLintptr offset, GLsizeiptr length)
{
  Internal("error_glFlushMappedNamedBufferRangeEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFlushMappedNamedBufferRangeEXT)(buffer, offset, length);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFlushMappedNamedBufferRangeEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFramebufferDrawBufferEXT(GLuint framebuffer, GLenum mode)
{
  Internal("error_glFramebufferDrawBufferEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFramebufferDrawBufferEXT)(framebuffer, mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFramebufferDrawBufferEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFramebufferDrawBuffersEXT(GLuint framebuffer, GLsizei n, const GLenum *bufs)
{
  Internal("error_glFramebufferDrawBuffersEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFramebufferDrawBuffersEXT)(framebuffer, n, bufs);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFramebufferDrawBuffersEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFramebufferReadBufferEXT(GLuint framebuffer, GLenum mode)
{
  Internal("error_glFramebufferReadBufferEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFramebufferReadBufferEXT)(framebuffer, mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFramebufferReadBufferEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenerateMultiTexMipmapEXT(GLenum texunit, GLenum target)
{
  Internal("error_glGenerateMultiTexMipmapEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenerateMultiTexMipmapEXT)(texunit, target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenerateMultiTexMipmapEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenerateTextureMipmapEXT(GLuint texture, GLenum target)
{
  Internal("error_glGenerateTextureMipmapEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenerateTextureMipmapEXT)(texture, target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenerateTextureMipmapEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetCompressedMultiTexImageEXT(GLenum texunit, GLenum target, GLint lod, GLvoid *img)
{
  Internal("error_glGetCompressedMultiTexImageEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetCompressedMultiTexImageEXT)(texunit, target, lod, img);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetCompressedMultiTexImageEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetCompressedTextureImageEXT(GLuint texture, GLenum target, GLint lod, GLvoid *img)
{
  Internal("error_glGetCompressedTextureImageEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetCompressedTextureImageEXT)(texture, target, lod, img);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetCompressedTextureImageEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetDoubleIndexedvEXT(GLenum target, GLuint index, GLdouble *data)
{
  Internal("error_glGetDoubleIndexedvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetDoubleIndexedvEXT)(target, index, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetDoubleIndexedvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetDoublei_vEXT(GLenum target, GLuint index, GLdouble *data)
{
  Internal("error_glGetDoublei_vEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetDoublei_vEXT)(target, index, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetDoublei_vEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetFloatIndexedvEXT(GLenum target, GLuint index, GLfloat *data)
{
  Internal("error_glGetFloatIndexedvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetFloatIndexedvEXT)(target, index, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetFloatIndexedvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetFloati_vEXT(GLenum target, GLuint index, GLfloat *data)
{
  Internal("error_glGetFloati_vEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetFloati_vEXT)(target, index, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetFloati_vEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetFramebufferParameterivEXT(GLuint framebuffer, GLenum pname, GLint *params)
{
  Internal("error_glGetFramebufferParameterivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetFramebufferParameterivEXT)(framebuffer, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetFramebufferParameterivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMultiTexEnvfvEXT(GLenum texunit, GLenum target, GLenum pname, GLfloat *params)
{
  Internal("error_glGetMultiTexEnvfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMultiTexEnvfvEXT)(texunit, target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMultiTexEnvfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMultiTexEnvivEXT(GLenum texunit, GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetMultiTexEnvivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMultiTexEnvivEXT)(texunit, target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMultiTexEnvivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMultiTexGendvEXT(GLenum texunit, GLenum coord, GLenum pname, GLdouble *params)
{
  Internal("error_glGetMultiTexGendvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMultiTexGendvEXT)(texunit, coord, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMultiTexGendvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMultiTexGenfvEXT(GLenum texunit, GLenum coord, GLenum pname, GLfloat *params)
{
  Internal("error_glGetMultiTexGenfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMultiTexGenfvEXT)(texunit, coord, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMultiTexGenfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMultiTexGenivEXT(GLenum texunit, GLenum coord, GLenum pname, GLint *params)
{
  Internal("error_glGetMultiTexGenivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMultiTexGenivEXT)(texunit, coord, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMultiTexGenivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMultiTexImageEXT(GLenum texunit, GLenum target, GLint level, GLenum format, GLenum type, GLvoid *pixels)
{
  Internal("error_glGetMultiTexImageEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMultiTexImageEXT)(texunit, target, level, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMultiTexImageEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMultiTexLevelParameterfvEXT(GLenum texunit, GLenum target, GLint level, GLenum pname, GLfloat *params)
{
  Internal("error_glGetMultiTexLevelParameterfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMultiTexLevelParameterfvEXT)(texunit, target, level, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMultiTexLevelParameterfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMultiTexLevelParameterivEXT(GLenum texunit, GLenum target, GLint level, GLenum pname, GLint *params)
{
  Internal("error_glGetMultiTexLevelParameterivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMultiTexLevelParameterivEXT)(texunit, target, level, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMultiTexLevelParameterivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMultiTexParameterIivEXT(GLenum texunit, GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetMultiTexParameterIivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMultiTexParameterIivEXT)(texunit, target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMultiTexParameterIivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMultiTexParameterIuivEXT(GLenum texunit, GLenum target, GLenum pname, GLuint *params)
{
  Internal("error_glGetMultiTexParameterIuivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMultiTexParameterIuivEXT)(texunit, target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMultiTexParameterIuivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMultiTexParameterfvEXT(GLenum texunit, GLenum target, GLenum pname, GLfloat *params)
{
  Internal("error_glGetMultiTexParameterfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMultiTexParameterfvEXT)(texunit, target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMultiTexParameterfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMultiTexParameterivEXT(GLenum texunit, GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetMultiTexParameterivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMultiTexParameterivEXT)(texunit, target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMultiTexParameterivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetNamedBufferParameterivEXT(GLuint buffer, GLenum pname, GLint *params)
{
  Internal("error_glGetNamedBufferParameterivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetNamedBufferParameterivEXT)(buffer, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetNamedBufferParameterivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetNamedBufferPointervEXT(GLuint buffer, GLenum pname, GLvoid **params)
{
  Internal("error_glGetNamedBufferPointervEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetNamedBufferPointervEXT)(buffer, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetNamedBufferPointervEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetNamedBufferSubDataEXT(GLuint buffer, GLintptr offset, GLsizeiptr size, GLvoid *data)
{
  Internal("error_glGetNamedBufferSubDataEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetNamedBufferSubDataEXT)(buffer, offset, size, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetNamedBufferSubDataEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetNamedFramebufferAttachmentParameterivEXT(GLuint framebuffer, GLenum attachment, GLenum pname, GLint *params)
{
  Internal("error_glGetNamedFramebufferAttachmentParameterivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetNamedFramebufferAttachmentParameterivEXT)(framebuffer, attachment, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetNamedFramebufferAttachmentParameterivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetNamedProgramLocalParameterIivEXT(GLuint program, GLenum target, GLuint index, GLint *params)
{
  Internal("error_glGetNamedProgramLocalParameterIivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetNamedProgramLocalParameterIivEXT)(program, target, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetNamedProgramLocalParameterIivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetNamedProgramLocalParameterIuivEXT(GLuint program, GLenum target, GLuint index, GLuint *params)
{
  Internal("error_glGetNamedProgramLocalParameterIuivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetNamedProgramLocalParameterIuivEXT)(program, target, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetNamedProgramLocalParameterIuivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetNamedProgramLocalParameterdvEXT(GLuint program, GLenum target, GLuint index, GLdouble *params)
{
  Internal("error_glGetNamedProgramLocalParameterdvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetNamedProgramLocalParameterdvEXT)(program, target, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetNamedProgramLocalParameterdvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetNamedProgramLocalParameterfvEXT(GLuint program, GLenum target, GLuint index, GLfloat *params)
{
  Internal("error_glGetNamedProgramLocalParameterfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetNamedProgramLocalParameterfvEXT)(program, target, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetNamedProgramLocalParameterfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetNamedProgramStringEXT(GLuint program, GLenum target, GLenum pname, GLvoid *string)
{
  Internal("error_glGetNamedProgramStringEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetNamedProgramStringEXT)(program, target, pname, string);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetNamedProgramStringEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetNamedProgramivEXT(GLuint program, GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetNamedProgramivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetNamedProgramivEXT)(program, target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetNamedProgramivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetNamedRenderbufferParameterivEXT(GLuint renderbuffer, GLenum pname, GLint *params)
{
  Internal("error_glGetNamedRenderbufferParameterivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetNamedRenderbufferParameterivEXT)(renderbuffer, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetNamedRenderbufferParameterivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPointerIndexedvEXT(GLenum target, GLuint index, GLvoid **data)
{
  Internal("error_glGetPointerIndexedvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPointerIndexedvEXT)(target, index, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPointerIndexedvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPointeri_vEXT(GLenum pname, GLuint index, GLvoid **params)
{
  Internal("error_glGetPointeri_vEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPointeri_vEXT)(pname, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPointeri_vEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTextureImageEXT(GLuint texture, GLenum target, GLint level, GLenum format, GLenum type, GLvoid *pixels)
{
  Internal("error_glGetTextureImageEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTextureImageEXT)(texture, target, level, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTextureImageEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTextureLevelParameterfvEXT(GLuint texture, GLenum target, GLint level, GLenum pname, GLfloat *params)
{
  Internal("error_glGetTextureLevelParameterfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTextureLevelParameterfvEXT)(texture, target, level, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTextureLevelParameterfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTextureLevelParameterivEXT(GLuint texture, GLenum target, GLint level, GLenum pname, GLint *params)
{
  Internal("error_glGetTextureLevelParameterivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTextureLevelParameterivEXT)(texture, target, level, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTextureLevelParameterivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTextureParameterIivEXT(GLuint texture, GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetTextureParameterIivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTextureParameterIivEXT)(texture, target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTextureParameterIivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTextureParameterIuivEXT(GLuint texture, GLenum target, GLenum pname, GLuint *params)
{
  Internal("error_glGetTextureParameterIuivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTextureParameterIuivEXT)(texture, target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTextureParameterIuivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTextureParameterfvEXT(GLuint texture, GLenum target, GLenum pname, GLfloat *params)
{
  Internal("error_glGetTextureParameterfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTextureParameterfvEXT)(texture, target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTextureParameterfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTextureParameterivEXT(GLuint texture, GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetTextureParameterivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTextureParameterivEXT)(texture, target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTextureParameterivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVertexArrayIntegeri_vEXT(GLuint vaobj, GLuint index, GLenum pname, GLint *param)
{
  Internal("error_glGetVertexArrayIntegeri_vEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexArrayIntegeri_vEXT)(vaobj, index, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexArrayIntegeri_vEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVertexArrayIntegervEXT(GLuint vaobj, GLenum pname, GLint *param)
{
  Internal("error_glGetVertexArrayIntegervEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexArrayIntegervEXT)(vaobj, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexArrayIntegervEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVertexArrayPointeri_vEXT(GLuint vaobj, GLuint index, GLenum pname, GLvoid **param)
{
  Internal("error_glGetVertexArrayPointeri_vEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexArrayPointeri_vEXT)(vaobj, index, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexArrayPointeri_vEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVertexArrayPointervEXT(GLuint vaobj, GLenum pname, GLvoid **param)
{
  Internal("error_glGetVertexArrayPointervEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexArrayPointervEXT)(vaobj, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexArrayPointervEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLvoid *REGAL_CALL error_glMapNamedBufferEXT(GLuint buffer, GLenum access)
{
  Internal("error_glMapNamedBufferEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLvoid * ret = _next->call(&_next->glMapNamedBufferEXT)(buffer, access);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMapNamedBufferEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLvoid *REGAL_CALL error_glMapNamedBufferRangeEXT(GLuint buffer, GLintptr offset, GLsizeiptr length, GLbitfield access)
{
  Internal("error_glMapNamedBufferRangeEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLvoid * ret = _next->call(&_next->glMapNamedBufferRangeEXT)(buffer, offset, length, access);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMapNamedBufferRangeEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glMatrixFrustumEXT(GLenum mode, GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar)
{
  Internal("error_glMatrixFrustumEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMatrixFrustumEXT)(mode, left, right, bottom, top, zNear, zFar);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMatrixFrustumEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMatrixLoadIdentityEXT(GLenum mode)
{
  Internal("error_glMatrixLoadIdentityEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMatrixLoadIdentityEXT)(mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMatrixLoadIdentityEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMatrixLoadTransposedEXT(GLenum mode, const GLdouble *m)
{
  Internal("error_glMatrixLoadTransposedEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMatrixLoadTransposedEXT)(mode, m);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMatrixLoadTransposedEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMatrixLoadTransposefEXT(GLenum mode, const GLfloat *m)
{
  Internal("error_glMatrixLoadTransposefEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMatrixLoadTransposefEXT)(mode, m);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMatrixLoadTransposefEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMatrixLoaddEXT(GLenum mode, const GLdouble *m)
{
  Internal("error_glMatrixLoaddEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMatrixLoaddEXT)(mode, m);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMatrixLoaddEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMatrixLoadfEXT(GLenum mode, const GLfloat *m)
{
  Internal("error_glMatrixLoadfEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMatrixLoadfEXT)(mode, m);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMatrixLoadfEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMatrixMultTransposedEXT(GLenum mode, const GLdouble *m)
{
  Internal("error_glMatrixMultTransposedEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMatrixMultTransposedEXT)(mode, m);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMatrixMultTransposedEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMatrixMultTransposefEXT(GLenum mode, const GLfloat *m)
{
  Internal("error_glMatrixMultTransposefEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMatrixMultTransposefEXT)(mode, m);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMatrixMultTransposefEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMatrixMultdEXT(GLenum mode, const GLdouble *m)
{
  Internal("error_glMatrixMultdEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMatrixMultdEXT)(mode, m);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMatrixMultdEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMatrixMultfEXT(GLenum mode, const GLfloat *m)
{
  Internal("error_glMatrixMultfEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMatrixMultfEXT)(mode, m);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMatrixMultfEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMatrixOrthoEXT(GLenum mode, GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar)
{
  Internal("error_glMatrixOrthoEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMatrixOrthoEXT)(mode, left, right, bottom, top, zNear, zFar);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMatrixOrthoEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMatrixPopEXT(GLenum mode)
{
  Internal("error_glMatrixPopEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMatrixPopEXT)(mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMatrixPopEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMatrixPushEXT(GLenum mode)
{
  Internal("error_glMatrixPushEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMatrixPushEXT)(mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMatrixPushEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMatrixRotatedEXT(GLenum mode, GLdouble angle, GLdouble x, GLdouble y, GLdouble z)
{
  Internal("error_glMatrixRotatedEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMatrixRotatedEXT)(mode, angle, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMatrixRotatedEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMatrixRotatefEXT(GLenum mode, GLfloat angle, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glMatrixRotatefEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMatrixRotatefEXT)(mode, angle, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMatrixRotatefEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMatrixScaledEXT(GLenum mode, GLdouble x, GLdouble y, GLdouble z)
{
  Internal("error_glMatrixScaledEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMatrixScaledEXT)(mode, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMatrixScaledEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMatrixScalefEXT(GLenum mode, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glMatrixScalefEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMatrixScalefEXT)(mode, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMatrixScalefEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMatrixTranslatedEXT(GLenum mode, GLdouble x, GLdouble y, GLdouble z)
{
  Internal("error_glMatrixTranslatedEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMatrixTranslatedEXT)(mode, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMatrixTranslatedEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMatrixTranslatefEXT(GLenum mode, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glMatrixTranslatefEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMatrixTranslatefEXT)(mode, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMatrixTranslatefEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexBufferEXT(GLenum texunit, GLenum target, GLenum internalformat, GLuint buffer)
{
  Internal("error_glMultiTexBufferEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexBufferEXT)(texunit, target, internalformat, buffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexBufferEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoordPointerEXT(GLenum texunit, GLint size, GLenum type, GLsizei stride, const GLvoid *pointer)
{
  Internal("error_glMultiTexCoordPointerEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoordPointerEXT)(texunit, size, type, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoordPointerEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexEnvfEXT(GLenum texunit, GLenum target, GLenum pname, GLfloat param)
{
  Internal("error_glMultiTexEnvfEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexEnvfEXT)(texunit, target, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexEnvfEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexEnvfvEXT(GLenum texunit, GLenum target, GLenum pname, const GLfloat *params)
{
  Internal("error_glMultiTexEnvfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexEnvfvEXT)(texunit, target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexEnvfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexEnviEXT(GLenum texunit, GLenum target, GLenum pname, GLint param)
{
  Internal("error_glMultiTexEnviEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexEnviEXT)(texunit, target, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexEnviEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexEnvivEXT(GLenum texunit, GLenum target, GLenum pname, const GLint *params)
{
  Internal("error_glMultiTexEnvivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexEnvivEXT)(texunit, target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexEnvivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexGendEXT(GLenum texunit, GLenum coord, GLenum pname, GLdouble param)
{
  Internal("error_glMultiTexGendEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexGendEXT)(texunit, coord, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexGendEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexGendvEXT(GLenum texunit, GLenum coord, GLenum pname, const GLdouble *params)
{
  Internal("error_glMultiTexGendvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexGendvEXT)(texunit, coord, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexGendvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexGenfEXT(GLenum texunit, GLenum coord, GLenum pname, GLfloat param)
{
  Internal("error_glMultiTexGenfEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexGenfEXT)(texunit, coord, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexGenfEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexGenfvEXT(GLenum texunit, GLenum coord, GLenum pname, const GLfloat *params)
{
  Internal("error_glMultiTexGenfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexGenfvEXT)(texunit, coord, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexGenfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexGeniEXT(GLenum texunit, GLenum coord, GLenum pname, GLint param)
{
  Internal("error_glMultiTexGeniEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexGeniEXT)(texunit, coord, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexGeniEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexGenivEXT(GLenum texunit, GLenum coord, GLenum pname, const GLint *params)
{
  Internal("error_glMultiTexGenivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexGenivEXT)(texunit, coord, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexGenivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexImage1DEXT(GLenum texunit, GLenum target, GLint level, GLint internalformat, GLsizei width, GLint border, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glMultiTexImage1DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexImage1DEXT)(texunit, target, level, internalformat, width, border, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexImage1DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexImage2DEXT(GLenum texunit, GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glMultiTexImage2DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexImage2DEXT)(texunit, target, level, internalformat, width, height, border, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexImage2DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexImage3DEXT(GLenum texunit, GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glMultiTexImage3DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexImage3DEXT)(texunit, target, level, internalformat, width, height, depth, border, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexImage3DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexParameterIivEXT(GLenum texunit, GLenum target, GLenum pname, const GLint *params)
{
  Internal("error_glMultiTexParameterIivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexParameterIivEXT)(texunit, target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexParameterIivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexParameterIuivEXT(GLenum texunit, GLenum target, GLenum pname, const GLuint *params)
{
  Internal("error_glMultiTexParameterIuivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexParameterIuivEXT)(texunit, target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexParameterIuivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexParameterfEXT(GLenum texunit, GLenum target, GLenum pname, GLfloat param)
{
  Internal("error_glMultiTexParameterfEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexParameterfEXT)(texunit, target, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexParameterfEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexParameterfvEXT(GLenum texunit, GLenum target, GLenum pname, const GLfloat *param)
{
  Internal("error_glMultiTexParameterfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexParameterfvEXT)(texunit, target, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexParameterfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexParameteriEXT(GLenum texunit, GLenum target, GLenum pname, GLint param)
{
  Internal("error_glMultiTexParameteriEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexParameteriEXT)(texunit, target, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexParameteriEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexParameterivEXT(GLenum texunit, GLenum target, GLenum pname, const GLint *param)
{
  Internal("error_glMultiTexParameterivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexParameterivEXT)(texunit, target, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexParameterivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexRenderbufferEXT(GLenum texunit, GLenum target, GLuint renderbuffer)
{
  Internal("error_glMultiTexRenderbufferEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexRenderbufferEXT)(texunit, target, renderbuffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexRenderbufferEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexSubImage1DEXT(GLenum texunit, GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glMultiTexSubImage1DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexSubImage1DEXT)(texunit, target, level, xoffset, width, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexSubImage1DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexSubImage2DEXT(GLenum texunit, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glMultiTexSubImage2DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexSubImage2DEXT)(texunit, target, level, xoffset, yoffset, width, height, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexSubImage2DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexSubImage3DEXT(GLenum texunit, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glMultiTexSubImage3DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexSubImage3DEXT)(texunit, target, level, xoffset, yoffset, zoffset, width, height, depth, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexSubImage3DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedBufferDataEXT(GLuint buffer, GLsizeiptr size, const GLvoid *data, GLenum usage)
{
  Internal("error_glNamedBufferDataEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedBufferDataEXT)(buffer, size, data, usage);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedBufferDataEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedBufferSubDataEXT(GLuint buffer, GLintptr offset, GLsizeiptr size, const GLvoid *data)
{
  Internal("error_glNamedBufferSubDataEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedBufferSubDataEXT)(buffer, offset, size, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedBufferSubDataEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedCopyBufferSubDataEXT(GLuint readBuffer, GLuint writeBuffer, GLintptr readOffset, GLintptr writeOffset, GLsizeiptr size)
{
  Internal("error_glNamedCopyBufferSubDataEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedCopyBufferSubDataEXT)(readBuffer, writeBuffer, readOffset, writeOffset, size);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedCopyBufferSubDataEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedFramebufferRenderbufferEXT(GLuint framebuffer, GLenum attachment, GLenum renderbuffertarget, GLuint renderbuffer)
{
  Internal("error_glNamedFramebufferRenderbufferEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedFramebufferRenderbufferEXT)(framebuffer, attachment, renderbuffertarget, renderbuffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedFramebufferRenderbufferEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedFramebufferTexture1DEXT(GLuint framebuffer, GLenum attachment, GLenum textarget, GLuint texture, GLint level)
{
  Internal("error_glNamedFramebufferTexture1DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedFramebufferTexture1DEXT)(framebuffer, attachment, textarget, texture, level);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedFramebufferTexture1DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedFramebufferTexture2DEXT(GLuint framebuffer, GLenum attachment, GLenum textarget, GLuint texture, GLint level)
{
  Internal("error_glNamedFramebufferTexture2DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedFramebufferTexture2DEXT)(framebuffer, attachment, textarget, texture, level);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedFramebufferTexture2DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedFramebufferTexture3DEXT(GLuint framebuffer, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLint zoffset)
{
  Internal("error_glNamedFramebufferTexture3DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedFramebufferTexture3DEXT)(framebuffer, attachment, textarget, texture, level, zoffset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedFramebufferTexture3DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedFramebufferTextureEXT(GLuint framebuffer, GLenum attachment, GLuint texture, GLint level)
{
  Internal("error_glNamedFramebufferTextureEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedFramebufferTextureEXT)(framebuffer, attachment, texture, level);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedFramebufferTextureEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedFramebufferTextureFaceEXT(GLuint framebuffer, GLenum attachment, GLuint texture, GLint level, GLenum face)
{
  Internal("error_glNamedFramebufferTextureFaceEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedFramebufferTextureFaceEXT)(framebuffer, attachment, texture, level, face);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedFramebufferTextureFaceEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedFramebufferTextureLayerEXT(GLuint framebuffer, GLenum attachment, GLuint texture, GLint level, GLint layer)
{
  Internal("error_glNamedFramebufferTextureLayerEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedFramebufferTextureLayerEXT)(framebuffer, attachment, texture, level, layer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedFramebufferTextureLayerEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedProgramLocalParameter4dEXT(GLuint program, GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
  Internal("error_glNamedProgramLocalParameter4dEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedProgramLocalParameter4dEXT)(program, target, index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedProgramLocalParameter4dEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedProgramLocalParameter4dvEXT(GLuint program, GLenum target, GLuint index, const GLdouble *params)
{
  Internal("error_glNamedProgramLocalParameter4dvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedProgramLocalParameter4dvEXT)(program, target, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedProgramLocalParameter4dvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedProgramLocalParameter4fEXT(GLuint program, GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
  Internal("error_glNamedProgramLocalParameter4fEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedProgramLocalParameter4fEXT)(program, target, index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedProgramLocalParameter4fEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedProgramLocalParameter4fvEXT(GLuint program, GLenum target, GLuint index, const GLfloat *params)
{
  Internal("error_glNamedProgramLocalParameter4fvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedProgramLocalParameter4fvEXT)(program, target, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedProgramLocalParameter4fvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedProgramLocalParameterI4iEXT(GLuint program, GLenum target, GLuint index, GLint x, GLint y, GLint z, GLint w)
{
  Internal("error_glNamedProgramLocalParameterI4iEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedProgramLocalParameterI4iEXT)(program, target, index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedProgramLocalParameterI4iEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedProgramLocalParameterI4ivEXT(GLuint program, GLenum target, GLuint index, const GLint *params)
{
  Internal("error_glNamedProgramLocalParameterI4ivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedProgramLocalParameterI4ivEXT)(program, target, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedProgramLocalParameterI4ivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedProgramLocalParameterI4uiEXT(GLuint program, GLenum target, GLuint index, GLuint x, GLuint y, GLuint z, GLuint w)
{
  Internal("error_glNamedProgramLocalParameterI4uiEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedProgramLocalParameterI4uiEXT)(program, target, index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedProgramLocalParameterI4uiEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedProgramLocalParameterI4uivEXT(GLuint program, GLenum target, GLuint index, const GLuint *params)
{
  Internal("error_glNamedProgramLocalParameterI4uivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedProgramLocalParameterI4uivEXT)(program, target, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedProgramLocalParameterI4uivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedProgramLocalParameters4fvEXT(GLuint program, GLenum target, GLuint index, GLsizei count, const GLfloat *params)
{
  Internal("error_glNamedProgramLocalParameters4fvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedProgramLocalParameters4fvEXT)(program, target, index, count, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedProgramLocalParameters4fvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedProgramLocalParametersI4ivEXT(GLuint program, GLenum target, GLuint index, GLsizei count, const GLint *params)
{
  Internal("error_glNamedProgramLocalParametersI4ivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedProgramLocalParametersI4ivEXT)(program, target, index, count, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedProgramLocalParametersI4ivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedProgramLocalParametersI4uivEXT(GLuint program, GLenum target, GLuint index, GLsizei count, const GLuint *params)
{
  Internal("error_glNamedProgramLocalParametersI4uivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedProgramLocalParametersI4uivEXT)(program, target, index, count, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedProgramLocalParametersI4uivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedProgramStringEXT(GLuint program, GLenum target, GLenum format, GLsizei len, const GLvoid *string)
{
  Internal("error_glNamedProgramStringEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedProgramStringEXT)(program, target, format, len, string);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedProgramStringEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedRenderbufferStorageEXT(GLuint renderbuffer, GLenum internalformat, GLsizei width, GLsizei height)
{
  Internal("error_glNamedRenderbufferStorageEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedRenderbufferStorageEXT)(renderbuffer, internalformat, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedRenderbufferStorageEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedRenderbufferStorageMultisampleCoverageEXT(GLuint renderbuffer, GLsizei coverageSamples, GLsizei colorSamples, GLenum internalformat, GLsizei width, GLsizei height)
{
  Internal("error_glNamedRenderbufferStorageMultisampleCoverageEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedRenderbufferStorageMultisampleCoverageEXT)(renderbuffer, coverageSamples, colorSamples, internalformat, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedRenderbufferStorageMultisampleCoverageEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNamedRenderbufferStorageMultisampleEXT(GLuint renderbuffer, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height)
{
  Internal("error_glNamedRenderbufferStorageMultisampleEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNamedRenderbufferStorageMultisampleEXT)(renderbuffer, samples, internalformat, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNamedRenderbufferStorageMultisampleEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform1dEXT(GLuint program, GLint location, GLdouble x)
{
  Internal("error_glProgramUniform1dEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform1dEXT)(program, location, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform1dEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform1dvEXT(GLuint program, GLint location, GLsizei count, const GLdouble *value)
{
  Internal("error_glProgramUniform1dvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform1dvEXT)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform1dvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform1fEXT(GLuint program, GLint location, GLfloat v0)
{
  Internal("error_glProgramUniform1fEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform1fEXT)(program, location, v0);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform1fEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform1fvEXT(GLuint program, GLint location, GLsizei count, const GLfloat *value)
{
  Internal("error_glProgramUniform1fvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform1fvEXT)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform1fvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform1iEXT(GLuint program, GLint location, GLint v0)
{
  Internal("error_glProgramUniform1iEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform1iEXT)(program, location, v0);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform1iEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform1ivEXT(GLuint program, GLint location, GLsizei count, const GLint *value)
{
  Internal("error_glProgramUniform1ivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform1ivEXT)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform1ivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform1uiEXT(GLuint program, GLint location, GLuint v0)
{
  Internal("error_glProgramUniform1uiEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform1uiEXT)(program, location, v0);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform1uiEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform1uivEXT(GLuint program, GLint location, GLsizei count, const GLuint *value)
{
  Internal("error_glProgramUniform1uivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform1uivEXT)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform1uivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform2dEXT(GLuint program, GLint location, GLdouble x, GLdouble y)
{
  Internal("error_glProgramUniform2dEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform2dEXT)(program, location, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform2dEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform2dvEXT(GLuint program, GLint location, GLsizei count, const GLdouble *value)
{
  Internal("error_glProgramUniform2dvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform2dvEXT)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform2dvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform2fEXT(GLuint program, GLint location, GLfloat v0, GLfloat v1)
{
  Internal("error_glProgramUniform2fEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform2fEXT)(program, location, v0, v1);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform2fEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform2fvEXT(GLuint program, GLint location, GLsizei count, const GLfloat *value)
{
  Internal("error_glProgramUniform2fvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform2fvEXT)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform2fvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform2iEXT(GLuint program, GLint location, GLint v0, GLint v1)
{
  Internal("error_glProgramUniform2iEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform2iEXT)(program, location, v0, v1);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform2iEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform2ivEXT(GLuint program, GLint location, GLsizei count, const GLint *value)
{
  Internal("error_glProgramUniform2ivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform2ivEXT)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform2ivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform2uiEXT(GLuint program, GLint location, GLuint v0, GLuint v1)
{
  Internal("error_glProgramUniform2uiEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform2uiEXT)(program, location, v0, v1);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform2uiEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform2uivEXT(GLuint program, GLint location, GLsizei count, const GLuint *value)
{
  Internal("error_glProgramUniform2uivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform2uivEXT)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform2uivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform3dEXT(GLuint program, GLint location, GLdouble x, GLdouble y, GLdouble z)
{
  Internal("error_glProgramUniform3dEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform3dEXT)(program, location, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform3dEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform3dvEXT(GLuint program, GLint location, GLsizei count, const GLdouble *value)
{
  Internal("error_glProgramUniform3dvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform3dvEXT)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform3dvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform3fEXT(GLuint program, GLint location, GLfloat v0, GLfloat v1, GLfloat v2)
{
  Internal("error_glProgramUniform3fEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform3fEXT)(program, location, v0, v1, v2);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform3fEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform3fvEXT(GLuint program, GLint location, GLsizei count, const GLfloat *value)
{
  Internal("error_glProgramUniform3fvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform3fvEXT)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform3fvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform3iEXT(GLuint program, GLint location, GLint v0, GLint v1, GLint v2)
{
  Internal("error_glProgramUniform3iEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform3iEXT)(program, location, v0, v1, v2);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform3iEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform3ivEXT(GLuint program, GLint location, GLsizei count, const GLint *value)
{
  Internal("error_glProgramUniform3ivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform3ivEXT)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform3ivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform3uiEXT(GLuint program, GLint location, GLuint v0, GLuint v1, GLuint v2)
{
  Internal("error_glProgramUniform3uiEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform3uiEXT)(program, location, v0, v1, v2);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform3uiEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform3uivEXT(GLuint program, GLint location, GLsizei count, const GLuint *value)
{
  Internal("error_glProgramUniform3uivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform3uivEXT)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform3uivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform4dEXT(GLuint program, GLint location, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
  Internal("error_glProgramUniform4dEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform4dEXT)(program, location, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform4dEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform4dvEXT(GLuint program, GLint location, GLsizei count, const GLdouble *value)
{
  Internal("error_glProgramUniform4dvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform4dvEXT)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform4dvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform4fEXT(GLuint program, GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3)
{
  Internal("error_glProgramUniform4fEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform4fEXT)(program, location, v0, v1, v2, v3);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform4fEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform4fvEXT(GLuint program, GLint location, GLsizei count, const GLfloat *value)
{
  Internal("error_glProgramUniform4fvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform4fvEXT)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform4fvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform4iEXT(GLuint program, GLint location, GLint v0, GLint v1, GLint v2, GLint v3)
{
  Internal("error_glProgramUniform4iEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform4iEXT)(program, location, v0, v1, v2, v3);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform4iEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform4ivEXT(GLuint program, GLint location, GLsizei count, const GLint *value)
{
  Internal("error_glProgramUniform4ivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform4ivEXT)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform4ivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform4uiEXT(GLuint program, GLint location, GLuint v0, GLuint v1, GLuint v2, GLuint v3)
{
  Internal("error_glProgramUniform4uiEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform4uiEXT)(program, location, v0, v1, v2, v3);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform4uiEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform4uivEXT(GLuint program, GLint location, GLsizei count, const GLuint *value)
{
  Internal("error_glProgramUniform4uivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform4uivEXT)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform4uivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix2dvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glProgramUniformMatrix2dvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix2dvEXT)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix2dvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix2fvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glProgramUniformMatrix2fvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix2fvEXT)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix2fvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix2x3dvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glProgramUniformMatrix2x3dvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix2x3dvEXT)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix2x3dvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix2x3fvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glProgramUniformMatrix2x3fvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix2x3fvEXT)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix2x3fvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix2x4dvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glProgramUniformMatrix2x4dvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix2x4dvEXT)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix2x4dvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix2x4fvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glProgramUniformMatrix2x4fvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix2x4fvEXT)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix2x4fvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix3dvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glProgramUniformMatrix3dvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix3dvEXT)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix3dvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix3fvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glProgramUniformMatrix3fvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix3fvEXT)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix3fvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix3x2dvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glProgramUniformMatrix3x2dvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix3x2dvEXT)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix3x2dvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix3x2fvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glProgramUniformMatrix3x2fvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix3x2fvEXT)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix3x2fvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix3x4dvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glProgramUniformMatrix3x4dvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix3x4dvEXT)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix3x4dvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix3x4fvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glProgramUniformMatrix3x4fvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix3x4fvEXT)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix3x4fvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix4dvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glProgramUniformMatrix4dvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix4dvEXT)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix4dvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix4fvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glProgramUniformMatrix4fvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix4fvEXT)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix4fvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix4x2dvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glProgramUniformMatrix4x2dvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix4x2dvEXT)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix4x2dvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix4x2fvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glProgramUniformMatrix4x2fvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix4x2fvEXT)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix4x2fvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix4x3dvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLdouble *value)
{
  Internal("error_glProgramUniformMatrix4x3dvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix4x3dvEXT)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix4x3dvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformMatrix4x3fvEXT(GLuint program, GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glProgramUniformMatrix4x3fvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformMatrix4x3fvEXT)(program, location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformMatrix4x3fvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPushClientAttribDefaultEXT(GLbitfield mask)
{
  Internal("error_glPushClientAttribDefaultEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPushClientAttribDefaultEXT)(mask);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPushClientAttribDefaultEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureBufferEXT(GLuint texture, GLenum target, GLenum internalformat, GLuint buffer)
{
  Internal("error_glTextureBufferEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureBufferEXT)(texture, target, internalformat, buffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureBufferEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureImage1DEXT(GLuint texture, GLenum target, GLint level, GLint internalformat, GLsizei width, GLint border, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glTextureImage1DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureImage1DEXT)(texture, target, level, internalformat, width, border, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureImage1DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureImage2DEXT(GLuint texture, GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glTextureImage2DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureImage2DEXT)(texture, target, level, internalformat, width, height, border, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureImage2DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureImage3DEXT(GLuint texture, GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glTextureImage3DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureImage3DEXT)(texture, target, level, internalformat, width, height, depth, border, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureImage3DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureParameterIivEXT(GLuint texture, GLenum target, GLenum pname, const GLint *params)
{
  Internal("error_glTextureParameterIivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureParameterIivEXT)(texture, target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureParameterIivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureParameterIuivEXT(GLuint texture, GLenum target, GLenum pname, const GLuint *params)
{
  Internal("error_glTextureParameterIuivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureParameterIuivEXT)(texture, target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureParameterIuivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureParameterfEXT(GLuint texture, GLenum target, GLenum pname, GLfloat param)
{
  Internal("error_glTextureParameterfEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureParameterfEXT)(texture, target, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureParameterfEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureParameterfvEXT(GLuint texture, GLenum target, GLenum pname, const GLfloat *param)
{
  Internal("error_glTextureParameterfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureParameterfvEXT)(texture, target, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureParameterfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureParameteriEXT(GLuint texture, GLenum target, GLenum pname, GLint param)
{
  Internal("error_glTextureParameteriEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureParameteriEXT)(texture, target, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureParameteriEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureParameterivEXT(GLuint texture, GLenum target, GLenum pname, const GLint *param)
{
  Internal("error_glTextureParameterivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureParameterivEXT)(texture, target, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureParameterivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureRenderbufferEXT(GLuint texture, GLenum target, GLuint renderbuffer)
{
  Internal("error_glTextureRenderbufferEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureRenderbufferEXT)(texture, target, renderbuffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureRenderbufferEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureSubImage1DEXT(GLuint texture, GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glTextureSubImage1DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureSubImage1DEXT)(texture, target, level, xoffset, width, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureSubImage1DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureSubImage2DEXT(GLuint texture, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glTextureSubImage2DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureSubImage2DEXT)(texture, target, level, xoffset, yoffset, width, height, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureSubImage2DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureSubImage3DEXT(GLuint texture, GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glTextureSubImage3DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureSubImage3DEXT)(texture, target, level, xoffset, yoffset, zoffset, width, height, depth, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureSubImage3DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glUnmapNamedBufferEXT(GLuint buffer)
{
  Internal("error_glUnmapNamedBufferEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glUnmapNamedBufferEXT)(buffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUnmapNamedBufferEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glVertexArrayColorOffsetEXT(GLuint vaobj, GLuint buffer, GLint size, GLenum type, GLsizei stride, const GLintptr offset)
{
  Internal("error_glVertexArrayColorOffsetEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexArrayColorOffsetEXT)(vaobj, buffer, size, type, stride, offset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexArrayColorOffsetEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexArrayEdgeFlagOffsetEXT(GLuint vaobj, GLuint buffer, GLsizei stride, const GLintptr offset)
{
  Internal("error_glVertexArrayEdgeFlagOffsetEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexArrayEdgeFlagOffsetEXT)(vaobj, buffer, stride, offset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexArrayEdgeFlagOffsetEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexArrayFogCoordOffsetEXT(GLuint vaobj, GLuint buffer, GLenum type, GLsizei stride, const GLintptr offset)
{
  Internal("error_glVertexArrayFogCoordOffsetEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexArrayFogCoordOffsetEXT)(vaobj, buffer, type, stride, offset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexArrayFogCoordOffsetEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexArrayIndexOffsetEXT(GLuint vaobj, GLuint buffer, GLenum type, GLsizei stride, const GLintptr offset)
{
  Internal("error_glVertexArrayIndexOffsetEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexArrayIndexOffsetEXT)(vaobj, buffer, type, stride, offset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexArrayIndexOffsetEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexArrayMultiTexCoordOffsetEXT(GLuint vaobj, GLuint buffer, GLenum texunit, GLint size, GLenum type, GLsizei stride, const GLintptr offset)
{
  Internal("error_glVertexArrayMultiTexCoordOffsetEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexArrayMultiTexCoordOffsetEXT)(vaobj, buffer, texunit, size, type, stride, offset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexArrayMultiTexCoordOffsetEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexArrayNormalOffsetEXT(GLuint vaobj, GLuint buffer, GLenum type, GLsizei stride, const GLintptr offset)
{
  Internal("error_glVertexArrayNormalOffsetEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexArrayNormalOffsetEXT)(vaobj, buffer, type, stride, offset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexArrayNormalOffsetEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexArraySecondaryColorOffsetEXT(GLuint vaobj, GLuint buffer, GLint size, GLenum type, GLsizei stride, const GLintptr offset)
{
  Internal("error_glVertexArraySecondaryColorOffsetEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexArraySecondaryColorOffsetEXT)(vaobj, buffer, size, type, stride, offset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexArraySecondaryColorOffsetEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexArrayTexCoordOffsetEXT(GLuint vaobj, GLuint buffer, GLint size, GLenum type, GLsizei stride, const GLintptr offset)
{
  Internal("error_glVertexArrayTexCoordOffsetEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexArrayTexCoordOffsetEXT)(vaobj, buffer, size, type, stride, offset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexArrayTexCoordOffsetEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexArrayVertexAttribIOffsetEXT(GLuint vaobj, GLuint buffer, GLuint index, GLint size, GLenum type, GLsizei stride, const GLintptr offset)
{
  Internal("error_glVertexArrayVertexAttribIOffsetEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexArrayVertexAttribIOffsetEXT)(vaobj, buffer, index, size, type, stride, offset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexArrayVertexAttribIOffsetEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexArrayVertexAttribOffsetEXT(GLuint vaobj, GLuint buffer, GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, const GLintptr offset)
{
  Internal("error_glVertexArrayVertexAttribOffsetEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexArrayVertexAttribOffsetEXT)(vaobj, buffer, index, size, type, normalized, stride, offset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexArrayVertexAttribOffsetEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexArrayVertexOffsetEXT(GLuint vaobj, GLuint buffer, GLint size, GLenum type, GLsizei stride, const GLintptr offset)
{
  Internal("error_glVertexArrayVertexOffsetEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexArrayVertexOffsetEXT)(vaobj, buffer, size, type, stride, offset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexArrayVertexOffsetEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_discard_framebuffer

static void REGAL_CALL error_glDiscardFramebufferEXT(GLenum target, GLsizei numAttachments, const GLenum *attachments)
{
  Internal("error_glDiscardFramebufferEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDiscardFramebufferEXT)(target, numAttachments, attachments);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDiscardFramebufferEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_disjoint_timer_query

static void REGAL_CALL error_glGetQueryObjectivEXT(GLuint id, GLenum pname, GLint *params)
{
  Internal("error_glGetQueryObjectivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetQueryObjectivEXT)(id, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetQueryObjectivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glQueryCounterEXT(GLuint id, GLenum target)
{
  Internal("error_glQueryCounterEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glQueryCounterEXT)(id, target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glQueryCounterEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_draw_buffers2

static void REGAL_CALL error_glColorMaskIndexedEXT(GLuint buf, GLboolean r, GLboolean g, GLboolean b, GLboolean a)
{
  Internal("error_glColorMaskIndexedEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColorMaskIndexedEXT)(buf, r, g, b, a);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColorMaskIndexedEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDisableIndexedEXT(GLenum target, GLuint index)
{
  Internal("error_glDisableIndexedEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDisableIndexedEXT)(target, index);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDisableIndexedEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEnableIndexedEXT(GLenum target, GLuint index)
{
  Internal("error_glEnableIndexedEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEnableIndexedEXT)(target, index);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEnableIndexedEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetBooleanIndexedvEXT(GLenum value, GLuint index, GLboolean *data)
{
  Internal("error_glGetBooleanIndexedvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetBooleanIndexedvEXT)(value, index, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetBooleanIndexedvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetIntegerIndexedvEXT(GLenum value, GLuint index, GLint *data)
{
  Internal("error_glGetIntegerIndexedvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetIntegerIndexedvEXT)(value, index, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetIntegerIndexedvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsEnabledIndexedEXT(GLenum target, GLuint index)
{
  Internal("error_glIsEnabledIndexedEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsEnabledIndexedEXT)(target, index);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsEnabledIndexedEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

// GL_EXT_draw_instanced

static void REGAL_CALL error_glDrawArraysInstancedEXT(GLenum mode, GLint start, GLsizei count, GLsizei primcount)
{
  Internal("error_glDrawArraysInstancedEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawArraysInstancedEXT)(mode, start, count, primcount);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawArraysInstancedEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDrawElementsInstancedEXT(GLenum mode, GLsizei count, GLenum type, const GLvoid *indices, GLsizei primcount)
{
  Internal("error_glDrawElementsInstancedEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawElementsInstancedEXT)(mode, count, type, indices, primcount);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawElementsInstancedEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_draw_range_elements

static void REGAL_CALL error_glDrawRangeElementsEXT(GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const GLvoid *indices)
{
  Internal("error_glDrawRangeElementsEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawRangeElementsEXT)(mode, start, end, count, type, indices);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawRangeElementsEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_fog_coord

static void REGAL_CALL error_glFogCoordPointerEXT(GLenum type, GLsizei stride, const GLvoid *pointer)
{
  Internal("error_glFogCoordPointerEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFogCoordPointerEXT)(type, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFogCoordPointerEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFogCoorddEXT(GLdouble coord)
{
  Internal("error_glFogCoorddEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFogCoorddEXT)(coord);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFogCoorddEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFogCoorddvEXT(const GLdouble *coord)
{
  Internal("error_glFogCoorddvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFogCoorddvEXT)(coord);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFogCoorddvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFogCoordfEXT(GLfloat coord)
{
  Internal("error_glFogCoordfEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFogCoordfEXT)(coord);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFogCoordfEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFogCoordfvEXT(const GLfloat *coord)
{
  Internal("error_glFogCoordfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFogCoordfvEXT)(coord);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFogCoordfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_fragment_lighting

static void REGAL_CALL error_glFragmentColorMaterialEXT(GLenum face, GLenum mode)
{
  Internal("error_glFragmentColorMaterialEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentColorMaterialEXT)(face, mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentColorMaterialEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFragmentLightModelfEXT(GLenum pname, GLfloat param)
{
  Internal("error_glFragmentLightModelfEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentLightModelfEXT)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentLightModelfEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFragmentLightModelfvEXT(GLenum pname, GLfloat *params)
{
  Internal("error_glFragmentLightModelfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentLightModelfvEXT)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentLightModelfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFragmentLightModeliEXT(GLenum pname, GLint param)
{
  Internal("error_glFragmentLightModeliEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentLightModeliEXT)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentLightModeliEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFragmentLightModelivEXT(GLenum pname, GLint *params)
{
  Internal("error_glFragmentLightModelivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentLightModelivEXT)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentLightModelivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFragmentLightfEXT(GLenum light, GLenum pname, GLfloat param)
{
  Internal("error_glFragmentLightfEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentLightfEXT)(light, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentLightfEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFragmentLightfvEXT(GLenum light, GLenum pname, GLfloat *params)
{
  Internal("error_glFragmentLightfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentLightfvEXT)(light, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentLightfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFragmentLightiEXT(GLenum light, GLenum pname, GLint param)
{
  Internal("error_glFragmentLightiEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentLightiEXT)(light, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentLightiEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFragmentLightivEXT(GLenum light, GLenum pname, GLint *params)
{
  Internal("error_glFragmentLightivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentLightivEXT)(light, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentLightivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFragmentMaterialfEXT(GLenum face, GLenum pname, const GLfloat param)
{
  Internal("error_glFragmentMaterialfEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentMaterialfEXT)(face, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentMaterialfEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFragmentMaterialfvEXT(GLenum face, GLenum pname, const GLfloat *params)
{
  Internal("error_glFragmentMaterialfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentMaterialfvEXT)(face, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentMaterialfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFragmentMaterialiEXT(GLenum face, GLenum pname, const GLint param)
{
  Internal("error_glFragmentMaterialiEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentMaterialiEXT)(face, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentMaterialiEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFragmentMaterialivEXT(GLenum face, GLenum pname, const GLint *params)
{
  Internal("error_glFragmentMaterialivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentMaterialivEXT)(face, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentMaterialivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetFragmentLightfvEXT(GLenum light, GLenum pname, GLfloat *params)
{
  Internal("error_glGetFragmentLightfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetFragmentLightfvEXT)(light, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetFragmentLightfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetFragmentLightivEXT(GLenum light, GLenum pname, GLint *params)
{
  Internal("error_glGetFragmentLightivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetFragmentLightivEXT)(light, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetFragmentLightivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetFragmentMaterialfvEXT(GLenum face, GLenum pname, const GLfloat *params)
{
  Internal("error_glGetFragmentMaterialfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetFragmentMaterialfvEXT)(face, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetFragmentMaterialfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetFragmentMaterialivEXT(GLenum face, GLenum pname, const GLint *params)
{
  Internal("error_glGetFragmentMaterialivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetFragmentMaterialivEXT)(face, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetFragmentMaterialivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLightEnviEXT(GLenum pname, GLint param)
{
  Internal("error_glLightEnviEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLightEnviEXT)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLightEnviEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_framebuffer_blit

static void REGAL_CALL error_glBlitFramebufferEXT(GLint srcX0, GLint srcY0, GLint srcX1, GLint srcY1, GLint dstX0, GLint dstY0, GLint dstX1, GLint dstY1, GLbitfield mask, GLenum filter)
{
  Internal("error_glBlitFramebufferEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlitFramebufferEXT)(srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlitFramebufferEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_framebuffer_multisample

static void REGAL_CALL error_glRenderbufferStorageMultisampleEXT(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height)
{
  Internal("error_glRenderbufferStorageMultisampleEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRenderbufferStorageMultisampleEXT)(target, samples, internalformat, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRenderbufferStorageMultisampleEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_framebuffer_object

static void REGAL_CALL error_glBindFramebufferEXT(GLenum target, GLuint framebuffer)
{
  Internal("error_glBindFramebufferEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindFramebufferEXT)(target, framebuffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindFramebufferEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBindRenderbufferEXT(GLenum target, GLuint renderbuffer)
{
  Internal("error_glBindRenderbufferEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindRenderbufferEXT)(target, renderbuffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindRenderbufferEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLenum REGAL_CALL error_glCheckFramebufferStatusEXT(GLenum target)
{
  Internal("error_glCheckFramebufferStatusEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLenum  ret = _next->call(&_next->glCheckFramebufferStatusEXT)(target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCheckFramebufferStatusEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glDeleteFramebuffersEXT(GLsizei n, const GLuint *framebuffers)
{
  Internal("error_glDeleteFramebuffersEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteFramebuffersEXT)(n, framebuffers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteFramebuffersEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteRenderbuffersEXT(GLsizei n, const GLuint *renderbuffers)
{
  Internal("error_glDeleteRenderbuffersEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteRenderbuffersEXT)(n, renderbuffers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteRenderbuffersEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFramebufferRenderbufferEXT(GLenum target, GLenum attachment, GLenum renderbuffertarget, GLuint renderbuffer)
{
  Internal("error_glFramebufferRenderbufferEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFramebufferRenderbufferEXT)(target, attachment, renderbuffertarget, renderbuffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFramebufferRenderbufferEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFramebufferTexture1DEXT(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level)
{
  Internal("error_glFramebufferTexture1DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFramebufferTexture1DEXT)(target, attachment, textarget, texture, level);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFramebufferTexture1DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFramebufferTexture2DEXT(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level)
{
  Internal("error_glFramebufferTexture2DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFramebufferTexture2DEXT)(target, attachment, textarget, texture, level);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFramebufferTexture2DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFramebufferTexture3DEXT(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLint zoffset)
{
  Internal("error_glFramebufferTexture3DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFramebufferTexture3DEXT)(target, attachment, textarget, texture, level, zoffset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFramebufferTexture3DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenFramebuffersEXT(GLsizei n, GLuint *framebuffers)
{
  Internal("error_glGenFramebuffersEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenFramebuffersEXT)(n, framebuffers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenFramebuffersEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenRenderbuffersEXT(GLsizei n, GLuint *renderbuffers)
{
  Internal("error_glGenRenderbuffersEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenRenderbuffersEXT)(n, renderbuffers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenRenderbuffersEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenerateMipmapEXT(GLenum target)
{
  Internal("error_glGenerateMipmapEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenerateMipmapEXT)(target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenerateMipmapEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetFramebufferAttachmentParameterivEXT(GLenum target, GLenum attachment, GLenum pname, GLint *params)
{
  Internal("error_glGetFramebufferAttachmentParameterivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetFramebufferAttachmentParameterivEXT)(target, attachment, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetFramebufferAttachmentParameterivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetRenderbufferParameterivEXT(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetRenderbufferParameterivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetRenderbufferParameterivEXT)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetRenderbufferParameterivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsFramebufferEXT(GLuint framebuffer)
{
  Internal("error_glIsFramebufferEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsFramebufferEXT)(framebuffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsFramebufferEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLboolean REGAL_CALL error_glIsRenderbufferEXT(GLuint renderbuffer)
{
  Internal("error_glIsRenderbufferEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsRenderbufferEXT)(renderbuffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsRenderbufferEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glRenderbufferStorageEXT(GLenum target, GLenum internalformat, GLsizei width, GLsizei height)
{
  Internal("error_glRenderbufferStorageEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRenderbufferStorageEXT)(target, internalformat, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRenderbufferStorageEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_geometry_shader4

static void REGAL_CALL error_glFramebufferTextureEXT(GLenum target, GLenum attachment, GLuint texture, GLint level)
{
  Internal("error_glFramebufferTextureEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFramebufferTextureEXT)(target, attachment, texture, level);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFramebufferTextureEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFramebufferTextureFaceEXT(GLenum target, GLenum attachment, GLuint texture, GLint level, GLenum face)
{
  Internal("error_glFramebufferTextureFaceEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFramebufferTextureFaceEXT)(target, attachment, texture, level, face);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFramebufferTextureFaceEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramParameteriEXT(GLuint program, GLenum pname, GLint value)
{
  Internal("error_glProgramParameteriEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramParameteriEXT)(program, pname, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramParameteriEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_gpu_program_parameters

static void REGAL_CALL error_glProgramEnvParameters4fvEXT(GLenum target, GLuint index, GLsizei count, const GLfloat *params)
{
  Internal("error_glProgramEnvParameters4fvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramEnvParameters4fvEXT)(target, index, count, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramEnvParameters4fvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramLocalParameters4fvEXT(GLenum target, GLuint index, GLsizei count, const GLfloat *params)
{
  Internal("error_glProgramLocalParameters4fvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramLocalParameters4fvEXT)(target, index, count, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramLocalParameters4fvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_gpu_shader4

static void REGAL_CALL error_glBindFragDataLocationEXT(GLuint program, GLuint color, const GLchar *name)
{
  Internal("error_glBindFragDataLocationEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindFragDataLocationEXT)(program, color, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindFragDataLocationEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLint REGAL_CALL error_glGetFragDataLocationEXT(GLuint program, const GLchar *name)
{
  Internal("error_glGetFragDataLocationEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLint  ret = _next->call(&_next->glGetFragDataLocationEXT)(program, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetFragDataLocationEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glGetUniformuivEXT(GLuint program, GLint location, GLuint *params)
{
  Internal("error_glGetUniformuivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetUniformuivEXT)(program, location, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetUniformuivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVertexAttribIivEXT(GLuint index, GLenum pname, GLint *params)
{
  Internal("error_glGetVertexAttribIivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexAttribIivEXT)(index, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexAttribIivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVertexAttribIuivEXT(GLuint index, GLenum pname, GLuint *params)
{
  Internal("error_glGetVertexAttribIuivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexAttribIuivEXT)(index, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexAttribIuivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform1uiEXT(GLint location, GLuint v0)
{
  Internal("error_glUniform1uiEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform1uiEXT)(location, v0);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform1uiEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform1uivEXT(GLint location, GLsizei count, const GLuint *value)
{
  Internal("error_glUniform1uivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform1uivEXT)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform1uivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform2uiEXT(GLint location, GLuint v0, GLuint v1)
{
  Internal("error_glUniform2uiEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform2uiEXT)(location, v0, v1);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform2uiEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform2uivEXT(GLint location, GLsizei count, const GLuint *value)
{
  Internal("error_glUniform2uivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform2uivEXT)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform2uivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform3uiEXT(GLint location, GLuint v0, GLuint v1, GLuint v2)
{
  Internal("error_glUniform3uiEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform3uiEXT)(location, v0, v1, v2);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform3uiEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform3uivEXT(GLint location, GLsizei count, const GLuint *value)
{
  Internal("error_glUniform3uivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform3uivEXT)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform3uivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform4uiEXT(GLint location, GLuint v0, GLuint v1, GLuint v2, GLuint v3)
{
  Internal("error_glUniform4uiEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform4uiEXT)(location, v0, v1, v2, v3);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform4uiEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform4uivEXT(GLint location, GLsizei count, const GLuint *value)
{
  Internal("error_glUniform4uivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform4uivEXT)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform4uivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI1iEXT(GLuint index, GLint x)
{
  Internal("error_glVertexAttribI1iEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI1iEXT)(index, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI1iEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI1ivEXT(GLuint index, const GLint *v)
{
  Internal("error_glVertexAttribI1ivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI1ivEXT)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI1ivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI1uiEXT(GLuint index, GLuint x)
{
  Internal("error_glVertexAttribI1uiEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI1uiEXT)(index, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI1uiEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI1uivEXT(GLuint index, const GLuint *v)
{
  Internal("error_glVertexAttribI1uivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI1uivEXT)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI1uivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI2iEXT(GLuint index, GLint x, GLint y)
{
  Internal("error_glVertexAttribI2iEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI2iEXT)(index, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI2iEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI2ivEXT(GLuint index, const GLint *v)
{
  Internal("error_glVertexAttribI2ivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI2ivEXT)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI2ivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI2uiEXT(GLuint index, GLuint x, GLuint y)
{
  Internal("error_glVertexAttribI2uiEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI2uiEXT)(index, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI2uiEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI2uivEXT(GLuint index, const GLuint *v)
{
  Internal("error_glVertexAttribI2uivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI2uivEXT)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI2uivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI3iEXT(GLuint index, GLint x, GLint y, GLint z)
{
  Internal("error_glVertexAttribI3iEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI3iEXT)(index, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI3iEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI3ivEXT(GLuint index, const GLint *v)
{
  Internal("error_glVertexAttribI3ivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI3ivEXT)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI3ivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI3uiEXT(GLuint index, GLuint x, GLuint y, GLuint z)
{
  Internal("error_glVertexAttribI3uiEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI3uiEXT)(index, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI3uiEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI3uivEXT(GLuint index, const GLuint *v)
{
  Internal("error_glVertexAttribI3uivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI3uivEXT)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI3uivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI4bvEXT(GLuint index, const GLbyte *v)
{
  Internal("error_glVertexAttribI4bvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI4bvEXT)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI4bvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI4iEXT(GLuint index, GLint x, GLint y, GLint z, GLint w)
{
  Internal("error_glVertexAttribI4iEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI4iEXT)(index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI4iEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI4ivEXT(GLuint index, const GLint *v)
{
  Internal("error_glVertexAttribI4ivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI4ivEXT)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI4ivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI4svEXT(GLuint index, const GLshort *v)
{
  Internal("error_glVertexAttribI4svEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI4svEXT)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI4svEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI4ubvEXT(GLuint index, const GLubyte *v)
{
  Internal("error_glVertexAttribI4ubvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI4ubvEXT)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI4ubvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI4uiEXT(GLuint index, GLuint x, GLuint y, GLuint z, GLuint w)
{
  Internal("error_glVertexAttribI4uiEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI4uiEXT)(index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI4uiEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI4uivEXT(GLuint index, const GLuint *v)
{
  Internal("error_glVertexAttribI4uivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI4uivEXT)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI4uivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribI4usvEXT(GLuint index, const GLushort *v)
{
  Internal("error_glVertexAttribI4usvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribI4usvEXT)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribI4usvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribIPointerEXT(GLuint index, GLint size, GLenum type, GLsizei stride, const GLvoid *pointer)
{
  Internal("error_glVertexAttribIPointerEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribIPointerEXT)(index, size, type, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribIPointerEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_histogram

static void REGAL_CALL error_glGetHistogramEXT(GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid *values)
{
  Internal("error_glGetHistogramEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetHistogramEXT)(target, reset, format, type, values);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetHistogramEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetHistogramParameterfvEXT(GLenum target, GLenum pname, GLfloat *params)
{
  Internal("error_glGetHistogramParameterfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetHistogramParameterfvEXT)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetHistogramParameterfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetHistogramParameterivEXT(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetHistogramParameterivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetHistogramParameterivEXT)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetHistogramParameterivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMinmaxEXT(GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid *values)
{
  Internal("error_glGetMinmaxEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMinmaxEXT)(target, reset, format, type, values);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMinmaxEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMinmaxParameterfvEXT(GLenum target, GLenum pname, GLfloat *params)
{
  Internal("error_glGetMinmaxParameterfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMinmaxParameterfvEXT)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMinmaxParameterfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMinmaxParameterivEXT(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetMinmaxParameterivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMinmaxParameterivEXT)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMinmaxParameterivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glHistogramEXT(GLenum target, GLsizei width, GLenum internalformat, GLboolean sink)
{
  Internal("error_glHistogramEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glHistogramEXT)(target, width, internalformat, sink);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glHistogramEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMinmaxEXT(GLenum target, GLenum internalformat, GLboolean sink)
{
  Internal("error_glMinmaxEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMinmaxEXT)(target, internalformat, sink);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMinmaxEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glResetHistogramEXT(GLenum target)
{
  Internal("error_glResetHistogramEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glResetHistogramEXT)(target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glResetHistogramEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glResetMinmaxEXT(GLenum target)
{
  Internal("error_glResetMinmaxEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glResetMinmaxEXT)(target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glResetMinmaxEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_index_func

static void REGAL_CALL error_glIndexFuncEXT(GLenum func, GLfloat ref)
{
  Internal("error_glIndexFuncEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glIndexFuncEXT)(func, ref);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIndexFuncEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_index_material

static void REGAL_CALL error_glIndexMaterialEXT(GLenum face, GLenum mode)
{
  Internal("error_glIndexMaterialEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glIndexMaterialEXT)(face, mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIndexMaterialEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_light_texture

static void REGAL_CALL error_glApplyTextureEXT(GLenum mode)
{
  Internal("error_glApplyTextureEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glApplyTextureEXT)(mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glApplyTextureEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureLightEXT(GLenum pname)
{
  Internal("error_glTextureLightEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureLightEXT)(pname);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureLightEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureMaterialEXT(GLenum face, GLenum mode)
{
  Internal("error_glTextureMaterialEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureMaterialEXT)(face, mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureMaterialEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_map_buffer_range

static void REGAL_CALL error_glFlushMappedBufferRangeEXT(GLenum target, GLintptr offset, GLsizeiptr length)
{
  Internal("error_glFlushMappedBufferRangeEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFlushMappedBufferRangeEXT)(target, offset, length);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFlushMappedBufferRangeEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLvoid *REGAL_CALL error_glMapBufferRangeEXT(GLenum target, GLintptr offset, GLsizeiptr length, GLbitfield access)
{
  Internal("error_glMapBufferRangeEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLvoid * ret = _next->call(&_next->glMapBufferRangeEXT)(target, offset, length, access);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMapBufferRangeEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

// GL_EXT_multi_draw_arrays

static void REGAL_CALL error_glMultiDrawArraysEXT(GLenum mode, const GLint *first, const GLsizei *count, GLsizei primcount)
{
  Internal("error_glMultiDrawArraysEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiDrawArraysEXT)(mode, first, count, primcount);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiDrawArraysEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiDrawElementsEXT(GLenum mode, const GLsizei *count, GLenum type, const GLvoid * const *indices, GLsizei primcount)
{
  Internal("error_glMultiDrawElementsEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiDrawElementsEXT)(mode, count, type, indices, primcount);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiDrawElementsEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_multisample

static void REGAL_CALL error_glSampleMaskEXT(GLclampf value, GLboolean invert)
{
  Internal("error_glSampleMaskEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSampleMaskEXT)(value, invert);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSampleMaskEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSamplePatternEXT(GLenum pattern)
{
  Internal("error_glSamplePatternEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSamplePatternEXT)(pattern);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSamplePatternEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_multisampled_render_to_texture

static void REGAL_CALL error_glFramebufferTexture2DMultisampleEXT(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLsizei samples)
{
  Internal("error_glFramebufferTexture2DMultisampleEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFramebufferTexture2DMultisampleEXT)(target, attachment, textarget, texture, level, samples);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFramebufferTexture2DMultisampleEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_multiview_draw_buffers

static void REGAL_CALL error_glDrawBuffersIndexedEXT(GLint n, const GLenum *location, const GLint *indices)
{
  Internal("error_glDrawBuffersIndexedEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawBuffersIndexedEXT)(n, location, indices);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawBuffersIndexedEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetIntegeri_vEXT(GLenum target, GLuint index, GLint *data)
{
  Internal("error_glGetIntegeri_vEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetIntegeri_vEXT)(target, index, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetIntegeri_vEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReadBufferIndexedEXT(GLenum src, GLint index)
{
  Internal("error_glReadBufferIndexedEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReadBufferIndexedEXT)(src, index);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReadBufferIndexedEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_occlusion_query_boolean

static void REGAL_CALL error_glBeginQueryEXT(GLenum target, GLuint id)
{
  Internal("error_glBeginQueryEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBeginQueryEXT)(target, id);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBeginQueryEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteQueriesEXT(GLsizei n, const GLuint *ids)
{
  Internal("error_glDeleteQueriesEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteQueriesEXT)(n, ids);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteQueriesEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEndQueryEXT(GLenum target)
{
  Internal("error_glEndQueryEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEndQueryEXT)(target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEndQueryEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenQueriesEXT(GLsizei n, GLuint *ids)
{
  Internal("error_glGenQueriesEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenQueriesEXT)(n, ids);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenQueriesEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetQueryObjectuivEXT(GLuint id, GLenum pname, GLuint *params)
{
  Internal("error_glGetQueryObjectuivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetQueryObjectuivEXT)(id, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetQueryObjectuivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetQueryivEXT(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetQueryivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetQueryivEXT)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetQueryivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsQueryEXT(GLuint id)
{
  Internal("error_glIsQueryEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsQueryEXT)(id);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsQueryEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

// GL_EXT_paletted_texture

static void REGAL_CALL error_glColorTableEXT(GLenum target, GLenum internalFormat, GLsizei width, GLenum format, GLenum type, const GLvoid *table)
{
  Internal("error_glColorTableEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColorTableEXT)(target, internalFormat, width, format, type, table);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColorTableEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetColorTableEXT(GLenum target, GLenum format, GLenum type, GLvoid *data)
{
  Internal("error_glGetColorTableEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetColorTableEXT)(target, format, type, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetColorTableEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetColorTableParameterfvEXT(GLenum target, GLenum pname, GLfloat *params)
{
  Internal("error_glGetColorTableParameterfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetColorTableParameterfvEXT)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetColorTableParameterfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetColorTableParameterivEXT(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetColorTableParameterivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetColorTableParameterivEXT)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetColorTableParameterivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_pixel_transform

static void REGAL_CALL error_glGetPixelTransformParameterfvEXT(GLenum target, GLenum pname, GLfloat *params)
{
  Internal("error_glGetPixelTransformParameterfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPixelTransformParameterfvEXT)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPixelTransformParameterfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPixelTransformParameterivEXT(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetPixelTransformParameterivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPixelTransformParameterivEXT)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPixelTransformParameterivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPixelTransformParameterfEXT(GLenum target, GLenum pname, const GLfloat param)
{
  Internal("error_glPixelTransformParameterfEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPixelTransformParameterfEXT)(target, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPixelTransformParameterfEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPixelTransformParameterfvEXT(GLenum target, GLenum pname, const GLfloat *params)
{
  Internal("error_glPixelTransformParameterfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPixelTransformParameterfvEXT)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPixelTransformParameterfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPixelTransformParameteriEXT(GLenum target, GLenum pname, const GLint param)
{
  Internal("error_glPixelTransformParameteriEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPixelTransformParameteriEXT)(target, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPixelTransformParameteriEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPixelTransformParameterivEXT(GLenum target, GLenum pname, const GLint *params)
{
  Internal("error_glPixelTransformParameterivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPixelTransformParameterivEXT)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPixelTransformParameterivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_point_parameters

static void REGAL_CALL error_glPointParameterfEXT(GLenum pname, GLfloat param)
{
  Internal("error_glPointParameterfEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPointParameterfEXT)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPointParameterfEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPointParameterfvEXT(GLenum pname, const GLfloat *params)
{
  Internal("error_glPointParameterfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPointParameterfvEXT)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPointParameterfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_polygon_offset

static void REGAL_CALL error_glPolygonOffsetEXT(GLfloat factor, GLfloat bias)
{
  Internal("error_glPolygonOffsetEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPolygonOffsetEXT)(factor, bias);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPolygonOffsetEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_provoking_vertex

static void REGAL_CALL error_glProvokingVertexEXT(GLenum mode)
{
  Internal("error_glProvokingVertexEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProvokingVertexEXT)(mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProvokingVertexEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_robustness

static void REGAL_CALL error_glGetnUniformfvEXT(GLuint program, GLint location, GLsizei bufSize, GLfloat *params)
{
  Internal("error_glGetnUniformfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetnUniformfvEXT)(program, location, bufSize, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetnUniformfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetnUniformivEXT(GLuint program, GLint location, GLsizei bufSize, GLint *params)
{
  Internal("error_glGetnUniformivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetnUniformivEXT)(program, location, bufSize, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetnUniformivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReadnPixelsEXT(GLint x, GLint y, GLsizei width, GLsizei height, GLenum format, GLenum type, GLsizei bufSize, GLvoid *data)
{
  Internal("error_glReadnPixelsEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReadnPixelsEXT)(x, y, width, height, format, type, bufSize, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReadnPixelsEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_scene_marker

static void REGAL_CALL error_glBeginSceneEXT(void)
{
  Internal("error_glBeginSceneEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBeginSceneEXT)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBeginSceneEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEndSceneEXT(void)
{
  Internal("error_glEndSceneEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEndSceneEXT)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEndSceneEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_secondary_color

static void REGAL_CALL error_glSecondaryColor3bEXT(GLbyte red, GLbyte green, GLbyte blue)
{
  Internal("error_glSecondaryColor3bEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3bEXT)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3bEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3bvEXT(const GLbyte *v)
{
  Internal("error_glSecondaryColor3bvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3bvEXT)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3bvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3dEXT(GLdouble red, GLdouble green, GLdouble blue)
{
  Internal("error_glSecondaryColor3dEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3dEXT)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3dEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3dvEXT(const GLdouble *v)
{
  Internal("error_glSecondaryColor3dvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3dvEXT)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3dvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3fEXT(GLfloat red, GLfloat green, GLfloat blue)
{
  Internal("error_glSecondaryColor3fEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3fEXT)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3fEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3fvEXT(const GLfloat *v)
{
  Internal("error_glSecondaryColor3fvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3fvEXT)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3fvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3iEXT(GLint red, GLint green, GLint blue)
{
  Internal("error_glSecondaryColor3iEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3iEXT)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3iEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3ivEXT(const GLint *v)
{
  Internal("error_glSecondaryColor3ivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3ivEXT)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3ivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3sEXT(GLshort red, GLshort green, GLshort blue)
{
  Internal("error_glSecondaryColor3sEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3sEXT)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3sEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3svEXT(const GLshort *v)
{
  Internal("error_glSecondaryColor3svEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3svEXT)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3svEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3ubEXT(GLubyte red, GLubyte green, GLubyte blue)
{
  Internal("error_glSecondaryColor3ubEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3ubEXT)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3ubEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3ubvEXT(const GLubyte *v)
{
  Internal("error_glSecondaryColor3ubvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3ubvEXT)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3ubvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3uiEXT(GLuint red, GLuint green, GLuint blue)
{
  Internal("error_glSecondaryColor3uiEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3uiEXT)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3uiEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3uivEXT(const GLuint *v)
{
  Internal("error_glSecondaryColor3uivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3uivEXT)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3uivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3usEXT(GLushort red, GLushort green, GLushort blue)
{
  Internal("error_glSecondaryColor3usEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3usEXT)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3usEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3usvEXT(const GLushort *v)
{
  Internal("error_glSecondaryColor3usvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3usvEXT)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3usvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColorPointerEXT(GLint size, GLenum type, GLsizei stride, const GLvoid *pointer)
{
  Internal("error_glSecondaryColorPointerEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColorPointerEXT)(size, type, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColorPointerEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_separate_shader_objects

static void REGAL_CALL error_glActiveProgramEXT(GLuint program)
{
  Internal("error_glActiveProgramEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glActiveProgramEXT)(program);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glActiveProgramEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLuint REGAL_CALL error_glCreateShaderProgramEXT(GLenum type, const GLchar *string)
{
  Internal("error_glCreateShaderProgramEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint  ret = _next->call(&_next->glCreateShaderProgramEXT)(type, string);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCreateShaderProgramEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glUseShaderProgramEXT(GLenum type, GLuint program)
{
  Internal("error_glUseShaderProgramEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUseShaderProgramEXT)(type, program);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUseShaderProgramEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_shader_image_load_store

static void REGAL_CALL error_glBindImageTextureEXT(GLuint index, GLuint texture, GLint level, GLboolean layered, GLint layer, GLenum access, GLint format)
{
  Internal("error_glBindImageTextureEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindImageTextureEXT)(index, texture, level, layered, layer, access, format);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindImageTextureEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMemoryBarrierEXT(GLbitfield barriers)
{
  Internal("error_glMemoryBarrierEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMemoryBarrierEXT)(barriers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMemoryBarrierEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_stencil_clear_tag

static void REGAL_CALL error_glStencilClearTagEXT(GLsizei stencilTagBits, GLuint stencilClearTag)
{
  Internal("error_glStencilClearTagEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glStencilClearTagEXT)(stencilTagBits, stencilClearTag);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glStencilClearTagEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_stencil_two_side

static void REGAL_CALL error_glActiveStencilFaceEXT(GLenum face)
{
  Internal("error_glActiveStencilFaceEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glActiveStencilFaceEXT)(face);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glActiveStencilFaceEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_subtexture

static void REGAL_CALL error_glTexSubImage1DEXT(GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glTexSubImage1DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexSubImage1DEXT)(target, level, xoffset, width, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexSubImage1DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexSubImage2DEXT(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glTexSubImage2DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexSubImage2DEXT)(target, level, xoffset, yoffset, width, height, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexSubImage2DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexSubImage3DEXT(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glTexSubImage3DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexSubImage3DEXT)(target, level, xoffset, yoffset, zoffset, width, height, depth, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexSubImage3DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_texture3D

static void REGAL_CALL error_glTexImage3DEXT(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glTexImage3DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexImage3DEXT)(target, level, internalformat, width, height, depth, border, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexImage3DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_texture_array

static void REGAL_CALL error_glFramebufferTextureLayerEXT(GLenum target, GLenum attachment, GLuint texture, GLint level, GLint layer)
{
  Internal("error_glFramebufferTextureLayerEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFramebufferTextureLayerEXT)(target, attachment, texture, level, layer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFramebufferTextureLayerEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_texture_buffer_object

static void REGAL_CALL error_glTexBufferEXT(GLenum target, GLenum internalformat, GLuint buffer)
{
  Internal("error_glTexBufferEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexBufferEXT)(target, internalformat, buffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexBufferEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_texture_integer

static void REGAL_CALL error_glClearColorIiEXT(GLint red, GLint green, GLint blue, GLint alpha)
{
  Internal("error_glClearColorIiEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClearColorIiEXT)(red, green, blue, alpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClearColorIiEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glClearColorIuiEXT(GLuint red, GLuint green, GLuint blue, GLuint alpha)
{
  Internal("error_glClearColorIuiEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClearColorIuiEXT)(red, green, blue, alpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClearColorIuiEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTexParameterIivEXT(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetTexParameterIivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTexParameterIivEXT)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTexParameterIivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTexParameterIuivEXT(GLenum target, GLenum pname, GLuint *params)
{
  Internal("error_glGetTexParameterIuivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTexParameterIuivEXT)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTexParameterIuivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexParameterIivEXT(GLenum target, GLenum pname, const GLint *params)
{
  Internal("error_glTexParameterIivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexParameterIivEXT)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexParameterIivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexParameterIuivEXT(GLenum target, GLenum pname, const GLuint *params)
{
  Internal("error_glTexParameterIuivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexParameterIuivEXT)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexParameterIuivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_texture_object

static GLboolean REGAL_CALL error_glAreTexturesResidentEXT(GLsizei n, const GLuint *textures, GLboolean *residences)
{
  Internal("error_glAreTexturesResidentEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glAreTexturesResidentEXT)(n, textures, residences);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glAreTexturesResidentEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glBindTextureEXT(GLenum target, GLuint texture)
{
  Internal("error_glBindTextureEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindTextureEXT)(target, texture);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindTextureEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteTexturesEXT(GLsizei n, const GLuint *textures)
{
  Internal("error_glDeleteTexturesEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteTexturesEXT)(n, textures);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteTexturesEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenTexturesEXT(GLsizei n, GLuint *textures)
{
  Internal("error_glGenTexturesEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenTexturesEXT)(n, textures);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenTexturesEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsTextureEXT(GLuint texture)
{
  Internal("error_glIsTextureEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsTextureEXT)(texture);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsTextureEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glPrioritizeTexturesEXT(GLsizei n, const GLuint *textures, const GLclampf *priorities)
{
  Internal("error_glPrioritizeTexturesEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPrioritizeTexturesEXT)(n, textures, priorities);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPrioritizeTexturesEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_texture_perturb_normal

static void REGAL_CALL error_glTextureNormalEXT(GLenum mode)
{
  Internal("error_glTextureNormalEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureNormalEXT)(mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureNormalEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_texture_storage

static void REGAL_CALL error_glTexStorage1DEXT(GLenum target, GLsizei levels, GLenum internalformat, GLsizei width)
{
  Internal("error_glTexStorage1DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexStorage1DEXT)(target, levels, internalformat, width);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexStorage1DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexStorage2DEXT(GLenum target, GLsizei levels, GLenum internalformat, GLsizei width, GLsizei height)
{
  Internal("error_glTexStorage2DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexStorage2DEXT)(target, levels, internalformat, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexStorage2DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexStorage3DEXT(GLenum target, GLsizei levels, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth)
{
  Internal("error_glTexStorage3DEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexStorage3DEXT)(target, levels, internalformat, width, height, depth);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexStorage3DEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_timer_query

static void REGAL_CALL error_glGetQueryObjecti64vEXT(GLuint id, GLenum pname, GLint64EXT *params)
{
  Internal("error_glGetQueryObjecti64vEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetQueryObjecti64vEXT)(id, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetQueryObjecti64vEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetQueryObjectui64vEXT(GLuint id, GLenum pname, GLuint64EXT *params)
{
  Internal("error_glGetQueryObjectui64vEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetQueryObjectui64vEXT)(id, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetQueryObjectui64vEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_transform_feedback

static void REGAL_CALL error_glBeginTransformFeedbackEXT(GLenum primitiveMode)
{
  Internal("error_glBeginTransformFeedbackEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBeginTransformFeedbackEXT)(primitiveMode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBeginTransformFeedbackEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBindBufferBaseEXT(GLenum target, GLuint index, GLuint buffer)
{
  Internal("error_glBindBufferBaseEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindBufferBaseEXT)(target, index, buffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindBufferBaseEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBindBufferOffsetEXT(GLenum target, GLuint index, GLuint buffer, GLintptr offset)
{
  Internal("error_glBindBufferOffsetEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindBufferOffsetEXT)(target, index, buffer, offset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindBufferOffsetEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBindBufferRangeEXT(GLenum target, GLuint index, GLuint buffer, GLintptr offset, GLsizeiptr size)
{
  Internal("error_glBindBufferRangeEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindBufferRangeEXT)(target, index, buffer, offset, size);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindBufferRangeEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEndTransformFeedbackEXT(void)
{
  Internal("error_glEndTransformFeedbackEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEndTransformFeedbackEXT)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEndTransformFeedbackEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTransformFeedbackVaryingEXT(GLuint program, GLuint index, GLsizei bufSize, GLsizei *length, GLsizei *size, GLenum *type, GLchar *name)
{
  Internal("error_glGetTransformFeedbackVaryingEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTransformFeedbackVaryingEXT)(program, index, bufSize, length, size, type, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTransformFeedbackVaryingEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTransformFeedbackVaryingsEXT(GLuint program, GLsizei count, const GLchar * const *varyings, GLenum bufferMode)
{
  Internal("error_glTransformFeedbackVaryingsEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTransformFeedbackVaryingsEXT)(program, count, varyings, bufferMode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTransformFeedbackVaryingsEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_vertex_array

static void REGAL_CALL error_glArrayElementEXT(GLint i)
{
  Internal("error_glArrayElementEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glArrayElementEXT)(i);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glArrayElementEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColorPointerEXT(GLint size, GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer)
{
  Internal("error_glColorPointerEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColorPointerEXT)(size, type, stride, count, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColorPointerEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDrawArraysEXT(GLenum mode, GLint first, GLsizei count)
{
  Internal("error_glDrawArraysEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawArraysEXT)(mode, first, count);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawArraysEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEdgeFlagPointerEXT(GLsizei stride, GLsizei count, const GLboolean *pointer)
{
  Internal("error_glEdgeFlagPointerEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEdgeFlagPointerEXT)(stride, count, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEdgeFlagPointerEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPointervEXT(GLenum pname, GLvoid **params)
{
  Internal("error_glGetPointervEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPointervEXT)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPointervEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glIndexPointerEXT(GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer)
{
  Internal("error_glIndexPointerEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glIndexPointerEXT)(type, stride, count, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIndexPointerEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormalPointerEXT(GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer)
{
  Internal("error_glNormalPointerEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormalPointerEXT)(type, stride, count, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormalPointerEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoordPointerEXT(GLint size, GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer)
{
  Internal("error_glTexCoordPointerEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoordPointerEXT)(size, type, stride, count, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoordPointerEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexPointerEXT(GLint size, GLenum type, GLsizei stride, GLsizei count, const GLvoid *pointer)
{
  Internal("error_glVertexPointerEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexPointerEXT)(size, type, stride, count, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexPointerEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_vertex_attrib_64bit

static void REGAL_CALL error_glGetVertexAttribLdvEXT(GLuint index, GLenum pname, GLdouble *params)
{
  Internal("error_glGetVertexAttribLdvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexAttribLdvEXT)(index, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexAttribLdvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexArrayVertexAttribLOffsetEXT(GLuint vaobj, GLuint buffer, GLuint index, GLint size, GLenum type, GLsizei stride, GLintptr offset)
{
  Internal("error_glVertexArrayVertexAttribLOffsetEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexArrayVertexAttribLOffsetEXT)(vaobj, buffer, index, size, type, stride, offset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexArrayVertexAttribLOffsetEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL1dEXT(GLuint index, GLdouble x)
{
  Internal("error_glVertexAttribL1dEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL1dEXT)(index, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL1dEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL1dvEXT(GLuint index, const GLdouble *v)
{
  Internal("error_glVertexAttribL1dvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL1dvEXT)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL1dvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL2dEXT(GLuint index, GLdouble x, GLdouble y)
{
  Internal("error_glVertexAttribL2dEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL2dEXT)(index, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL2dEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL2dvEXT(GLuint index, const GLdouble *v)
{
  Internal("error_glVertexAttribL2dvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL2dvEXT)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL2dvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL3dEXT(GLuint index, GLdouble x, GLdouble y, GLdouble z)
{
  Internal("error_glVertexAttribL3dEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL3dEXT)(index, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL3dEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL3dvEXT(GLuint index, const GLdouble *v)
{
  Internal("error_glVertexAttribL3dvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL3dvEXT)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL3dvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL4dEXT(GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
  Internal("error_glVertexAttribL4dEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL4dEXT)(index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL4dEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL4dvEXT(GLuint index, const GLdouble *v)
{
  Internal("error_glVertexAttribL4dvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL4dvEXT)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL4dvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribLPointerEXT(GLuint index, GLint size, GLenum type, GLsizei stride, const GLvoid *pointer)
{
  Internal("error_glVertexAttribLPointerEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribLPointerEXT)(index, size, type, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribLPointerEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_vertex_shader

static void REGAL_CALL error_glBeginVertexShaderEXT(void)
{
  Internal("error_glBeginVertexShaderEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBeginVertexShaderEXT)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBeginVertexShaderEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLuint REGAL_CALL error_glBindLightParameterEXT(GLenum light, GLenum value)
{
  Internal("error_glBindLightParameterEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint  ret = _next->call(&_next->glBindLightParameterEXT)(light, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindLightParameterEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLuint REGAL_CALL error_glBindMaterialParameterEXT(GLenum face, GLenum value)
{
  Internal("error_glBindMaterialParameterEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint  ret = _next->call(&_next->glBindMaterialParameterEXT)(face, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindMaterialParameterEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLuint REGAL_CALL error_glBindParameterEXT(GLenum value)
{
  Internal("error_glBindParameterEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint  ret = _next->call(&_next->glBindParameterEXT)(value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindParameterEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLuint REGAL_CALL error_glBindTexGenParameterEXT(GLenum unit, GLenum coord, GLenum value)
{
  Internal("error_glBindTexGenParameterEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint  ret = _next->call(&_next->glBindTexGenParameterEXT)(unit, coord, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindTexGenParameterEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLuint REGAL_CALL error_glBindTextureUnitParameterEXT(GLenum unit, GLenum value)
{
  Internal("error_glBindTextureUnitParameterEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint  ret = _next->call(&_next->glBindTextureUnitParameterEXT)(unit, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindTextureUnitParameterEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glBindVertexShaderEXT(GLuint id)
{
  Internal("error_glBindVertexShaderEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindVertexShaderEXT)(id);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindVertexShaderEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteVertexShaderEXT(GLuint id)
{
  Internal("error_glDeleteVertexShaderEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteVertexShaderEXT)(id);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteVertexShaderEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDisableVariantClientStateEXT(GLuint id)
{
  Internal("error_glDisableVariantClientStateEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDisableVariantClientStateEXT)(id);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDisableVariantClientStateEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEnableVariantClientStateEXT(GLuint id)
{
  Internal("error_glEnableVariantClientStateEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEnableVariantClientStateEXT)(id);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEnableVariantClientStateEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEndVertexShaderEXT(void)
{
  Internal("error_glEndVertexShaderEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEndVertexShaderEXT)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEndVertexShaderEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glExtractComponentEXT(GLuint res, GLuint src, GLuint num)
{
  Internal("error_glExtractComponentEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glExtractComponentEXT)(res, src, num);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glExtractComponentEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLuint REGAL_CALL error_glGenSymbolsEXT(GLenum datatype, GLenum storagetype, GLenum range, GLuint components)
{
  Internal("error_glGenSymbolsEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint  ret = _next->call(&_next->glGenSymbolsEXT)(datatype, storagetype, range, components);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenSymbolsEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLuint REGAL_CALL error_glGenVertexShadersEXT(GLuint range)
{
  Internal("error_glGenVertexShadersEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint  ret = _next->call(&_next->glGenVertexShadersEXT)(range);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenVertexShadersEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glGetInvariantBooleanvEXT(GLuint id, GLenum value, GLboolean *data)
{
  Internal("error_glGetInvariantBooleanvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetInvariantBooleanvEXT)(id, value, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetInvariantBooleanvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetInvariantFloatvEXT(GLuint id, GLenum value, GLfloat *data)
{
  Internal("error_glGetInvariantFloatvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetInvariantFloatvEXT)(id, value, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetInvariantFloatvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetInvariantIntegervEXT(GLuint id, GLenum value, GLint *data)
{
  Internal("error_glGetInvariantIntegervEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetInvariantIntegervEXT)(id, value, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetInvariantIntegervEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetLocalConstantBooleanvEXT(GLuint id, GLenum value, GLboolean *data)
{
  Internal("error_glGetLocalConstantBooleanvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetLocalConstantBooleanvEXT)(id, value, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetLocalConstantBooleanvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetLocalConstantFloatvEXT(GLuint id, GLenum value, GLfloat *data)
{
  Internal("error_glGetLocalConstantFloatvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetLocalConstantFloatvEXT)(id, value, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetLocalConstantFloatvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetLocalConstantIntegervEXT(GLuint id, GLenum value, GLint *data)
{
  Internal("error_glGetLocalConstantIntegervEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetLocalConstantIntegervEXT)(id, value, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetLocalConstantIntegervEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVariantBooleanvEXT(GLuint id, GLenum value, GLboolean *data)
{
  Internal("error_glGetVariantBooleanvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVariantBooleanvEXT)(id, value, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVariantBooleanvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVariantFloatvEXT(GLuint id, GLenum value, GLfloat *data)
{
  Internal("error_glGetVariantFloatvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVariantFloatvEXT)(id, value, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVariantFloatvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVariantIntegervEXT(GLuint id, GLenum value, GLint *data)
{
  Internal("error_glGetVariantIntegervEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVariantIntegervEXT)(id, value, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVariantIntegervEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVariantPointervEXT(GLuint id, GLenum value, GLvoid **data)
{
  Internal("error_glGetVariantPointervEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVariantPointervEXT)(id, value, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVariantPointervEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glInsertComponentEXT(GLuint res, GLuint src, GLuint num)
{
  Internal("error_glInsertComponentEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glInsertComponentEXT)(res, src, num);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glInsertComponentEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsVariantEnabledEXT(GLuint id, GLenum cap)
{
  Internal("error_glIsVariantEnabledEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsVariantEnabledEXT)(id, cap);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsVariantEnabledEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glSetInvariantEXT(GLuint id, GLenum type, const GLvoid *addr)
{
  Internal("error_glSetInvariantEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSetInvariantEXT)(id, type, addr);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSetInvariantEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSetLocalConstantEXT(GLuint id, GLenum type, const GLvoid *addr)
{
  Internal("error_glSetLocalConstantEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSetLocalConstantEXT)(id, type, addr);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSetLocalConstantEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glShaderOp1EXT(GLenum op, GLuint res, GLuint arg1)
{
  Internal("error_glShaderOp1EXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glShaderOp1EXT)(op, res, arg1);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glShaderOp1EXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glShaderOp2EXT(GLenum op, GLuint res, GLuint arg1, GLuint arg2)
{
  Internal("error_glShaderOp2EXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glShaderOp2EXT)(op, res, arg1, arg2);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glShaderOp2EXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glShaderOp3EXT(GLenum op, GLuint res, GLuint arg1, GLuint arg2, GLuint arg3)
{
  Internal("error_glShaderOp3EXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glShaderOp3EXT)(op, res, arg1, arg2, arg3);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glShaderOp3EXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSwizzleEXT(GLuint res, GLuint in, GLenum outX, GLenum outY, GLenum outZ, GLenum outW)
{
  Internal("error_glSwizzleEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSwizzleEXT)(res, in, outX, outY, outZ, outW);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSwizzleEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVariantPointerEXT(GLuint id, GLenum type, GLuint stride, const GLvoid *addr)
{
  Internal("error_glVariantPointerEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVariantPointerEXT)(id, type, stride, addr);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVariantPointerEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVariantbvEXT(GLuint id, const GLbyte *addr)
{
  Internal("error_glVariantbvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVariantbvEXT)(id, addr);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVariantbvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVariantdvEXT(GLuint id, const GLdouble *addr)
{
  Internal("error_glVariantdvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVariantdvEXT)(id, addr);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVariantdvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVariantfvEXT(GLuint id, const GLfloat *addr)
{
  Internal("error_glVariantfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVariantfvEXT)(id, addr);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVariantfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVariantivEXT(GLuint id, const GLint *addr)
{
  Internal("error_glVariantivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVariantivEXT)(id, addr);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVariantivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVariantsvEXT(GLuint id, const GLshort *addr)
{
  Internal("error_glVariantsvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVariantsvEXT)(id, addr);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVariantsvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVariantubvEXT(GLuint id, const GLubyte *addr)
{
  Internal("error_glVariantubvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVariantubvEXT)(id, addr);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVariantubvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVariantuivEXT(GLuint id, const GLuint *addr)
{
  Internal("error_glVariantuivEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVariantuivEXT)(id, addr);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVariantuivEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVariantusvEXT(GLuint id, const GLushort *addr)
{
  Internal("error_glVariantusvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVariantusvEXT)(id, addr);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVariantusvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWriteMaskEXT(GLuint res, GLuint in, GLenum outX, GLenum outY, GLenum outZ, GLenum outW)
{
  Internal("error_glWriteMaskEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWriteMaskEXT)(res, in, outX, outY, outZ, outW);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWriteMaskEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_vertex_weighting

static void REGAL_CALL error_glVertexWeightPointerEXT(GLsizei size, GLenum type, GLsizei stride, const GLvoid *pointer)
{
  Internal("error_glVertexWeightPointerEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexWeightPointerEXT)(size, type, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexWeightPointerEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexWeightfEXT(GLfloat weight)
{
  Internal("error_glVertexWeightfEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexWeightfEXT)(weight);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexWeightfEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexWeightfvEXT(const GLfloat *weight)
{
  Internal("error_glVertexWeightfvEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexWeightfvEXT)(weight);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexWeightfvEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_EXT_x11_sync_object

static GLsync REGAL_CALL error_glImportSyncEXT(GLenum external_sync_type, GLintptr external_sync, GLbitfield flags)
{
  Internal("error_glImportSyncEXT","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLsync  ret = _next->call(&_next->glImportSyncEXT)(external_sync_type, external_sync, flags);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glImportSyncEXT : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

// GL_GREMEDY_frame_terminator

static void REGAL_CALL error_glFrameTerminatorGREMEDY(void)
{
  Internal("error_glFrameTerminatorGREMEDY","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFrameTerminatorGREMEDY)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFrameTerminatorGREMEDY : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_GREMEDY_string_marker

static void REGAL_CALL error_glStringMarkerGREMEDY(GLsizei len, const GLvoid *string)
{
  Internal("error_glStringMarkerGREMEDY","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glStringMarkerGREMEDY)(len, string);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glStringMarkerGREMEDY : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_HP_image_transform

static void REGAL_CALL error_glGetImageTransformParameterfvHP(GLenum target, GLenum pname, GLfloat *params)
{
  Internal("error_glGetImageTransformParameterfvHP","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetImageTransformParameterfvHP)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetImageTransformParameterfvHP : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetImageTransformParameterivHP(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetImageTransformParameterivHP","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetImageTransformParameterivHP)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetImageTransformParameterivHP : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glImageTransformParameterfHP(GLenum target, GLenum pname, GLfloat param)
{
  Internal("error_glImageTransformParameterfHP","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glImageTransformParameterfHP)(target, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glImageTransformParameterfHP : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glImageTransformParameterfvHP(GLenum target, GLenum pname, const GLfloat *params)
{
  Internal("error_glImageTransformParameterfvHP","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glImageTransformParameterfvHP)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glImageTransformParameterfvHP : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glImageTransformParameteriHP(GLenum target, GLenum pname, GLint param)
{
  Internal("error_glImageTransformParameteriHP","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glImageTransformParameteriHP)(target, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glImageTransformParameteriHP : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glImageTransformParameterivHP(GLenum target, GLenum pname, const GLint *params)
{
  Internal("error_glImageTransformParameterivHP","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glImageTransformParameterivHP)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glImageTransformParameterivHP : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_IBM_multimode_draw_arrays

static void REGAL_CALL error_glMultiModeDrawArraysIBM(const GLenum *mode, const GLint *first, const GLsizei *count, GLsizei primcount, GLint modestride)
{
  Internal("error_glMultiModeDrawArraysIBM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiModeDrawArraysIBM)(mode, first, count, primcount, modestride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiModeDrawArraysIBM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiModeDrawElementsIBM(const GLenum *mode, const GLsizei *count, GLenum type, const GLvoid * const *indices, GLsizei primcount, GLint modestride)
{
  Internal("error_glMultiModeDrawElementsIBM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiModeDrawElementsIBM)(mode, count, type, indices, primcount, modestride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiModeDrawElementsIBM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_IBM_vertex_array_lists

static void REGAL_CALL error_glColorPointerListIBM(GLint size, GLenum type, GLint stride, const GLvoid **pointer, GLint ptrstride)
{
  Internal("error_glColorPointerListIBM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColorPointerListIBM)(size, type, stride, pointer, ptrstride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColorPointerListIBM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEdgeFlagPointerListIBM(GLint stride, const GLboolean **pointer, GLint ptrstride)
{
  Internal("error_glEdgeFlagPointerListIBM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEdgeFlagPointerListIBM)(stride, pointer, ptrstride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEdgeFlagPointerListIBM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFogCoordPointerListIBM(GLenum type, GLint stride, const GLvoid **pointer, GLint ptrstride)
{
  Internal("error_glFogCoordPointerListIBM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFogCoordPointerListIBM)(type, stride, pointer, ptrstride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFogCoordPointerListIBM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glIndexPointerListIBM(GLenum type, GLint stride, const GLvoid **pointer, GLint ptrstride)
{
  Internal("error_glIndexPointerListIBM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glIndexPointerListIBM)(type, stride, pointer, ptrstride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIndexPointerListIBM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormalPointerListIBM(GLenum type, GLint stride, const GLvoid **pointer, GLint ptrstride)
{
  Internal("error_glNormalPointerListIBM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormalPointerListIBM)(type, stride, pointer, ptrstride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormalPointerListIBM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColorPointerListIBM(GLint size, GLenum type, GLint stride, const GLvoid **pointer, GLint ptrstride)
{
  Internal("error_glSecondaryColorPointerListIBM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColorPointerListIBM)(size, type, stride, pointer, ptrstride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColorPointerListIBM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoordPointerListIBM(GLint size, GLenum type, GLint stride, const GLvoid **pointer, GLint ptrstride)
{
  Internal("error_glTexCoordPointerListIBM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoordPointerListIBM)(size, type, stride, pointer, ptrstride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoordPointerListIBM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexPointerListIBM(GLint size, GLenum type, GLint stride, const GLvoid **pointer, GLint ptrstride)
{
  Internal("error_glVertexPointerListIBM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexPointerListIBM)(size, type, stride, pointer, ptrstride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexPointerListIBM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_IMG_multisampled_render_to_texture

static void REGAL_CALL error_glFramebufferTexture2DMultisampleIMG(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLsizei samples)
{
  Internal("error_glFramebufferTexture2DMultisampleIMG","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFramebufferTexture2DMultisampleIMG)(target, attachment, textarget, texture, level, samples);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFramebufferTexture2DMultisampleIMG : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRenderbufferStorageMultisampleIMG(GLenum target, GLsizei samples, GLenum internalformat, GLsizei width, GLsizei height)
{
  Internal("error_glRenderbufferStorageMultisampleIMG","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRenderbufferStorageMultisampleIMG)(target, samples, internalformat, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRenderbufferStorageMultisampleIMG : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_INGR_blend_func_separate

static void REGAL_CALL error_glBlendFuncSeparateINGR(GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha)
{
  Internal("error_glBlendFuncSeparateINGR","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendFuncSeparateINGR)(sfactorRGB, dfactorRGB, sfactorAlpha, dfactorAlpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendFuncSeparateINGR : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_INTEL_map_texture

static GLvoid *REGAL_CALL error_glMapTexture2DINTEL(GLuint texture, GLint level, GLbitfield access, GLint *stride, GLenum *layout)
{
  Internal("error_glMapTexture2DINTEL","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLvoid * ret = _next->call(&_next->glMapTexture2DINTEL)(texture, level, access, stride, layout);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMapTexture2DINTEL : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glSyncTextureINTEL(GLuint texture)
{
  Internal("error_glSyncTextureINTEL","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSyncTextureINTEL)(texture);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSyncTextureINTEL : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUnmapTexture2DINTEL(GLuint texture, GLint level)
{
  Internal("error_glUnmapTexture2DINTEL","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUnmapTexture2DINTEL)(texture, level);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUnmapTexture2DINTEL : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_INTEL_parallel_arrays

static void REGAL_CALL error_glColorPointervINTEL(GLint size, GLenum type, const GLvoid **pointer)
{
  Internal("error_glColorPointervINTEL","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColorPointervINTEL)(size, type, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColorPointervINTEL : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormalPointervINTEL(GLenum type, const GLvoid **pointer)
{
  Internal("error_glNormalPointervINTEL","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormalPointervINTEL)(type, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormalPointervINTEL : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoordPointervINTEL(GLint size, GLenum type, const GLvoid **pointer)
{
  Internal("error_glTexCoordPointervINTEL","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoordPointervINTEL)(size, type, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoordPointervINTEL : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexPointervINTEL(GLint size, GLenum type, const GLvoid **pointer)
{
  Internal("error_glVertexPointervINTEL","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexPointervINTEL)(size, type, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexPointervINTEL : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_INTEL_texture_scissor

static void REGAL_CALL error_glTexScissorFuncINTEL(GLenum target, GLenum lfunc, GLenum hfunc)
{
  Internal("error_glTexScissorFuncINTEL","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexScissorFuncINTEL)(target, lfunc, hfunc);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexScissorFuncINTEL : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexScissorINTEL(GLenum target, GLclampf tlow, GLclampf thigh)
{
  Internal("error_glTexScissorINTEL","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexScissorINTEL)(target, tlow, thigh);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexScissorINTEL : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_KHR_debug

static void REGAL_CALL error_glDebugMessageCallback(GLDEBUGPROC callback, const void *userParam)
{
  Internal("error_glDebugMessageCallback","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDebugMessageCallback)(callback, userParam);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDebugMessageCallback : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDebugMessageControl(GLenum source, GLenum type, GLenum severity, GLsizei count, const GLuint *ids, GLboolean enabled)
{
  Internal("error_glDebugMessageControl","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDebugMessageControl)(source, type, severity, count, ids, enabled);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDebugMessageControl : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDebugMessageInsert(GLenum source, GLenum type, GLuint id, GLenum severity, GLsizei length, const GLchar *buf)
{
  Internal("error_glDebugMessageInsert","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDebugMessageInsert)(source, type, id, severity, length, buf);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDebugMessageInsert : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLuint REGAL_CALL error_glGetDebugMessageLog(GLuint count, GLsizei bufsize, GLenum *sources, GLenum *types, GLuint *ids, GLenum *severities, GLsizei *lengths, GLchar *messageLog)
{
  Internal("error_glGetDebugMessageLog","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint  ret = _next->call(&_next->glGetDebugMessageLog)(count, bufsize, sources, types, ids, severities, lengths, messageLog);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetDebugMessageLog : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glGetObjectLabel(GLenum identifier, GLuint name, GLsizei bufSize, GLsizei *length, GLchar *label)
{
  Internal("error_glGetObjectLabel","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetObjectLabel)(identifier, name, bufSize, length, label);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetObjectLabel : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetObjectPtrLabel(const GLvoid *ptr, GLsizei bufSize, GLsizei *length, GLchar *label)
{
  Internal("error_glGetObjectPtrLabel","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetObjectPtrLabel)(ptr, bufSize, length, label);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetObjectPtrLabel : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glObjectLabel(GLenum identifier, GLuint name, GLsizei length, const GLchar *label)
{
  Internal("error_glObjectLabel","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glObjectLabel)(identifier, name, length, label);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glObjectLabel : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glObjectPtrLabel(const GLvoid *ptr, GLsizei length, const GLchar *label)
{
  Internal("error_glObjectPtrLabel","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glObjectPtrLabel)(ptr, length, label);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glObjectPtrLabel : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPopDebugGroup(void)
{
  Internal("error_glPopDebugGroup","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPopDebugGroup)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPopDebugGroup : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPushDebugGroup(GLenum source, GLuint id, GLsizei length, const GLchar *message)
{
  Internal("error_glPushDebugGroup","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPushDebugGroup)(source, id, length, message);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPushDebugGroup : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_KTX_buffer_region

static GLuint REGAL_CALL error_glBufferRegionEnabled(void)
{
  Internal("error_glBufferRegionEnabled","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint  ret = _next->call(&_next->glBufferRegionEnabled)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBufferRegionEnabled : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glDeleteBufferRegion(GLenum region)
{
  Internal("error_glDeleteBufferRegion","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteBufferRegion)(region);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteBufferRegion : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDrawBufferRegion(GLuint region, GLint x, GLint y, GLsizei width, GLsizei height, GLint xDest, GLint yDest)
{
  Internal("error_glDrawBufferRegion","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawBufferRegion)(region, x, y, width, height, xDest, yDest);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawBufferRegion : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLuint REGAL_CALL error_glNewBufferRegion(GLenum region)
{
  Internal("error_glNewBufferRegion","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint  ret = _next->call(&_next->glNewBufferRegion)(region);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNewBufferRegion : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glReadBufferRegion(GLuint region, GLint x, GLint y, GLsizei width, GLsizei height)
{
  Internal("error_glReadBufferRegion","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReadBufferRegion)(region, x, y, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReadBufferRegion : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_MESA_resize_buffers

static void REGAL_CALL error_glResizeBuffersMESA(void)
{
  Internal("error_glResizeBuffersMESA","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glResizeBuffersMESA)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glResizeBuffersMESA : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_MESA_window_pos

static void REGAL_CALL error_glWindowPos2dMESA(GLdouble x, GLdouble y)
{
  Internal("error_glWindowPos2dMESA","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos2dMESA)(x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos2dMESA : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos2dvMESA(const GLdouble *v)
{
  Internal("error_glWindowPos2dvMESA","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos2dvMESA)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos2dvMESA : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos2fMESA(GLfloat x, GLfloat y)
{
  Internal("error_glWindowPos2fMESA","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos2fMESA)(x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos2fMESA : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos2fvMESA(const GLfloat *v)
{
  Internal("error_glWindowPos2fvMESA","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos2fvMESA)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos2fvMESA : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos2iMESA(GLint x, GLint y)
{
  Internal("error_glWindowPos2iMESA","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos2iMESA)(x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos2iMESA : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos2ivMESA(const GLint *v)
{
  Internal("error_glWindowPos2ivMESA","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos2ivMESA)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos2ivMESA : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos2sMESA(GLshort x, GLshort y)
{
  Internal("error_glWindowPos2sMESA","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos2sMESA)(x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos2sMESA : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos2svMESA(const GLshort *v)
{
  Internal("error_glWindowPos2svMESA","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos2svMESA)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos2svMESA : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos3dMESA(GLdouble x, GLdouble y, GLdouble z)
{
  Internal("error_glWindowPos3dMESA","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos3dMESA)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos3dMESA : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos3dvMESA(const GLdouble *v)
{
  Internal("error_glWindowPos3dvMESA","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos3dvMESA)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos3dvMESA : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos3fMESA(GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glWindowPos3fMESA","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos3fMESA)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos3fMESA : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos3fvMESA(const GLfloat *v)
{
  Internal("error_glWindowPos3fvMESA","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos3fvMESA)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos3fvMESA : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos3iMESA(GLint x, GLint y, GLint z)
{
  Internal("error_glWindowPos3iMESA","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos3iMESA)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos3iMESA : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos3ivMESA(const GLint *v)
{
  Internal("error_glWindowPos3ivMESA","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos3ivMESA)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos3ivMESA : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos3sMESA(GLshort x, GLshort y, GLshort z)
{
  Internal("error_glWindowPos3sMESA","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos3sMESA)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos3sMESA : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos3svMESA(const GLshort *v)
{
  Internal("error_glWindowPos3svMESA","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos3svMESA)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos3svMESA : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos4dMESA(GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
  Internal("error_glWindowPos4dMESA","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos4dMESA)(x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos4dMESA : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos4dvMESA(const GLdouble *v)
{
  Internal("error_glWindowPos4dvMESA","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos4dvMESA)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos4dvMESA : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos4fMESA(GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
  Internal("error_glWindowPos4fMESA","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos4fMESA)(x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos4fMESA : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos4fvMESA(const GLfloat *v)
{
  Internal("error_glWindowPos4fvMESA","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos4fvMESA)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos4fvMESA : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos4iMESA(GLint x, GLint y, GLint z, GLint w)
{
  Internal("error_glWindowPos4iMESA","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos4iMESA)(x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos4iMESA : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos4ivMESA(const GLint *v)
{
  Internal("error_glWindowPos4ivMESA","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos4ivMESA)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos4ivMESA : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos4sMESA(GLshort x, GLshort y, GLshort z, GLshort w)
{
  Internal("error_glWindowPos4sMESA","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos4sMESA)(x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos4sMESA : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWindowPos4svMESA(const GLshort *v)
{
  Internal("error_glWindowPos4svMESA","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWindowPos4svMESA)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWindowPos4svMESA : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NVX_conditional_render

static void REGAL_CALL error_glBeginConditionalRenderNVX(GLuint id)
{
  Internal("error_glBeginConditionalRenderNVX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBeginConditionalRenderNVX)(id);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBeginConditionalRenderNVX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEndConditionalRenderNVX(void)
{
  Internal("error_glEndConditionalRenderNVX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEndConditionalRenderNVX)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEndConditionalRenderNVX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_bindless_texture

static GLuint64 REGAL_CALL error_glGetImageHandleNV(GLuint texture, GLint level, GLboolean layered, GLint layer, GLenum format)
{
  Internal("error_glGetImageHandleNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint64  ret = _next->call(&_next->glGetImageHandleNV)(texture, level, layered, layer, format);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetImageHandleNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLuint64 REGAL_CALL error_glGetTextureHandleNV(GLuint texture)
{
  Internal("error_glGetTextureHandleNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint64  ret = _next->call(&_next->glGetTextureHandleNV)(texture);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTextureHandleNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLuint64 REGAL_CALL error_glGetTextureSamplerHandleNV(GLuint texture, GLuint sampler)
{
  Internal("error_glGetTextureSamplerHandleNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint64  ret = _next->call(&_next->glGetTextureSamplerHandleNV)(texture, sampler);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTextureSamplerHandleNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLboolean REGAL_CALL error_glIsImageHandleResidentNV(GLuint64 handle)
{
  Internal("error_glIsImageHandleResidentNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsImageHandleResidentNV)(handle);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsImageHandleResidentNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLboolean REGAL_CALL error_glIsTextureHandleResidentNV(GLuint64 handle)
{
  Internal("error_glIsTextureHandleResidentNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsTextureHandleResidentNV)(handle);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsTextureHandleResidentNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glMakeImageHandleNonResidentNV(GLuint64 handle)
{
  Internal("error_glMakeImageHandleNonResidentNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMakeImageHandleNonResidentNV)(handle);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMakeImageHandleNonResidentNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMakeImageHandleResidentNV(GLuint64 handle, GLenum access)
{
  Internal("error_glMakeImageHandleResidentNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMakeImageHandleResidentNV)(handle, access);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMakeImageHandleResidentNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMakeTextureHandleNonResidentNV(GLuint64 handle)
{
  Internal("error_glMakeTextureHandleNonResidentNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMakeTextureHandleNonResidentNV)(handle);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMakeTextureHandleNonResidentNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMakeTextureHandleResidentNV(GLuint64 handle)
{
  Internal("error_glMakeTextureHandleResidentNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMakeTextureHandleResidentNV)(handle);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMakeTextureHandleResidentNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformHandleui64NV(GLuint program, GLint location, GLuint64 value)
{
  Internal("error_glProgramUniformHandleui64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformHandleui64NV)(program, location, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformHandleui64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformHandleui64vNV(GLuint program, GLint location, GLsizei count, const GLuint64 *values)
{
  Internal("error_glProgramUniformHandleui64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformHandleui64vNV)(program, location, count, values);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformHandleui64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformHandleui64NV(GLint location, GLuint64 value)
{
  Internal("error_glUniformHandleui64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformHandleui64NV)(location, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformHandleui64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformHandleui64vNV(GLint location, GLsizei count, const GLuint64 *value)
{
  Internal("error_glUniformHandleui64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformHandleui64vNV)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformHandleui64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_blend_equation_advanced

static void REGAL_CALL error_glBlendBarrierNV(void)
{
  Internal("error_glBlendBarrierNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendBarrierNV)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendBarrierNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBlendParameteriNV(GLenum pname, GLint value)
{
  Internal("error_glBlendParameteriNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendParameteriNV)(pname, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendParameteriNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_conditional_render

static void REGAL_CALL error_glBeginConditionalRenderNV(GLuint id, GLenum mode)
{
  Internal("error_glBeginConditionalRenderNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBeginConditionalRenderNV)(id, mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBeginConditionalRenderNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEndConditionalRenderNV(void)
{
  Internal("error_glEndConditionalRenderNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEndConditionalRenderNV)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEndConditionalRenderNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_copy_buffer

static void REGAL_CALL error_glCopyBufferSubDataNV(GLenum readtarget, GLenum writetarget, GLintptr readoffset, GLintptr writeoffset, GLsizeiptr size)
{
  Internal("error_glCopyBufferSubDataNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyBufferSubDataNV)(readtarget, writetarget, readoffset, writeoffset, size);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyBufferSubDataNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_copy_image

static void REGAL_CALL error_glCopyImageSubDataNV(GLuint srcName, GLenum srcTarget, GLint srcLevel, GLint srcX, GLint srcY, GLint srcZ, GLuint dstName, GLenum dstTarget, GLint dstLevel, GLint dstX, GLint dstY, GLint dstZ, GLsizei width, GLsizei height, GLsizei depth)
{
  Internal("error_glCopyImageSubDataNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyImageSubDataNV)(srcName, srcTarget, srcLevel, srcX, srcY, srcZ, dstName, dstTarget, dstLevel, dstX, dstY, dstZ, width, height, depth);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyImageSubDataNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_coverage_sample

static void REGAL_CALL error_glCoverageMaskNV(GLboolean mask)
{
  Internal("error_glCoverageMaskNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCoverageMaskNV)(mask);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCoverageMaskNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCoverageOperationNV(GLenum operation)
{
  Internal("error_glCoverageOperationNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCoverageOperationNV)(operation);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCoverageOperationNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_depth_buffer_float

static void REGAL_CALL error_glClearDepthdNV(GLdouble depth)
{
  Internal("error_glClearDepthdNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClearDepthdNV)(depth);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClearDepthdNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDepthBoundsdNV(GLdouble zmin, GLdouble zmax)
{
  Internal("error_glDepthBoundsdNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDepthBoundsdNV)(zmin, zmax);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDepthBoundsdNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDepthRangedNV(GLdouble zNear, GLdouble zFar)
{
  Internal("error_glDepthRangedNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDepthRangedNV)(zNear, zFar);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDepthRangedNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_draw_buffers

static void REGAL_CALL error_glDrawBuffersNV(GLsizei n, const GLenum *bufs)
{
  Internal("error_glDrawBuffersNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawBuffersNV)(n, bufs);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawBuffersNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_draw_texture

static void REGAL_CALL error_glDrawTextureNV(GLuint texture, GLuint sampler, GLfloat x0, GLfloat y0, GLfloat x1, GLfloat y1, GLfloat z, GLfloat s0, GLfloat t0, GLfloat s1, GLfloat t1)
{
  Internal("error_glDrawTextureNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawTextureNV)(texture, sampler, x0, y0, x1, y1, z, s0, t0, s1, t1);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawTextureNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_evaluators

static void REGAL_CALL error_glEvalMapsNV(GLenum target, GLenum mode)
{
  Internal("error_glEvalMapsNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEvalMapsNV)(target, mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEvalMapsNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMapAttribParameterfvNV(GLenum target, GLuint index, GLenum pname, GLfloat *params)
{
  Internal("error_glGetMapAttribParameterfvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMapAttribParameterfvNV)(target, index, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMapAttribParameterfvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMapAttribParameterivNV(GLenum target, GLuint index, GLenum pname, GLint *params)
{
  Internal("error_glGetMapAttribParameterivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMapAttribParameterivNV)(target, index, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMapAttribParameterivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMapControlPointsNV(GLenum target, GLuint index, GLenum type, GLsizei ustride, GLsizei vstride, GLboolean packed, GLvoid *points)
{
  Internal("error_glGetMapControlPointsNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMapControlPointsNV)(target, index, type, ustride, vstride, packed, points);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMapControlPointsNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMapParameterfvNV(GLenum target, GLenum pname, GLfloat *params)
{
  Internal("error_glGetMapParameterfvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMapParameterfvNV)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMapParameterfvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMapParameterivNV(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetMapParameterivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMapParameterivNV)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMapParameterivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMapControlPointsNV(GLenum target, GLuint index, GLenum type, GLsizei ustride, GLsizei vstride, GLint uorder, GLint vorder, GLboolean packed, const GLvoid *points)
{
  Internal("error_glMapControlPointsNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMapControlPointsNV)(target, index, type, ustride, vstride, uorder, vorder, packed, points);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMapControlPointsNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMapParameterfvNV(GLenum target, GLenum pname, const GLfloat *params)
{
  Internal("error_glMapParameterfvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMapParameterfvNV)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMapParameterfvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMapParameterivNV(GLenum target, GLenum pname, const GLint *params)
{
  Internal("error_glMapParameterivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMapParameterivNV)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMapParameterivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_explicit_multisample

static void REGAL_CALL error_glGetMultisamplefvNV(GLenum pname, GLuint index, GLfloat *val)
{
  Internal("error_glGetMultisamplefvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMultisamplefvNV)(pname, index, val);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMultisamplefvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSampleMaskIndexedNV(GLuint index, GLbitfield mask)
{
  Internal("error_glSampleMaskIndexedNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSampleMaskIndexedNV)(index, mask);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSampleMaskIndexedNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexRenderbufferNV(GLenum target, GLuint renderbuffer)
{
  Internal("error_glTexRenderbufferNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexRenderbufferNV)(target, renderbuffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexRenderbufferNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_fence

static void REGAL_CALL error_glDeleteFencesNV(GLsizei n, const GLuint *fences)
{
  Internal("error_glDeleteFencesNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteFencesNV)(n, fences);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteFencesNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFinishFenceNV(GLuint fence)
{
  Internal("error_glFinishFenceNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFinishFenceNV)(fence);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFinishFenceNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenFencesNV(GLsizei n, GLuint *fences)
{
  Internal("error_glGenFencesNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenFencesNV)(n, fences);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenFencesNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetFenceivNV(GLuint fence, GLenum pname, GLint *params)
{
  Internal("error_glGetFenceivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetFenceivNV)(fence, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetFenceivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsFenceNV(GLuint fence)
{
  Internal("error_glIsFenceNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsFenceNV)(fence);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsFenceNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glSetFenceNV(GLuint fence, GLenum condition)
{
  Internal("error_glSetFenceNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSetFenceNV)(fence, condition);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSetFenceNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glTestFenceNV(GLuint fence)
{
  Internal("error_glTestFenceNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glTestFenceNV)(fence);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTestFenceNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

// GL_NV_fragment_program

static void REGAL_CALL error_glGetProgramNamedParameterdvNV(GLuint id, GLsizei len, const GLubyte *name, GLdouble *params)
{
  Internal("error_glGetProgramNamedParameterdvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramNamedParameterdvNV)(id, len, name, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramNamedParameterdvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetProgramNamedParameterfvNV(GLuint id, GLsizei len, const GLubyte *name, GLfloat *params)
{
  Internal("error_glGetProgramNamedParameterfvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramNamedParameterfvNV)(id, len, name, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramNamedParameterfvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramNamedParameter4dNV(GLuint id, GLsizei len, const GLubyte *name, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
  Internal("error_glProgramNamedParameter4dNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramNamedParameter4dNV)(id, len, name, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramNamedParameter4dNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramNamedParameter4dvNV(GLuint id, GLsizei len, const GLubyte *name, const GLdouble *v)
{
  Internal("error_glProgramNamedParameter4dvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramNamedParameter4dvNV)(id, len, name, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramNamedParameter4dvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramNamedParameter4fNV(GLuint id, GLsizei len, const GLubyte *name, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
  Internal("error_glProgramNamedParameter4fNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramNamedParameter4fNV)(id, len, name, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramNamedParameter4fNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramNamedParameter4fvNV(GLuint id, GLsizei len, const GLubyte *name, const GLfloat *v)
{
  Internal("error_glProgramNamedParameter4fvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramNamedParameter4fvNV)(id, len, name, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramNamedParameter4fvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_framebuffer_blit

static void REGAL_CALL error_glBlitFramebufferNV(GLint srcX0, GLint srcY0, GLint srcX1, GLint srcY1, GLint dstX0, GLint dstY0, GLint dstX1, GLint dstY1, GLbitfield mask, GLenum filter)
{
  Internal("error_glBlitFramebufferNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlitFramebufferNV)(srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlitFramebufferNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_framebuffer_multisample_coverage

static void REGAL_CALL error_glRenderbufferStorageMultisampleCoverageNV(GLenum target, GLsizei coverageSamples, GLsizei colorSamples, GLenum internalformat, GLsizei width, GLsizei height)
{
  Internal("error_glRenderbufferStorageMultisampleCoverageNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRenderbufferStorageMultisampleCoverageNV)(target, coverageSamples, colorSamples, internalformat, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRenderbufferStorageMultisampleCoverageNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_geometry_program4

static void REGAL_CALL error_glProgramVertexLimitNV(GLenum target, GLint limit)
{
  Internal("error_glProgramVertexLimitNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramVertexLimitNV)(target, limit);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramVertexLimitNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_gpu_program4

static void REGAL_CALL error_glGetProgramEnvParameterIivNV(GLenum target, GLuint index, GLint *params)
{
  Internal("error_glGetProgramEnvParameterIivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramEnvParameterIivNV)(target, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramEnvParameterIivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetProgramEnvParameterIuivNV(GLenum target, GLuint index, GLuint *params)
{
  Internal("error_glGetProgramEnvParameterIuivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramEnvParameterIuivNV)(target, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramEnvParameterIuivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetProgramLocalParameterIivNV(GLenum target, GLuint index, GLint *params)
{
  Internal("error_glGetProgramLocalParameterIivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramLocalParameterIivNV)(target, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramLocalParameterIivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetProgramLocalParameterIuivNV(GLenum target, GLuint index, GLuint *params)
{
  Internal("error_glGetProgramLocalParameterIuivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramLocalParameterIuivNV)(target, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramLocalParameterIuivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramEnvParameterI4iNV(GLenum target, GLuint index, GLint x, GLint y, GLint z, GLint w)
{
  Internal("error_glProgramEnvParameterI4iNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramEnvParameterI4iNV)(target, index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramEnvParameterI4iNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramEnvParameterI4ivNV(GLenum target, GLuint index, const GLint *params)
{
  Internal("error_glProgramEnvParameterI4ivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramEnvParameterI4ivNV)(target, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramEnvParameterI4ivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramEnvParameterI4uiNV(GLenum target, GLuint index, GLuint x, GLuint y, GLuint z, GLuint w)
{
  Internal("error_glProgramEnvParameterI4uiNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramEnvParameterI4uiNV)(target, index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramEnvParameterI4uiNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramEnvParameterI4uivNV(GLenum target, GLuint index, const GLuint *params)
{
  Internal("error_glProgramEnvParameterI4uivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramEnvParameterI4uivNV)(target, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramEnvParameterI4uivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramEnvParametersI4ivNV(GLenum target, GLuint index, GLsizei count, const GLint *params)
{
  Internal("error_glProgramEnvParametersI4ivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramEnvParametersI4ivNV)(target, index, count, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramEnvParametersI4ivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramEnvParametersI4uivNV(GLenum target, GLuint index, GLsizei count, const GLuint *params)
{
  Internal("error_glProgramEnvParametersI4uivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramEnvParametersI4uivNV)(target, index, count, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramEnvParametersI4uivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramLocalParameterI4iNV(GLenum target, GLuint index, GLint x, GLint y, GLint z, GLint w)
{
  Internal("error_glProgramLocalParameterI4iNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramLocalParameterI4iNV)(target, index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramLocalParameterI4iNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramLocalParameterI4ivNV(GLenum target, GLuint index, const GLint *params)
{
  Internal("error_glProgramLocalParameterI4ivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramLocalParameterI4ivNV)(target, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramLocalParameterI4ivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramLocalParameterI4uiNV(GLenum target, GLuint index, GLuint x, GLuint y, GLuint z, GLuint w)
{
  Internal("error_glProgramLocalParameterI4uiNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramLocalParameterI4uiNV)(target, index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramLocalParameterI4uiNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramLocalParameterI4uivNV(GLenum target, GLuint index, const GLuint *params)
{
  Internal("error_glProgramLocalParameterI4uivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramLocalParameterI4uivNV)(target, index, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramLocalParameterI4uivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramLocalParametersI4ivNV(GLenum target, GLuint index, GLsizei count, const GLint *params)
{
  Internal("error_glProgramLocalParametersI4ivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramLocalParametersI4ivNV)(target, index, count, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramLocalParametersI4ivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramLocalParametersI4uivNV(GLenum target, GLuint index, GLsizei count, const GLuint *params)
{
  Internal("error_glProgramLocalParametersI4uivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramLocalParametersI4uivNV)(target, index, count, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramLocalParametersI4uivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_gpu_shader5

static void REGAL_CALL error_glGetUniformi64vNV(GLuint program, GLint location, GLint64EXT *params)
{
  Internal("error_glGetUniformi64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetUniformi64vNV)(program, location, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetUniformi64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform1i64NV(GLuint program, GLint location, GLint64EXT x)
{
  Internal("error_glProgramUniform1i64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform1i64NV)(program, location, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform1i64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform1i64vNV(GLuint program, GLint location, GLsizei count, const GLint64EXT *value)
{
  Internal("error_glProgramUniform1i64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform1i64vNV)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform1i64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform1ui64NV(GLuint program, GLint location, GLuint64EXT x)
{
  Internal("error_glProgramUniform1ui64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform1ui64NV)(program, location, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform1ui64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform1ui64vNV(GLuint program, GLint location, GLsizei count, const GLuint64EXT *value)
{
  Internal("error_glProgramUniform1ui64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform1ui64vNV)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform1ui64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform2i64NV(GLuint program, GLint location, GLint64EXT x, GLint64EXT y)
{
  Internal("error_glProgramUniform2i64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform2i64NV)(program, location, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform2i64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform2i64vNV(GLuint program, GLint location, GLsizei count, const GLint64EXT *value)
{
  Internal("error_glProgramUniform2i64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform2i64vNV)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform2i64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform2ui64NV(GLuint program, GLint location, GLuint64EXT x, GLuint64EXT y)
{
  Internal("error_glProgramUniform2ui64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform2ui64NV)(program, location, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform2ui64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform2ui64vNV(GLuint program, GLint location, GLsizei count, const GLuint64EXT *value)
{
  Internal("error_glProgramUniform2ui64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform2ui64vNV)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform2ui64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform3i64NV(GLuint program, GLint location, GLint64EXT x, GLint64EXT y, GLint64EXT z)
{
  Internal("error_glProgramUniform3i64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform3i64NV)(program, location, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform3i64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform3i64vNV(GLuint program, GLint location, GLsizei count, const GLint64EXT *value)
{
  Internal("error_glProgramUniform3i64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform3i64vNV)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform3i64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform3ui64NV(GLuint program, GLint location, GLuint64EXT x, GLuint64EXT y, GLuint64EXT z)
{
  Internal("error_glProgramUniform3ui64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform3ui64NV)(program, location, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform3ui64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform3ui64vNV(GLuint program, GLint location, GLsizei count, const GLuint64EXT *value)
{
  Internal("error_glProgramUniform3ui64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform3ui64vNV)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform3ui64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform4i64NV(GLuint program, GLint location, GLint64EXT x, GLint64EXT y, GLint64EXT z, GLint64EXT w)
{
  Internal("error_glProgramUniform4i64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform4i64NV)(program, location, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform4i64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform4i64vNV(GLuint program, GLint location, GLsizei count, const GLint64EXT *value)
{
  Internal("error_glProgramUniform4i64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform4i64vNV)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform4i64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform4ui64NV(GLuint program, GLint location, GLuint64EXT x, GLuint64EXT y, GLuint64EXT z, GLuint64EXT w)
{
  Internal("error_glProgramUniform4ui64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform4ui64NV)(program, location, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform4ui64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniform4ui64vNV(GLuint program, GLint location, GLsizei count, const GLuint64EXT *value)
{
  Internal("error_glProgramUniform4ui64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniform4ui64vNV)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniform4ui64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform1i64NV(GLint location, GLint64EXT x)
{
  Internal("error_glUniform1i64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform1i64NV)(location, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform1i64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform1i64vNV(GLint location, GLsizei count, const GLint64EXT *value)
{
  Internal("error_glUniform1i64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform1i64vNV)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform1i64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform1ui64NV(GLint location, GLuint64EXT x)
{
  Internal("error_glUniform1ui64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform1ui64NV)(location, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform1ui64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform1ui64vNV(GLint location, GLsizei count, const GLuint64EXT *value)
{
  Internal("error_glUniform1ui64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform1ui64vNV)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform1ui64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform2i64NV(GLint location, GLint64EXT x, GLint64EXT y)
{
  Internal("error_glUniform2i64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform2i64NV)(location, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform2i64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform2i64vNV(GLint location, GLsizei count, const GLint64EXT *value)
{
  Internal("error_glUniform2i64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform2i64vNV)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform2i64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform2ui64NV(GLint location, GLuint64EXT x, GLuint64EXT y)
{
  Internal("error_glUniform2ui64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform2ui64NV)(location, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform2ui64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform2ui64vNV(GLint location, GLsizei count, const GLuint64EXT *value)
{
  Internal("error_glUniform2ui64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform2ui64vNV)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform2ui64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform3i64NV(GLint location, GLint64EXT x, GLint64EXT y, GLint64EXT z)
{
  Internal("error_glUniform3i64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform3i64NV)(location, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform3i64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform3i64vNV(GLint location, GLsizei count, const GLint64EXT *value)
{
  Internal("error_glUniform3i64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform3i64vNV)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform3i64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform3ui64NV(GLint location, GLuint64EXT x, GLuint64EXT y, GLuint64EXT z)
{
  Internal("error_glUniform3ui64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform3ui64NV)(location, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform3ui64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform3ui64vNV(GLint location, GLsizei count, const GLuint64EXT *value)
{
  Internal("error_glUniform3ui64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform3ui64vNV)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform3ui64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform4i64NV(GLint location, GLint64EXT x, GLint64EXT y, GLint64EXT z, GLint64EXT w)
{
  Internal("error_glUniform4i64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform4i64NV)(location, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform4i64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform4i64vNV(GLint location, GLsizei count, const GLint64EXT *value)
{
  Internal("error_glUniform4i64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform4i64vNV)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform4i64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform4ui64NV(GLint location, GLuint64EXT x, GLuint64EXT y, GLuint64EXT z, GLuint64EXT w)
{
  Internal("error_glUniform4ui64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform4ui64NV)(location, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform4ui64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniform4ui64vNV(GLint location, GLsizei count, const GLuint64EXT *value)
{
  Internal("error_glUniform4ui64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniform4ui64vNV)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniform4ui64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_half_float

static void REGAL_CALL error_glColor3hNV(GLhalfNV red, GLhalfNV green, GLhalfNV blue)
{
  Internal("error_glColor3hNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor3hNV)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor3hNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor3hvNV(const GLhalfNV *v)
{
  Internal("error_glColor3hvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor3hvNV)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor3hvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor4hNV(GLhalfNV red, GLhalfNV green, GLhalfNV blue, GLhalfNV alpha)
{
  Internal("error_glColor4hNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor4hNV)(red, green, blue, alpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor4hNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor4hvNV(const GLhalfNV *v)
{
  Internal("error_glColor4hvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor4hvNV)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor4hvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFogCoordhNV(GLhalfNV coord)
{
  Internal("error_glFogCoordhNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFogCoordhNV)(coord);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFogCoordhNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFogCoordhvNV(const GLhalfNV *coord)
{
  Internal("error_glFogCoordhvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFogCoordhvNV)(coord);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFogCoordhvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord1hNV(GLenum target, GLhalfNV s)
{
  Internal("error_glMultiTexCoord1hNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord1hNV)(target, s);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord1hNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord1hvNV(GLenum target, const GLhalfNV *v)
{
  Internal("error_glMultiTexCoord1hvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord1hvNV)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord1hvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord2hNV(GLenum target, GLhalfNV s, GLhalfNV t)
{
  Internal("error_glMultiTexCoord2hNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord2hNV)(target, s, t);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord2hNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord2hvNV(GLenum target, const GLhalfNV *v)
{
  Internal("error_glMultiTexCoord2hvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord2hvNV)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord2hvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord3hNV(GLenum target, GLhalfNV s, GLhalfNV t, GLhalfNV r)
{
  Internal("error_glMultiTexCoord3hNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord3hNV)(target, s, t, r);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord3hNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord3hvNV(GLenum target, const GLhalfNV *v)
{
  Internal("error_glMultiTexCoord3hvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord3hvNV)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord3hvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord4hNV(GLenum target, GLhalfNV s, GLhalfNV t, GLhalfNV r, GLhalfNV q)
{
  Internal("error_glMultiTexCoord4hNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord4hNV)(target, s, t, r, q);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord4hNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord4hvNV(GLenum target, const GLhalfNV *v)
{
  Internal("error_glMultiTexCoord4hvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord4hvNV)(target, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord4hvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormal3hNV(GLhalfNV nx, GLhalfNV ny, GLhalfNV nz)
{
  Internal("error_glNormal3hNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormal3hNV)(nx, ny, nz);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormal3hNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormal3hvNV(const GLhalfNV *v)
{
  Internal("error_glNormal3hvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormal3hvNV)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormal3hvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3hNV(GLhalfNV red, GLhalfNV green, GLhalfNV blue)
{
  Internal("error_glSecondaryColor3hNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3hNV)(red, green, blue);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3hNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColor3hvNV(const GLhalfNV *v)
{
  Internal("error_glSecondaryColor3hvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColor3hvNV)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColor3hvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord1hNV(GLhalfNV s)
{
  Internal("error_glTexCoord1hNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord1hNV)(s);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord1hNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord1hvNV(const GLhalfNV *v)
{
  Internal("error_glTexCoord1hvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord1hvNV)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord1hvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord2hNV(GLhalfNV s, GLhalfNV t)
{
  Internal("error_glTexCoord2hNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord2hNV)(s, t);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord2hNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord2hvNV(const GLhalfNV *v)
{
  Internal("error_glTexCoord2hvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord2hvNV)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord2hvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord3hNV(GLhalfNV s, GLhalfNV t, GLhalfNV r)
{
  Internal("error_glTexCoord3hNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord3hNV)(s, t, r);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord3hNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord3hvNV(const GLhalfNV *v)
{
  Internal("error_glTexCoord3hvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord3hvNV)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord3hvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord4hNV(GLhalfNV s, GLhalfNV t, GLhalfNV r, GLhalfNV q)
{
  Internal("error_glTexCoord4hNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord4hNV)(s, t, r, q);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord4hNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord4hvNV(const GLhalfNV *v)
{
  Internal("error_glTexCoord4hvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord4hvNV)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord4hvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex2hNV(GLhalfNV x, GLhalfNV y)
{
  Internal("error_glVertex2hNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex2hNV)(x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex2hNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex2hvNV(const GLhalfNV *v)
{
  Internal("error_glVertex2hvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex2hvNV)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex2hvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex3hNV(GLhalfNV x, GLhalfNV y, GLhalfNV z)
{
  Internal("error_glVertex3hNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex3hNV)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex3hNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex3hvNV(const GLhalfNV *v)
{
  Internal("error_glVertex3hvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex3hvNV)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex3hvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex4hNV(GLhalfNV x, GLhalfNV y, GLhalfNV z, GLhalfNV w)
{
  Internal("error_glVertex4hNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex4hNV)(x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex4hNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertex4hvNV(const GLhalfNV *v)
{
  Internal("error_glVertex4hvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertex4hvNV)(v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertex4hvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib1hNV(GLuint index, GLhalfNV x)
{
  Internal("error_glVertexAttrib1hNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib1hNV)(index, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib1hNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib1hvNV(GLuint index, const GLhalfNV *v)
{
  Internal("error_glVertexAttrib1hvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib1hvNV)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib1hvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib2hNV(GLuint index, GLhalfNV x, GLhalfNV y)
{
  Internal("error_glVertexAttrib2hNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib2hNV)(index, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib2hNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib2hvNV(GLuint index, const GLhalfNV *v)
{
  Internal("error_glVertexAttrib2hvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib2hvNV)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib2hvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib3hNV(GLuint index, GLhalfNV x, GLhalfNV y, GLhalfNV z)
{
  Internal("error_glVertexAttrib3hNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib3hNV)(index, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib3hNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib3hvNV(GLuint index, const GLhalfNV *v)
{
  Internal("error_glVertexAttrib3hvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib3hvNV)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib3hvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4hNV(GLuint index, GLhalfNV x, GLhalfNV y, GLhalfNV z, GLhalfNV w)
{
  Internal("error_glVertexAttrib4hNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4hNV)(index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4hNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4hvNV(GLuint index, const GLhalfNV *v)
{
  Internal("error_glVertexAttrib4hvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4hvNV)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4hvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribs1hvNV(GLuint index, GLsizei count, const GLhalfNV *v)
{
  Internal("error_glVertexAttribs1hvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribs1hvNV)(index, count, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribs1hvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribs2hvNV(GLuint index, GLsizei count, const GLhalfNV *v)
{
  Internal("error_glVertexAttribs2hvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribs2hvNV)(index, count, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribs2hvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribs3hvNV(GLuint index, GLsizei count, const GLhalfNV *v)
{
  Internal("error_glVertexAttribs3hvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribs3hvNV)(index, count, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribs3hvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribs4hvNV(GLuint index, GLsizei count, const GLhalfNV *v)
{
  Internal("error_glVertexAttribs4hvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribs4hvNV)(index, count, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribs4hvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexWeighthNV(GLhalfNV weight)
{
  Internal("error_glVertexWeighthNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexWeighthNV)(weight);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexWeighthNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexWeighthvNV(const GLhalfNV *weight)
{
  Internal("error_glVertexWeighthvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexWeighthvNV)(weight);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexWeighthvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_non_square_matrices

static void REGAL_CALL error_glUniformMatrix2x3fvNV(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glUniformMatrix2x3fvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix2x3fvNV)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix2x3fvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformMatrix2x4fvNV(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glUniformMatrix2x4fvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix2x4fvNV)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix2x4fvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformMatrix3x2fvNV(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glUniformMatrix3x2fvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix3x2fvNV)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix3x2fvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformMatrix3x4fvNV(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glUniformMatrix3x4fvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix3x4fvNV)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix3x4fvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformMatrix4x2fvNV(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glUniformMatrix4x2fvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix4x2fvNV)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix4x2fvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformMatrix4x3fvNV(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("error_glUniformMatrix4x3fvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformMatrix4x3fvNV)(location, count, transpose, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformMatrix4x3fvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_occlusion_query

static void REGAL_CALL error_glBeginOcclusionQueryNV(GLuint id)
{
  Internal("error_glBeginOcclusionQueryNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBeginOcclusionQueryNV)(id);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBeginOcclusionQueryNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteOcclusionQueriesNV(GLsizei n, const GLuint *ids)
{
  Internal("error_glDeleteOcclusionQueriesNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteOcclusionQueriesNV)(n, ids);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteOcclusionQueriesNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEndOcclusionQueryNV(void)
{
  Internal("error_glEndOcclusionQueryNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEndOcclusionQueryNV)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEndOcclusionQueryNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenOcclusionQueriesNV(GLsizei n, GLuint *ids)
{
  Internal("error_glGenOcclusionQueriesNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenOcclusionQueriesNV)(n, ids);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenOcclusionQueriesNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetOcclusionQueryivNV(GLuint id, GLenum pname, GLint *params)
{
  Internal("error_glGetOcclusionQueryivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetOcclusionQueryivNV)(id, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetOcclusionQueryivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetOcclusionQueryuivNV(GLuint id, GLenum pname, GLuint *params)
{
  Internal("error_glGetOcclusionQueryuivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetOcclusionQueryuivNV)(id, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetOcclusionQueryuivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsOcclusionQueryNV(GLuint id)
{
  Internal("error_glIsOcclusionQueryNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsOcclusionQueryNV)(id);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsOcclusionQueryNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

// GL_NV_parameter_buffer_object

static void REGAL_CALL error_glProgramBufferParametersIivNV(GLenum target, GLuint buffer, GLuint index, GLsizei count, const GLint *params)
{
  Internal("error_glProgramBufferParametersIivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramBufferParametersIivNV)(target, buffer, index, count, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramBufferParametersIivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramBufferParametersIuivNV(GLenum target, GLuint buffer, GLuint index, GLsizei count, const GLuint *params)
{
  Internal("error_glProgramBufferParametersIuivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramBufferParametersIuivNV)(target, buffer, index, count, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramBufferParametersIuivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramBufferParametersfvNV(GLenum target, GLuint buffer, GLuint index, GLsizei count, const GLfloat *params)
{
  Internal("error_glProgramBufferParametersfvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramBufferParametersfvNV)(target, buffer, index, count, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramBufferParametersfvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_path_rendering

static void REGAL_CALL error_glCopyPathNV(GLuint resultPath, GLuint srcPath)
{
  Internal("error_glCopyPathNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyPathNV)(resultPath, srcPath);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyPathNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCoverFillPathInstancedNV(GLsizei numPaths, GLenum pathNameType, const GLvoid *paths, GLuint pathBase, GLenum coverMode, GLenum transformType, const GLfloat *transformValues)
{
  Internal("error_glCoverFillPathInstancedNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCoverFillPathInstancedNV)(numPaths, pathNameType, paths, pathBase, coverMode, transformType, transformValues);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCoverFillPathInstancedNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCoverFillPathNV(GLuint path, GLenum coverMode)
{
  Internal("error_glCoverFillPathNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCoverFillPathNV)(path, coverMode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCoverFillPathNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCoverStrokePathInstancedNV(GLsizei numPaths, GLenum pathNameType, const GLvoid *paths, GLuint pathBase, GLenum coverMode, GLenum transformType, const GLfloat *transformValues)
{
  Internal("error_glCoverStrokePathInstancedNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCoverStrokePathInstancedNV)(numPaths, pathNameType, paths, pathBase, coverMode, transformType, transformValues);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCoverStrokePathInstancedNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCoverStrokePathNV(GLuint name, GLenum coverMode)
{
  Internal("error_glCoverStrokePathNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCoverStrokePathNV)(name, coverMode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCoverStrokePathNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeletePathsNV(GLuint path, GLsizei range)
{
  Internal("error_glDeletePathsNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeletePathsNV)(path, range);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeletePathsNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLuint REGAL_CALL error_glGenPathsNV(GLsizei range)
{
  Internal("error_glGenPathsNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint  ret = _next->call(&_next->glGenPathsNV)(range);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenPathsNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glGetPathColorGenfvNV(GLenum color, GLenum pname, GLfloat *value)
{
  Internal("error_glGetPathColorGenfvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPathColorGenfvNV)(color, pname, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPathColorGenfvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPathColorGenivNV(GLenum color, GLenum pname, GLint *value)
{
  Internal("error_glGetPathColorGenivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPathColorGenivNV)(color, pname, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPathColorGenivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPathCommandsNV(GLuint name, GLubyte *commands)
{
  Internal("error_glGetPathCommandsNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPathCommandsNV)(name, commands);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPathCommandsNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPathCoordsNV(GLuint name, GLfloat *coords)
{
  Internal("error_glGetPathCoordsNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPathCoordsNV)(name, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPathCoordsNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPathDashArrayNV(GLuint name, GLfloat *dashArray)
{
  Internal("error_glGetPathDashArrayNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPathDashArrayNV)(name, dashArray);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPathDashArrayNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLfloat REGAL_CALL error_glGetPathLengthNV(GLuint path, GLsizei startSegment, GLsizei numSegments)
{
  Internal("error_glGetPathLengthNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLfloat  ret = _next->call(&_next->glGetPathLengthNV)(path, startSegment, numSegments);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPathLengthNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glGetPathMetricRangeNV(GLbitfield metricQueryMask, GLuint fistPathName, GLsizei numPaths, GLsizei stride, GLfloat *metrics)
{
  Internal("error_glGetPathMetricRangeNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPathMetricRangeNV)(metricQueryMask, fistPathName, numPaths, stride, metrics);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPathMetricRangeNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPathMetricsNV(GLbitfield metricQueryMask, GLsizei numPaths, GLenum pathNameType, const GLvoid *paths, GLuint pathBase, GLsizei stride, GLfloat *metrics)
{
  Internal("error_glGetPathMetricsNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPathMetricsNV)(metricQueryMask, numPaths, pathNameType, paths, pathBase, stride, metrics);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPathMetricsNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPathParameterfvNV(GLuint name, GLenum param, GLfloat *value)
{
  Internal("error_glGetPathParameterfvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPathParameterfvNV)(name, param, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPathParameterfvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPathParameterivNV(GLuint name, GLenum param, GLint *value)
{
  Internal("error_glGetPathParameterivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPathParameterivNV)(name, param, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPathParameterivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPathSpacingNV(GLenum pathListMode, GLsizei numPaths, GLenum pathNameType, const GLvoid *paths, GLuint pathBase, GLfloat advanceScale, GLfloat kerningScale, GLenum transformType, GLfloat *returnedSpacing)
{
  Internal("error_glGetPathSpacingNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPathSpacingNV)(pathListMode, numPaths, pathNameType, paths, pathBase, advanceScale, kerningScale, transformType, returnedSpacing);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPathSpacingNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPathTexGenfvNV(GLenum texCoordSet, GLenum pname, GLfloat *value)
{
  Internal("error_glGetPathTexGenfvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPathTexGenfvNV)(texCoordSet, pname, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPathTexGenfvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPathTexGenivNV(GLenum texCoordSet, GLenum pname, GLint *value)
{
  Internal("error_glGetPathTexGenivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPathTexGenivNV)(texCoordSet, pname, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPathTexGenivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glInterpolatePathsNV(GLuint resultPath, GLuint pathA, GLuint pathB, GLfloat weight)
{
  Internal("error_glInterpolatePathsNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glInterpolatePathsNV)(resultPath, pathA, pathB, weight);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glInterpolatePathsNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsPathNV(GLuint path)
{
  Internal("error_glIsPathNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsPathNV)(path);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsPathNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLboolean REGAL_CALL error_glIsPointInFillPathNV(GLuint path, GLuint mask, GLfloat x, GLfloat y)
{
  Internal("error_glIsPointInFillPathNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsPointInFillPathNV)(path, mask, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsPointInFillPathNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLboolean REGAL_CALL error_glIsPointInStrokePathNV(GLuint path, GLfloat x, GLfloat y)
{
  Internal("error_glIsPointInStrokePathNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsPointInStrokePathNV)(path, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsPointInStrokePathNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glPathColorGenNV(GLenum color, GLenum genMode, GLenum colorFormat, const GLfloat *coeffs)
{
  Internal("error_glPathColorGenNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPathColorGenNV)(color, genMode, colorFormat, coeffs);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPathColorGenNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPathCommandsNV(GLuint path, GLsizei numCommands, const GLubyte *commands, GLsizei numCoords, GLenum coordType, const GLvoid *coords)
{
  Internal("error_glPathCommandsNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPathCommandsNV)(path, numCommands, commands, numCoords, coordType, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPathCommandsNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPathCoordsNV(GLuint path, GLsizei numCoords, GLenum coordType, const GLvoid *coords)
{
  Internal("error_glPathCoordsNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPathCoordsNV)(path, numCoords, coordType, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPathCoordsNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPathCoverDepthFuncNV(GLenum zfunc)
{
  Internal("error_glPathCoverDepthFuncNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPathCoverDepthFuncNV)(zfunc);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPathCoverDepthFuncNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPathDashArrayNV(GLuint path, GLsizei dashCount, const GLfloat *dashArray)
{
  Internal("error_glPathDashArrayNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPathDashArrayNV)(path, dashCount, dashArray);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPathDashArrayNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPathFogGenNV(GLenum genMode)
{
  Internal("error_glPathFogGenNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPathFogGenNV)(genMode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPathFogGenNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPathGlyphRangeNV(GLuint firstPathName, GLenum fontTarget, const GLvoid *fontName, GLbitfield fontStyle, GLuint firstGlyph, GLsizei numGlyphs, GLenum handleMissingGlyphs, GLuint pathParameterTemplate, GLfloat emScale)
{
  Internal("error_glPathGlyphRangeNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPathGlyphRangeNV)(firstPathName, fontTarget, fontName, fontStyle, firstGlyph, numGlyphs, handleMissingGlyphs, pathParameterTemplate, emScale);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPathGlyphRangeNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPathGlyphsNV(GLuint firstPathName, GLenum fontTarget, const GLvoid *fontName, GLbitfield fontStyle, GLsizei numGlyphs, GLenum type, const GLvoid *charcodes, GLenum handleMissingGlyphs, GLuint pathParameterTemplate, GLfloat emScale)
{
  Internal("error_glPathGlyphsNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPathGlyphsNV)(firstPathName, fontTarget, fontName, fontStyle, numGlyphs, type, charcodes, handleMissingGlyphs, pathParameterTemplate, emScale);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPathGlyphsNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPathParameterfNV(GLuint path, GLenum pname, GLfloat value)
{
  Internal("error_glPathParameterfNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPathParameterfNV)(path, pname, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPathParameterfNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPathParameterfvNV(GLuint path, GLenum pname, const GLfloat *value)
{
  Internal("error_glPathParameterfvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPathParameterfvNV)(path, pname, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPathParameterfvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPathParameteriNV(GLuint path, GLenum pname, GLint value)
{
  Internal("error_glPathParameteriNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPathParameteriNV)(path, pname, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPathParameteriNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPathParameterivNV(GLuint path, GLenum pname, const GLint *value)
{
  Internal("error_glPathParameterivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPathParameterivNV)(path, pname, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPathParameterivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPathStencilDepthOffsetNV(GLfloat factor, GLfloat units)
{
  Internal("error_glPathStencilDepthOffsetNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPathStencilDepthOffsetNV)(factor, units);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPathStencilDepthOffsetNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPathStencilFuncNV(GLenum func, GLint ref, GLuint mask)
{
  Internal("error_glPathStencilFuncNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPathStencilFuncNV)(func, ref, mask);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPathStencilFuncNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPathStringNV(GLuint path, GLenum format, GLsizei length, const GLvoid *pathString)
{
  Internal("error_glPathStringNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPathStringNV)(path, format, length, pathString);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPathStringNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPathSubCommandsNV(GLuint path, GLsizei commandStart, GLsizei commandsToDelete, GLsizei numCommands, const GLubyte *commands, GLsizei numCoords, GLenum coordType, const GLvoid *coords)
{
  Internal("error_glPathSubCommandsNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPathSubCommandsNV)(path, commandStart, commandsToDelete, numCommands, commands, numCoords, coordType, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPathSubCommandsNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPathSubCoordsNV(GLuint path, GLsizei coordStart, GLsizei numCoords, GLenum coordType, const GLvoid *coords)
{
  Internal("error_glPathSubCoordsNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPathSubCoordsNV)(path, coordStart, numCoords, coordType, coords);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPathSubCoordsNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPathTexGenNV(GLenum texCoordSet, GLenum genMode, GLint components, const GLfloat *coeffs)
{
  Internal("error_glPathTexGenNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPathTexGenNV)(texCoordSet, genMode, components, coeffs);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPathTexGenNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glPointAlongPathNV(GLuint path, GLsizei startSegment, GLsizei numSegments, GLfloat distance, GLfloat *x, GLfloat *y, GLfloat *tangentX, GLfloat *tangentY)
{
  Internal("error_glPointAlongPathNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glPointAlongPathNV)(path, startSegment, numSegments, distance, x, y, tangentX, tangentY);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPointAlongPathNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glStencilFillPathInstancedNV(GLsizei numPaths, GLenum pathNameType, const GLvoid *paths, GLuint pathBase, GLenum fillMode, GLuint mask, GLenum transformType, const GLfloat *transformValues)
{
  Internal("error_glStencilFillPathInstancedNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glStencilFillPathInstancedNV)(numPaths, pathNameType, paths, pathBase, fillMode, mask, transformType, transformValues);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glStencilFillPathInstancedNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glStencilFillPathNV(GLuint path, GLenum fillMode, GLuint mask)
{
  Internal("error_glStencilFillPathNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glStencilFillPathNV)(path, fillMode, mask);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glStencilFillPathNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glStencilStrokePathInstancedNV(GLsizei numPaths, GLenum pathNameType, const GLvoid *paths, GLuint pathBase, GLint reference, GLuint mask, GLenum transformType, const GLfloat *transformValues)
{
  Internal("error_glStencilStrokePathInstancedNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glStencilStrokePathInstancedNV)(numPaths, pathNameType, paths, pathBase, reference, mask, transformType, transformValues);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glStencilStrokePathInstancedNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glStencilStrokePathNV(GLuint path, GLint reference, GLuint mask)
{
  Internal("error_glStencilStrokePathNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glStencilStrokePathNV)(path, reference, mask);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glStencilStrokePathNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTransformPathNV(GLuint resultPath, GLuint srcPath, GLenum transformType, const GLfloat *transformValues)
{
  Internal("error_glTransformPathNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTransformPathNV)(resultPath, srcPath, transformType, transformValues);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTransformPathNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWeightPathsNV(GLuint resultPath, GLsizei numPaths, const GLuint *paths, const GLfloat *weights)
{
  Internal("error_glWeightPathsNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWeightPathsNV)(resultPath, numPaths, paths, weights);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWeightPathsNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_pixel_data_range

static void REGAL_CALL error_glFlushPixelDataRangeNV(GLenum target)
{
  Internal("error_glFlushPixelDataRangeNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFlushPixelDataRangeNV)(target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFlushPixelDataRangeNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPixelDataRangeNV(GLenum target, GLsizei size, const GLvoid *pointer)
{
  Internal("error_glPixelDataRangeNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPixelDataRangeNV)(target, size, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPixelDataRangeNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_point_sprite

static void REGAL_CALL error_glPointParameteriNV(GLenum pname, GLint param)
{
  Internal("error_glPointParameteriNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPointParameteriNV)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPointParameteriNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPointParameterivNV(GLenum pname, const GLint *params)
{
  Internal("error_glPointParameterivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPointParameterivNV)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPointParameterivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_present_video

static void REGAL_CALL error_glGetVideoi64vNV(GLuint video_slot, GLenum pname, GLint64EXT *params)
{
  Internal("error_glGetVideoi64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVideoi64vNV)(video_slot, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVideoi64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVideoivNV(GLuint video_slot, GLenum pname, GLint *params)
{
  Internal("error_glGetVideoivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVideoivNV)(video_slot, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVideoivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVideoui64vNV(GLuint video_slot, GLenum pname, GLuint64EXT *params)
{
  Internal("error_glGetVideoui64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVideoui64vNV)(video_slot, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVideoui64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVideouivNV(GLuint video_slot, GLenum pname, GLuint *params)
{
  Internal("error_glGetVideouivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVideouivNV)(video_slot, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVideouivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPresentFrameDualFillNV(GLuint video_slot, GLuint64EXT minPresentTime, GLuint beginPresentTimeId, GLuint presentDurationId, GLenum type, GLenum target0, GLuint fill0, GLenum target1, GLuint fill1, GLenum target2, GLuint fill2, GLenum target3, GLuint fill3)
{
  Internal("error_glPresentFrameDualFillNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPresentFrameDualFillNV)(video_slot, minPresentTime, beginPresentTimeId, presentDurationId, type, target0, fill0, target1, fill1, target2, fill2, target3, fill3);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPresentFrameDualFillNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPresentFrameKeyedNV(GLuint video_slot, GLuint64EXT minPresentTime, GLuint beginPresentTimeId, GLuint presentDurationId, GLenum type, GLenum target0, GLuint fill0, GLuint key0, GLenum target1, GLuint fill1, GLuint key1)
{
  Internal("error_glPresentFrameKeyedNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPresentFrameKeyedNV)(video_slot, minPresentTime, beginPresentTimeId, presentDurationId, type, target0, fill0, key0, target1, fill1, key1);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPresentFrameKeyedNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_primitive_restart

static void REGAL_CALL error_glPrimitiveRestartIndexNV(GLuint index)
{
  Internal("error_glPrimitiveRestartIndexNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPrimitiveRestartIndexNV)(index);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPrimitiveRestartIndexNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPrimitiveRestartNV(void)
{
  Internal("error_glPrimitiveRestartNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPrimitiveRestartNV)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPrimitiveRestartNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_read_buffer

static void REGAL_CALL error_glReadBufferNV(GLenum mode)
{
  Internal("error_glReadBufferNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReadBufferNV)(mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReadBufferNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_register_combiners

static void REGAL_CALL error_glCombinerInputNV(GLenum stage, GLenum portion, GLenum variable, GLenum input, GLenum mapping, GLenum componentUsage)
{
  Internal("error_glCombinerInputNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCombinerInputNV)(stage, portion, variable, input, mapping, componentUsage);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCombinerInputNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCombinerOutputNV(GLenum stage, GLenum portion, GLenum abOutput, GLenum cdOutput, GLenum sumOutput, GLenum scale, GLenum bias, GLboolean abDotProduct, GLboolean cdDotProduct, GLboolean muxSum)
{
  Internal("error_glCombinerOutputNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCombinerOutputNV)(stage, portion, abOutput, cdOutput, sumOutput, scale, bias, abDotProduct, cdDotProduct, muxSum);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCombinerOutputNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCombinerParameterfNV(GLenum pname, GLfloat param)
{
  Internal("error_glCombinerParameterfNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCombinerParameterfNV)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCombinerParameterfNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCombinerParameterfvNV(GLenum pname, const GLfloat *params)
{
  Internal("error_glCombinerParameterfvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCombinerParameterfvNV)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCombinerParameterfvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCombinerParameteriNV(GLenum pname, GLint param)
{
  Internal("error_glCombinerParameteriNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCombinerParameteriNV)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCombinerParameteriNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCombinerParameterivNV(GLenum pname, const GLint *params)
{
  Internal("error_glCombinerParameterivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCombinerParameterivNV)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCombinerParameterivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFinalCombinerInputNV(GLenum variable, GLenum input, GLenum mapping, GLenum componentUsage)
{
  Internal("error_glFinalCombinerInputNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFinalCombinerInputNV)(variable, input, mapping, componentUsage);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFinalCombinerInputNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetCombinerInputParameterfvNV(GLenum stage, GLenum portion, GLenum variable, GLenum pname, GLfloat *params)
{
  Internal("error_glGetCombinerInputParameterfvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetCombinerInputParameterfvNV)(stage, portion, variable, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetCombinerInputParameterfvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetCombinerInputParameterivNV(GLenum stage, GLenum portion, GLenum variable, GLenum pname, GLint *params)
{
  Internal("error_glGetCombinerInputParameterivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetCombinerInputParameterivNV)(stage, portion, variable, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetCombinerInputParameterivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetCombinerOutputParameterfvNV(GLenum stage, GLenum portion, GLenum pname, GLfloat *params)
{
  Internal("error_glGetCombinerOutputParameterfvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetCombinerOutputParameterfvNV)(stage, portion, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetCombinerOutputParameterfvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetCombinerOutputParameterivNV(GLenum stage, GLenum portion, GLenum pname, GLint *params)
{
  Internal("error_glGetCombinerOutputParameterivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetCombinerOutputParameterivNV)(stage, portion, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetCombinerOutputParameterivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetFinalCombinerInputParameterfvNV(GLenum variable, GLenum pname, GLfloat *params)
{
  Internal("error_glGetFinalCombinerInputParameterfvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetFinalCombinerInputParameterfvNV)(variable, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetFinalCombinerInputParameterfvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetFinalCombinerInputParameterivNV(GLenum variable, GLenum pname, GLint *params)
{
  Internal("error_glGetFinalCombinerInputParameterivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetFinalCombinerInputParameterivNV)(variable, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetFinalCombinerInputParameterivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_register_combiners2

static void REGAL_CALL error_glCombinerStageParameterfvNV(GLenum stage, GLenum pname, const GLfloat *params)
{
  Internal("error_glCombinerStageParameterfvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCombinerStageParameterfvNV)(stage, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCombinerStageParameterfvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetCombinerStageParameterfvNV(GLenum stage, GLenum pname, GLfloat *params)
{
  Internal("error_glGetCombinerStageParameterfvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetCombinerStageParameterfvNV)(stage, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetCombinerStageParameterfvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_shader_buffer_load

static void REGAL_CALL error_glGetBufferParameterui64vNV(GLenum target, GLenum pname, GLuint64EXT *params)
{
  Internal("error_glGetBufferParameterui64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetBufferParameterui64vNV)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetBufferParameterui64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetIntegerui64vNV(GLenum target, GLuint64EXT *data)
{
  Internal("error_glGetIntegerui64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetIntegerui64vNV)(target, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetIntegerui64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetNamedBufferParameterui64vNV(GLuint buffer, GLenum pname, GLuint64EXT *params)
{
  Internal("error_glGetNamedBufferParameterui64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetNamedBufferParameterui64vNV)(buffer, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetNamedBufferParameterui64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetUniformui64vNV(GLuint program, GLint location, GLuint64EXT *params)
{
  Internal("error_glGetUniformui64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetUniformui64vNV)(program, location, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetUniformui64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsBufferResidentNV(GLenum target)
{
  Internal("error_glIsBufferResidentNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsBufferResidentNV)(target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsBufferResidentNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLboolean REGAL_CALL error_glIsNamedBufferResidentNV(GLuint buffer)
{
  Internal("error_glIsNamedBufferResidentNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsNamedBufferResidentNV)(buffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsNamedBufferResidentNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glMakeBufferNonResidentNV(GLenum target)
{
  Internal("error_glMakeBufferNonResidentNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMakeBufferNonResidentNV)(target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMakeBufferNonResidentNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMakeBufferResidentNV(GLenum target, GLenum access)
{
  Internal("error_glMakeBufferResidentNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMakeBufferResidentNV)(target, access);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMakeBufferResidentNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMakeNamedBufferNonResidentNV(GLuint buffer)
{
  Internal("error_glMakeNamedBufferNonResidentNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMakeNamedBufferNonResidentNV)(buffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMakeNamedBufferNonResidentNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMakeNamedBufferResidentNV(GLuint buffer, GLenum access)
{
  Internal("error_glMakeNamedBufferResidentNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMakeNamedBufferResidentNV)(buffer, access);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMakeNamedBufferResidentNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformui64NV(GLuint program, GLint location, GLuint64EXT v0)
{
  Internal("error_glProgramUniformui64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformui64NV)(program, location, v0);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformui64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramUniformui64vNV(GLuint program, GLint location, GLsizei count, const GLuint64EXT *value)
{
  Internal("error_glProgramUniformui64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramUniformui64vNV)(program, location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramUniformui64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformui64NV(GLint location, GLuint64EXT v0)
{
  Internal("error_glUniformui64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformui64NV)(location, v0);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformui64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glUniformui64vNV(GLint location, GLsizei count, const GLuint64EXT *value)
{
  Internal("error_glUniformui64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glUniformui64vNV)(location, count, value);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUniformui64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_texture_barrier

static void REGAL_CALL error_glTextureBarrierNV(void)
{
  Internal("error_glTextureBarrierNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureBarrierNV)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureBarrierNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_texture_multisample

static void REGAL_CALL error_glTexImage2DMultisampleCoverageNV(GLenum target, GLsizei coverageSamples, GLsizei colorSamples, GLint internalFormat, GLsizei width, GLsizei height, GLboolean fixedSampleLocations)
{
  Internal("error_glTexImage2DMultisampleCoverageNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexImage2DMultisampleCoverageNV)(target, coverageSamples, colorSamples, internalFormat, width, height, fixedSampleLocations);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexImage2DMultisampleCoverageNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexImage3DMultisampleCoverageNV(GLenum target, GLsizei coverageSamples, GLsizei colorSamples, GLint internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLboolean fixedSampleLocations)
{
  Internal("error_glTexImage3DMultisampleCoverageNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexImage3DMultisampleCoverageNV)(target, coverageSamples, colorSamples, internalFormat, width, height, depth, fixedSampleLocations);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexImage3DMultisampleCoverageNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureImage2DMultisampleCoverageNV(GLuint texture, GLenum target, GLsizei coverageSamples, GLsizei colorSamples, GLint internalFormat, GLsizei width, GLsizei height, GLboolean fixedSampleLocations)
{
  Internal("error_glTextureImage2DMultisampleCoverageNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureImage2DMultisampleCoverageNV)(texture, target, coverageSamples, colorSamples, internalFormat, width, height, fixedSampleLocations);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureImage2DMultisampleCoverageNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureImage2DMultisampleNV(GLuint texture, GLenum target, GLsizei samples, GLint internalFormat, GLsizei width, GLsizei height, GLboolean fixedSampleLocations)
{
  Internal("error_glTextureImage2DMultisampleNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureImage2DMultisampleNV)(texture, target, samples, internalFormat, width, height, fixedSampleLocations);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureImage2DMultisampleNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureImage3DMultisampleCoverageNV(GLuint texture, GLenum target, GLsizei coverageSamples, GLsizei colorSamples, GLint internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLboolean fixedSampleLocations)
{
  Internal("error_glTextureImage3DMultisampleCoverageNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureImage3DMultisampleCoverageNV)(texture, target, coverageSamples, colorSamples, internalFormat, width, height, depth, fixedSampleLocations);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureImage3DMultisampleCoverageNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTextureImage3DMultisampleNV(GLuint texture, GLenum target, GLsizei samples, GLint internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLboolean fixedSampleLocations)
{
  Internal("error_glTextureImage3DMultisampleNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureImage3DMultisampleNV)(texture, target, samples, internalFormat, width, height, depth, fixedSampleLocations);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureImage3DMultisampleNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_transform_feedback

static void REGAL_CALL error_glActiveVaryingNV(GLuint program, const GLchar *name)
{
  Internal("error_glActiveVaryingNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glActiveVaryingNV)(program, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glActiveVaryingNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBeginTransformFeedbackNV(GLenum primitiveMode)
{
  Internal("error_glBeginTransformFeedbackNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBeginTransformFeedbackNV)(primitiveMode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBeginTransformFeedbackNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBindBufferBaseNV(GLenum target, GLuint index, GLuint buffer)
{
  Internal("error_glBindBufferBaseNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindBufferBaseNV)(target, index, buffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindBufferBaseNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBindBufferOffsetNV(GLenum target, GLuint index, GLuint buffer, GLintptr offset)
{
  Internal("error_glBindBufferOffsetNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindBufferOffsetNV)(target, index, buffer, offset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindBufferOffsetNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBindBufferRangeNV(GLenum target, GLuint index, GLuint buffer, GLintptr offset, GLsizeiptr size)
{
  Internal("error_glBindBufferRangeNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindBufferRangeNV)(target, index, buffer, offset, size);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindBufferRangeNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEndTransformFeedbackNV(void)
{
  Internal("error_glEndTransformFeedbackNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEndTransformFeedbackNV)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEndTransformFeedbackNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetActiveVaryingNV(GLuint program, GLuint index, GLsizei bufSize, GLsizei *length, GLsizei *size, GLenum *type, GLchar *name)
{
  Internal("error_glGetActiveVaryingNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetActiveVaryingNV)(program, index, bufSize, length, size, type, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetActiveVaryingNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTransformFeedbackVaryingNV(GLuint program, GLuint index, GLint *location)
{
  Internal("error_glGetTransformFeedbackVaryingNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTransformFeedbackVaryingNV)(program, index, location);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTransformFeedbackVaryingNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLint REGAL_CALL error_glGetVaryingLocationNV(GLuint program, const GLchar *name)
{
  Internal("error_glGetVaryingLocationNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLint  ret = _next->call(&_next->glGetVaryingLocationNV)(program, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVaryingLocationNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glTransformFeedbackAttribsNV(GLuint count, const GLint *attribs, GLenum bufferMode)
{
  Internal("error_glTransformFeedbackAttribsNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTransformFeedbackAttribsNV)(count, attribs, bufferMode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTransformFeedbackAttribsNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTransformFeedbackVaryingsNV(GLuint program, GLsizei count, const GLint *locations, GLenum bufferMode)
{
  Internal("error_glTransformFeedbackVaryingsNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTransformFeedbackVaryingsNV)(program, count, locations, bufferMode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTransformFeedbackVaryingsNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_transform_feedback2

static void REGAL_CALL error_glBindTransformFeedbackNV(GLenum target, GLuint id)
{
  Internal("error_glBindTransformFeedbackNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindTransformFeedbackNV)(target, id);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindTransformFeedbackNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteTransformFeedbacksNV(GLsizei n, const GLuint *ids)
{
  Internal("error_glDeleteTransformFeedbacksNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteTransformFeedbacksNV)(n, ids);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteTransformFeedbacksNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDrawTransformFeedbackNV(GLenum mode, GLuint name)
{
  Internal("error_glDrawTransformFeedbackNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawTransformFeedbackNV)(mode, name);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawTransformFeedbackNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenTransformFeedbacksNV(GLsizei n, GLuint *ids)
{
  Internal("error_glGenTransformFeedbacksNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenTransformFeedbacksNV)(n, ids);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenTransformFeedbacksNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsTransformFeedbackNV(GLuint id)
{
  Internal("error_glIsTransformFeedbackNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsTransformFeedbackNV)(id);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsTransformFeedbackNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glPauseTransformFeedbackNV(void)
{
  Internal("error_glPauseTransformFeedbackNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPauseTransformFeedbackNV)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPauseTransformFeedbackNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glResumeTransformFeedbackNV(void)
{
  Internal("error_glResumeTransformFeedbackNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glResumeTransformFeedbackNV)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glResumeTransformFeedbackNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_vdpau_interop

static void REGAL_CALL error_glVDPAUFiniNV(void)
{
  Internal("error_glVDPAUFiniNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVDPAUFiniNV)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVDPAUFiniNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVDPAUGetSurfaceivNV(GLvdpauSurfaceNV surface, GLenum pname, GLsizei bufSize, GLsizei *length, GLint *values)
{
  Internal("error_glVDPAUGetSurfaceivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVDPAUGetSurfaceivNV)(surface, pname, bufSize, length, values);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVDPAUGetSurfaceivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVDPAUInitNV(const GLvoid *vdpDevice, const GLvoid *getProcAddress)
{
  Internal("error_glVDPAUInitNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVDPAUInitNV)(vdpDevice, getProcAddress);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVDPAUInitNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glVDPAUIsSurfaceNV(GLvdpauSurfaceNV surface)
{
  Internal("error_glVDPAUIsSurfaceNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glVDPAUIsSurfaceNV)(surface);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVDPAUIsSurfaceNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glVDPAUMapSurfacesNV(GLsizei numSurfaces, const GLvdpauSurfaceNV *surfaces)
{
  Internal("error_glVDPAUMapSurfacesNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVDPAUMapSurfacesNV)(numSurfaces, surfaces);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVDPAUMapSurfacesNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLvdpauSurfaceNV REGAL_CALL error_glVDPAURegisterOutputSurfaceNV(const GLvoid *vdpSurface, GLenum target, GLsizei numTextureNames, const GLuint *textureNames)
{
  Internal("error_glVDPAURegisterOutputSurfaceNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLvdpauSurfaceNV  ret = _next->call(&_next->glVDPAURegisterOutputSurfaceNV)(vdpSurface, target, numTextureNames, textureNames);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVDPAURegisterOutputSurfaceNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLvdpauSurfaceNV REGAL_CALL error_glVDPAURegisterVideoSurfaceNV(const GLvoid *vdpSurface, GLenum target, GLsizei numTextureNames, const GLuint *textureNames)
{
  Internal("error_glVDPAURegisterVideoSurfaceNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLvdpauSurfaceNV  ret = _next->call(&_next->glVDPAURegisterVideoSurfaceNV)(vdpSurface, target, numTextureNames, textureNames);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVDPAURegisterVideoSurfaceNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glVDPAUSurfaceAccessNV(GLvdpauSurfaceNV surface, GLenum access)
{
  Internal("error_glVDPAUSurfaceAccessNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVDPAUSurfaceAccessNV)(surface, access);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVDPAUSurfaceAccessNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVDPAUUnmapSurfacesNV(GLsizei numSurfaces, const GLvdpauSurfaceNV *surfaces)
{
  Internal("error_glVDPAUUnmapSurfacesNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVDPAUUnmapSurfacesNV)(numSurfaces, surfaces);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVDPAUUnmapSurfacesNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVDPAUUnregisterSurfaceNV(GLvdpauSurfaceNV surface)
{
  Internal("error_glVDPAUUnregisterSurfaceNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVDPAUUnregisterSurfaceNV)(surface);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVDPAUUnregisterSurfaceNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_vertex_array_range

static void REGAL_CALL error_glFlushVertexArrayRangeNV(void)
{
  Internal("error_glFlushVertexArrayRangeNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFlushVertexArrayRangeNV)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFlushVertexArrayRangeNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexArrayRangeNV(GLsizei size, const GLvoid *pointer)
{
  Internal("error_glVertexArrayRangeNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexArrayRangeNV)(size, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexArrayRangeNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_vertex_attrib_integer_64bit

static void REGAL_CALL error_glGetVertexAttribLi64vNV(GLuint index, GLenum pname, GLint64EXT *params)
{
  Internal("error_glGetVertexAttribLi64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexAttribLi64vNV)(index, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexAttribLi64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVertexAttribLui64vNV(GLuint index, GLenum pname, GLuint64EXT *params)
{
  Internal("error_glGetVertexAttribLui64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexAttribLui64vNV)(index, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexAttribLui64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL1i64NV(GLuint index, GLint64EXT x)
{
  Internal("error_glVertexAttribL1i64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL1i64NV)(index, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL1i64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL1i64vNV(GLuint index, const GLint64EXT *v)
{
  Internal("error_glVertexAttribL1i64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL1i64vNV)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL1i64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL1ui64NV(GLuint index, GLuint64EXT x)
{
  Internal("error_glVertexAttribL1ui64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL1ui64NV)(index, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL1ui64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL1ui64vNV(GLuint index, const GLuint64EXT *v)
{
  Internal("error_glVertexAttribL1ui64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL1ui64vNV)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL1ui64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL2i64NV(GLuint index, GLint64EXT x, GLint64EXT y)
{
  Internal("error_glVertexAttribL2i64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL2i64NV)(index, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL2i64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL2i64vNV(GLuint index, const GLint64EXT *v)
{
  Internal("error_glVertexAttribL2i64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL2i64vNV)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL2i64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL2ui64NV(GLuint index, GLuint64EXT x, GLuint64EXT y)
{
  Internal("error_glVertexAttribL2ui64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL2ui64NV)(index, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL2ui64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL2ui64vNV(GLuint index, const GLuint64EXT *v)
{
  Internal("error_glVertexAttribL2ui64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL2ui64vNV)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL2ui64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL3i64NV(GLuint index, GLint64EXT x, GLint64EXT y, GLint64EXT z)
{
  Internal("error_glVertexAttribL3i64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL3i64NV)(index, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL3i64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL3i64vNV(GLuint index, const GLint64EXT *v)
{
  Internal("error_glVertexAttribL3i64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL3i64vNV)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL3i64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL3ui64NV(GLuint index, GLuint64EXT x, GLuint64EXT y, GLuint64EXT z)
{
  Internal("error_glVertexAttribL3ui64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL3ui64NV)(index, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL3ui64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL3ui64vNV(GLuint index, const GLuint64EXT *v)
{
  Internal("error_glVertexAttribL3ui64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL3ui64vNV)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL3ui64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL4i64NV(GLuint index, GLint64EXT x, GLint64EXT y, GLint64EXT z, GLint64EXT w)
{
  Internal("error_glVertexAttribL4i64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL4i64NV)(index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL4i64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL4i64vNV(GLuint index, const GLint64EXT *v)
{
  Internal("error_glVertexAttribL4i64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL4i64vNV)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL4i64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL4ui64NV(GLuint index, GLuint64EXT x, GLuint64EXT y, GLuint64EXT z, GLuint64EXT w)
{
  Internal("error_glVertexAttribL4ui64NV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL4ui64NV)(index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL4ui64NV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribL4ui64vNV(GLuint index, const GLuint64EXT *v)
{
  Internal("error_glVertexAttribL4ui64vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribL4ui64vNV)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribL4ui64vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribLFormatNV(GLuint index, GLint size, GLenum type, GLsizei stride)
{
  Internal("error_glVertexAttribLFormatNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribLFormatNV)(index, size, type, stride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribLFormatNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_vertex_buffer_unified_memory

static void REGAL_CALL error_glBufferAddressRangeNV(GLenum pname, GLuint index, GLuint64EXT address, GLsizeiptr length)
{
  Internal("error_glBufferAddressRangeNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBufferAddressRangeNV)(pname, index, address, length);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBufferAddressRangeNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColorFormatNV(GLint size, GLenum type, GLsizei stride)
{
  Internal("error_glColorFormatNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColorFormatNV)(size, type, stride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColorFormatNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEdgeFlagFormatNV(GLsizei stride)
{
  Internal("error_glEdgeFlagFormatNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEdgeFlagFormatNV)(stride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEdgeFlagFormatNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFogCoordFormatNV(GLenum type, GLsizei stride)
{
  Internal("error_glFogCoordFormatNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFogCoordFormatNV)(type, stride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFogCoordFormatNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetIntegerui64i_vNV(GLenum target, GLuint index, GLuint64EXT *data)
{
  Internal("error_glGetIntegerui64i_vNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetIntegerui64i_vNV)(target, index, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetIntegerui64i_vNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glIndexFormatNV(GLenum type, GLsizei stride)
{
  Internal("error_glIndexFormatNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glIndexFormatNV)(type, stride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIndexFormatNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormalFormatNV(GLenum type, GLsizei stride)
{
  Internal("error_glNormalFormatNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormalFormatNV)(type, stride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormalFormatNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSecondaryColorFormatNV(GLint size, GLenum type, GLsizei stride)
{
  Internal("error_glSecondaryColorFormatNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSecondaryColorFormatNV)(size, type, stride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSecondaryColorFormatNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoordFormatNV(GLint size, GLenum type, GLsizei stride)
{
  Internal("error_glTexCoordFormatNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoordFormatNV)(size, type, stride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoordFormatNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribFormatNV(GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride)
{
  Internal("error_glVertexAttribFormatNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribFormatNV)(index, size, type, normalized, stride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribFormatNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribIFormatNV(GLuint index, GLint size, GLenum type, GLsizei stride)
{
  Internal("error_glVertexAttribIFormatNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribIFormatNV)(index, size, type, stride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribIFormatNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexFormatNV(GLint size, GLenum type, GLsizei stride)
{
  Internal("error_glVertexFormatNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexFormatNV)(size, type, stride);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexFormatNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_vertex_program

static GLboolean REGAL_CALL error_glAreProgramsResidentNV(GLsizei n, const GLuint *programs, GLboolean *residences)
{
  Internal("error_glAreProgramsResidentNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glAreProgramsResidentNV)(n, programs, residences);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glAreProgramsResidentNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glBindProgramNV(GLenum target, GLuint id)
{
  Internal("error_glBindProgramNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindProgramNV)(target, id);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindProgramNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteProgramsNV(GLsizei n, const GLuint *programs)
{
  Internal("error_glDeleteProgramsNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteProgramsNV)(n, programs);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteProgramsNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glExecuteProgramNV(GLenum target, GLuint id, const GLfloat *params)
{
  Internal("error_glExecuteProgramNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glExecuteProgramNV)(target, id, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glExecuteProgramNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenProgramsNV(GLsizei n, GLuint *programs)
{
  Internal("error_glGenProgramsNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenProgramsNV)(n, programs);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenProgramsNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetProgramParameterdvNV(GLenum target, GLuint index, GLenum pname, GLdouble *params)
{
  Internal("error_glGetProgramParameterdvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramParameterdvNV)(target, index, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramParameterdvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetProgramParameterfvNV(GLenum target, GLuint index, GLenum pname, GLfloat *params)
{
  Internal("error_glGetProgramParameterfvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramParameterfvNV)(target, index, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramParameterfvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetProgramStringNV(GLuint id, GLenum pname, GLubyte *program)
{
  Internal("error_glGetProgramStringNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramStringNV)(id, pname, program);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramStringNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetProgramivNV(GLuint id, GLenum pname, GLint *params)
{
  Internal("error_glGetProgramivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramivNV)(id, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTrackMatrixivNV(GLenum target, GLuint address, GLenum pname, GLint *params)
{
  Internal("error_glGetTrackMatrixivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTrackMatrixivNV)(target, address, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTrackMatrixivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVertexAttribPointervNV(GLuint index, GLenum pname, GLvoid **pointer)
{
  Internal("error_glGetVertexAttribPointervNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexAttribPointervNV)(index, pname, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexAttribPointervNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVertexAttribdvNV(GLuint index, GLenum pname, GLdouble *params)
{
  Internal("error_glGetVertexAttribdvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexAttribdvNV)(index, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexAttribdvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVertexAttribfvNV(GLuint index, GLenum pname, GLfloat *params)
{
  Internal("error_glGetVertexAttribfvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexAttribfvNV)(index, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexAttribfvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVertexAttribivNV(GLuint index, GLenum pname, GLint *params)
{
  Internal("error_glGetVertexAttribivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVertexAttribivNV)(index, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVertexAttribivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsProgramNV(GLuint id)
{
  Internal("error_glIsProgramNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsProgramNV)(id);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsProgramNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glLoadProgramNV(GLenum target, GLuint id, GLsizei len, const GLubyte *program)
{
  Internal("error_glLoadProgramNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLoadProgramNV)(target, id, len, program);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLoadProgramNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramParameter4dNV(GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
  Internal("error_glProgramParameter4dNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramParameter4dNV)(target, index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramParameter4dNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramParameter4dvNV(GLenum target, GLuint index, const GLdouble *v)
{
  Internal("error_glProgramParameter4dvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramParameter4dvNV)(target, index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramParameter4dvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramParameter4fNV(GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
  Internal("error_glProgramParameter4fNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramParameter4fNV)(target, index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramParameter4fNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramParameter4fvNV(GLenum target, GLuint index, const GLfloat *v)
{
  Internal("error_glProgramParameter4fvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramParameter4fvNV)(target, index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramParameter4fvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramParameters4dvNV(GLenum target, GLuint index, GLsizei count, const GLdouble *v)
{
  Internal("error_glProgramParameters4dvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramParameters4dvNV)(target, index, count, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramParameters4dvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramParameters4fvNV(GLenum target, GLuint index, GLsizei count, const GLfloat *v)
{
  Internal("error_glProgramParameters4fvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramParameters4fvNV)(target, index, count, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramParameters4fvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRequestResidentProgramsNV(GLsizei n, const GLuint *programs)
{
  Internal("error_glRequestResidentProgramsNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRequestResidentProgramsNV)(n, programs);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRequestResidentProgramsNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTrackMatrixNV(GLenum target, GLuint address, GLenum matrix, GLenum transform)
{
  Internal("error_glTrackMatrixNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTrackMatrixNV)(target, address, matrix, transform);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTrackMatrixNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib1dNV(GLuint index, GLdouble x)
{
  Internal("error_glVertexAttrib1dNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib1dNV)(index, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib1dNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib1dvNV(GLuint index, const GLdouble *v)
{
  Internal("error_glVertexAttrib1dvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib1dvNV)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib1dvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib1fNV(GLuint index, GLfloat x)
{
  Internal("error_glVertexAttrib1fNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib1fNV)(index, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib1fNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib1fvNV(GLuint index, const GLfloat *v)
{
  Internal("error_glVertexAttrib1fvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib1fvNV)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib1fvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib1sNV(GLuint index, GLshort x)
{
  Internal("error_glVertexAttrib1sNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib1sNV)(index, x);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib1sNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib1svNV(GLuint index, const GLshort *v)
{
  Internal("error_glVertexAttrib1svNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib1svNV)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib1svNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib2dNV(GLuint index, GLdouble x, GLdouble y)
{
  Internal("error_glVertexAttrib2dNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib2dNV)(index, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib2dNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib2dvNV(GLuint index, const GLdouble *v)
{
  Internal("error_glVertexAttrib2dvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib2dvNV)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib2dvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib2fNV(GLuint index, GLfloat x, GLfloat y)
{
  Internal("error_glVertexAttrib2fNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib2fNV)(index, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib2fNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib2fvNV(GLuint index, const GLfloat *v)
{
  Internal("error_glVertexAttrib2fvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib2fvNV)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib2fvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib2sNV(GLuint index, GLshort x, GLshort y)
{
  Internal("error_glVertexAttrib2sNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib2sNV)(index, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib2sNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib2svNV(GLuint index, const GLshort *v)
{
  Internal("error_glVertexAttrib2svNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib2svNV)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib2svNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib3dNV(GLuint index, GLdouble x, GLdouble y, GLdouble z)
{
  Internal("error_glVertexAttrib3dNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib3dNV)(index, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib3dNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib3dvNV(GLuint index, const GLdouble *v)
{
  Internal("error_glVertexAttrib3dvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib3dvNV)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib3dvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib3fNV(GLuint index, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glVertexAttrib3fNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib3fNV)(index, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib3fNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib3fvNV(GLuint index, const GLfloat *v)
{
  Internal("error_glVertexAttrib3fvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib3fvNV)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib3fvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib3sNV(GLuint index, GLshort x, GLshort y, GLshort z)
{
  Internal("error_glVertexAttrib3sNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib3sNV)(index, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib3sNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib3svNV(GLuint index, const GLshort *v)
{
  Internal("error_glVertexAttrib3svNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib3svNV)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib3svNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4dNV(GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
{
  Internal("error_glVertexAttrib4dNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4dNV)(index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4dNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4dvNV(GLuint index, const GLdouble *v)
{
  Internal("error_glVertexAttrib4dvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4dvNV)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4dvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4fNV(GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
  Internal("error_glVertexAttrib4fNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4fNV)(index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4fNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4fvNV(GLuint index, const GLfloat *v)
{
  Internal("error_glVertexAttrib4fvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4fvNV)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4fvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4sNV(GLuint index, GLshort x, GLshort y, GLshort z, GLshort w)
{
  Internal("error_glVertexAttrib4sNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4sNV)(index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4sNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4svNV(GLuint index, const GLshort *v)
{
  Internal("error_glVertexAttrib4svNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4svNV)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4svNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4ubNV(GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w)
{
  Internal("error_glVertexAttrib4ubNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4ubNV)(index, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4ubNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttrib4ubvNV(GLuint index, const GLubyte *v)
{
  Internal("error_glVertexAttrib4ubvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttrib4ubvNV)(index, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttrib4ubvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribPointerNV(GLuint index, GLint fsize, GLenum type, GLsizei stride, const GLvoid *pointer)
{
  Internal("error_glVertexAttribPointerNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribPointerNV)(index, fsize, type, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribPointerNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribs1dvNV(GLuint index, GLsizei n, const GLdouble *v)
{
  Internal("error_glVertexAttribs1dvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribs1dvNV)(index, n, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribs1dvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribs1fvNV(GLuint index, GLsizei n, const GLfloat *v)
{
  Internal("error_glVertexAttribs1fvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribs1fvNV)(index, n, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribs1fvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribs1svNV(GLuint index, GLsizei n, const GLshort *v)
{
  Internal("error_glVertexAttribs1svNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribs1svNV)(index, n, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribs1svNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribs2dvNV(GLuint index, GLsizei n, const GLdouble *v)
{
  Internal("error_glVertexAttribs2dvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribs2dvNV)(index, n, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribs2dvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribs2fvNV(GLuint index, GLsizei n, const GLfloat *v)
{
  Internal("error_glVertexAttribs2fvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribs2fvNV)(index, n, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribs2fvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribs2svNV(GLuint index, GLsizei n, const GLshort *v)
{
  Internal("error_glVertexAttribs2svNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribs2svNV)(index, n, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribs2svNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribs3dvNV(GLuint index, GLsizei n, const GLdouble *v)
{
  Internal("error_glVertexAttribs3dvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribs3dvNV)(index, n, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribs3dvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribs3fvNV(GLuint index, GLsizei n, const GLfloat *v)
{
  Internal("error_glVertexAttribs3fvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribs3fvNV)(index, n, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribs3fvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribs3svNV(GLuint index, GLsizei n, const GLshort *v)
{
  Internal("error_glVertexAttribs3svNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribs3svNV)(index, n, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribs3svNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribs4dvNV(GLuint index, GLsizei n, const GLdouble *v)
{
  Internal("error_glVertexAttribs4dvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribs4dvNV)(index, n, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribs4dvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribs4fvNV(GLuint index, GLsizei n, const GLfloat *v)
{
  Internal("error_glVertexAttribs4fvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribs4fvNV)(index, n, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribs4fvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribs4svNV(GLuint index, GLsizei n, const GLshort *v)
{
  Internal("error_glVertexAttribs4svNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribs4svNV)(index, n, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribs4svNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVertexAttribs4ubvNV(GLuint index, GLsizei n, const GLubyte *v)
{
  Internal("error_glVertexAttribs4ubvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVertexAttribs4ubvNV)(index, n, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVertexAttribs4ubvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_NV_video_capture

static void REGAL_CALL error_glBeginVideoCaptureNV(GLuint video_capture_slot)
{
  Internal("error_glBeginVideoCaptureNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBeginVideoCaptureNV)(video_capture_slot);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBeginVideoCaptureNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBindVideoCaptureStreamBufferNV(GLuint video_capture_slot, GLuint stream, GLenum frame_region, GLintptr offset)
{
  Internal("error_glBindVideoCaptureStreamBufferNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindVideoCaptureStreamBufferNV)(video_capture_slot, stream, frame_region, offset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindVideoCaptureStreamBufferNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBindVideoCaptureStreamTextureNV(GLuint video_capture_slot, GLuint stream, GLenum frame_region, GLenum target, GLuint texture)
{
  Internal("error_glBindVideoCaptureStreamTextureNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindVideoCaptureStreamTextureNV)(video_capture_slot, stream, frame_region, target, texture);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindVideoCaptureStreamTextureNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEndVideoCaptureNV(GLuint video_capture_slot)
{
  Internal("error_glEndVideoCaptureNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEndVideoCaptureNV)(video_capture_slot);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEndVideoCaptureNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVideoCaptureStreamdvNV(GLuint video_capture_slot, GLuint stream, GLenum pname, GLdouble *params)
{
  Internal("error_glGetVideoCaptureStreamdvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVideoCaptureStreamdvNV)(video_capture_slot, stream, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVideoCaptureStreamdvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVideoCaptureStreamfvNV(GLuint video_capture_slot, GLuint stream, GLenum pname, GLfloat *params)
{
  Internal("error_glGetVideoCaptureStreamfvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVideoCaptureStreamfvNV)(video_capture_slot, stream, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVideoCaptureStreamfvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVideoCaptureStreamivNV(GLuint video_capture_slot, GLuint stream, GLenum pname, GLint *params)
{
  Internal("error_glGetVideoCaptureStreamivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVideoCaptureStreamivNV)(video_capture_slot, stream, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVideoCaptureStreamivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetVideoCaptureivNV(GLuint video_capture_slot, GLenum pname, GLint *params)
{
  Internal("error_glGetVideoCaptureivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetVideoCaptureivNV)(video_capture_slot, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetVideoCaptureivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLenum REGAL_CALL error_glVideoCaptureNV(GLuint video_capture_slot, GLuint *sequence_num, GLuint64EXT *capture_time)
{
  Internal("error_glVideoCaptureNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLenum  ret = _next->call(&_next->glVideoCaptureNV)(video_capture_slot, sequence_num, capture_time);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVideoCaptureNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glVideoCaptureStreamParameterdvNV(GLuint video_capture_slot, GLuint stream, GLenum pname, const GLdouble *params)
{
  Internal("error_glVideoCaptureStreamParameterdvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVideoCaptureStreamParameterdvNV)(video_capture_slot, stream, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVideoCaptureStreamParameterdvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVideoCaptureStreamParameterfvNV(GLuint video_capture_slot, GLuint stream, GLenum pname, const GLfloat *params)
{
  Internal("error_glVideoCaptureStreamParameterfvNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVideoCaptureStreamParameterfvNV)(video_capture_slot, stream, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVideoCaptureStreamParameterfvNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glVideoCaptureStreamParameterivNV(GLuint video_capture_slot, GLuint stream, GLenum pname, const GLint *params)
{
  Internal("error_glVideoCaptureStreamParameterivNV","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glVideoCaptureStreamParameterivNV)(video_capture_slot, stream, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glVideoCaptureStreamParameterivNV : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_OES_blend_equation_separate

static void REGAL_CALL error_glBlendEquationSeparateOES(GLenum modeRGB, GLenum modeAlpha)
{
  Internal("error_glBlendEquationSeparateOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendEquationSeparateOES)(modeRGB, modeAlpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendEquationSeparateOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_OES_blend_func_separate

static void REGAL_CALL error_glBlendFuncSeparateOES(GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha)
{
  Internal("error_glBlendFuncSeparateOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendFuncSeparateOES)(sfactorRGB, dfactorRGB, sfactorAlpha, dfactorAlpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendFuncSeparateOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_OES_blend_subtract

static void REGAL_CALL error_glBlendEquationOES(GLenum mode)
{
  Internal("error_glBlendEquationOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBlendEquationOES)(mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBlendEquationOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_OES_framebuffer_object

static void REGAL_CALL error_glBindFramebufferOES(GLenum target, GLuint framebuffer)
{
  Internal("error_glBindFramebufferOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindFramebufferOES)(target, framebuffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindFramebufferOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glBindRenderbufferOES(GLenum target, GLuint renderbuffer)
{
  Internal("error_glBindRenderbufferOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindRenderbufferOES)(target, renderbuffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindRenderbufferOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLenum REGAL_CALL error_glCheckFramebufferStatusOES(GLenum target)
{
  Internal("error_glCheckFramebufferStatusOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLenum  ret = _next->call(&_next->glCheckFramebufferStatusOES)(target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCheckFramebufferStatusOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glDeleteFramebuffersOES(GLsizei n, const GLuint *framebuffers)
{
  Internal("error_glDeleteFramebuffersOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteFramebuffersOES)(n, framebuffers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteFramebuffersOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteRenderbuffersOES(GLsizei n, const GLuint *renderbuffers)
{
  Internal("error_glDeleteRenderbuffersOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteRenderbuffersOES)(n, renderbuffers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteRenderbuffersOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFramebufferRenderbufferOES(GLenum target, GLenum attachment, GLenum renderbuffertarget, GLuint renderbuffer)
{
  Internal("error_glFramebufferRenderbufferOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFramebufferRenderbufferOES)(target, attachment, renderbuffertarget, renderbuffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFramebufferRenderbufferOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFramebufferTexture2DOES(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level)
{
  Internal("error_glFramebufferTexture2DOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFramebufferTexture2DOES)(target, attachment, textarget, texture, level);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFramebufferTexture2DOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenFramebuffersOES(GLsizei n, GLuint *framebuffers)
{
  Internal("error_glGenFramebuffersOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenFramebuffersOES)(n, framebuffers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenFramebuffersOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenRenderbuffersOES(GLsizei n, GLuint *renderbuffers)
{
  Internal("error_glGenRenderbuffersOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenRenderbuffersOES)(n, renderbuffers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenRenderbuffersOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenerateMipmapOES(GLenum target)
{
  Internal("error_glGenerateMipmapOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenerateMipmapOES)(target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenerateMipmapOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetFramebufferAttachmentParameterivOES(GLenum target, GLenum attachment, GLenum pname, GLint *params)
{
  Internal("error_glGetFramebufferAttachmentParameterivOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetFramebufferAttachmentParameterivOES)(target, attachment, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetFramebufferAttachmentParameterivOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetRenderbufferParameterivOES(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetRenderbufferParameterivOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetRenderbufferParameterivOES)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetRenderbufferParameterivOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsFramebufferOES(GLuint framebuffer)
{
  Internal("error_glIsFramebufferOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsFramebufferOES)(framebuffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsFramebufferOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLboolean REGAL_CALL error_glIsRenderbufferOES(GLuint renderbuffer)
{
  Internal("error_glIsRenderbufferOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsRenderbufferOES)(renderbuffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsRenderbufferOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glRenderbufferStorageOES(GLenum target, GLenum internalformat, GLsizei width, GLsizei height)
{
  Internal("error_glRenderbufferStorageOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRenderbufferStorageOES)(target, internalformat, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRenderbufferStorageOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_OES_get_program_binary

static void REGAL_CALL error_glGetProgramBinaryOES(GLuint program, GLsizei bufSize, GLsizei *length, GLenum *binaryFormat, GLvoid *binary)
{
  Internal("error_glGetProgramBinaryOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetProgramBinaryOES)(program, bufSize, length, binaryFormat, binary);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetProgramBinaryOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glProgramBinaryOES(GLuint program, GLenum binaryFormat, const GLvoid *binary, GLint length)
{
  Internal("error_glProgramBinaryOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glProgramBinaryOES)(program, binaryFormat, binary, length);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glProgramBinaryOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_OES_mapbuffer

static void REGAL_CALL error_glGetBufferPointervOES(GLenum target, GLenum pname, GLvoid **params)
{
  Internal("error_glGetBufferPointervOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetBufferPointervOES)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetBufferPointervOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLvoid *REGAL_CALL error_glMapBufferOES(GLenum target, GLenum access)
{
  Internal("error_glMapBufferOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLvoid * ret = _next->call(&_next->glMapBufferOES)(target, access);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMapBufferOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLboolean REGAL_CALL error_glUnmapBufferOES(GLenum target)
{
  Internal("error_glUnmapBufferOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glUnmapBufferOES)(target);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glUnmapBufferOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

// GL_OES_matrix_palette

static void REGAL_CALL error_glCurrentPaletteMatrixOES(GLuint index)
{
  Internal("error_glCurrentPaletteMatrixOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCurrentPaletteMatrixOES)(index);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCurrentPaletteMatrixOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMatrixIndexPointerOES(GLint size, GLenum type, GLsizei stride, GLvoid *pointer)
{
  Internal("error_glMatrixIndexPointerOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMatrixIndexPointerOES)(size, type, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMatrixIndexPointerOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glWeightPointerOES(GLint size, GLenum type, GLsizei stride, GLvoid *pointer)
{
  Internal("error_glWeightPointerOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glWeightPointerOES)(size, type, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glWeightPointerOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_OES_single_precision

static void REGAL_CALL error_glClearDepthfOES(GLclampd depth)
{
  Internal("error_glClearDepthfOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClearDepthfOES)(depth);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClearDepthfOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glClipPlanefOES(GLenum plane, const GLfloat *equation)
{
  Internal("error_glClipPlanefOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClipPlanefOES)(plane, equation);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClipPlanefOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDepthRangefOES(GLclampf n, GLclampf f)
{
  Internal("error_glDepthRangefOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDepthRangefOES)(n, f);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDepthRangefOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFrustumfOES(GLfloat l, GLfloat r, GLfloat b, GLfloat t, GLfloat n, GLfloat f)
{
  Internal("error_glFrustumfOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFrustumfOES)(l, r, b, t, n, f);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFrustumfOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetClipPlanefOES(GLenum plane, GLfloat *equation)
{
  Internal("error_glGetClipPlanefOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetClipPlanefOES)(plane, equation);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetClipPlanefOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glOrthofOES(GLfloat l, GLfloat r, GLfloat b, GLfloat t, GLfloat n, GLfloat f)
{
  Internal("error_glOrthofOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glOrthofOES)(l, r, b, t, n, f);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glOrthofOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_OES_texture_3D

static void REGAL_CALL error_glCompressedTexImage3DOES(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, const GLvoid *data)
{
  Internal("error_glCompressedTexImage3DOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedTexImage3DOES)(target, level, internalformat, width, height, depth, border, imageSize, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedTexImage3DOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCompressedTexSubImage3DOES(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, const GLvoid *data)
{
  Internal("error_glCompressedTexSubImage3DOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCompressedTexSubImage3DOES)(target, level, xoffset, yoffset, zoffset, width, height, depth, format, imageSize, data);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCompressedTexSubImage3DOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyTexSubImage3DOES(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height)
{
  Internal("error_glCopyTexSubImage3DOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyTexSubImage3DOES)(target, level, xoffset, yoffset, zoffset, x, y, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyTexSubImage3DOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFramebufferTexture3DOES(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level, GLint zoffset)
{
  Internal("error_glFramebufferTexture3DOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFramebufferTexture3DOES)(target, attachment, textarget, texture, level, zoffset);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFramebufferTexture3DOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexImage3DOES(GLenum target, GLint level, GLenum internalFormat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glTexImage3DOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexImage3DOES)(target, level, internalFormat, width, height, depth, border, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexImage3DOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexSubImage3DOES(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glTexSubImage3DOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexSubImage3DOES)(target, level, xoffset, yoffset, zoffset, width, height, depth, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexSubImage3DOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_OES_texture_cube_map

static void REGAL_CALL error_glGetTexGenfvOES(GLenum coord, GLenum pname, GLfloat *params)
{
  Internal("error_glGetTexGenfvOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTexGenfvOES)(coord, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTexGenfvOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTexGenivOES(GLenum coord, GLenum pname, GLint *params)
{
  Internal("error_glGetTexGenivOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTexGenivOES)(coord, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTexGenivOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTexGenxvOES(GLenum coord, GLenum pname, GLfixed *params)
{
  Internal("error_glGetTexGenxvOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTexGenxvOES)(coord, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTexGenxvOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexGenfOES(GLenum coord, GLenum pname, GLfloat param)
{
  Internal("error_glTexGenfOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexGenfOES)(coord, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexGenfOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexGenfvOES(GLenum coord, GLenum pname, const GLfloat *params)
{
  Internal("error_glTexGenfvOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexGenfvOES)(coord, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexGenfvOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexGeniOES(GLenum coord, GLenum pname, GLint param)
{
  Internal("error_glTexGeniOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexGeniOES)(coord, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexGeniOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexGenivOES(GLenum coord, GLenum pname, const GLint *params)
{
  Internal("error_glTexGenivOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexGenivOES)(coord, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexGenivOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexGenxOES(GLenum coord, GLenum pname, GLfixed param)
{
  Internal("error_glTexGenxOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexGenxOES)(coord, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexGenxOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexGenxvOES(GLenum coord, GLenum pname, const GLfixed *params)
{
  Internal("error_glTexGenxvOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexGenxvOES)(coord, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexGenxvOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_OES_vertex_array_object

static void REGAL_CALL error_glBindVertexArrayOES(GLuint array)
{
  Internal("error_glBindVertexArrayOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glBindVertexArrayOES)(array);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glBindVertexArrayOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteVertexArraysOES(GLsizei n, const GLuint *arrays)
{
  Internal("error_glDeleteVertexArraysOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteVertexArraysOES)(n, arrays);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteVertexArraysOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGenVertexArraysOES(GLsizei n, GLuint *arrays)
{
  Internal("error_glGenVertexArraysOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGenVertexArraysOES)(n, arrays);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenVertexArraysOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glIsVertexArrayOES(GLuint array)
{
  Internal("error_glIsVertexArrayOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsVertexArrayOES)(array);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsVertexArrayOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

// GL_PGI_misc_hints

static void REGAL_CALL error_glHintPGI(GLenum target, GLint mode)
{
  Internal("error_glHintPGI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glHintPGI)(target, mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glHintPGI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_QCOM_alpha_test

static void REGAL_CALL error_glAlphaFuncQCOM(GLenum func, GLclampf ref)
{
  Internal("error_glAlphaFuncQCOM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glAlphaFuncQCOM)(func, ref);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glAlphaFuncQCOM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_QCOM_driver_control

static void REGAL_CALL error_glDisableDriverControlQCOM(GLuint driverControl)
{
  Internal("error_glDisableDriverControlQCOM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDisableDriverControlQCOM)(driverControl);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDisableDriverControlQCOM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glEnableDriverControlQCOM(GLuint driverControl)
{
  Internal("error_glEnableDriverControlQCOM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEnableDriverControlQCOM)(driverControl);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEnableDriverControlQCOM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetDriverControlStringQCOM(GLuint driverControl, GLsizei bufSize, GLsizei *length, GLchar *driverControlString)
{
  Internal("error_glGetDriverControlStringQCOM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetDriverControlStringQCOM)(driverControl, bufSize, length, driverControlString);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetDriverControlStringQCOM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetDriverControlsQCOM(GLint *num, GLsizei size, GLuint *driverControls)
{
  Internal("error_glGetDriverControlsQCOM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetDriverControlsQCOM)(num, size, driverControls);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetDriverControlsQCOM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_QCOM_extended_get

static void REGAL_CALL error_glExtGetBufferPointervQCOM(GLenum target, GLvoid **params)
{
  Internal("error_glExtGetBufferPointervQCOM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glExtGetBufferPointervQCOM)(target, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glExtGetBufferPointervQCOM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glExtGetBuffersQCOM(GLuint *buffers, GLint maxBuffers, GLint *numBuffers)
{
  Internal("error_glExtGetBuffersQCOM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glExtGetBuffersQCOM)(buffers, maxBuffers, numBuffers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glExtGetBuffersQCOM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glExtGetFramebuffersQCOM(GLuint *framebuffers, GLint maxFramebuffers, GLint *numFramebuffers)
{
  Internal("error_glExtGetFramebuffersQCOM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glExtGetFramebuffersQCOM)(framebuffers, maxFramebuffers, numFramebuffers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glExtGetFramebuffersQCOM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glExtGetRenderbuffersQCOM(GLuint *renderbuffers, GLint maxRenderbuffers, GLint *numRenderbuffers)
{
  Internal("error_glExtGetRenderbuffersQCOM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glExtGetRenderbuffersQCOM)(renderbuffers, maxRenderbuffers, numRenderbuffers);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glExtGetRenderbuffersQCOM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glExtGetTexLevelParameterivQCOM(GLuint texture, GLenum face, GLint level, GLenum pname, GLint *params)
{
  Internal("error_glExtGetTexLevelParameterivQCOM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glExtGetTexLevelParameterivQCOM)(texture, face, level, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glExtGetTexLevelParameterivQCOM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glExtGetTexSubImageQCOM(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, GLvoid *texels)
{
  Internal("error_glExtGetTexSubImageQCOM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glExtGetTexSubImageQCOM)(target, level, xoffset, yoffset, zoffset, width, height, depth, format, type, texels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glExtGetTexSubImageQCOM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glExtGetTexturesQCOM(GLuint *textures, GLint maxTextures, GLint *numTextures)
{
  Internal("error_glExtGetTexturesQCOM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glExtGetTexturesQCOM)(textures, maxTextures, numTextures);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glExtGetTexturesQCOM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glExtTexObjectStateOverrideiQCOM(GLenum target, GLenum pname, GLint param)
{
  Internal("error_glExtTexObjectStateOverrideiQCOM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glExtTexObjectStateOverrideiQCOM)(target, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glExtTexObjectStateOverrideiQCOM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_QCOM_extended_get2

static void REGAL_CALL error_glExtGetProgramBinarySourceQCOM(GLuint program, GLenum shadertype, GLchar *source, GLint *length)
{
  Internal("error_glExtGetProgramBinarySourceQCOM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glExtGetProgramBinarySourceQCOM)(program, shadertype, source, length);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glExtGetProgramBinarySourceQCOM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glExtGetProgramsQCOM(GLuint *programs, GLint maxPrograms, GLint *numPrograms)
{
  Internal("error_glExtGetProgramsQCOM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glExtGetProgramsQCOM)(programs, maxPrograms, numPrograms);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glExtGetProgramsQCOM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glExtGetShadersQCOM(GLuint *shaders, GLint maxShaders, GLint *numShaders)
{
  Internal("error_glExtGetShadersQCOM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glExtGetShadersQCOM)(shaders, maxShaders, numShaders);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glExtGetShadersQCOM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLboolean REGAL_CALL error_glExtIsProgramBinaryQCOM(GLuint program)
{
  Internal("error_glExtIsProgramBinaryQCOM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glExtIsProgramBinaryQCOM)(program);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glExtIsProgramBinaryQCOM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

// GL_QCOM_tiled_rendering

static void REGAL_CALL error_glEndTilingQCOM(GLbitfield preserveMask)
{
  Internal("error_glEndTilingQCOM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glEndTilingQCOM)(preserveMask);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glEndTilingQCOM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glStartTilingQCOM(GLuint x, GLuint y, GLuint width, GLuint height, GLbitfield preserveMask)
{
  Internal("error_glStartTilingQCOM","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glStartTilingQCOM)(x, y, width, height, preserveMask);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glStartTilingQCOM : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_REGAL_ES1_0_compatibility

static void REGAL_CALL error_glAlphaFuncx(GLenum func, GLclampx ref)
{
  Internal("error_glAlphaFuncx","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glAlphaFuncx)(func, ref);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glAlphaFuncx : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glClearColorx(GLclampx red, GLclampx green, GLclampx blue, GLclampx alpha)
{
  Internal("error_glClearColorx","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClearColorx)(red, green, blue, alpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClearColorx : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glClearDepthx(GLclampx depth)
{
  Internal("error_glClearDepthx","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClearDepthx)(depth);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClearDepthx : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor4x(GLfixed red, GLfixed green, GLfixed blue, GLfixed alpha)
{
  Internal("error_glColor4x","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor4x)(red, green, blue, alpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor4x : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDepthRangex(GLclampx zNear, GLclampx zFar)
{
  Internal("error_glDepthRangex","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDepthRangex)(zNear, zFar);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDepthRangex : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFogx(GLenum pname, GLfixed param)
{
  Internal("error_glFogx","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFogx)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFogx : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFogxv(GLenum pname, const GLfixed *params)
{
  Internal("error_glFogxv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFogxv)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFogxv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFrustumf(GLfloat left, GLfloat right, GLfloat bottom, GLfloat top, GLfloat zNear, GLfloat zFar)
{
  Internal("error_glFrustumf","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFrustumf)(left, right, bottom, top, zNear, zFar);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFrustumf : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFrustumx(GLfixed left, GLfixed right, GLfixed bottom, GLfixed top, GLfixed zNear, GLfixed zFar)
{
  Internal("error_glFrustumx","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFrustumx)(left, right, bottom, top, zNear, zFar);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFrustumx : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLightModelx(GLenum pname, GLfixed param)
{
  Internal("error_glLightModelx","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLightModelx)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLightModelx : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLightModelxv(GLenum pname, const GLfixed *params)
{
  Internal("error_glLightModelxv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLightModelxv)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLightModelxv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLightx(GLenum light, GLenum pname, GLfixed param)
{
  Internal("error_glLightx","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLightx)(light, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLightx : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLightxv(GLenum light, GLenum pname, const GLfixed *params)
{
  Internal("error_glLightxv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLightxv)(light, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLightxv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLineWidthx(GLfixed width)
{
  Internal("error_glLineWidthx","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLineWidthx)(width);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLineWidthx : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLoadMatrixx(const GLfixed *m)
{
  Internal("error_glLoadMatrixx","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLoadMatrixx)(m);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLoadMatrixx : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMaterialx(GLenum face, GLenum pname, GLfixed param)
{
  Internal("error_glMaterialx","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMaterialx)(face, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMaterialx : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMaterialxv(GLenum face, GLenum pname, const GLfixed *params)
{
  Internal("error_glMaterialxv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMaterialxv)(face, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMaterialxv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultMatrixx(const GLfixed *m)
{
  Internal("error_glMultMatrixx","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultMatrixx)(m);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultMatrixx : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glMultiTexCoord4x(GLenum target, GLfixed s, GLfixed t, GLfixed r, GLfixed q)
{
  Internal("error_glMultiTexCoord4x","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glMultiTexCoord4x)(target, s, t, r, q);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glMultiTexCoord4x : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormal3x(GLfixed nx, GLfixed ny, GLfixed nz)
{
  Internal("error_glNormal3x","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormal3x)(nx, ny, nz);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormal3x : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glOrthof(GLfloat left, GLfloat right, GLfloat bottom, GLfloat top, GLfloat zNear, GLfloat zFar)
{
  Internal("error_glOrthof","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glOrthof)(left, right, bottom, top, zNear, zFar);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glOrthof : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glOrthox(GLfixed left, GLfixed right, GLfixed bottom, GLfixed top, GLfixed zNear, GLfixed zFar)
{
  Internal("error_glOrthox","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glOrthox)(left, right, bottom, top, zNear, zFar);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glOrthox : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPointSizex(GLfixed size)
{
  Internal("error_glPointSizex","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPointSizex)(size);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPointSizex : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPolygonOffsetx(GLfixed factor, GLfixed units)
{
  Internal("error_glPolygonOffsetx","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPolygonOffsetx)(factor, units);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPolygonOffsetx : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glRotatex(GLfixed angle, GLfixed x, GLfixed y, GLfixed z)
{
  Internal("error_glRotatex","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glRotatex)(angle, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glRotatex : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSampleCoveragex(GLclampx value, GLboolean invert)
{
  Internal("error_glSampleCoveragex","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSampleCoveragex)(value, invert);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSampleCoveragex : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glScalex(GLfixed x, GLfixed y, GLfixed z)
{
  Internal("error_glScalex","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glScalex)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glScalex : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexEnvx(GLenum target, GLenum pname, GLfixed param)
{
  Internal("error_glTexEnvx","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexEnvx)(target, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexEnvx : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexEnvxv(GLenum target, GLenum pname, const GLfixed *params)
{
  Internal("error_glTexEnvxv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexEnvxv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexEnvxv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexParameterx(GLenum target, GLenum pname, GLfixed param)
{
  Internal("error_glTexParameterx","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexParameterx)(target, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexParameterx : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTranslatex(GLfixed x, GLfixed y, GLfixed z)
{
  Internal("error_glTranslatex","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTranslatex)(x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTranslatex : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_REGAL_ES1_1_compatibility

static void REGAL_CALL error_glClipPlanef(GLenum plane, const GLfloat *equation)
{
  Internal("error_glClipPlanef","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClipPlanef)(plane, equation);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClipPlanef : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glClipPlanex(GLenum plane, const GLfixed *equation)
{
  Internal("error_glClipPlanex","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glClipPlanex)(plane, equation);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glClipPlanex : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetClipPlanef(GLenum pname, GLfloat *eqn)
{
  Internal("error_glGetClipPlanef","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetClipPlanef)(pname, eqn);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetClipPlanef : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetClipPlanex(GLenum pname, GLfixed *eqn)
{
  Internal("error_glGetClipPlanex","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetClipPlanex)(pname, eqn);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetClipPlanex : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetFixedv(GLenum pname, GLfixed *params)
{
  Internal("error_glGetFixedv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetFixedv)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetFixedv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetLightxv(GLenum light, GLenum pname, GLfixed *params)
{
  Internal("error_glGetLightxv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetLightxv)(light, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetLightxv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetMaterialxv(GLenum face, GLenum pname, GLfixed *params)
{
  Internal("error_glGetMaterialxv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetMaterialxv)(face, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetMaterialxv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTexEnvxv(GLenum env, GLenum pname, GLfixed *params)
{
  Internal("error_glGetTexEnvxv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTexEnvxv)(env, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTexEnvxv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetTexParameterxv(GLenum target, GLenum pname, GLfixed *params)
{
  Internal("error_glGetTexParameterxv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTexParameterxv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTexParameterxv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPointParameterx(GLenum pname, GLfixed param)
{
  Internal("error_glPointParameterx","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPointParameterx)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPointParameterx : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPointParameterxv(GLenum pname, const GLfixed *params)
{
  Internal("error_glPointParameterxv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPointParameterxv)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPointParameterxv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPointSizePointerOES(GLenum type, GLsizei stride, const GLvoid *pointer)
{
  Internal("error_glPointSizePointerOES","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPointSizePointerOES)(type, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPointSizePointerOES : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexParameterxv(GLenum target, GLenum pname, const GLfixed *params)
{
  Internal("error_glTexParameterxv","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexParameterxv)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexParameterxv : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_REGAL_log

static void REGAL_CALL error_glLogMessageCallbackREGAL(GLLOGPROCREGAL callback)
{
  Internal("error_glLogMessageCallbackREGAL","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLogMessageCallbackREGAL)(callback);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLogMessageCallbackREGAL : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SGIS_detail_texture

static void REGAL_CALL error_glDetailTexFuncSGIS(GLenum target, GLsizei n, const GLfloat *points)
{
  Internal("error_glDetailTexFuncSGIS","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDetailTexFuncSGIS)(target, n, points);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDetailTexFuncSGIS : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetDetailTexFuncSGIS(GLenum target, GLfloat *points)
{
  Internal("error_glGetDetailTexFuncSGIS","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetDetailTexFuncSGIS)(target, points);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetDetailTexFuncSGIS : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SGIS_fog_function

static void REGAL_CALL error_glFogFuncSGIS(GLsizei n, const GLfloat *points)
{
  Internal("error_glFogFuncSGIS","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFogFuncSGIS)(n, points);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFogFuncSGIS : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetFogFuncSGIS(GLfloat *points)
{
  Internal("error_glGetFogFuncSGIS","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetFogFuncSGIS)(points);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetFogFuncSGIS : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SGIS_multisample

static void REGAL_CALL error_glSampleMaskSGIS(GLclampf value, GLboolean invert)
{
  Internal("error_glSampleMaskSGIS","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSampleMaskSGIS)(value, invert);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSampleMaskSGIS : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSamplePatternSGIS(GLenum pattern)
{
  Internal("error_glSamplePatternSGIS","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSamplePatternSGIS)(pattern);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSamplePatternSGIS : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SGIS_pixel_texture

static void REGAL_CALL error_glGetPixelTexGenParameterfvSGIS(GLenum pname, GLfloat *params)
{
  Internal("error_glGetPixelTexGenParameterfvSGIS","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPixelTexGenParameterfvSGIS)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPixelTexGenParameterfvSGIS : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetPixelTexGenParameterivSGIS(GLenum pname, GLint *params)
{
  Internal("error_glGetPixelTexGenParameterivSGIS","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetPixelTexGenParameterivSGIS)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetPixelTexGenParameterivSGIS : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPixelTexGenParameterfSGIS(GLenum pname, GLfloat param)
{
  Internal("error_glPixelTexGenParameterfSGIS","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPixelTexGenParameterfSGIS)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPixelTexGenParameterfSGIS : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPixelTexGenParameterfvSGIS(GLenum pname, const GLfloat *params)
{
  Internal("error_glPixelTexGenParameterfvSGIS","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPixelTexGenParameterfvSGIS)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPixelTexGenParameterfvSGIS : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPixelTexGenParameteriSGIS(GLenum pname, GLint param)
{
  Internal("error_glPixelTexGenParameteriSGIS","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPixelTexGenParameteriSGIS)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPixelTexGenParameteriSGIS : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPixelTexGenParameterivSGIS(GLenum pname, const GLint *params)
{
  Internal("error_glPixelTexGenParameterivSGIS","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPixelTexGenParameterivSGIS)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPixelTexGenParameterivSGIS : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SGIS_point_parameters

static void REGAL_CALL error_glPointParameterfSGIS(GLenum pname, GLfloat param)
{
  Internal("error_glPointParameterfSGIS","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPointParameterfSGIS)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPointParameterfSGIS : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glPointParameterfvSGIS(GLenum pname, const GLfloat *params)
{
  Internal("error_glPointParameterfvSGIS","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPointParameterfvSGIS)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPointParameterfvSGIS : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SGIS_sharpen_texture

static void REGAL_CALL error_glGetSharpenTexFuncSGIS(GLenum target, GLfloat *points)
{
  Internal("error_glGetSharpenTexFuncSGIS","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetSharpenTexFuncSGIS)(target, points);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetSharpenTexFuncSGIS : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSharpenTexFuncSGIS(GLenum target, GLsizei n, const GLfloat *points)
{
  Internal("error_glSharpenTexFuncSGIS","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSharpenTexFuncSGIS)(target, n, points);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSharpenTexFuncSGIS : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SGIS_texture4D

static void REGAL_CALL error_glTexImage4DSGIS(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLsizei size4d, GLint border, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glTexImage4DSGIS","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexImage4DSGIS)(target, level, internalformat, width, height, depth, size4d, border, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexImage4DSGIS : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexSubImage4DSGIS(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint woffset, GLsizei width, GLsizei height, GLsizei depth, GLsizei size4d, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("error_glTexSubImage4DSGIS","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexSubImage4DSGIS)(target, level, xoffset, yoffset, zoffset, woffset, width, height, depth, size4d, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexSubImage4DSGIS : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SGIS_texture_color_mask

static void REGAL_CALL error_glTextureColorMaskSGIS(GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha)
{
  Internal("error_glTextureColorMaskSGIS","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureColorMaskSGIS)(red, green, blue, alpha);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureColorMaskSGIS : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SGIS_texture_filter4

static void REGAL_CALL error_glGetTexFilterFuncSGIS(GLenum target, GLenum filter, GLfloat *weights)
{
  Internal("error_glGetTexFilterFuncSGIS","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetTexFilterFuncSGIS)(target, filter, weights);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetTexFilterFuncSGIS : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexFilterFuncSGIS(GLenum target, GLenum filter, GLsizei n, const GLfloat *weights)
{
  Internal("error_glTexFilterFuncSGIS","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexFilterFuncSGIS)(target, filter, n, weights);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexFilterFuncSGIS : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SGIX_async

static void REGAL_CALL error_glAsyncMarkerSGIX(GLuint marker)
{
  Internal("error_glAsyncMarkerSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glAsyncMarkerSGIX)(marker);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glAsyncMarkerSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeleteAsyncMarkersSGIX(GLuint marker, GLsizei range)
{
  Internal("error_glDeleteAsyncMarkersSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeleteAsyncMarkersSGIX)(marker, range);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeleteAsyncMarkersSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLint REGAL_CALL error_glFinishAsyncSGIX(GLuint *markerp)
{
  Internal("error_glFinishAsyncSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLint  ret = _next->call(&_next->glFinishAsyncSGIX)(markerp);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFinishAsyncSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLuint REGAL_CALL error_glGenAsyncMarkersSGIX(GLsizei range)
{
  Internal("error_glGenAsyncMarkersSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLuint  ret = _next->call(&_next->glGenAsyncMarkersSGIX)(range);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGenAsyncMarkersSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLboolean REGAL_CALL error_glIsAsyncMarkerSGIX(GLuint marker)
{
  Internal("error_glIsAsyncMarkerSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLboolean  ret = _next->call(&_next->glIsAsyncMarkerSGIX)(marker);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIsAsyncMarkerSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static GLint REGAL_CALL error_glPollAsyncSGIX(GLuint *markerp)
{
  Internal("error_glPollAsyncSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLint  ret = _next->call(&_next->glPollAsyncSGIX)(markerp);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPollAsyncSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

// GL_SGIX_flush_raster

static void REGAL_CALL error_glFlushRasterSGIX(void)
{
  Internal("error_glFlushRasterSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFlushRasterSGIX)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFlushRasterSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SGIX_fog_texture

static void REGAL_CALL error_glTextureFogSGIX(GLenum pname)
{
  Internal("error_glTextureFogSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTextureFogSGIX)(pname);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTextureFogSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SGIX_fragment_lighting

static void REGAL_CALL error_glFragmentColorMaterialSGIX(GLenum face, GLenum mode)
{
  Internal("error_glFragmentColorMaterialSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentColorMaterialSGIX)(face, mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentColorMaterialSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFragmentLightModelfSGIX(GLenum pname, GLfloat param)
{
  Internal("error_glFragmentLightModelfSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentLightModelfSGIX)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentLightModelfSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFragmentLightModelfvSGIX(GLenum pname, const GLfloat *params)
{
  Internal("error_glFragmentLightModelfvSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentLightModelfvSGIX)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentLightModelfvSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFragmentLightModeliSGIX(GLenum pname, GLint param)
{
  Internal("error_glFragmentLightModeliSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentLightModeliSGIX)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentLightModeliSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFragmentLightModelivSGIX(GLenum pname, const GLint *params)
{
  Internal("error_glFragmentLightModelivSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentLightModelivSGIX)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentLightModelivSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFragmentLightfSGIX(GLenum light, GLenum pname, GLfloat param)
{
  Internal("error_glFragmentLightfSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentLightfSGIX)(light, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentLightfSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFragmentLightfvSGIX(GLenum light, GLenum pname, const GLfloat *params)
{
  Internal("error_glFragmentLightfvSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentLightfvSGIX)(light, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentLightfvSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFragmentLightiSGIX(GLenum light, GLenum pname, GLint param)
{
  Internal("error_glFragmentLightiSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentLightiSGIX)(light, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentLightiSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFragmentLightivSGIX(GLenum light, GLenum pname, const GLint *params)
{
  Internal("error_glFragmentLightivSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentLightivSGIX)(light, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentLightivSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFragmentMaterialfSGIX(GLenum face, GLenum pname, GLfloat param)
{
  Internal("error_glFragmentMaterialfSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentMaterialfSGIX)(face, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentMaterialfSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFragmentMaterialfvSGIX(GLenum face, GLenum pname, const GLfloat *params)
{
  Internal("error_glFragmentMaterialfvSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentMaterialfvSGIX)(face, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentMaterialfvSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFragmentMaterialiSGIX(GLenum face, GLenum pname, GLint param)
{
  Internal("error_glFragmentMaterialiSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentMaterialiSGIX)(face, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentMaterialiSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glFragmentMaterialivSGIX(GLenum face, GLenum pname, const GLint *params)
{
  Internal("error_glFragmentMaterialivSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFragmentMaterialivSGIX)(face, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFragmentMaterialivSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetFragmentLightfvSGIX(GLenum light, GLenum pname, GLfloat *params)
{
  Internal("error_glGetFragmentLightfvSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetFragmentLightfvSGIX)(light, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetFragmentLightfvSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetFragmentLightivSGIX(GLenum light, GLenum pname, GLint *params)
{
  Internal("error_glGetFragmentLightivSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetFragmentLightivSGIX)(light, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetFragmentLightivSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetFragmentMaterialfvSGIX(GLenum face, GLenum pname, GLfloat *params)
{
  Internal("error_glGetFragmentMaterialfvSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetFragmentMaterialfvSGIX)(face, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetFragmentMaterialfvSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetFragmentMaterialivSGIX(GLenum face, GLenum pname, GLint *params)
{
  Internal("error_glGetFragmentMaterialivSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetFragmentMaterialivSGIX)(face, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetFragmentMaterialivSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLightEnviSGIX(GLenum pname, GLint param)
{
  Internal("error_glLightEnviSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLightEnviSGIX)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLightEnviSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SGIX_framezoom

static void REGAL_CALL error_glFrameZoomSGIX(GLint factor)
{
  Internal("error_glFrameZoomSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFrameZoomSGIX)(factor);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFrameZoomSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SGIX_igloo_interface

static void REGAL_CALL error_glIglooInterfaceSGIX(GLenum pname, const GLvoid *params)
{
  Internal("error_glIglooInterfaceSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glIglooInterfaceSGIX)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glIglooInterfaceSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SGIX_instruments

static GLint REGAL_CALL error_glGetInstrumentsSGIX(void)
{
  Internal("error_glGetInstrumentsSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLint  ret = _next->call(&_next->glGetInstrumentsSGIX)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetInstrumentsSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glInstrumentsBufferSGIX(GLsizei size, GLint *buffer)
{
  Internal("error_glInstrumentsBufferSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glInstrumentsBufferSGIX)(size, buffer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glInstrumentsBufferSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static GLint REGAL_CALL error_glPollInstrumentsSGIX(GLint *marker_p)
{
  Internal("error_glPollInstrumentsSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  GLint  ret = _next->call(&_next->glPollInstrumentsSGIX)(marker_p);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPollInstrumentsSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
return ret;
}

static void REGAL_CALL error_glReadInstrumentsSGIX(GLint marker)
{
  Internal("error_glReadInstrumentsSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReadInstrumentsSGIX)(marker);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReadInstrumentsSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glStartInstrumentsSGIX(void)
{
  Internal("error_glStartInstrumentsSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glStartInstrumentsSGIX)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glStartInstrumentsSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glStopInstrumentsSGIX(GLint marker)
{
  Internal("error_glStopInstrumentsSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glStopInstrumentsSGIX)(marker);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glStopInstrumentsSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SGIX_list_priority

static void REGAL_CALL error_glGetListParameterfvSGIX(GLuint list, GLenum pname, GLfloat *params)
{
  Internal("error_glGetListParameterfvSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetListParameterfvSGIX)(list, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetListParameterfvSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetListParameterivSGIX(GLuint list, GLenum pname, GLint *params)
{
  Internal("error_glGetListParameterivSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetListParameterivSGIX)(list, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetListParameterivSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glListParameterfSGIX(GLuint list, GLenum pname, GLfloat param)
{
  Internal("error_glListParameterfSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glListParameterfSGIX)(list, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glListParameterfSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glListParameterfvSGIX(GLuint list, GLenum pname, const GLfloat *params)
{
  Internal("error_glListParameterfvSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glListParameterfvSGIX)(list, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glListParameterfvSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glListParameteriSGIX(GLuint list, GLenum pname, GLint param)
{
  Internal("error_glListParameteriSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glListParameteriSGIX)(list, pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glListParameteriSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glListParameterivSGIX(GLuint list, GLenum pname, const GLint *params)
{
  Internal("error_glListParameterivSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glListParameterivSGIX)(list, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glListParameterivSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SGIX_pixel_texture

static void REGAL_CALL error_glPixelTexGenSGIX(GLenum mode)
{
  Internal("error_glPixelTexGenSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glPixelTexGenSGIX)(mode);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glPixelTexGenSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SGIX_polynomial_ffd

static void REGAL_CALL error_glDeformSGIX(GLbitfield mask)
{
  Internal("error_glDeformSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeformSGIX)(mask);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeformSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeformationMap3dSGIX(GLenum target, GLdouble u1, GLdouble u2, GLint ustride, GLint uorder, GLdouble v1, GLdouble v2, GLint vstride, GLint vorder, GLdouble w1, GLdouble w2, GLint wstride, GLint worder, const GLdouble *points)
{
  Internal("error_glDeformationMap3dSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeformationMap3dSGIX)(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, w1, w2, wstride, worder, points);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeformationMap3dSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glDeformationMap3fSGIX(GLenum target, GLfloat u1, GLfloat u2, GLint ustride, GLint uorder, GLfloat v1, GLfloat v2, GLint vstride, GLint vorder, GLfloat w1, GLfloat w2, GLint wstride, GLint worder, const GLfloat *points)
{
  Internal("error_glDeformationMap3fSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDeformationMap3fSGIX)(target, u1, u2, ustride, uorder, v1, v2, vstride, vorder, w1, w2, wstride, worder, points);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDeformationMap3fSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glLoadIdentityDeformationMapSGIX(GLbitfield mask)
{
  Internal("error_glLoadIdentityDeformationMapSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glLoadIdentityDeformationMapSGIX)(mask);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glLoadIdentityDeformationMapSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SGIX_reference_plane

static void REGAL_CALL error_glReferencePlaneSGIX(const GLdouble *equation)
{
  Internal("error_glReferencePlaneSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReferencePlaneSGIX)(equation);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReferencePlaneSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SGIX_sprite

static void REGAL_CALL error_glSpriteParameterfSGIX(GLenum pname, GLfloat param)
{
  Internal("error_glSpriteParameterfSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSpriteParameterfSGIX)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSpriteParameterfSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSpriteParameterfvSGIX(GLenum pname, const GLfloat *params)
{
  Internal("error_glSpriteParameterfvSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSpriteParameterfvSGIX)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSpriteParameterfvSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSpriteParameteriSGIX(GLenum pname, GLint param)
{
  Internal("error_glSpriteParameteriSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSpriteParameteriSGIX)(pname, param);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSpriteParameteriSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glSpriteParameterivSGIX(GLenum pname, const GLint *params)
{
  Internal("error_glSpriteParameterivSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glSpriteParameterivSGIX)(pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glSpriteParameterivSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SGIX_tag_sample_buffer

static void REGAL_CALL error_glTagSampleBufferSGIX(void)
{
  Internal("error_glTagSampleBufferSGIX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTagSampleBufferSGIX)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTagSampleBufferSGIX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SGI_color_table

static void REGAL_CALL error_glColorTableParameterfvSGI(GLenum target, GLenum pname, const GLfloat *params)
{
  Internal("error_glColorTableParameterfvSGI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColorTableParameterfvSGI)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColorTableParameterfvSGI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColorTableParameterivSGI(GLenum target, GLenum pname, const GLint *params)
{
  Internal("error_glColorTableParameterivSGI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColorTableParameterivSGI)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColorTableParameterivSGI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColorTableSGI(GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, const GLvoid *table)
{
  Internal("error_glColorTableSGI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColorTableSGI)(target, internalformat, width, format, type, table);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColorTableSGI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glCopyColorTableSGI(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width)
{
  Internal("error_glCopyColorTableSGI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glCopyColorTableSGI)(target, internalformat, x, y, width);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glCopyColorTableSGI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetColorTableParameterfvSGI(GLenum target, GLenum pname, GLfloat *params)
{
  Internal("error_glGetColorTableParameterfvSGI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetColorTableParameterfvSGI)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetColorTableParameterfvSGI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetColorTableParameterivSGI(GLenum target, GLenum pname, GLint *params)
{
  Internal("error_glGetColorTableParameterivSGI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetColorTableParameterivSGI)(target, pname, params);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetColorTableParameterivSGI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGetColorTableSGI(GLenum target, GLenum format, GLenum type, GLvoid *table)
{
  Internal("error_glGetColorTableSGI","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGetColorTableSGI)(target, format, type, table);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGetColorTableSGI : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SUNX_constant_data

static void REGAL_CALL error_glFinishTextureSUNX(void)
{
  Internal("error_glFinishTextureSUNX","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glFinishTextureSUNX)();
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glFinishTextureSUNX : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SUN_global_alpha

static void REGAL_CALL error_glGlobalAlphaFactorbSUN(GLbyte factor)
{
  Internal("error_glGlobalAlphaFactorbSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGlobalAlphaFactorbSUN)(factor);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGlobalAlphaFactorbSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGlobalAlphaFactordSUN(GLdouble factor)
{
  Internal("error_glGlobalAlphaFactordSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGlobalAlphaFactordSUN)(factor);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGlobalAlphaFactordSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGlobalAlphaFactorfSUN(GLfloat factor)
{
  Internal("error_glGlobalAlphaFactorfSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGlobalAlphaFactorfSUN)(factor);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGlobalAlphaFactorfSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGlobalAlphaFactoriSUN(GLint factor)
{
  Internal("error_glGlobalAlphaFactoriSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGlobalAlphaFactoriSUN)(factor);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGlobalAlphaFactoriSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGlobalAlphaFactorsSUN(GLshort factor)
{
  Internal("error_glGlobalAlphaFactorsSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGlobalAlphaFactorsSUN)(factor);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGlobalAlphaFactorsSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGlobalAlphaFactorubSUN(GLubyte factor)
{
  Internal("error_glGlobalAlphaFactorubSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGlobalAlphaFactorubSUN)(factor);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGlobalAlphaFactorubSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGlobalAlphaFactoruiSUN(GLuint factor)
{
  Internal("error_glGlobalAlphaFactoruiSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGlobalAlphaFactoruiSUN)(factor);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGlobalAlphaFactoruiSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glGlobalAlphaFactorusSUN(GLushort factor)
{
  Internal("error_glGlobalAlphaFactorusSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glGlobalAlphaFactorusSUN)(factor);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glGlobalAlphaFactorusSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SUN_mesh_array

static void REGAL_CALL error_glDrawMeshArraysSUN(GLenum mode, GLint first, GLsizei count, GLsizei width)
{
  Internal("error_glDrawMeshArraysSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glDrawMeshArraysSUN)(mode, first, count, width);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glDrawMeshArraysSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SUN_read_video_pixels

static void REGAL_CALL error_glReadVideoPixelsSUN(GLint x, GLint y, GLsizei width, GLsizei height, GLenum format, GLenum type, GLvoid *pixels)
{
  Internal("error_glReadVideoPixelsSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReadVideoPixelsSUN)(x, y, width, height, format, type, pixels);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReadVideoPixelsSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SUN_triangle_list

static void REGAL_CALL error_glReplacementCodePointerSUN(GLenum type, GLsizei stride, const GLvoid **pointer)
{
  Internal("error_glReplacementCodePointerSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReplacementCodePointerSUN)(type, stride, pointer);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReplacementCodePointerSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReplacementCodeubSUN(GLubyte code)
{
  Internal("error_glReplacementCodeubSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReplacementCodeubSUN)(code);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReplacementCodeubSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReplacementCodeubvSUN(const GLubyte *code)
{
  Internal("error_glReplacementCodeubvSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReplacementCodeubvSUN)(code);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReplacementCodeubvSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReplacementCodeuiSUN(GLuint code)
{
  Internal("error_glReplacementCodeuiSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReplacementCodeuiSUN)(code);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReplacementCodeuiSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReplacementCodeuivSUN(const GLuint *code)
{
  Internal("error_glReplacementCodeuivSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReplacementCodeuivSUN)(code);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReplacementCodeuivSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReplacementCodeusSUN(GLushort code)
{
  Internal("error_glReplacementCodeusSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReplacementCodeusSUN)(code);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReplacementCodeusSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReplacementCodeusvSUN(const GLushort *code)
{
  Internal("error_glReplacementCodeusvSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReplacementCodeusvSUN)(code);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReplacementCodeusvSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_SUN_vertex

static void REGAL_CALL error_glColor3fVertex3fSUN(GLfloat r, GLfloat g, GLfloat b, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glColor3fVertex3fSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor3fVertex3fSUN)(r, g, b, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor3fVertex3fSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor3fVertex3fvSUN(const GLfloat *c, const GLfloat *v)
{
  Internal("error_glColor3fVertex3fvSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor3fVertex3fvSUN)(c, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor3fVertex3fvSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor4fNormal3fVertex3fSUN(GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glColor4fNormal3fVertex3fSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor4fNormal3fVertex3fSUN)(r, g, b, a, nx, ny, nz, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor4fNormal3fVertex3fSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor4fNormal3fVertex3fvSUN(const GLfloat *c, const GLfloat *n, const GLfloat *v)
{
  Internal("error_glColor4fNormal3fVertex3fvSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor4fNormal3fVertex3fvSUN)(c, n, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor4fNormal3fVertex3fvSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor4ubVertex2fSUN(GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y)
{
  Internal("error_glColor4ubVertex2fSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor4ubVertex2fSUN)(r, g, b, a, x, y);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor4ubVertex2fSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor4ubVertex2fvSUN(const GLubyte *c, const GLfloat *v)
{
  Internal("error_glColor4ubVertex2fvSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor4ubVertex2fvSUN)(c, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor4ubVertex2fvSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor4ubVertex3fSUN(GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glColor4ubVertex3fSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor4ubVertex3fSUN)(r, g, b, a, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor4ubVertex3fSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glColor4ubVertex3fvSUN(const GLubyte *c, const GLfloat *v)
{
  Internal("error_glColor4ubVertex3fvSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glColor4ubVertex3fvSUN)(c, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glColor4ubVertex3fvSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormal3fVertex3fSUN(GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glNormal3fVertex3fSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormal3fVertex3fSUN)(nx, ny, nz, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormal3fVertex3fSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glNormal3fVertex3fvSUN(const GLfloat *n, const GLfloat *v)
{
  Internal("error_glNormal3fVertex3fvSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glNormal3fVertex3fvSUN)(n, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glNormal3fVertex3fvSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReplacementCodeuiColor3fVertex3fSUN(GLuint rc, GLfloat r, GLfloat g, GLfloat b, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glReplacementCodeuiColor3fVertex3fSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReplacementCodeuiColor3fVertex3fSUN)(rc, r, g, b, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReplacementCodeuiColor3fVertex3fSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReplacementCodeuiColor3fVertex3fvSUN(const GLuint *rc, const GLfloat *c, const GLfloat *v)
{
  Internal("error_glReplacementCodeuiColor3fVertex3fvSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReplacementCodeuiColor3fVertex3fvSUN)(rc, c, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReplacementCodeuiColor3fVertex3fvSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReplacementCodeuiColor4fNormal3fVertex3fSUN(GLuint rc, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glReplacementCodeuiColor4fNormal3fVertex3fSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReplacementCodeuiColor4fNormal3fVertex3fSUN)(rc, r, g, b, a, nx, ny, nz, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReplacementCodeuiColor4fNormal3fVertex3fSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReplacementCodeuiColor4fNormal3fVertex3fvSUN(const GLuint *rc, const GLfloat *c, const GLfloat *n, const GLfloat *v)
{
  Internal("error_glReplacementCodeuiColor4fNormal3fVertex3fvSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReplacementCodeuiColor4fNormal3fVertex3fvSUN)(rc, c, n, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReplacementCodeuiColor4fNormal3fVertex3fvSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReplacementCodeuiColor4ubVertex3fSUN(GLuint rc, GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glReplacementCodeuiColor4ubVertex3fSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReplacementCodeuiColor4ubVertex3fSUN)(rc, r, g, b, a, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReplacementCodeuiColor4ubVertex3fSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReplacementCodeuiColor4ubVertex3fvSUN(const GLuint *rc, const GLubyte *c, const GLfloat *v)
{
  Internal("error_glReplacementCodeuiColor4ubVertex3fvSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReplacementCodeuiColor4ubVertex3fvSUN)(rc, c, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReplacementCodeuiColor4ubVertex3fvSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReplacementCodeuiNormal3fVertex3fSUN(GLuint rc, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glReplacementCodeuiNormal3fVertex3fSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReplacementCodeuiNormal3fVertex3fSUN)(rc, nx, ny, nz, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReplacementCodeuiNormal3fVertex3fSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReplacementCodeuiNormal3fVertex3fvSUN(const GLuint *rc, const GLfloat *n, const GLfloat *v)
{
  Internal("error_glReplacementCodeuiNormal3fVertex3fvSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReplacementCodeuiNormal3fVertex3fvSUN)(rc, n, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReplacementCodeuiNormal3fVertex3fvSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN(GLuint rc, GLfloat s, GLfloat t, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN)(rc, s, t, r, g, b, a, nx, ny, nz, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN(const GLuint *rc, const GLfloat *tc, const GLfloat *c, const GLfloat *n, const GLfloat *v)
{
  Internal("error_glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN)(rc, tc, c, n, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN(GLuint rc, GLfloat s, GLfloat t, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN)(rc, s, t, nx, ny, nz, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN(const GLuint *rc, const GLfloat *tc, const GLfloat *n, const GLfloat *v)
{
  Internal("error_glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN)(rc, tc, n, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReplacementCodeuiTexCoord2fVertex3fSUN(GLuint rc, GLfloat s, GLfloat t, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glReplacementCodeuiTexCoord2fVertex3fSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReplacementCodeuiTexCoord2fVertex3fSUN)(rc, s, t, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReplacementCodeuiTexCoord2fVertex3fSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReplacementCodeuiTexCoord2fVertex3fvSUN(const GLuint *rc, const GLfloat *tc, const GLfloat *v)
{
  Internal("error_glReplacementCodeuiTexCoord2fVertex3fvSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReplacementCodeuiTexCoord2fVertex3fvSUN)(rc, tc, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReplacementCodeuiTexCoord2fVertex3fvSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReplacementCodeuiVertex3fSUN(GLuint rc, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glReplacementCodeuiVertex3fSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReplacementCodeuiVertex3fSUN)(rc, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReplacementCodeuiVertex3fSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glReplacementCodeuiVertex3fvSUN(const GLuint *rc, const GLfloat *v)
{
  Internal("error_glReplacementCodeuiVertex3fvSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glReplacementCodeuiVertex3fvSUN)(rc, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glReplacementCodeuiVertex3fvSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord2fColor3fVertex3fSUN(GLfloat s, GLfloat t, GLfloat r, GLfloat g, GLfloat b, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glTexCoord2fColor3fVertex3fSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord2fColor3fVertex3fSUN)(s, t, r, g, b, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord2fColor3fVertex3fSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord2fColor3fVertex3fvSUN(const GLfloat *tc, const GLfloat *c, const GLfloat *v)
{
  Internal("error_glTexCoord2fColor3fVertex3fvSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord2fColor3fVertex3fvSUN)(tc, c, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord2fColor3fVertex3fvSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord2fColor4fNormal3fVertex3fSUN(GLfloat s, GLfloat t, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glTexCoord2fColor4fNormal3fVertex3fSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord2fColor4fNormal3fVertex3fSUN)(s, t, r, g, b, a, nx, ny, nz, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord2fColor4fNormal3fVertex3fSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord2fColor4fNormal3fVertex3fvSUN(const GLfloat *tc, const GLfloat *c, const GLfloat *n, const GLfloat *v)
{
  Internal("error_glTexCoord2fColor4fNormal3fVertex3fvSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord2fColor4fNormal3fVertex3fvSUN)(tc, c, n, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord2fColor4fNormal3fVertex3fvSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord2fColor4ubVertex3fSUN(GLfloat s, GLfloat t, GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glTexCoord2fColor4ubVertex3fSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord2fColor4ubVertex3fSUN)(s, t, r, g, b, a, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord2fColor4ubVertex3fSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord2fColor4ubVertex3fvSUN(const GLfloat *tc, const GLubyte *c, const GLfloat *v)
{
  Internal("error_glTexCoord2fColor4ubVertex3fvSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord2fColor4ubVertex3fvSUN)(tc, c, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord2fColor4ubVertex3fvSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord2fNormal3fVertex3fSUN(GLfloat s, GLfloat t, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glTexCoord2fNormal3fVertex3fSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord2fNormal3fVertex3fSUN)(s, t, nx, ny, nz, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord2fNormal3fVertex3fSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord2fNormal3fVertex3fvSUN(const GLfloat *tc, const GLfloat *n, const GLfloat *v)
{
  Internal("error_glTexCoord2fNormal3fVertex3fvSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord2fNormal3fVertex3fvSUN)(tc, n, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord2fNormal3fVertex3fvSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord2fVertex3fSUN(GLfloat s, GLfloat t, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("error_glTexCoord2fVertex3fSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord2fVertex3fSUN)(s, t, x, y, z);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord2fVertex3fSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord2fVertex3fvSUN(const GLfloat *tc, const GLfloat *v)
{
  Internal("error_glTexCoord2fVertex3fvSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord2fVertex3fvSUN)(tc, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord2fVertex3fvSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord4fColor4fNormal3fVertex4fSUN(GLfloat s, GLfloat t, GLfloat p, GLfloat q, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
  Internal("error_glTexCoord4fColor4fNormal3fVertex4fSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord4fColor4fNormal3fVertex4fSUN)(s, t, p, q, r, g, b, a, nx, ny, nz, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord4fColor4fNormal3fVertex4fSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord4fColor4fNormal3fVertex4fvSUN(const GLfloat *tc, const GLfloat *c, const GLfloat *n, const GLfloat *v)
{
  Internal("error_glTexCoord4fColor4fNormal3fVertex4fvSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord4fColor4fNormal3fVertex4fvSUN)(tc, c, n, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord4fColor4fNormal3fVertex4fvSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord4fVertex4fSUN(GLfloat s, GLfloat t, GLfloat p, GLfloat q, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
  Internal("error_glTexCoord4fVertex4fSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord4fVertex4fSUN)(s, t, p, q, x, y, z, w);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord4fVertex4fSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

static void REGAL_CALL error_glTexCoord4fVertex4fvSUN(const GLfloat *tc, const GLfloat *v)
{
  Internal("error_glTexCoord4fVertex4fvSUN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glTexCoord4fVertex4fvSUN)(tc, v);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glTexCoord4fVertex4fvSUN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

// GL_WIN_swap_hint

static void REGAL_CALL error_glAddSwapHintRectWIN(GLint x, GLint y, GLsizei width, GLsizei height)
{
  Internal("error_glAddSwapHintRectWIN","()");
  RegalContext *_context = REGAL_GET_CONTEXT();
  RegalAssert(_context);
  DispatchTableGL *_next = _context->dispatcher.error.next();
  RegalAssert(_next);
  GLenum _error = GL_NO_ERROR;
  if (!_context->err.inBeginEnd)
    _error = _next->call(&_next->glGetError)();
  RegalAssert(_error==GL_NO_ERROR);
  _next->call(&_next->glAddSwapHintRectWIN)(x, y, width, height);
  if (!_context->err.inBeginEnd) {
    _error = _next->call(&_next->glGetError)();
    if (_error!=GL_NO_ERROR) {
      Error("glAddSwapHintRectWIN : ",Token::GLerrorToString(_error));
      #if REGAL_BREAK
      Break::ErrorCB(_error);
      #endif
      if (_context->err.callback)
        _context->err.callback( _error );
    }
  }
}

void InitDispatchTableError(DispatchTableGL &tbl)
{

  // GL_VERSION_1_0

  tbl.glAccum = error_glAccum;
  tbl.glAlphaFunc = error_glAlphaFunc;
  tbl.glBegin = error_glBegin;
  tbl.glBitmap = error_glBitmap;
  tbl.glBlendFunc = error_glBlendFunc;
  tbl.glCallList = error_glCallList;
  tbl.glCallLists = error_glCallLists;
  tbl.glClear = error_glClear;
  tbl.glClearAccum = error_glClearAccum;
  tbl.glClearColor = error_glClearColor;
  tbl.glClearDepth = error_glClearDepth;
  tbl.glClearIndex = error_glClearIndex;
  tbl.glClearStencil = error_glClearStencil;
  tbl.glClipPlane = error_glClipPlane;
  tbl.glColor3b = error_glColor3b;
  tbl.glColor3bv = error_glColor3bv;
  tbl.glColor3d = error_glColor3d;
  tbl.glColor3dv = error_glColor3dv;
  tbl.glColor3f = error_glColor3f;
  tbl.glColor3fv = error_glColor3fv;
  tbl.glColor3i = error_glColor3i;
  tbl.glColor3iv = error_glColor3iv;
  tbl.glColor3s = error_glColor3s;
  tbl.glColor3sv = error_glColor3sv;
  tbl.glColor3ub = error_glColor3ub;
  tbl.glColor3ubv = error_glColor3ubv;
  tbl.glColor3ui = error_glColor3ui;
  tbl.glColor3uiv = error_glColor3uiv;
  tbl.glColor3us = error_glColor3us;
  tbl.glColor3usv = error_glColor3usv;
  tbl.glColor4b = error_glColor4b;
  tbl.glColor4bv = error_glColor4bv;
  tbl.glColor4d = error_glColor4d;
  tbl.glColor4dv = error_glColor4dv;
  tbl.glColor4f = error_glColor4f;
  tbl.glColor4fv = error_glColor4fv;
  tbl.glColor4i = error_glColor4i;
  tbl.glColor4iv = error_glColor4iv;
  tbl.glColor4s = error_glColor4s;
  tbl.glColor4sv = error_glColor4sv;
  tbl.glColor4ub = error_glColor4ub;
  tbl.glColor4ubv = error_glColor4ubv;
  tbl.glColor4ui = error_glColor4ui;
  tbl.glColor4uiv = error_glColor4uiv;
  tbl.glColor4us = error_glColor4us;
  tbl.glColor4usv = error_glColor4usv;
  tbl.glColorMask = error_glColorMask;
  tbl.glColorMaterial = error_glColorMaterial;
  tbl.glCopyPixels = error_glCopyPixels;
  tbl.glCullFace = error_glCullFace;
  tbl.glDeleteLists = error_glDeleteLists;
  tbl.glDepthFunc = error_glDepthFunc;
  tbl.glDepthMask = error_glDepthMask;
  tbl.glDepthRange = error_glDepthRange;
  tbl.glDisable = error_glDisable;
  tbl.glDrawBuffer = error_glDrawBuffer;
  tbl.glDrawPixels = error_glDrawPixels;
  tbl.glEdgeFlag = error_glEdgeFlag;
  tbl.glEdgeFlagv = error_glEdgeFlagv;
  tbl.glEnable = error_glEnable;
  tbl.glEnd = error_glEnd;
  tbl.glEndList = error_glEndList;
  tbl.glEvalCoord1d = error_glEvalCoord1d;
  tbl.glEvalCoord1dv = error_glEvalCoord1dv;
  tbl.glEvalCoord1f = error_glEvalCoord1f;
  tbl.glEvalCoord1fv = error_glEvalCoord1fv;
  tbl.glEvalCoord2d = error_glEvalCoord2d;
  tbl.glEvalCoord2dv = error_glEvalCoord2dv;
  tbl.glEvalCoord2f = error_glEvalCoord2f;
  tbl.glEvalCoord2fv = error_glEvalCoord2fv;
  tbl.glEvalMesh1 = error_glEvalMesh1;
  tbl.glEvalMesh2 = error_glEvalMesh2;
  tbl.glEvalPoint1 = error_glEvalPoint1;
  tbl.glEvalPoint2 = error_glEvalPoint2;
  tbl.glFeedbackBuffer = error_glFeedbackBuffer;
  tbl.glFinish = error_glFinish;
  tbl.glFlush = error_glFlush;
  tbl.glFogf = error_glFogf;
  tbl.glFogfv = error_glFogfv;
  tbl.glFogi = error_glFogi;
  tbl.glFogiv = error_glFogiv;
  tbl.glFrontFace = error_glFrontFace;
  tbl.glFrustum = error_glFrustum;
  tbl.glGenLists = error_glGenLists;
  tbl.glGetBooleanv = error_glGetBooleanv;
  tbl.glGetClipPlane = error_glGetClipPlane;
  tbl.glGetDoublev = error_glGetDoublev;
  tbl.glGetError = error_glGetError;
  tbl.glGetFloatv = error_glGetFloatv;
  tbl.glGetIntegerv = error_glGetIntegerv;
  tbl.glGetLightfv = error_glGetLightfv;
  tbl.glGetLightiv = error_glGetLightiv;
  tbl.glGetMapdv = error_glGetMapdv;
  tbl.glGetMapfv = error_glGetMapfv;
  tbl.glGetMapiv = error_glGetMapiv;
  tbl.glGetMaterialfv = error_glGetMaterialfv;
  tbl.glGetMaterialiv = error_glGetMaterialiv;
  tbl.glGetPixelMapfv = error_glGetPixelMapfv;
  tbl.glGetPixelMapuiv = error_glGetPixelMapuiv;
  tbl.glGetPixelMapusv = error_glGetPixelMapusv;
  tbl.glGetPolygonStipple = error_glGetPolygonStipple;
  tbl.glGetString = error_glGetString;
  tbl.glGetTexEnvfv = error_glGetTexEnvfv;
  tbl.glGetTexEnviv = error_glGetTexEnviv;
  tbl.glGetTexGendv = error_glGetTexGendv;
  tbl.glGetTexGenfv = error_glGetTexGenfv;
  tbl.glGetTexGeniv = error_glGetTexGeniv;
  tbl.glGetTexImage = error_glGetTexImage;
  tbl.glGetTexLevelParameterfv = error_glGetTexLevelParameterfv;
  tbl.glGetTexLevelParameteriv = error_glGetTexLevelParameteriv;
  tbl.glGetTexParameterfv = error_glGetTexParameterfv;
  tbl.glGetTexParameteriv = error_glGetTexParameteriv;
  tbl.glHint = error_glHint;
  tbl.glIndexMask = error_glIndexMask;
  tbl.glIndexd = error_glIndexd;
  tbl.glIndexdv = error_glIndexdv;
  tbl.glIndexf = error_glIndexf;
  tbl.glIndexfv = error_glIndexfv;
  tbl.glIndexi = error_glIndexi;
  tbl.glIndexiv = error_glIndexiv;
  tbl.glIndexs = error_glIndexs;
  tbl.glIndexsv = error_glIndexsv;
  tbl.glInitNames = error_glInitNames;
  tbl.glIsEnabled = error_glIsEnabled;
  tbl.glIsList = error_glIsList;
  tbl.glLightModelf = error_glLightModelf;
  tbl.glLightModelfv = error_glLightModelfv;
  tbl.glLightModeli = error_glLightModeli;
  tbl.glLightModeliv = error_glLightModeliv;
  tbl.glLightf = error_glLightf;
  tbl.glLightfv = error_glLightfv;
  tbl.glLighti = error_glLighti;
  tbl.glLightiv = error_glLightiv;
  tbl.glLineStipple = error_glLineStipple;
  tbl.glLineWidth = error_glLineWidth;
  tbl.glListBase = error_glListBase;
  tbl.glLoadIdentity = error_glLoadIdentity;
  tbl.glLoadMatrixd = error_glLoadMatrixd;
  tbl.glLoadMatrixf = error_glLoadMatrixf;
  tbl.glLoadName = error_glLoadName;
  tbl.glLogicOp = error_glLogicOp;
  tbl.glMap1d = error_glMap1d;
  tbl.glMap1f = error_glMap1f;
  tbl.glMap2d = error_glMap2d;
  tbl.glMap2f = error_glMap2f;
  tbl.glMapGrid1d = error_glMapGrid1d;
  tbl.glMapGrid1f = error_glMapGrid1f;
  tbl.glMapGrid2d = error_glMapGrid2d;
  tbl.glMapGrid2f = error_glMapGrid2f;
  tbl.glMaterialf = error_glMaterialf;
  tbl.glMaterialfv = error_glMaterialfv;
  tbl.glMateriali = error_glMateriali;
  tbl.glMaterialiv = error_glMaterialiv;
  tbl.glMatrixMode = error_glMatrixMode;
  tbl.glMultMatrixd = error_glMultMatrixd;
  tbl.glMultMatrixf = error_glMultMatrixf;
  tbl.glNewList = error_glNewList;
  tbl.glNormal3b = error_glNormal3b;
  tbl.glNormal3bv = error_glNormal3bv;
  tbl.glNormal3d = error_glNormal3d;
  tbl.glNormal3dv = error_glNormal3dv;
  tbl.glNormal3f = error_glNormal3f;
  tbl.glNormal3fv = error_glNormal3fv;
  tbl.glNormal3i = error_glNormal3i;
  tbl.glNormal3iv = error_glNormal3iv;
  tbl.glNormal3s = error_glNormal3s;
  tbl.glNormal3sv = error_glNormal3sv;
  tbl.glOrtho = error_glOrtho;
  tbl.glPassThrough = error_glPassThrough;
  tbl.glPixelMapfv = error_glPixelMapfv;
  tbl.glPixelMapuiv = error_glPixelMapuiv;
  tbl.glPixelMapusv = error_glPixelMapusv;
  tbl.glPixelStoref = error_glPixelStoref;
  tbl.glPixelStorei = error_glPixelStorei;
  tbl.glPixelTransferf = error_glPixelTransferf;
  tbl.glPixelTransferi = error_glPixelTransferi;
  tbl.glPixelZoom = error_glPixelZoom;
  tbl.glPointSize = error_glPointSize;
  tbl.glPolygonMode = error_glPolygonMode;
  tbl.glPolygonStipple = error_glPolygonStipple;
  tbl.glPopAttrib = error_glPopAttrib;
  tbl.glPopMatrix = error_glPopMatrix;
  tbl.glPopName = error_glPopName;
  tbl.glPushAttrib = error_glPushAttrib;
  tbl.glPushMatrix = error_glPushMatrix;
  tbl.glPushName = error_glPushName;
  tbl.glRasterPos2d = error_glRasterPos2d;
  tbl.glRasterPos2dv = error_glRasterPos2dv;
  tbl.glRasterPos2f = error_glRasterPos2f;
  tbl.glRasterPos2fv = error_glRasterPos2fv;
  tbl.glRasterPos2i = error_glRasterPos2i;
  tbl.glRasterPos2iv = error_glRasterPos2iv;
  tbl.glRasterPos2s = error_glRasterPos2s;
  tbl.glRasterPos2sv = error_glRasterPos2sv;
  tbl.glRasterPos3d = error_glRasterPos3d;
  tbl.glRasterPos3dv = error_glRasterPos3dv;
  tbl.glRasterPos3f = error_glRasterPos3f;
  tbl.glRasterPos3fv = error_glRasterPos3fv;
  tbl.glRasterPos3i = error_glRasterPos3i;
  tbl.glRasterPos3iv = error_glRasterPos3iv;
  tbl.glRasterPos3s = error_glRasterPos3s;
  tbl.glRasterPos3sv = error_glRasterPos3sv;
  tbl.glRasterPos4d = error_glRasterPos4d;
  tbl.glRasterPos4dv = error_glRasterPos4dv;
  tbl.glRasterPos4f = error_glRasterPos4f;
  tbl.glRasterPos4fv = error_glRasterPos4fv;
  tbl.glRasterPos4i = error_glRasterPos4i;
  tbl.glRasterPos4iv = error_glRasterPos4iv;
  tbl.glRasterPos4s = error_glRasterPos4s;
  tbl.glRasterPos4sv = error_glRasterPos4sv;
  tbl.glReadBuffer = error_glReadBuffer;
  tbl.glReadPixels = error_glReadPixels;
  tbl.glRectd = error_glRectd;
  tbl.glRectdv = error_glRectdv;
  tbl.glRectf = error_glRectf;
  tbl.glRectfv = error_glRectfv;
  tbl.glRecti = error_glRecti;
  tbl.glRectiv = error_glRectiv;
  tbl.glRects = error_glRects;
  tbl.glRectsv = error_glRectsv;
  tbl.glRenderMode = error_glRenderMode;
  tbl.glRotated = error_glRotated;
  tbl.glRotatef = error_glRotatef;
  tbl.glScaled = error_glScaled;
  tbl.glScalef = error_glScalef;
  tbl.glScissor = error_glScissor;
  tbl.glSelectBuffer = error_glSelectBuffer;
  tbl.glShadeModel = error_glShadeModel;
  tbl.glStencilFunc = error_glStencilFunc;
  tbl.glStencilMask = error_glStencilMask;
  tbl.glStencilOp = error_glStencilOp;
  tbl.glTexCoord1d = error_glTexCoord1d;
  tbl.glTexCoord1dv = error_glTexCoord1dv;
  tbl.glTexCoord1f = error_glTexCoord1f;
  tbl.glTexCoord1fv = error_glTexCoord1fv;
  tbl.glTexCoord1i = error_glTexCoord1i;
  tbl.glTexCoord1iv = error_glTexCoord1iv;
  tbl.glTexCoord1s = error_glTexCoord1s;
  tbl.glTexCoord1sv = error_glTexCoord1sv;
  tbl.glTexCoord2d = error_glTexCoord2d;
  tbl.glTexCoord2dv = error_glTexCoord2dv;
  tbl.glTexCoord2f = error_glTexCoord2f;
  tbl.glTexCoord2fv = error_glTexCoord2fv;
  tbl.glTexCoord2i = error_glTexCoord2i;
  tbl.glTexCoord2iv = error_glTexCoord2iv;
  tbl.glTexCoord2s = error_glTexCoord2s;
  tbl.glTexCoord2sv = error_glTexCoord2sv;
  tbl.glTexCoord3d = error_glTexCoord3d;
  tbl.glTexCoord3dv = error_glTexCoord3dv;
  tbl.glTexCoord3f = error_glTexCoord3f;
  tbl.glTexCoord3fv = error_glTexCoord3fv;
  tbl.glTexCoord3i = error_glTexCoord3i;
  tbl.glTexCoord3iv = error_glTexCoord3iv;
  tbl.glTexCoord3s = error_glTexCoord3s;
  tbl.glTexCoord3sv = error_glTexCoord3sv;
  tbl.glTexCoord4d = error_glTexCoord4d;
  tbl.glTexCoord4dv = error_glTexCoord4dv;
  tbl.glTexCoord4f = error_glTexCoord4f;
  tbl.glTexCoord4fv = error_glTexCoord4fv;
  tbl.glTexCoord4i = error_glTexCoord4i;
  tbl.glTexCoord4iv = error_glTexCoord4iv;
  tbl.glTexCoord4s = error_glTexCoord4s;
  tbl.glTexCoord4sv = error_glTexCoord4sv;
  tbl.glTexEnvf = error_glTexEnvf;
  tbl.glTexEnvfv = error_glTexEnvfv;
  tbl.glTexEnvi = error_glTexEnvi;
  tbl.glTexEnviv = error_glTexEnviv;
  tbl.glTexGend = error_glTexGend;
  tbl.glTexGendv = error_glTexGendv;
  tbl.glTexGenf = error_glTexGenf;
  tbl.glTexGenfv = error_glTexGenfv;
  tbl.glTexGeni = error_glTexGeni;
  tbl.glTexGeniv = error_glTexGeniv;
  tbl.glTexImage1D = error_glTexImage1D;
  tbl.glTexImage2D = error_glTexImage2D;
  tbl.glTexParameterf = error_glTexParameterf;
  tbl.glTexParameterfv = error_glTexParameterfv;
  tbl.glTexParameteri = error_glTexParameteri;
  tbl.glTexParameteriv = error_glTexParameteriv;
  tbl.glTranslated = error_glTranslated;
  tbl.glTranslatef = error_glTranslatef;
  tbl.glVertex2d = error_glVertex2d;
  tbl.glVertex2dv = error_glVertex2dv;
  tbl.glVertex2f = error_glVertex2f;
  tbl.glVertex2fv = error_glVertex2fv;
  tbl.glVertex2i = error_glVertex2i;
  tbl.glVertex2iv = error_glVertex2iv;
  tbl.glVertex2s = error_glVertex2s;
  tbl.glVertex2sv = error_glVertex2sv;
  tbl.glVertex3d = error_glVertex3d;
  tbl.glVertex3dv = error_glVertex3dv;
  tbl.glVertex3f = error_glVertex3f;
  tbl.glVertex3fv = error_glVertex3fv;
  tbl.glVertex3i = error_glVertex3i;
  tbl.glVertex3iv = error_glVertex3iv;
  tbl.glVertex3s = error_glVertex3s;
  tbl.glVertex3sv = error_glVertex3sv;
  tbl.glVertex4d = error_glVertex4d;
  tbl.glVertex4dv = error_glVertex4dv;
  tbl.glVertex4f = error_glVertex4f;
  tbl.glVertex4fv = error_glVertex4fv;
  tbl.glVertex4i = error_glVertex4i;
  tbl.glVertex4iv = error_glVertex4iv;
  tbl.glVertex4s = error_glVertex4s;
  tbl.glVertex4sv = error_glVertex4sv;
  tbl.glViewport = error_glViewport;

  // GL_VERSION_1_1

  tbl.glAreTexturesResident = error_glAreTexturesResident;
  tbl.glArrayElement = error_glArrayElement;
  tbl.glBindTexture = error_glBindTexture;
  tbl.glColorPointer = error_glColorPointer;
  tbl.glCopyTexImage1D = error_glCopyTexImage1D;
  tbl.glCopyTexImage2D = error_glCopyTexImage2D;
  tbl.glCopyTexSubImage1D = error_glCopyTexSubImage1D;
  tbl.glCopyTexSubImage2D = error_glCopyTexSubImage2D;
  tbl.glDeleteTextures = error_glDeleteTextures;
  tbl.glDisableClientState = error_glDisableClientState;
  tbl.glDrawArrays = error_glDrawArrays;
  tbl.glDrawElements = error_glDrawElements;
  tbl.glEdgeFlagPointer = error_glEdgeFlagPointer;
  tbl.glEnableClientState = error_glEnableClientState;
  tbl.glGenTextures = error_glGenTextures;
  tbl.glGetPointerv = error_glGetPointerv;
  tbl.glIndexPointer = error_glIndexPointer;
  tbl.glIndexub = error_glIndexub;
  tbl.glIndexubv = error_glIndexubv;
  tbl.glInterleavedArrays = error_glInterleavedArrays;
  tbl.glIsTexture = error_glIsTexture;
  tbl.glNormalPointer = error_glNormalPointer;
  tbl.glPolygonOffset = error_glPolygonOffset;
  tbl.glPopClientAttrib = error_glPopClientAttrib;
  tbl.glPrioritizeTextures = error_glPrioritizeTextures;
  tbl.glPushClientAttrib = error_glPushClientAttrib;
  tbl.glTexCoordPointer = error_glTexCoordPointer;
  tbl.glTexSubImage1D = error_glTexSubImage1D;
  tbl.glTexSubImage2D = error_glTexSubImage2D;
  tbl.glVertexPointer = error_glVertexPointer;

  // GL_VERSION_1_2

  tbl.glBlendColor = error_glBlendColor;
  tbl.glBlendEquation = error_glBlendEquation;
  tbl.glCopyTexSubImage3D = error_glCopyTexSubImage3D;
  tbl.glDrawRangeElements = error_glDrawRangeElements;
  tbl.glTexImage3D = error_glTexImage3D;
  tbl.glTexSubImage3D = error_glTexSubImage3D;

  // GL_VERSION_1_3

  tbl.glActiveTexture = error_glActiveTexture;
  tbl.glClientActiveTexture = error_glClientActiveTexture;
  tbl.glCompressedTexImage1D = error_glCompressedTexImage1D;
  tbl.glCompressedTexImage2D = error_glCompressedTexImage2D;
  tbl.glCompressedTexImage3D = error_glCompressedTexImage3D;
  tbl.glCompressedTexSubImage1D = error_glCompressedTexSubImage1D;
  tbl.glCompressedTexSubImage2D = error_glCompressedTexSubImage2D;
  tbl.glCompressedTexSubImage3D = error_glCompressedTexSubImage3D;
  tbl.glGetCompressedTexImage = error_glGetCompressedTexImage;
  tbl.glLoadTransposeMatrixd = error_glLoadTransposeMatrixd;
  tbl.glLoadTransposeMatrixf = error_glLoadTransposeMatrixf;
  tbl.glMultTransposeMatrixd = error_glMultTransposeMatrixd;
  tbl.glMultTransposeMatrixf = error_glMultTransposeMatrixf;
  tbl.glMultiTexCoord1d = error_glMultiTexCoord1d;
  tbl.glMultiTexCoord1dv = error_glMultiTexCoord1dv;
  tbl.glMultiTexCoord1f = error_glMultiTexCoord1f;
  tbl.glMultiTexCoord1fv = error_glMultiTexCoord1fv;
  tbl.glMultiTexCoord1i = error_glMultiTexCoord1i;
  tbl.glMultiTexCoord1iv = error_glMultiTexCoord1iv;
  tbl.glMultiTexCoord1s = error_glMultiTexCoord1s;
  tbl.glMultiTexCoord1sv = error_glMultiTexCoord1sv;
  tbl.glMultiTexCoord2d = error_glMultiTexCoord2d;
  tbl.glMultiTexCoord2dv = error_glMultiTexCoord2dv;
  tbl.glMultiTexCoord2f = error_glMultiTexCoord2f;
  tbl.glMultiTexCoord2fv = error_glMultiTexCoord2fv;
  tbl.glMultiTexCoord2i = error_glMultiTexCoord2i;
  tbl.glMultiTexCoord2iv = error_glMultiTexCoord2iv;
  tbl.glMultiTexCoord2s = error_glMultiTexCoord2s;
  tbl.glMultiTexCoord2sv = error_glMultiTexCoord2sv;
  tbl.glMultiTexCoord3d = error_glMultiTexCoord3d;
  tbl.glMultiTexCoord3dv = error_glMultiTexCoord3dv;
  tbl.glMultiTexCoord3f = error_glMultiTexCoord3f;
  tbl.glMultiTexCoord3fv = error_glMultiTexCoord3fv;
  tbl.glMultiTexCoord3i = error_glMultiTexCoord3i;
  tbl.glMultiTexCoord3iv = error_glMultiTexCoord3iv;
  tbl.glMultiTexCoord3s = error_glMultiTexCoord3s;
  tbl.glMultiTexCoord3sv = error_glMultiTexCoord3sv;
  tbl.glMultiTexCoord4d = error_glMultiTexCoord4d;
  tbl.glMultiTexCoord4dv = error_glMultiTexCoord4dv;
  tbl.glMultiTexCoord4f = error_glMultiTexCoord4f;
  tbl.glMultiTexCoord4fv = error_glMultiTexCoord4fv;
  tbl.glMultiTexCoord4i = error_glMultiTexCoord4i;
  tbl.glMultiTexCoord4iv = error_glMultiTexCoord4iv;
  tbl.glMultiTexCoord4s = error_glMultiTexCoord4s;
  tbl.glMultiTexCoord4sv = error_glMultiTexCoord4sv;
  tbl.glSampleCoverage = error_glSampleCoverage;

  // GL_VERSION_1_4

  tbl.glBlendFuncSeparate = error_glBlendFuncSeparate;
  tbl.glFogCoordPointer = error_glFogCoordPointer;
  tbl.glFogCoordd = error_glFogCoordd;
  tbl.glFogCoorddv = error_glFogCoorddv;
  tbl.glFogCoordf = error_glFogCoordf;
  tbl.glFogCoordfv = error_glFogCoordfv;
  tbl.glMultiDrawArrays = error_glMultiDrawArrays;
  tbl.glMultiDrawElements = error_glMultiDrawElements;
  tbl.glPointParameterf = error_glPointParameterf;
  tbl.glPointParameterfv = error_glPointParameterfv;
  tbl.glPointParameteri = error_glPointParameteri;
  tbl.glPointParameteriv = error_glPointParameteriv;
  tbl.glSecondaryColor3b = error_glSecondaryColor3b;
  tbl.glSecondaryColor3bv = error_glSecondaryColor3bv;
  tbl.glSecondaryColor3d = error_glSecondaryColor3d;
  tbl.glSecondaryColor3dv = error_glSecondaryColor3dv;
  tbl.glSecondaryColor3f = error_glSecondaryColor3f;
  tbl.glSecondaryColor3fv = error_glSecondaryColor3fv;
  tbl.glSecondaryColor3i = error_glSecondaryColor3i;
  tbl.glSecondaryColor3iv = error_glSecondaryColor3iv;
  tbl.glSecondaryColor3s = error_glSecondaryColor3s;
  tbl.glSecondaryColor3sv = error_glSecondaryColor3sv;
  tbl.glSecondaryColor3ub = error_glSecondaryColor3ub;
  tbl.glSecondaryColor3ubv = error_glSecondaryColor3ubv;
  tbl.glSecondaryColor3ui = error_glSecondaryColor3ui;
  tbl.glSecondaryColor3uiv = error_glSecondaryColor3uiv;
  tbl.glSecondaryColor3us = error_glSecondaryColor3us;
  tbl.glSecondaryColor3usv = error_glSecondaryColor3usv;
  tbl.glSecondaryColorPointer = error_glSecondaryColorPointer;
  tbl.glWindowPos2d = error_glWindowPos2d;
  tbl.glWindowPos2dv = error_glWindowPos2dv;
  tbl.glWindowPos2f = error_glWindowPos2f;
  tbl.glWindowPos2fv = error_glWindowPos2fv;
  tbl.glWindowPos2i = error_glWindowPos2i;
  tbl.glWindowPos2iv = error_glWindowPos2iv;
  tbl.glWindowPos2s = error_glWindowPos2s;
  tbl.glWindowPos2sv = error_glWindowPos2sv;
  tbl.glWindowPos3d = error_glWindowPos3d;
  tbl.glWindowPos3dv = error_glWindowPos3dv;
  tbl.glWindowPos3f = error_glWindowPos3f;
  tbl.glWindowPos3fv = error_glWindowPos3fv;
  tbl.glWindowPos3i = error_glWindowPos3i;
  tbl.glWindowPos3iv = error_glWindowPos3iv;
  tbl.glWindowPos3s = error_glWindowPos3s;
  tbl.glWindowPos3sv = error_glWindowPos3sv;

  // GL_VERSION_1_5

  tbl.glBeginQuery = error_glBeginQuery;
  tbl.glBindBuffer = error_glBindBuffer;
  tbl.glBufferData = error_glBufferData;
  tbl.glBufferSubData = error_glBufferSubData;
  tbl.glDeleteBuffers = error_glDeleteBuffers;
  tbl.glDeleteQueries = error_glDeleteQueries;
  tbl.glEndQuery = error_glEndQuery;
  tbl.glGenBuffers = error_glGenBuffers;
  tbl.glGenQueries = error_glGenQueries;
  tbl.glGetBufferParameteriv = error_glGetBufferParameteriv;
  tbl.glGetBufferPointerv = error_glGetBufferPointerv;
  tbl.glGetBufferSubData = error_glGetBufferSubData;
  tbl.glGetQueryObjectiv = error_glGetQueryObjectiv;
  tbl.glGetQueryObjectuiv = error_glGetQueryObjectuiv;
  tbl.glGetQueryiv = error_glGetQueryiv;
  tbl.glIsBuffer = error_glIsBuffer;
  tbl.glIsQuery = error_glIsQuery;
  tbl.glMapBuffer = error_glMapBuffer;
  tbl.glUnmapBuffer = error_glUnmapBuffer;

  // GL_VERSION_2_0

  tbl.glAttachShader = error_glAttachShader;
  tbl.glBindAttribLocation = error_glBindAttribLocation;
  tbl.glBlendEquationSeparate = error_glBlendEquationSeparate;
  tbl.glCompileShader = error_glCompileShader;
  tbl.glCreateProgram = error_glCreateProgram;
  tbl.glCreateShader = error_glCreateShader;
  tbl.glDeleteProgram = error_glDeleteProgram;
  tbl.glDeleteShader = error_glDeleteShader;
  tbl.glDetachShader = error_glDetachShader;
  tbl.glDisableVertexAttribArray = error_glDisableVertexAttribArray;
  tbl.glDrawBuffers = error_glDrawBuffers;
  tbl.glEnableVertexAttribArray = error_glEnableVertexAttribArray;
  tbl.glGetActiveAttrib = error_glGetActiveAttrib;
  tbl.glGetActiveUniform = error_glGetActiveUniform;
  tbl.glGetAttachedShaders = error_glGetAttachedShaders;
  tbl.glGetAttribLocation = error_glGetAttribLocation;
  tbl.glGetProgramInfoLog = error_glGetProgramInfoLog;
  tbl.glGetProgramiv = error_glGetProgramiv;
  tbl.glGetShaderInfoLog = error_glGetShaderInfoLog;
  tbl.glGetShaderSource = error_glGetShaderSource;
  tbl.glGetShaderiv = error_glGetShaderiv;
  tbl.glGetUniformLocation = error_glGetUniformLocation;
  tbl.glGetUniformfv = error_glGetUniformfv;
  tbl.glGetUniformiv = error_glGetUniformiv;
  tbl.glGetVertexAttribPointerv = error_glGetVertexAttribPointerv;
  tbl.glGetVertexAttribdv = error_glGetVertexAttribdv;
  tbl.glGetVertexAttribfv = error_glGetVertexAttribfv;
  tbl.glGetVertexAttribiv = error_glGetVertexAttribiv;
  tbl.glIsProgram = error_glIsProgram;
  tbl.glIsShader = error_glIsShader;
  tbl.glLinkProgram = error_glLinkProgram;
  tbl.glShaderSource = error_glShaderSource;
  tbl.glStencilFuncSeparate = error_glStencilFuncSeparate;
  tbl.glStencilMaskSeparate = error_glStencilMaskSeparate;
  tbl.glStencilOpSeparate = error_glStencilOpSeparate;
  tbl.glUniform1f = error_glUniform1f;
  tbl.glUniform1fv = error_glUniform1fv;
  tbl.glUniform1i = error_glUniform1i;
  tbl.glUniform1iv = error_glUniform1iv;
  tbl.glUniform2f = error_glUniform2f;
  tbl.glUniform2fv = error_glUniform2fv;
  tbl.glUniform2i = error_glUniform2i;
  tbl.glUniform2iv = error_glUniform2iv;
  tbl.glUniform3f = error_glUniform3f;
  tbl.glUniform3fv = error_glUniform3fv;
  tbl.glUniform3i = error_glUniform3i;
  tbl.glUniform3iv = error_glUniform3iv;
  tbl.glUniform4f = error_glUniform4f;
  tbl.glUniform4fv = error_glUniform4fv;
  tbl.glUniform4i = error_glUniform4i;
  tbl.glUniform4iv = error_glUniform4iv;
  tbl.glUniformMatrix2fv = error_glUniformMatrix2fv;
  tbl.glUniformMatrix3fv = error_glUniformMatrix3fv;
  tbl.glUniformMatrix4fv = error_glUniformMatrix4fv;
  tbl.glUseProgram = error_glUseProgram;
  tbl.glValidateProgram = error_glValidateProgram;
  tbl.glVertexAttrib1d = error_glVertexAttrib1d;
  tbl.glVertexAttrib1dv = error_glVertexAttrib1dv;
  tbl.glVertexAttrib1f = error_glVertexAttrib1f;
  tbl.glVertexAttrib1fv = error_glVertexAttrib1fv;
  tbl.glVertexAttrib1s = error_glVertexAttrib1s;
  tbl.glVertexAttrib1sv = error_glVertexAttrib1sv;
  tbl.glVertexAttrib2d = error_glVertexAttrib2d;
  tbl.glVertexAttrib2dv = error_glVertexAttrib2dv;
  tbl.glVertexAttrib2f = error_glVertexAttrib2f;
  tbl.glVertexAttrib2fv = error_glVertexAttrib2fv;
  tbl.glVertexAttrib2s = error_glVertexAttrib2s;
  tbl.glVertexAttrib2sv = error_glVertexAttrib2sv;
  tbl.glVertexAttrib3d = error_glVertexAttrib3d;
  tbl.glVertexAttrib3dv = error_glVertexAttrib3dv;
  tbl.glVertexAttrib3f = error_glVertexAttrib3f;
  tbl.glVertexAttrib3fv = error_glVertexAttrib3fv;
  tbl.glVertexAttrib3s = error_glVertexAttrib3s;
  tbl.glVertexAttrib3sv = error_glVertexAttrib3sv;
  tbl.glVertexAttrib4Nbv = error_glVertexAttrib4Nbv;
  tbl.glVertexAttrib4Niv = error_glVertexAttrib4Niv;
  tbl.glVertexAttrib4Nsv = error_glVertexAttrib4Nsv;
  tbl.glVertexAttrib4Nub = error_glVertexAttrib4Nub;
  tbl.glVertexAttrib4Nubv = error_glVertexAttrib4Nubv;
  tbl.glVertexAttrib4Nuiv = error_glVertexAttrib4Nuiv;
  tbl.glVertexAttrib4Nusv = error_glVertexAttrib4Nusv;
  tbl.glVertexAttrib4bv = error_glVertexAttrib4bv;
  tbl.glVertexAttrib4d = error_glVertexAttrib4d;
  tbl.glVertexAttrib4dv = error_glVertexAttrib4dv;
  tbl.glVertexAttrib4f = error_glVertexAttrib4f;
  tbl.glVertexAttrib4fv = error_glVertexAttrib4fv;
  tbl.glVertexAttrib4iv = error_glVertexAttrib4iv;
  tbl.glVertexAttrib4s = error_glVertexAttrib4s;
  tbl.glVertexAttrib4sv = error_glVertexAttrib4sv;
  tbl.glVertexAttrib4ubv = error_glVertexAttrib4ubv;
  tbl.glVertexAttrib4uiv = error_glVertexAttrib4uiv;
  tbl.glVertexAttrib4usv = error_glVertexAttrib4usv;
  tbl.glVertexAttribPointer = error_glVertexAttribPointer;

  // GL_VERSION_2_1

  tbl.glUniformMatrix2x3fv = error_glUniformMatrix2x3fv;
  tbl.glUniformMatrix2x4fv = error_glUniformMatrix2x4fv;
  tbl.glUniformMatrix3x2fv = error_glUniformMatrix3x2fv;
  tbl.glUniformMatrix3x4fv = error_glUniformMatrix3x4fv;
  tbl.glUniformMatrix4x2fv = error_glUniformMatrix4x2fv;
  tbl.glUniformMatrix4x3fv = error_glUniformMatrix4x3fv;

  // GL_VERSION_3_0

  tbl.glBeginConditionalRender = error_glBeginConditionalRender;
  tbl.glBeginTransformFeedback = error_glBeginTransformFeedback;
  tbl.glBindFragDataLocation = error_glBindFragDataLocation;
  tbl.glClampColor = error_glClampColor;
  tbl.glClearBufferfi = error_glClearBufferfi;
  tbl.glClearBufferfv = error_glClearBufferfv;
  tbl.glClearBufferiv = error_glClearBufferiv;
  tbl.glClearBufferuiv = error_glClearBufferuiv;
  tbl.glColorMaski = error_glColorMaski;
  tbl.glDisablei = error_glDisablei;
  tbl.glEnablei = error_glEnablei;
  tbl.glEndConditionalRender = error_glEndConditionalRender;
  tbl.glEndTransformFeedback = error_glEndTransformFeedback;
  tbl.glGetBooleani_v = error_glGetBooleani_v;
  tbl.glGetFragDataLocation = error_glGetFragDataLocation;
  tbl.glGetStringi = error_glGetStringi;
  tbl.glGetTexParameterIiv = error_glGetTexParameterIiv;
  tbl.glGetTexParameterIuiv = error_glGetTexParameterIuiv;
  tbl.glGetTransformFeedbackVarying = error_glGetTransformFeedbackVarying;
  tbl.glGetUniformuiv = error_glGetUniformuiv;
  tbl.glGetVertexAttribIiv = error_glGetVertexAttribIiv;
  tbl.glGetVertexAttribIuiv = error_glGetVertexAttribIuiv;
  tbl.glIsEnabledi = error_glIsEnabledi;
  tbl.glTexParameterIiv = error_glTexParameterIiv;
  tbl.glTexParameterIuiv = error_glTexParameterIuiv;
  tbl.glTransformFeedbackVaryings = error_glTransformFeedbackVaryings;
  tbl.glUniform1ui = error_glUniform1ui;
  tbl.glUniform1uiv = error_glUniform1uiv;
  tbl.glUniform2ui = error_glUniform2ui;
  tbl.glUniform2uiv = error_glUniform2uiv;
  tbl.glUniform3ui = error_glUniform3ui;
  tbl.glUniform3uiv = error_glUniform3uiv;
  tbl.glUniform4ui = error_glUniform4ui;
  tbl.glUniform4uiv = error_glUniform4uiv;
  tbl.glVertexAttribI1i = error_glVertexAttribI1i;
  tbl.glVertexAttribI1iv = error_glVertexAttribI1iv;
  tbl.glVertexAttribI1ui = error_glVertexAttribI1ui;
  tbl.glVertexAttribI1uiv = error_glVertexAttribI1uiv;
  tbl.glVertexAttribI2i = error_glVertexAttribI2i;
  tbl.glVertexAttribI2iv = error_glVertexAttribI2iv;
  tbl.glVertexAttribI2ui = error_glVertexAttribI2ui;
  tbl.glVertexAttribI2uiv = error_glVertexAttribI2uiv;
  tbl.glVertexAttribI3i = error_glVertexAttribI3i;
  tbl.glVertexAttribI3iv = error_glVertexAttribI3iv;
  tbl.glVertexAttribI3ui = error_glVertexAttribI3ui;
  tbl.glVertexAttribI3uiv = error_glVertexAttribI3uiv;
  tbl.glVertexAttribI4bv = error_glVertexAttribI4bv;
  tbl.glVertexAttribI4i = error_glVertexAttribI4i;
  tbl.glVertexAttribI4iv = error_glVertexAttribI4iv;
  tbl.glVertexAttribI4sv = error_glVertexAttribI4sv;
  tbl.glVertexAttribI4ubv = error_glVertexAttribI4ubv;
  tbl.glVertexAttribI4ui = error_glVertexAttribI4ui;
  tbl.glVertexAttribI4uiv = error_glVertexAttribI4uiv;
  tbl.glVertexAttribI4usv = error_glVertexAttribI4usv;
  tbl.glVertexAttribIPointer = error_glVertexAttribIPointer;

  // GL_VERSION_3_1

  tbl.glDrawArraysInstanced = error_glDrawArraysInstanced;
  tbl.glDrawElementsInstanced = error_glDrawElementsInstanced;
  tbl.glPrimitiveRestartIndex = error_glPrimitiveRestartIndex;
  tbl.glTexBuffer = error_glTexBuffer;

  // GL_VERSION_3_2

  tbl.glFramebufferTexture = error_glFramebufferTexture;
  tbl.glGetBufferParameteri64v = error_glGetBufferParameteri64v;
  tbl.glGetInteger64i_v = error_glGetInteger64i_v;

  // GL_VERSION_3_3

  tbl.glVertexAttribDivisor = error_glVertexAttribDivisor;

  // GL_VERSION_4_0

  tbl.glBlendEquationSeparatei = error_glBlendEquationSeparatei;
  tbl.glBlendEquationi = error_glBlendEquationi;
  tbl.glBlendFuncSeparatei = error_glBlendFuncSeparatei;
  tbl.glBlendFunci = error_glBlendFunci;

  // GL_3DFX_tbuffer

  tbl.glTbufferMask3DFX = error_glTbufferMask3DFX;

  // GL_AMD_debug_output

  tbl.glDebugMessageCallbackAMD = error_glDebugMessageCallbackAMD;
  tbl.glDebugMessageEnableAMD = error_glDebugMessageEnableAMD;
  tbl.glDebugMessageInsertAMD = error_glDebugMessageInsertAMD;
  tbl.glGetDebugMessageLogAMD = error_glGetDebugMessageLogAMD;

  // GL_AMD_draw_buffers_blend

  tbl.glBlendEquationIndexedAMD = error_glBlendEquationIndexedAMD;
  tbl.glBlendEquationSeparateIndexedAMD = error_glBlendEquationSeparateIndexedAMD;
  tbl.glBlendFuncIndexedAMD = error_glBlendFuncIndexedAMD;
  tbl.glBlendFuncSeparateIndexedAMD = error_glBlendFuncSeparateIndexedAMD;

  // GL_AMD_interleaved_elements

  tbl.glVertexAttribParameteriAMD = error_glVertexAttribParameteriAMD;

  // GL_AMD_multi_draw_indirect

  tbl.glMultiDrawArraysIndirectAMD = error_glMultiDrawArraysIndirectAMD;
  tbl.glMultiDrawElementsIndirectAMD = error_glMultiDrawElementsIndirectAMD;

  // GL_AMD_name_gen_delete

  tbl.glDeleteNamesAMD = error_glDeleteNamesAMD;
  tbl.glGenNamesAMD = error_glGenNamesAMD;
  tbl.glIsNameAMD = error_glIsNameAMD;

  // GL_AMD_performance_monitor

  tbl.glBeginPerfMonitorAMD = error_glBeginPerfMonitorAMD;
  tbl.glDeletePerfMonitorsAMD = error_glDeletePerfMonitorsAMD;
  tbl.glEndPerfMonitorAMD = error_glEndPerfMonitorAMD;
  tbl.glGenPerfMonitorsAMD = error_glGenPerfMonitorsAMD;
  tbl.glGetPerfMonitorCounterDataAMD = error_glGetPerfMonitorCounterDataAMD;
  tbl.glGetPerfMonitorCounterInfoAMD = error_glGetPerfMonitorCounterInfoAMD;
  tbl.glGetPerfMonitorCounterStringAMD = error_glGetPerfMonitorCounterStringAMD;
  tbl.glGetPerfMonitorCountersAMD = error_glGetPerfMonitorCountersAMD;
  tbl.glGetPerfMonitorGroupStringAMD = error_glGetPerfMonitorGroupStringAMD;
  tbl.glGetPerfMonitorGroupsAMD = error_glGetPerfMonitorGroupsAMD;
  tbl.glSelectPerfMonitorCountersAMD = error_glSelectPerfMonitorCountersAMD;

  // GL_AMD_sample_positions

  tbl.glSetMultisamplefvAMD = error_glSetMultisamplefvAMD;

  // GL_AMD_sparse_texture

  tbl.glTexStorageSparseAMD = error_glTexStorageSparseAMD;
  tbl.glTextureStorageSparseAMD = error_glTextureStorageSparseAMD;

  // GL_AMD_stencil_operation_extended

  tbl.glStencilOpValueAMD = error_glStencilOpValueAMD;

  // GL_AMD_vertex_shader_tessellator

  tbl.glTessellationFactorAMD = error_glTessellationFactorAMD;
  tbl.glTessellationModeAMD = error_glTessellationModeAMD;

  // GL_ANGLE_framebuffer_blit

  tbl.glBlitFramebufferANGLE = error_glBlitFramebufferANGLE;

  // GL_ANGLE_framebuffer_multisample

  tbl.glRenderbufferStorageMultisampleANGLE = error_glRenderbufferStorageMultisampleANGLE;

  // GL_ANGLE_instanced_arrays

  tbl.glDrawArraysInstancedANGLE = error_glDrawArraysInstancedANGLE;
  tbl.glDrawElementsInstancedANGLE = error_glDrawElementsInstancedANGLE;
  tbl.glVertexAttribDivisorANGLE = error_glVertexAttribDivisorANGLE;

  // GL_ANGLE_timer_query

  tbl.glBeginQueryANGLE = error_glBeginQueryANGLE;
  tbl.glDeleteQueriesANGLE = error_glDeleteQueriesANGLE;
  tbl.glEndQueryANGLE = error_glEndQueryANGLE;
  tbl.glGenQueriesANGLE = error_glGenQueriesANGLE;
  tbl.glGetQueryObjecti64vANGLE = error_glGetQueryObjecti64vANGLE;
  tbl.glGetQueryObjectivANGLE = error_glGetQueryObjectivANGLE;
  tbl.glGetQueryObjectui64vANGLE = error_glGetQueryObjectui64vANGLE;
  tbl.glGetQueryObjectuivANGLE = error_glGetQueryObjectuivANGLE;
  tbl.glGetQueryivANGLE = error_glGetQueryivANGLE;
  tbl.glIsQueryANGLE = error_glIsQueryANGLE;
  tbl.glQueryCounterANGLE = error_glQueryCounterANGLE;

  // GL_ANGLE_translated_shader_source

  tbl.glGetTranslatedShaderSourceANGLE = error_glGetTranslatedShaderSourceANGLE;

  // GL_APPLE_copy_texture_levels

  tbl.glCopyTextureLevelsAPPLE = error_glCopyTextureLevelsAPPLE;

  // GL_APPLE_element_array

  tbl.glDrawElementArrayAPPLE = error_glDrawElementArrayAPPLE;
  tbl.glDrawRangeElementArrayAPPLE = error_glDrawRangeElementArrayAPPLE;
  tbl.glElementPointerAPPLE = error_glElementPointerAPPLE;
  tbl.glMultiDrawElementArrayAPPLE = error_glMultiDrawElementArrayAPPLE;
  tbl.glMultiDrawRangeElementArrayAPPLE = error_glMultiDrawRangeElementArrayAPPLE;

  // GL_APPLE_fence

  tbl.glDeleteFencesAPPLE = error_glDeleteFencesAPPLE;
  tbl.glFinishFenceAPPLE = error_glFinishFenceAPPLE;
  tbl.glFinishObjectAPPLE = error_glFinishObjectAPPLE;
  tbl.glGenFencesAPPLE = error_glGenFencesAPPLE;
  tbl.glIsFenceAPPLE = error_glIsFenceAPPLE;
  tbl.glSetFenceAPPLE = error_glSetFenceAPPLE;
  tbl.glTestFenceAPPLE = error_glTestFenceAPPLE;
  tbl.glTestObjectAPPLE = error_glTestObjectAPPLE;

  // GL_APPLE_flush_buffer_range

  tbl.glBufferParameteriAPPLE = error_glBufferParameteriAPPLE;
  tbl.glFlushMappedBufferRangeAPPLE = error_glFlushMappedBufferRangeAPPLE;

  // GL_APPLE_flush_render

  tbl.glFinishRenderAPPLE = error_glFinishRenderAPPLE;
  tbl.glFlushRenderAPPLE = error_glFlushRenderAPPLE;
  tbl.glSwapAPPLE = error_glSwapAPPLE;

  // GL_APPLE_framebuffer_multisample

  tbl.glRenderbufferStorageMultisampleAPPLE = error_glRenderbufferStorageMultisampleAPPLE;
  tbl.glResolveMultisampleFramebufferAPPLE = error_glResolveMultisampleFramebufferAPPLE;

  // GL_APPLE_object_purgeable

  tbl.glGetObjectParameterivAPPLE = error_glGetObjectParameterivAPPLE;
  tbl.glObjectPurgeableAPPLE = error_glObjectPurgeableAPPLE;
  tbl.glObjectUnpurgeableAPPLE = error_glObjectUnpurgeableAPPLE;

  // GL_APPLE_sync

  tbl.glClientWaitSyncAPPLE = error_glClientWaitSyncAPPLE;
  tbl.glDeleteSyncAPPLE = error_glDeleteSyncAPPLE;
  tbl.glFenceSyncAPPLE = error_glFenceSyncAPPLE;
  tbl.glGetInteger64vAPPLE = error_glGetInteger64vAPPLE;
  tbl.glGetSyncivAPPLE = error_glGetSyncivAPPLE;
  tbl.glIsSyncAPPLE = error_glIsSyncAPPLE;
  tbl.glWaitSyncAPPLE = error_glWaitSyncAPPLE;

  // GL_APPLE_texture_range

  tbl.glGetTexParameterPointervAPPLE = error_glGetTexParameterPointervAPPLE;
  tbl.glTextureRangeAPPLE = error_glTextureRangeAPPLE;

  // GL_APPLE_vertex_array_object

  tbl.glBindVertexArrayAPPLE = error_glBindVertexArrayAPPLE;
  tbl.glDeleteVertexArraysAPPLE = error_glDeleteVertexArraysAPPLE;
  tbl.glGenVertexArraysAPPLE = error_glGenVertexArraysAPPLE;
  tbl.glIsVertexArrayAPPLE = error_glIsVertexArrayAPPLE;

  // GL_APPLE_vertex_array_range

  tbl.glFlushVertexArrayRangeAPPLE = error_glFlushVertexArrayRangeAPPLE;
  tbl.glVertexArrayParameteriAPPLE = error_glVertexArrayParameteriAPPLE;
  tbl.glVertexArrayRangeAPPLE = error_glVertexArrayRangeAPPLE;

  // GL_APPLE_vertex_program_evaluators

  tbl.glDisableVertexAttribAPPLE = error_glDisableVertexAttribAPPLE;
  tbl.glEnableVertexAttribAPPLE = error_glEnableVertexAttribAPPLE;
  tbl.glIsVertexAttribEnabledAPPLE = error_glIsVertexAttribEnabledAPPLE;
  tbl.glMapVertexAttrib1dAPPLE = error_glMapVertexAttrib1dAPPLE;
  tbl.glMapVertexAttrib1fAPPLE = error_glMapVertexAttrib1fAPPLE;
  tbl.glMapVertexAttrib2dAPPLE = error_glMapVertexAttrib2dAPPLE;
  tbl.glMapVertexAttrib2fAPPLE = error_glMapVertexAttrib2fAPPLE;

  // GL_ARB_ES2_compatibility

  tbl.glClearDepthf = error_glClearDepthf;
  tbl.glDepthRangef = error_glDepthRangef;
  tbl.glGetShaderPrecisionFormat = error_glGetShaderPrecisionFormat;
  tbl.glReleaseShaderCompiler = error_glReleaseShaderCompiler;
  tbl.glShaderBinary = error_glShaderBinary;

  // GL_ARB_base_instance

  tbl.glDrawArraysInstancedBaseInstance = error_glDrawArraysInstancedBaseInstance;
  tbl.glDrawElementsInstancedBaseInstance = error_glDrawElementsInstancedBaseInstance;
  tbl.glDrawElementsInstancedBaseVertexBaseInstance = error_glDrawElementsInstancedBaseVertexBaseInstance;

  // GL_ARB_bindless_texture

  tbl.glGetImageHandleARB = error_glGetImageHandleARB;
  tbl.glGetTextureHandleARB = error_glGetTextureHandleARB;
  tbl.glGetTextureSamplerHandleARB = error_glGetTextureSamplerHandleARB;
  tbl.glGetVertexAttribLui64vARB = error_glGetVertexAttribLui64vARB;
  tbl.glIsImageHandleResidentARB = error_glIsImageHandleResidentARB;
  tbl.glIsTextureHandleResidentARB = error_glIsTextureHandleResidentARB;
  tbl.glMakeImageHandleNonResidentARB = error_glMakeImageHandleNonResidentARB;
  tbl.glMakeImageHandleResidentARB = error_glMakeImageHandleResidentARB;
  tbl.glMakeTextureHandleNonResidentARB = error_glMakeTextureHandleNonResidentARB;
  tbl.glMakeTextureHandleResidentARB = error_glMakeTextureHandleResidentARB;
  tbl.glProgramUniformHandleui64ARB = error_glProgramUniformHandleui64ARB;
  tbl.glProgramUniformHandleui64vARB = error_glProgramUniformHandleui64vARB;
  tbl.glUniformHandleui64ARB = error_glUniformHandleui64ARB;
  tbl.glUniformHandleui64vARB = error_glUniformHandleui64vARB;
  tbl.glVertexAttribL1ui64ARB = error_glVertexAttribL1ui64ARB;
  tbl.glVertexAttribL1ui64vARB = error_glVertexAttribL1ui64vARB;

  // GL_ARB_blend_func_extended

  tbl.glBindFragDataLocationIndexed = error_glBindFragDataLocationIndexed;
  tbl.glGetFragDataIndex = error_glGetFragDataIndex;

  // GL_ARB_buffer_storage

  tbl.glBufferStorage = error_glBufferStorage;
  tbl.glNamedBufferStorageEXT = error_glNamedBufferStorageEXT;

  // GL_ARB_cl_event

  tbl.glCreateSyncFromCLeventARB = error_glCreateSyncFromCLeventARB;

  // GL_ARB_clear_buffer_object

  tbl.glClearBufferData = error_glClearBufferData;
  tbl.glClearBufferSubData = error_glClearBufferSubData;
  tbl.glClearNamedBufferDataEXT = error_glClearNamedBufferDataEXT;
  tbl.glClearNamedBufferSubDataEXT = error_glClearNamedBufferSubDataEXT;

  // GL_ARB_clear_texture

  tbl.glClearTexImage = error_glClearTexImage;
  tbl.glClearTexSubImage = error_glClearTexSubImage;

  // GL_ARB_color_buffer_float

  tbl.glClampColorARB = error_glClampColorARB;

  // GL_ARB_compute_shader

  tbl.glDispatchCompute = error_glDispatchCompute;
  tbl.glDispatchComputeIndirect = error_glDispatchComputeIndirect;

  // GL_ARB_compute_variable_group_size

  tbl.glDispatchComputeGroupSizeARB = error_glDispatchComputeGroupSizeARB;

  // GL_ARB_copy_buffer

  tbl.glCopyBufferSubData = error_glCopyBufferSubData;

  // GL_ARB_copy_image

  tbl.glCopyImageSubData = error_glCopyImageSubData;

  // GL_ARB_debug_output

  tbl.glDebugMessageCallbackARB = error_glDebugMessageCallbackARB;
  tbl.glDebugMessageControlARB = error_glDebugMessageControlARB;
  tbl.glDebugMessageInsertARB = error_glDebugMessageInsertARB;
  tbl.glGetDebugMessageLogARB = error_glGetDebugMessageLogARB;

  // GL_ARB_draw_buffers

  tbl.glDrawBuffersARB = error_glDrawBuffersARB;

  // GL_ARB_draw_buffers_blend

  tbl.glBlendEquationSeparateiARB = error_glBlendEquationSeparateiARB;
  tbl.glBlendEquationiARB = error_glBlendEquationiARB;
  tbl.glBlendFuncSeparateiARB = error_glBlendFuncSeparateiARB;
  tbl.glBlendFunciARB = error_glBlendFunciARB;

  // GL_ARB_draw_elements_base_vertex

  tbl.glDrawElementsBaseVertex = error_glDrawElementsBaseVertex;
  tbl.glDrawElementsInstancedBaseVertex = error_glDrawElementsInstancedBaseVertex;
  tbl.glDrawRangeElementsBaseVertex = error_glDrawRangeElementsBaseVertex;
  tbl.glMultiDrawElementsBaseVertex = error_glMultiDrawElementsBaseVertex;

  // GL_ARB_draw_indirect

  tbl.glDrawArraysIndirect = error_glDrawArraysIndirect;
  tbl.glDrawElementsIndirect = error_glDrawElementsIndirect;

  // GL_ARB_draw_instanced

  tbl.glDrawArraysInstancedARB = error_glDrawArraysInstancedARB;
  tbl.glDrawElementsInstancedARB = error_glDrawElementsInstancedARB;

  // GL_ARB_framebuffer_no_attachments

  tbl.glFramebufferParameteri = error_glFramebufferParameteri;
  tbl.glGetFramebufferParameteriv = error_glGetFramebufferParameteriv;
  tbl.glGetNamedFramebufferParameterivEXT = error_glGetNamedFramebufferParameterivEXT;
  tbl.glNamedFramebufferParameteriEXT = error_glNamedFramebufferParameteriEXT;

  // GL_ARB_framebuffer_object

  tbl.glBindFramebuffer = error_glBindFramebuffer;
  tbl.glBindRenderbuffer = error_glBindRenderbuffer;
  tbl.glBlitFramebuffer = error_glBlitFramebuffer;
  tbl.glCheckFramebufferStatus = error_glCheckFramebufferStatus;
  tbl.glDeleteFramebuffers = error_glDeleteFramebuffers;
  tbl.glDeleteRenderbuffers = error_glDeleteRenderbuffers;
  tbl.glFramebufferRenderbuffer = error_glFramebufferRenderbuffer;
  tbl.glFramebufferTexture1D = error_glFramebufferTexture1D;
  tbl.glFramebufferTexture2D = error_glFramebufferTexture2D;
  tbl.glFramebufferTexture3D = error_glFramebufferTexture3D;
  tbl.glFramebufferTextureLayer = error_glFramebufferTextureLayer;
  tbl.glGenFramebuffers = error_glGenFramebuffers;
  tbl.glGenRenderbuffers = error_glGenRenderbuffers;
  tbl.glGenerateMipmap = error_glGenerateMipmap;
  tbl.glGetFramebufferAttachmentParameteriv = error_glGetFramebufferAttachmentParameteriv;
  tbl.glGetRenderbufferParameteriv = error_glGetRenderbufferParameteriv;
  tbl.glIsFramebuffer = error_glIsFramebuffer;
  tbl.glIsRenderbuffer = error_glIsRenderbuffer;
  tbl.glRenderbufferStorage = error_glRenderbufferStorage;
  tbl.glRenderbufferStorageMultisample = error_glRenderbufferStorageMultisample;

  // GL_ARB_geometry_shader4

  tbl.glFramebufferTextureARB = error_glFramebufferTextureARB;
  tbl.glFramebufferTextureFaceARB = error_glFramebufferTextureFaceARB;
  tbl.glFramebufferTextureLayerARB = error_glFramebufferTextureLayerARB;
  tbl.glProgramParameteriARB = error_glProgramParameteriARB;

  // GL_ARB_get_program_binary

  tbl.glGetProgramBinary = error_glGetProgramBinary;
  tbl.glProgramBinary = error_glProgramBinary;
  tbl.glProgramParameteri = error_glProgramParameteri;

  // GL_ARB_gpu_shader_fp64

  tbl.glGetUniformdv = error_glGetUniformdv;
  tbl.glUniform1d = error_glUniform1d;
  tbl.glUniform1dv = error_glUniform1dv;
  tbl.glUniform2d = error_glUniform2d;
  tbl.glUniform2dv = error_glUniform2dv;
  tbl.glUniform3d = error_glUniform3d;
  tbl.glUniform3dv = error_glUniform3dv;
  tbl.glUniform4d = error_glUniform4d;
  tbl.glUniform4dv = error_glUniform4dv;
  tbl.glUniformMatrix2dv = error_glUniformMatrix2dv;
  tbl.glUniformMatrix2x3dv = error_glUniformMatrix2x3dv;
  tbl.glUniformMatrix2x4dv = error_glUniformMatrix2x4dv;
  tbl.glUniformMatrix3dv = error_glUniformMatrix3dv;
  tbl.glUniformMatrix3x2dv = error_glUniformMatrix3x2dv;
  tbl.glUniformMatrix3x4dv = error_glUniformMatrix3x4dv;
  tbl.glUniformMatrix4dv = error_glUniformMatrix4dv;
  tbl.glUniformMatrix4x2dv = error_glUniformMatrix4x2dv;
  tbl.glUniformMatrix4x3dv = error_glUniformMatrix4x3dv;

  // GL_ARB_imaging

  tbl.glColorSubTable = error_glColorSubTable;
  tbl.glColorTable = error_glColorTable;
  tbl.glColorTableParameterfv = error_glColorTableParameterfv;
  tbl.glColorTableParameteriv = error_glColorTableParameteriv;
  tbl.glConvolutionFilter1D = error_glConvolutionFilter1D;
  tbl.glConvolutionFilter2D = error_glConvolutionFilter2D;
  tbl.glConvolutionParameterf = error_glConvolutionParameterf;
  tbl.glConvolutionParameterfv = error_glConvolutionParameterfv;
  tbl.glConvolutionParameteri = error_glConvolutionParameteri;
  tbl.glConvolutionParameteriv = error_glConvolutionParameteriv;
  tbl.glCopyColorSubTable = error_glCopyColorSubTable;
  tbl.glCopyColorTable = error_glCopyColorTable;
  tbl.glCopyConvolutionFilter1D = error_glCopyConvolutionFilter1D;
  tbl.glCopyConvolutionFilter2D = error_glCopyConvolutionFilter2D;
  tbl.glGetColorTable = error_glGetColorTable;
  tbl.glGetColorTableParameterfv = error_glGetColorTableParameterfv;
  tbl.glGetColorTableParameteriv = error_glGetColorTableParameteriv;
  tbl.glGetConvolutionFilter = error_glGetConvolutionFilter;
  tbl.glGetConvolutionParameterfv = error_glGetConvolutionParameterfv;
  tbl.glGetConvolutionParameteriv = error_glGetConvolutionParameteriv;
  tbl.glGetHistogram = error_glGetHistogram;
  tbl.glGetHistogramParameterfv = error_glGetHistogramParameterfv;
  tbl.glGetHistogramParameteriv = error_glGetHistogramParameteriv;
  tbl.glGetMinmax = error_glGetMinmax;
  tbl.glGetMinmaxParameterfv = error_glGetMinmaxParameterfv;
  tbl.glGetMinmaxParameteriv = error_glGetMinmaxParameteriv;
  tbl.glGetSeparableFilter = error_glGetSeparableFilter;
  tbl.glHistogram = error_glHistogram;
  tbl.glMinmax = error_glMinmax;
  tbl.glResetHistogram = error_glResetHistogram;
  tbl.glResetMinmax = error_glResetMinmax;
  tbl.glSeparableFilter2D = error_glSeparableFilter2D;

  // GL_ARB_indirect_parameters

  tbl.glMultiDrawArraysIndirectCountARB = error_glMultiDrawArraysIndirectCountARB;
  tbl.glMultiDrawElementsIndirectCountARB = error_glMultiDrawElementsIndirectCountARB;

  // GL_ARB_instanced_arrays

  tbl.glVertexAttribDivisorARB = error_glVertexAttribDivisorARB;

  // GL_ARB_internalformat_query

  tbl.glGetInternalformativ = error_glGetInternalformativ;

  // GL_ARB_internalformat_query2

  tbl.glGetInternalformati64v = error_glGetInternalformati64v;

  // GL_ARB_invalidate_subdata

  tbl.glInvalidateBufferData = error_glInvalidateBufferData;
  tbl.glInvalidateBufferSubData = error_glInvalidateBufferSubData;
  tbl.glInvalidateFramebuffer = error_glInvalidateFramebuffer;
  tbl.glInvalidateSubFramebuffer = error_glInvalidateSubFramebuffer;
  tbl.glInvalidateTexImage = error_glInvalidateTexImage;
  tbl.glInvalidateTexSubImage = error_glInvalidateTexSubImage;

  // GL_ARB_map_buffer_range

  tbl.glFlushMappedBufferRange = error_glFlushMappedBufferRange;
  tbl.glMapBufferRange = error_glMapBufferRange;

  // GL_ARB_matrix_palette

  tbl.glCurrentPaletteMatrixARB = error_glCurrentPaletteMatrixARB;
  tbl.glMatrixIndexPointerARB = error_glMatrixIndexPointerARB;
  tbl.glMatrixIndexubvARB = error_glMatrixIndexubvARB;
  tbl.glMatrixIndexuivARB = error_glMatrixIndexuivARB;
  tbl.glMatrixIndexusvARB = error_glMatrixIndexusvARB;

  // GL_ARB_multi_bind

  tbl.glBindBuffersBase = error_glBindBuffersBase;
  tbl.glBindBuffersRange = error_glBindBuffersRange;
  tbl.glBindImageTextures = error_glBindImageTextures;
  tbl.glBindSamplers = error_glBindSamplers;
  tbl.glBindTextures = error_glBindTextures;
  tbl.glBindVertexBuffers = error_glBindVertexBuffers;

  // GL_ARB_multi_draw_indirect

  tbl.glMultiDrawArraysIndirect = error_glMultiDrawArraysIndirect;
  tbl.glMultiDrawElementsIndirect = error_glMultiDrawElementsIndirect;

  // GL_ARB_multisample

  tbl.glSampleCoverageARB = error_glSampleCoverageARB;

  // GL_ARB_multitexture

  tbl.glActiveTextureARB = error_glActiveTextureARB;
  tbl.glClientActiveTextureARB = error_glClientActiveTextureARB;
  tbl.glMultiTexCoord1dARB = error_glMultiTexCoord1dARB;
  tbl.glMultiTexCoord1dvARB = error_glMultiTexCoord1dvARB;
  tbl.glMultiTexCoord1fARB = error_glMultiTexCoord1fARB;
  tbl.glMultiTexCoord1fvARB = error_glMultiTexCoord1fvARB;
  tbl.glMultiTexCoord1iARB = error_glMultiTexCoord1iARB;
  tbl.glMultiTexCoord1ivARB = error_glMultiTexCoord1ivARB;
  tbl.glMultiTexCoord1sARB = error_glMultiTexCoord1sARB;
  tbl.glMultiTexCoord1svARB = error_glMultiTexCoord1svARB;
  tbl.glMultiTexCoord2dARB = error_glMultiTexCoord2dARB;
  tbl.glMultiTexCoord2dvARB = error_glMultiTexCoord2dvARB;
  tbl.glMultiTexCoord2fARB = error_glMultiTexCoord2fARB;
  tbl.glMultiTexCoord2fvARB = error_glMultiTexCoord2fvARB;
  tbl.glMultiTexCoord2iARB = error_glMultiTexCoord2iARB;
  tbl.glMultiTexCoord2ivARB = error_glMultiTexCoord2ivARB;
  tbl.glMultiTexCoord2sARB = error_glMultiTexCoord2sARB;
  tbl.glMultiTexCoord2svARB = error_glMultiTexCoord2svARB;
  tbl.glMultiTexCoord3dARB = error_glMultiTexCoord3dARB;
  tbl.glMultiTexCoord3dvARB = error_glMultiTexCoord3dvARB;
  tbl.glMultiTexCoord3fARB = error_glMultiTexCoord3fARB;
  tbl.glMultiTexCoord3fvARB = error_glMultiTexCoord3fvARB;
  tbl.glMultiTexCoord3iARB = error_glMultiTexCoord3iARB;
  tbl.glMultiTexCoord3ivARB = error_glMultiTexCoord3ivARB;
  tbl.glMultiTexCoord3sARB = error_glMultiTexCoord3sARB;
  tbl.glMultiTexCoord3svARB = error_glMultiTexCoord3svARB;
  tbl.glMultiTexCoord4dARB = error_glMultiTexCoord4dARB;
  tbl.glMultiTexCoord4dvARB = error_glMultiTexCoord4dvARB;
  tbl.glMultiTexCoord4fARB = error_glMultiTexCoord4fARB;
  tbl.glMultiTexCoord4fvARB = error_glMultiTexCoord4fvARB;
  tbl.glMultiTexCoord4iARB = error_glMultiTexCoord4iARB;
  tbl.glMultiTexCoord4ivARB = error_glMultiTexCoord4ivARB;
  tbl.glMultiTexCoord4sARB = error_glMultiTexCoord4sARB;
  tbl.glMultiTexCoord4svARB = error_glMultiTexCoord4svARB;

  // GL_ARB_occlusion_query

  tbl.glBeginQueryARB = error_glBeginQueryARB;
  tbl.glDeleteQueriesARB = error_glDeleteQueriesARB;
  tbl.glEndQueryARB = error_glEndQueryARB;
  tbl.glGenQueriesARB = error_glGenQueriesARB;
  tbl.glGetQueryObjectivARB = error_glGetQueryObjectivARB;
  tbl.glGetQueryObjectuivARB = error_glGetQueryObjectuivARB;
  tbl.glGetQueryivARB = error_glGetQueryivARB;
  tbl.glIsQueryARB = error_glIsQueryARB;

  // GL_ARB_point_parameters

  tbl.glPointParameterfARB = error_glPointParameterfARB;
  tbl.glPointParameterfvARB = error_glPointParameterfvARB;

  // GL_ARB_program_interface_query

  tbl.glGetProgramInterfaceiv = error_glGetProgramInterfaceiv;
  tbl.glGetProgramResourceIndex = error_glGetProgramResourceIndex;
  tbl.glGetProgramResourceLocation = error_glGetProgramResourceLocation;
  tbl.glGetProgramResourceLocationIndex = error_glGetProgramResourceLocationIndex;
  tbl.glGetProgramResourceName = error_glGetProgramResourceName;
  tbl.glGetProgramResourceiv = error_glGetProgramResourceiv;

  // GL_ARB_provoking_vertex

  tbl.glProvokingVertex = error_glProvokingVertex;

  // GL_ARB_robustness

  tbl.glGetGraphicsResetStatusARB = error_glGetGraphicsResetStatusARB;
  tbl.glGetnColorTableARB = error_glGetnColorTableARB;
  tbl.glGetnCompressedTexImageARB = error_glGetnCompressedTexImageARB;
  tbl.glGetnConvolutionFilterARB = error_glGetnConvolutionFilterARB;
  tbl.glGetnHistogramARB = error_glGetnHistogramARB;
  tbl.glGetnMapdvARB = error_glGetnMapdvARB;
  tbl.glGetnMapfvARB = error_glGetnMapfvARB;
  tbl.glGetnMapivARB = error_glGetnMapivARB;
  tbl.glGetnMinmaxARB = error_glGetnMinmaxARB;
  tbl.glGetnPixelMapfvARB = error_glGetnPixelMapfvARB;
  tbl.glGetnPixelMapuivARB = error_glGetnPixelMapuivARB;
  tbl.glGetnPixelMapusvARB = error_glGetnPixelMapusvARB;
  tbl.glGetnPolygonStippleARB = error_glGetnPolygonStippleARB;
  tbl.glGetnSeparableFilterARB = error_glGetnSeparableFilterARB;
  tbl.glGetnTexImageARB = error_glGetnTexImageARB;
  tbl.glGetnUniformdvARB = error_glGetnUniformdvARB;
  tbl.glGetnUniformfvARB = error_glGetnUniformfvARB;
  tbl.glGetnUniformivARB = error_glGetnUniformivARB;
  tbl.glGetnUniformuivARB = error_glGetnUniformuivARB;
  tbl.glReadnPixelsARB = error_glReadnPixelsARB;

  // GL_ARB_sample_shading

  tbl.glMinSampleShading = error_glMinSampleShading;
  tbl.glMinSampleShadingARB = error_glMinSampleShadingARB;

  // GL_ARB_sampler_objects

  tbl.glBindSampler = error_glBindSampler;
  tbl.glDeleteSamplers = error_glDeleteSamplers;
  tbl.glGenSamplers = error_glGenSamplers;
  tbl.glGetSamplerParameterIiv = error_glGetSamplerParameterIiv;
  tbl.glGetSamplerParameterIuiv = error_glGetSamplerParameterIuiv;
  tbl.glGetSamplerParameterfv = error_glGetSamplerParameterfv;
  tbl.glGetSamplerParameteriv = error_glGetSamplerParameteriv;
  tbl.glIsSampler = error_glIsSampler;
  tbl.glSamplerParameterIiv = error_glSamplerParameterIiv;
  tbl.glSamplerParameterIuiv = error_glSamplerParameterIuiv;
  tbl.glSamplerParameterf = error_glSamplerParameterf;
  tbl.glSamplerParameterfv = error_glSamplerParameterfv;
  tbl.glSamplerParameteri = error_glSamplerParameteri;
  tbl.glSamplerParameteriv = error_glSamplerParameteriv;

  // GL_ARB_separate_shader_objects

  tbl.glActiveShaderProgram = error_glActiveShaderProgram;
  tbl.glBindProgramPipeline = error_glBindProgramPipeline;
  tbl.glCreateShaderProgramv = error_glCreateShaderProgramv;
  tbl.glDeleteProgramPipelines = error_glDeleteProgramPipelines;
  tbl.glGenProgramPipelines = error_glGenProgramPipelines;
  tbl.glGetProgramPipelineInfoLog = error_glGetProgramPipelineInfoLog;
  tbl.glGetProgramPipelineiv = error_glGetProgramPipelineiv;
  tbl.glIsProgramPipeline = error_glIsProgramPipeline;
  tbl.glProgramUniform1d = error_glProgramUniform1d;
  tbl.glProgramUniform1dv = error_glProgramUniform1dv;
  tbl.glProgramUniform1f = error_glProgramUniform1f;
  tbl.glProgramUniform1fv = error_glProgramUniform1fv;
  tbl.glProgramUniform1i = error_glProgramUniform1i;
  tbl.glProgramUniform1iv = error_glProgramUniform1iv;
  tbl.glProgramUniform1ui = error_glProgramUniform1ui;
  tbl.glProgramUniform1uiv = error_glProgramUniform1uiv;
  tbl.glProgramUniform2d = error_glProgramUniform2d;
  tbl.glProgramUniform2dv = error_glProgramUniform2dv;
  tbl.glProgramUniform2f = error_glProgramUniform2f;
  tbl.glProgramUniform2fv = error_glProgramUniform2fv;
  tbl.glProgramUniform2i = error_glProgramUniform2i;
  tbl.glProgramUniform2iv = error_glProgramUniform2iv;
  tbl.glProgramUniform2ui = error_glProgramUniform2ui;
  tbl.glProgramUniform2uiv = error_glProgramUniform2uiv;
  tbl.glProgramUniform3d = error_glProgramUniform3d;
  tbl.glProgramUniform3dv = error_glProgramUniform3dv;
  tbl.glProgramUniform3f = error_glProgramUniform3f;
  tbl.glProgramUniform3fv = error_glProgramUniform3fv;
  tbl.glProgramUniform3i = error_glProgramUniform3i;
  tbl.glProgramUniform3iv = error_glProgramUniform3iv;
  tbl.glProgramUniform3ui = error_glProgramUniform3ui;
  tbl.glProgramUniform3uiv = error_glProgramUniform3uiv;
  tbl.glProgramUniform4d = error_glProgramUniform4d;
  tbl.glProgramUniform4dv = error_glProgramUniform4dv;
  tbl.glProgramUniform4f = error_glProgramUniform4f;
  tbl.glProgramUniform4fv = error_glProgramUniform4fv;
  tbl.glProgramUniform4i = error_glProgramUniform4i;
  tbl.glProgramUniform4iv = error_glProgramUniform4iv;
  tbl.glProgramUniform4ui = error_glProgramUniform4ui;
  tbl.glProgramUniform4uiv = error_glProgramUniform4uiv;
  tbl.glProgramUniformMatrix2dv = error_glProgramUniformMatrix2dv;
  tbl.glProgramUniformMatrix2fv = error_glProgramUniformMatrix2fv;
  tbl.glProgramUniformMatrix2x3dv = error_glProgramUniformMatrix2x3dv;
  tbl.glProgramUniformMatrix2x3fv = error_glProgramUniformMatrix2x3fv;
  tbl.glProgramUniformMatrix2x4dv = error_glProgramUniformMatrix2x4dv;
  tbl.glProgramUniformMatrix2x4fv = error_glProgramUniformMatrix2x4fv;
  tbl.glProgramUniformMatrix3dv = error_glProgramUniformMatrix3dv;
  tbl.glProgramUniformMatrix3fv = error_glProgramUniformMatrix3fv;
  tbl.glProgramUniformMatrix3x2dv = error_glProgramUniformMatrix3x2dv;
  tbl.glProgramUniformMatrix3x2fv = error_glProgramUniformMatrix3x2fv;
  tbl.glProgramUniformMatrix3x4dv = error_glProgramUniformMatrix3x4dv;
  tbl.glProgramUniformMatrix3x4fv = error_glProgramUniformMatrix3x4fv;
  tbl.glProgramUniformMatrix4dv = error_glProgramUniformMatrix4dv;
  tbl.glProgramUniformMatrix4fv = error_glProgramUniformMatrix4fv;
  tbl.glProgramUniformMatrix4x2dv = error_glProgramUniformMatrix4x2dv;
  tbl.glProgramUniformMatrix4x2fv = error_glProgramUniformMatrix4x2fv;
  tbl.glProgramUniformMatrix4x3dv = error_glProgramUniformMatrix4x3dv;
  tbl.glProgramUniformMatrix4x3fv = error_glProgramUniformMatrix4x3fv;
  tbl.glUseProgramStages = error_glUseProgramStages;
  tbl.glValidateProgramPipeline = error_glValidateProgramPipeline;

  // GL_ARB_shader_atomic_counters

  tbl.glGetActiveAtomicCounterBufferiv = error_glGetActiveAtomicCounterBufferiv;

  // GL_ARB_shader_image_load_store

  tbl.glBindImageTexture = error_glBindImageTexture;
  tbl.glMemoryBarrier = error_glMemoryBarrier;

  // GL_ARB_shader_objects

  tbl.glAttachObjectARB = error_glAttachObjectARB;
  tbl.glCompileShaderARB = error_glCompileShaderARB;
  tbl.glCreateProgramObjectARB = error_glCreateProgramObjectARB;
  tbl.glCreateShaderObjectARB = error_glCreateShaderObjectARB;
  tbl.glDeleteObjectARB = error_glDeleteObjectARB;
  tbl.glDetachObjectARB = error_glDetachObjectARB;
  tbl.glGetActiveUniformARB = error_glGetActiveUniformARB;
  tbl.glGetAttachedObjectsARB = error_glGetAttachedObjectsARB;
  tbl.glGetHandleARB = error_glGetHandleARB;
  tbl.glGetInfoLogARB = error_glGetInfoLogARB;
  tbl.glGetObjectParameterfvARB = error_glGetObjectParameterfvARB;
  tbl.glGetObjectParameterivARB = error_glGetObjectParameterivARB;
  tbl.glGetShaderSourceARB = error_glGetShaderSourceARB;
  tbl.glGetUniformLocationARB = error_glGetUniformLocationARB;
  tbl.glGetUniformfvARB = error_glGetUniformfvARB;
  tbl.glGetUniformivARB = error_glGetUniformivARB;
  tbl.glLinkProgramARB = error_glLinkProgramARB;
  tbl.glShaderSourceARB = error_glShaderSourceARB;
  tbl.glUniform1fARB = error_glUniform1fARB;
  tbl.glUniform1fvARB = error_glUniform1fvARB;
  tbl.glUniform1iARB = error_glUniform1iARB;
  tbl.glUniform1ivARB = error_glUniform1ivARB;
  tbl.glUniform2fARB = error_glUniform2fARB;
  tbl.glUniform2fvARB = error_glUniform2fvARB;
  tbl.glUniform2iARB = error_glUniform2iARB;
  tbl.glUniform2ivARB = error_glUniform2ivARB;
  tbl.glUniform3fARB = error_glUniform3fARB;
  tbl.glUniform3fvARB = error_glUniform3fvARB;
  tbl.glUniform3iARB = error_glUniform3iARB;
  tbl.glUniform3ivARB = error_glUniform3ivARB;
  tbl.glUniform4fARB = error_glUniform4fARB;
  tbl.glUniform4fvARB = error_glUniform4fvARB;
  tbl.glUniform4iARB = error_glUniform4iARB;
  tbl.glUniform4ivARB = error_glUniform4ivARB;
  tbl.glUniformMatrix2fvARB = error_glUniformMatrix2fvARB;
  tbl.glUniformMatrix3fvARB = error_glUniformMatrix3fvARB;
  tbl.glUniformMatrix4fvARB = error_glUniformMatrix4fvARB;
  tbl.glUseProgramObjectARB = error_glUseProgramObjectARB;
  tbl.glValidateProgramARB = error_glValidateProgramARB;

  // GL_ARB_shader_storage_buffer_object

  tbl.glShaderStorageBlockBinding = error_glShaderStorageBlockBinding;

  // GL_ARB_shader_subroutine

  tbl.glGetActiveSubroutineName = error_glGetActiveSubroutineName;
  tbl.glGetActiveSubroutineUniformName = error_glGetActiveSubroutineUniformName;
  tbl.glGetActiveSubroutineUniformiv = error_glGetActiveSubroutineUniformiv;
  tbl.glGetProgramStageiv = error_glGetProgramStageiv;
  tbl.glGetProgramSubroutineParameteruivNV = error_glGetProgramSubroutineParameteruivNV;
  tbl.glGetSubroutineIndex = error_glGetSubroutineIndex;
  tbl.glGetSubroutineUniformLocation = error_glGetSubroutineUniformLocation;
  tbl.glGetUniformSubroutineuiv = error_glGetUniformSubroutineuiv;
  tbl.glProgramSubroutineParametersuivNV = error_glProgramSubroutineParametersuivNV;
  tbl.glUniformSubroutinesuiv = error_glUniformSubroutinesuiv;

  // GL_ARB_shading_language_include

  tbl.glCompileShaderIncludeARB = error_glCompileShaderIncludeARB;
  tbl.glDeleteNamedStringARB = error_glDeleteNamedStringARB;
  tbl.glGetNamedStringARB = error_glGetNamedStringARB;
  tbl.glGetNamedStringivARB = error_glGetNamedStringivARB;
  tbl.glIsNamedStringARB = error_glIsNamedStringARB;
  tbl.glNamedStringARB = error_glNamedStringARB;

  // GL_ARB_sparse_texture

  tbl.glTexPageCommitmentARB = error_glTexPageCommitmentARB;
  tbl.glTexturePageCommitmentEXT = error_glTexturePageCommitmentEXT;

  // GL_ARB_sync

  tbl.glClientWaitSync = error_glClientWaitSync;
  tbl.glDeleteSync = error_glDeleteSync;
  tbl.glFenceSync = error_glFenceSync;
  tbl.glGetInteger64v = error_glGetInteger64v;
  tbl.glGetSynciv = error_glGetSynciv;
  tbl.glIsSync = error_glIsSync;
  tbl.glWaitSync = error_glWaitSync;

  // GL_ARB_tessellation_shader

  tbl.glPatchParameterfv = error_glPatchParameterfv;
  tbl.glPatchParameteri = error_glPatchParameteri;

  // GL_ARB_texture_buffer_object

  tbl.glTexBufferARB = error_glTexBufferARB;

  // GL_ARB_texture_buffer_range

  tbl.glTexBufferRange = error_glTexBufferRange;
  tbl.glTextureBufferRangeEXT = error_glTextureBufferRangeEXT;

  // GL_ARB_texture_compression

  tbl.glCompressedTexImage1DARB = error_glCompressedTexImage1DARB;
  tbl.glCompressedTexImage2DARB = error_glCompressedTexImage2DARB;
  tbl.glCompressedTexImage3DARB = error_glCompressedTexImage3DARB;
  tbl.glCompressedTexSubImage1DARB = error_glCompressedTexSubImage1DARB;
  tbl.glCompressedTexSubImage2DARB = error_glCompressedTexSubImage2DARB;
  tbl.glCompressedTexSubImage3DARB = error_glCompressedTexSubImage3DARB;
  tbl.glGetCompressedTexImageARB = error_glGetCompressedTexImageARB;

  // GL_ARB_texture_multisample

  tbl.glGetMultisamplefv = error_glGetMultisamplefv;
  tbl.glSampleMaski = error_glSampleMaski;
  tbl.glTexImage2DMultisample = error_glTexImage2DMultisample;
  tbl.glTexImage3DMultisample = error_glTexImage3DMultisample;

  // GL_ARB_texture_storage

  tbl.glTexStorage1D = error_glTexStorage1D;
  tbl.glTexStorage2D = error_glTexStorage2D;
  tbl.glTexStorage3D = error_glTexStorage3D;
  tbl.glTextureStorage1DEXT = error_glTextureStorage1DEXT;
  tbl.glTextureStorage2DEXT = error_glTextureStorage2DEXT;
  tbl.glTextureStorage3DEXT = error_glTextureStorage3DEXT;

  // GL_ARB_texture_storage_multisample

  tbl.glTexStorage2DMultisample = error_glTexStorage2DMultisample;
  tbl.glTexStorage3DMultisample = error_glTexStorage3DMultisample;
  tbl.glTextureStorage2DMultisampleEXT = error_glTextureStorage2DMultisampleEXT;
  tbl.glTextureStorage3DMultisampleEXT = error_glTextureStorage3DMultisampleEXT;

  // GL_ARB_texture_view

  tbl.glTextureView = error_glTextureView;

  // GL_ARB_timer_query

  tbl.glGetQueryObjecti64v = error_glGetQueryObjecti64v;
  tbl.glGetQueryObjectui64v = error_glGetQueryObjectui64v;
  tbl.glQueryCounter = error_glQueryCounter;

  // GL_ARB_transform_feedback2

  tbl.glBindTransformFeedback = error_glBindTransformFeedback;
  tbl.glDeleteTransformFeedbacks = error_glDeleteTransformFeedbacks;
  tbl.glDrawTransformFeedback = error_glDrawTransformFeedback;
  tbl.glGenTransformFeedbacks = error_glGenTransformFeedbacks;
  tbl.glIsTransformFeedback = error_glIsTransformFeedback;
  tbl.glPauseTransformFeedback = error_glPauseTransformFeedback;
  tbl.glResumeTransformFeedback = error_glResumeTransformFeedback;

  // GL_ARB_transform_feedback3

  tbl.glBeginQueryIndexed = error_glBeginQueryIndexed;
  tbl.glDrawTransformFeedbackStream = error_glDrawTransformFeedbackStream;
  tbl.glEndQueryIndexed = error_glEndQueryIndexed;
  tbl.glGetQueryIndexediv = error_glGetQueryIndexediv;

  // GL_ARB_transform_feedback_instanced

  tbl.glDrawTransformFeedbackInstanced = error_glDrawTransformFeedbackInstanced;
  tbl.glDrawTransformFeedbackStreamInstanced = error_glDrawTransformFeedbackStreamInstanced;

  // GL_ARB_transpose_matrix

  tbl.glLoadTransposeMatrixdARB = error_glLoadTransposeMatrixdARB;
  tbl.glLoadTransposeMatrixfARB = error_glLoadTransposeMatrixfARB;
  tbl.glMultTransposeMatrixdARB = error_glMultTransposeMatrixdARB;
  tbl.glMultTransposeMatrixfARB = error_glMultTransposeMatrixfARB;

  // GL_ARB_uniform_buffer_object

  tbl.glBindBufferBase = error_glBindBufferBase;
  tbl.glBindBufferRange = error_glBindBufferRange;
  tbl.glGetActiveUniformBlockName = error_glGetActiveUniformBlockName;
  tbl.glGetActiveUniformBlockiv = error_glGetActiveUniformBlockiv;
  tbl.glGetActiveUniformName = error_glGetActiveUniformName;
  tbl.glGetActiveUniformsiv = error_glGetActiveUniformsiv;
  tbl.glGetIntegeri_v = error_glGetIntegeri_v;
  tbl.glGetUniformBlockIndex = error_glGetUniformBlockIndex;
  tbl.glGetUniformIndices = error_glGetUniformIndices;
  tbl.glUniformBlockBinding = error_glUniformBlockBinding;

  // GL_ARB_vertex_array_object

  tbl.glBindVertexArray = error_glBindVertexArray;
  tbl.glDeleteVertexArrays = error_glDeleteVertexArrays;
  tbl.glGenVertexArrays = error_glGenVertexArrays;
  tbl.glIsVertexArray = error_glIsVertexArray;

  // GL_ARB_vertex_attrib_64bit

  tbl.glGetVertexAttribLdv = error_glGetVertexAttribLdv;
  tbl.glVertexAttribL1d = error_glVertexAttribL1d;
  tbl.glVertexAttribL1dv = error_glVertexAttribL1dv;
  tbl.glVertexAttribL2d = error_glVertexAttribL2d;
  tbl.glVertexAttribL2dv = error_glVertexAttribL2dv;
  tbl.glVertexAttribL3d = error_glVertexAttribL3d;
  tbl.glVertexAttribL3dv = error_glVertexAttribL3dv;
  tbl.glVertexAttribL4d = error_glVertexAttribL4d;
  tbl.glVertexAttribL4dv = error_glVertexAttribL4dv;
  tbl.glVertexAttribLPointer = error_glVertexAttribLPointer;

  // GL_ARB_vertex_attrib_binding

  tbl.glBindVertexBuffer = error_glBindVertexBuffer;
  tbl.glVertexArrayBindVertexBufferEXT = error_glVertexArrayBindVertexBufferEXT;
  tbl.glVertexArrayVertexAttribBindingEXT = error_glVertexArrayVertexAttribBindingEXT;
  tbl.glVertexArrayVertexAttribFormatEXT = error_glVertexArrayVertexAttribFormatEXT;
  tbl.glVertexArrayVertexAttribIFormatEXT = error_glVertexArrayVertexAttribIFormatEXT;
  tbl.glVertexArrayVertexAttribLFormatEXT = error_glVertexArrayVertexAttribLFormatEXT;
  tbl.glVertexArrayVertexBindingDivisorEXT = error_glVertexArrayVertexBindingDivisorEXT;
  tbl.glVertexAttribBinding = error_glVertexAttribBinding;
  tbl.glVertexAttribFormat = error_glVertexAttribFormat;
  tbl.glVertexAttribIFormat = error_glVertexAttribIFormat;
  tbl.glVertexAttribLFormat = error_glVertexAttribLFormat;
  tbl.glVertexBindingDivisor = error_glVertexBindingDivisor;

  // GL_ARB_vertex_blend

  tbl.glVertexBlendARB = error_glVertexBlendARB;
  tbl.glWeightPointerARB = error_glWeightPointerARB;
  tbl.glWeightbvARB = error_glWeightbvARB;
  tbl.glWeightdvARB = error_glWeightdvARB;
  tbl.glWeightfvARB = error_glWeightfvARB;
  tbl.glWeightivARB = error_glWeightivARB;
  tbl.glWeightsvARB = error_glWeightsvARB;
  tbl.glWeightubvARB = error_glWeightubvARB;
  tbl.glWeightuivARB = error_glWeightuivARB;
  tbl.glWeightusvARB = error_glWeightusvARB;

  // GL_ARB_vertex_buffer_object

  tbl.glBindBufferARB = error_glBindBufferARB;
  tbl.glBufferDataARB = error_glBufferDataARB;
  tbl.glBufferSubDataARB = error_glBufferSubDataARB;
  tbl.glDeleteBuffersARB = error_glDeleteBuffersARB;
  tbl.glGenBuffersARB = error_glGenBuffersARB;
  tbl.glGetBufferParameterivARB = error_glGetBufferParameterivARB;
  tbl.glGetBufferPointervARB = error_glGetBufferPointervARB;
  tbl.glGetBufferSubDataARB = error_glGetBufferSubDataARB;
  tbl.glIsBufferARB = error_glIsBufferARB;
  tbl.glMapBufferARB = error_glMapBufferARB;
  tbl.glUnmapBufferARB = error_glUnmapBufferARB;

  // GL_ARB_vertex_program

  tbl.glBindProgramARB = error_glBindProgramARB;
  tbl.glDeleteProgramsARB = error_glDeleteProgramsARB;
  tbl.glDisableVertexAttribArrayARB = error_glDisableVertexAttribArrayARB;
  tbl.glEnableVertexAttribArrayARB = error_glEnableVertexAttribArrayARB;
  tbl.glGenProgramsARB = error_glGenProgramsARB;
  tbl.glGetProgramEnvParameterdvARB = error_glGetProgramEnvParameterdvARB;
  tbl.glGetProgramEnvParameterfvARB = error_glGetProgramEnvParameterfvARB;
  tbl.glGetProgramLocalParameterdvARB = error_glGetProgramLocalParameterdvARB;
  tbl.glGetProgramLocalParameterfvARB = error_glGetProgramLocalParameterfvARB;
  tbl.glGetProgramStringARB = error_glGetProgramStringARB;
  tbl.glGetProgramivARB = error_glGetProgramivARB;
  tbl.glGetVertexAttribPointervARB = error_glGetVertexAttribPointervARB;
  tbl.glGetVertexAttribdvARB = error_glGetVertexAttribdvARB;
  tbl.glGetVertexAttribfvARB = error_glGetVertexAttribfvARB;
  tbl.glGetVertexAttribivARB = error_glGetVertexAttribivARB;
  tbl.glIsProgramARB = error_glIsProgramARB;
  tbl.glProgramEnvParameter4dARB = error_glProgramEnvParameter4dARB;
  tbl.glProgramEnvParameter4dvARB = error_glProgramEnvParameter4dvARB;
  tbl.glProgramEnvParameter4fARB = error_glProgramEnvParameter4fARB;
  tbl.glProgramEnvParameter4fvARB = error_glProgramEnvParameter4fvARB;
  tbl.glProgramLocalParameter4dARB = error_glProgramLocalParameter4dARB;
  tbl.glProgramLocalParameter4dvARB = error_glProgramLocalParameter4dvARB;
  tbl.glProgramLocalParameter4fARB = error_glProgramLocalParameter4fARB;
  tbl.glProgramLocalParameter4fvARB = error_glProgramLocalParameter4fvARB;
  tbl.glProgramStringARB = error_glProgramStringARB;
  tbl.glVertexAttrib1dARB = error_glVertexAttrib1dARB;
  tbl.glVertexAttrib1dvARB = error_glVertexAttrib1dvARB;
  tbl.glVertexAttrib1fARB = error_glVertexAttrib1fARB;
  tbl.glVertexAttrib1fvARB = error_glVertexAttrib1fvARB;
  tbl.glVertexAttrib1sARB = error_glVertexAttrib1sARB;
  tbl.glVertexAttrib1svARB = error_glVertexAttrib1svARB;
  tbl.glVertexAttrib2dARB = error_glVertexAttrib2dARB;
  tbl.glVertexAttrib2dvARB = error_glVertexAttrib2dvARB;
  tbl.glVertexAttrib2fARB = error_glVertexAttrib2fARB;
  tbl.glVertexAttrib2fvARB = error_glVertexAttrib2fvARB;
  tbl.glVertexAttrib2sARB = error_glVertexAttrib2sARB;
  tbl.glVertexAttrib2svARB = error_glVertexAttrib2svARB;
  tbl.glVertexAttrib3dARB = error_glVertexAttrib3dARB;
  tbl.glVertexAttrib3dvARB = error_glVertexAttrib3dvARB;
  tbl.glVertexAttrib3fARB = error_glVertexAttrib3fARB;
  tbl.glVertexAttrib3fvARB = error_glVertexAttrib3fvARB;
  tbl.glVertexAttrib3sARB = error_glVertexAttrib3sARB;
  tbl.glVertexAttrib3svARB = error_glVertexAttrib3svARB;
  tbl.glVertexAttrib4NbvARB = error_glVertexAttrib4NbvARB;
  tbl.glVertexAttrib4NivARB = error_glVertexAttrib4NivARB;
  tbl.glVertexAttrib4NsvARB = error_glVertexAttrib4NsvARB;
  tbl.glVertexAttrib4NubARB = error_glVertexAttrib4NubARB;
  tbl.glVertexAttrib4NubvARB = error_glVertexAttrib4NubvARB;
  tbl.glVertexAttrib4NuivARB = error_glVertexAttrib4NuivARB;
  tbl.glVertexAttrib4NusvARB = error_glVertexAttrib4NusvARB;
  tbl.glVertexAttrib4bvARB = error_glVertexAttrib4bvARB;
  tbl.glVertexAttrib4dARB = error_glVertexAttrib4dARB;
  tbl.glVertexAttrib4dvARB = error_glVertexAttrib4dvARB;
  tbl.glVertexAttrib4fARB = error_glVertexAttrib4fARB;
  tbl.glVertexAttrib4fvARB = error_glVertexAttrib4fvARB;
  tbl.glVertexAttrib4ivARB = error_glVertexAttrib4ivARB;
  tbl.glVertexAttrib4sARB = error_glVertexAttrib4sARB;
  tbl.glVertexAttrib4svARB = error_glVertexAttrib4svARB;
  tbl.glVertexAttrib4ubvARB = error_glVertexAttrib4ubvARB;
  tbl.glVertexAttrib4uivARB = error_glVertexAttrib4uivARB;
  tbl.glVertexAttrib4usvARB = error_glVertexAttrib4usvARB;
  tbl.glVertexAttribPointerARB = error_glVertexAttribPointerARB;

  // GL_ARB_vertex_shader

  tbl.glBindAttribLocationARB = error_glBindAttribLocationARB;
  tbl.glGetActiveAttribARB = error_glGetActiveAttribARB;
  tbl.glGetAttribLocationARB = error_glGetAttribLocationARB;

  // GL_ARB_vertex_type_2_10_10_10_rev

  tbl.glColorP3ui = error_glColorP3ui;
  tbl.glColorP3uiv = error_glColorP3uiv;
  tbl.glColorP4ui = error_glColorP4ui;
  tbl.glColorP4uiv = error_glColorP4uiv;
  tbl.glMultiTexCoordP1ui = error_glMultiTexCoordP1ui;
  tbl.glMultiTexCoordP1uiv = error_glMultiTexCoordP1uiv;
  tbl.glMultiTexCoordP2ui = error_glMultiTexCoordP2ui;
  tbl.glMultiTexCoordP2uiv = error_glMultiTexCoordP2uiv;
  tbl.glMultiTexCoordP3ui = error_glMultiTexCoordP3ui;
  tbl.glMultiTexCoordP3uiv = error_glMultiTexCoordP3uiv;
  tbl.glMultiTexCoordP4ui = error_glMultiTexCoordP4ui;
  tbl.glMultiTexCoordP4uiv = error_glMultiTexCoordP4uiv;
  tbl.glNormalP3ui = error_glNormalP3ui;
  tbl.glNormalP3uiv = error_glNormalP3uiv;
  tbl.glSecondaryColorP3ui = error_glSecondaryColorP3ui;
  tbl.glSecondaryColorP3uiv = error_glSecondaryColorP3uiv;
  tbl.glTexCoordP1ui = error_glTexCoordP1ui;
  tbl.glTexCoordP1uiv = error_glTexCoordP1uiv;
  tbl.glTexCoordP2ui = error_glTexCoordP2ui;
  tbl.glTexCoordP2uiv = error_glTexCoordP2uiv;
  tbl.glTexCoordP3ui = error_glTexCoordP3ui;
  tbl.glTexCoordP3uiv = error_glTexCoordP3uiv;
  tbl.glTexCoordP4ui = error_glTexCoordP4ui;
  tbl.glTexCoordP4uiv = error_glTexCoordP4uiv;
  tbl.glVertexAttribP1ui = error_glVertexAttribP1ui;
  tbl.glVertexAttribP1uiv = error_glVertexAttribP1uiv;
  tbl.glVertexAttribP2ui = error_glVertexAttribP2ui;
  tbl.glVertexAttribP2uiv = error_glVertexAttribP2uiv;
  tbl.glVertexAttribP3ui = error_glVertexAttribP3ui;
  tbl.glVertexAttribP3uiv = error_glVertexAttribP3uiv;
  tbl.glVertexAttribP4ui = error_glVertexAttribP4ui;
  tbl.glVertexAttribP4uiv = error_glVertexAttribP4uiv;
  tbl.glVertexP2ui = error_glVertexP2ui;
  tbl.glVertexP2uiv = error_glVertexP2uiv;
  tbl.glVertexP3ui = error_glVertexP3ui;
  tbl.glVertexP3uiv = error_glVertexP3uiv;
  tbl.glVertexP4ui = error_glVertexP4ui;
  tbl.glVertexP4uiv = error_glVertexP4uiv;

  // GL_ARB_viewport_array

  tbl.glDepthRangeArrayv = error_glDepthRangeArrayv;
  tbl.glDepthRangeIndexed = error_glDepthRangeIndexed;
  tbl.glGetDoublei_v = error_glGetDoublei_v;
  tbl.glGetFloati_v = error_glGetFloati_v;
  tbl.glScissorArrayv = error_glScissorArrayv;
  tbl.glScissorIndexed = error_glScissorIndexed;
  tbl.glScissorIndexedv = error_glScissorIndexedv;
  tbl.glViewportArrayv = error_glViewportArrayv;
  tbl.glViewportIndexedf = error_glViewportIndexedf;
  tbl.glViewportIndexedfv = error_glViewportIndexedfv;

  // GL_ARB_window_pos

  tbl.glWindowPos2dARB = error_glWindowPos2dARB;
  tbl.glWindowPos2dvARB = error_glWindowPos2dvARB;
  tbl.glWindowPos2fARB = error_glWindowPos2fARB;
  tbl.glWindowPos2fvARB = error_glWindowPos2fvARB;
  tbl.glWindowPos2iARB = error_glWindowPos2iARB;
  tbl.glWindowPos2ivARB = error_glWindowPos2ivARB;
  tbl.glWindowPos2sARB = error_glWindowPos2sARB;
  tbl.glWindowPos2svARB = error_glWindowPos2svARB;
  tbl.glWindowPos3dARB = error_glWindowPos3dARB;
  tbl.glWindowPos3dvARB = error_glWindowPos3dvARB;
  tbl.glWindowPos3fARB = error_glWindowPos3fARB;
  tbl.glWindowPos3fvARB = error_glWindowPos3fvARB;
  tbl.glWindowPos3iARB = error_glWindowPos3iARB;
  tbl.glWindowPos3ivARB = error_glWindowPos3ivARB;
  tbl.glWindowPos3sARB = error_glWindowPos3sARB;
  tbl.glWindowPos3svARB = error_glWindowPos3svARB;

  // GL_ATI_draw_buffers

  tbl.glDrawBuffersATI = error_glDrawBuffersATI;

  // GL_ATI_element_array

  tbl.glDrawElementArrayATI = error_glDrawElementArrayATI;
  tbl.glDrawRangeElementArrayATI = error_glDrawRangeElementArrayATI;
  tbl.glElementPointerATI = error_glElementPointerATI;

  // GL_ATI_envmap_bumpmap

  tbl.glGetTexBumpParameterfvATI = error_glGetTexBumpParameterfvATI;
  tbl.glGetTexBumpParameterivATI = error_glGetTexBumpParameterivATI;
  tbl.glTexBumpParameterfvATI = error_glTexBumpParameterfvATI;
  tbl.glTexBumpParameterivATI = error_glTexBumpParameterivATI;

  // GL_ATI_fragment_shader

  tbl.glAlphaFragmentOp1ATI = error_glAlphaFragmentOp1ATI;
  tbl.glAlphaFragmentOp2ATI = error_glAlphaFragmentOp2ATI;
  tbl.glAlphaFragmentOp3ATI = error_glAlphaFragmentOp3ATI;
  tbl.glBeginFragmentShaderATI = error_glBeginFragmentShaderATI;
  tbl.glBindFragmentShaderATI = error_glBindFragmentShaderATI;
  tbl.glColorFragmentOp1ATI = error_glColorFragmentOp1ATI;
  tbl.glColorFragmentOp2ATI = error_glColorFragmentOp2ATI;
  tbl.glColorFragmentOp3ATI = error_glColorFragmentOp3ATI;
  tbl.glDeleteFragmentShaderATI = error_glDeleteFragmentShaderATI;
  tbl.glEndFragmentShaderATI = error_glEndFragmentShaderATI;
  tbl.glGenFragmentShadersATI = error_glGenFragmentShadersATI;
  tbl.glPassTexCoordATI = error_glPassTexCoordATI;
  tbl.glSampleMapATI = error_glSampleMapATI;
  tbl.glSetFragmentShaderConstantATI = error_glSetFragmentShaderConstantATI;

  // GL_ATI_map_object_buffer

  tbl.glMapObjectBufferATI = error_glMapObjectBufferATI;
  tbl.glUnmapObjectBufferATI = error_glUnmapObjectBufferATI;

  // GL_ATI_pn_triangles

  tbl.glPNTrianglesfATI = error_glPNTrianglesfATI;
  tbl.glPNTrianglesiATI = error_glPNTrianglesiATI;

  // GL_ATI_separate_stencil

  tbl.glStencilFuncSeparateATI = error_glStencilFuncSeparateATI;
  tbl.glStencilOpSeparateATI = error_glStencilOpSeparateATI;

  // GL_ATI_vertex_array_object

  tbl.glArrayObjectATI = error_glArrayObjectATI;
  tbl.glFreeObjectBufferATI = error_glFreeObjectBufferATI;
  tbl.glGetArrayObjectfvATI = error_glGetArrayObjectfvATI;
  tbl.glGetArrayObjectivATI = error_glGetArrayObjectivATI;
  tbl.glGetObjectBufferfvATI = error_glGetObjectBufferfvATI;
  tbl.glGetObjectBufferivATI = error_glGetObjectBufferivATI;
  tbl.glGetVariantArrayObjectfvATI = error_glGetVariantArrayObjectfvATI;
  tbl.glGetVariantArrayObjectivATI = error_glGetVariantArrayObjectivATI;
  tbl.glIsObjectBufferATI = error_glIsObjectBufferATI;
  tbl.glNewObjectBufferATI = error_glNewObjectBufferATI;
  tbl.glUpdateObjectBufferATI = error_glUpdateObjectBufferATI;
  tbl.glVariantArrayObjectATI = error_glVariantArrayObjectATI;

  // GL_ATI_vertex_attrib_array_object

  tbl.glGetVertexAttribArrayObjectfvATI = error_glGetVertexAttribArrayObjectfvATI;
  tbl.glGetVertexAttribArrayObjectivATI = error_glGetVertexAttribArrayObjectivATI;
  tbl.glVertexAttribArrayObjectATI = error_glVertexAttribArrayObjectATI;

  // GL_ATI_vertex_streams

  tbl.glClientActiveVertexStreamATI = error_glClientActiveVertexStreamATI;
  tbl.glNormalStream3bATI = error_glNormalStream3bATI;
  tbl.glNormalStream3bvATI = error_glNormalStream3bvATI;
  tbl.glNormalStream3dATI = error_glNormalStream3dATI;
  tbl.glNormalStream3dvATI = error_glNormalStream3dvATI;
  tbl.glNormalStream3fATI = error_glNormalStream3fATI;
  tbl.glNormalStream3fvATI = error_glNormalStream3fvATI;
  tbl.glNormalStream3iATI = error_glNormalStream3iATI;
  tbl.glNormalStream3ivATI = error_glNormalStream3ivATI;
  tbl.glNormalStream3sATI = error_glNormalStream3sATI;
  tbl.glNormalStream3svATI = error_glNormalStream3svATI;
  tbl.glVertexBlendEnvfATI = error_glVertexBlendEnvfATI;
  tbl.glVertexBlendEnviATI = error_glVertexBlendEnviATI;
  tbl.glVertexStream1dATI = error_glVertexStream1dATI;
  tbl.glVertexStream1dvATI = error_glVertexStream1dvATI;
  tbl.glVertexStream1fATI = error_glVertexStream1fATI;
  tbl.glVertexStream1fvATI = error_glVertexStream1fvATI;
  tbl.glVertexStream1iATI = error_glVertexStream1iATI;
  tbl.glVertexStream1ivATI = error_glVertexStream1ivATI;
  tbl.glVertexStream1sATI = error_glVertexStream1sATI;
  tbl.glVertexStream1svATI = error_glVertexStream1svATI;
  tbl.glVertexStream2dATI = error_glVertexStream2dATI;
  tbl.glVertexStream2dvATI = error_glVertexStream2dvATI;
  tbl.glVertexStream2fATI = error_glVertexStream2fATI;
  tbl.glVertexStream2fvATI = error_glVertexStream2fvATI;
  tbl.glVertexStream2iATI = error_glVertexStream2iATI;
  tbl.glVertexStream2ivATI = error_glVertexStream2ivATI;
  tbl.glVertexStream2sATI = error_glVertexStream2sATI;
  tbl.glVertexStream2svATI = error_glVertexStream2svATI;
  tbl.glVertexStream3dATI = error_glVertexStream3dATI;
  tbl.glVertexStream3dvATI = error_glVertexStream3dvATI;
  tbl.glVertexStream3fATI = error_glVertexStream3fATI;
  tbl.glVertexStream3fvATI = error_glVertexStream3fvATI;
  tbl.glVertexStream3iATI = error_glVertexStream3iATI;
  tbl.glVertexStream3ivATI = error_glVertexStream3ivATI;
  tbl.glVertexStream3sATI = error_glVertexStream3sATI;
  tbl.glVertexStream3svATI = error_glVertexStream3svATI;
  tbl.glVertexStream4dATI = error_glVertexStream4dATI;
  tbl.glVertexStream4dvATI = error_glVertexStream4dvATI;
  tbl.glVertexStream4fATI = error_glVertexStream4fATI;
  tbl.glVertexStream4fvATI = error_glVertexStream4fvATI;
  tbl.glVertexStream4iATI = error_glVertexStream4iATI;
  tbl.glVertexStream4ivATI = error_glVertexStream4ivATI;
  tbl.glVertexStream4sATI = error_glVertexStream4sATI;
  tbl.glVertexStream4svATI = error_glVertexStream4svATI;

  // GL_EXT_bindable_uniform

  tbl.glGetUniformBufferSizeEXT = error_glGetUniformBufferSizeEXT;
  tbl.glGetUniformOffsetEXT = error_glGetUniformOffsetEXT;
  tbl.glUniformBufferEXT = error_glUniformBufferEXT;

  // GL_EXT_blend_color

  tbl.glBlendColorEXT = error_glBlendColorEXT;

  // GL_EXT_blend_equation_separate

  tbl.glBlendEquationSeparateEXT = error_glBlendEquationSeparateEXT;

  // GL_EXT_blend_func_separate

  tbl.glBlendFuncSeparateEXT = error_glBlendFuncSeparateEXT;

  // GL_EXT_blend_minmax

  tbl.glBlendEquationEXT = error_glBlendEquationEXT;

  // GL_EXT_color_subtable

  tbl.glColorSubTableEXT = error_glColorSubTableEXT;
  tbl.glCopyColorSubTableEXT = error_glCopyColorSubTableEXT;

  // GL_EXT_compiled_vertex_array

  tbl.glLockArraysEXT = error_glLockArraysEXT;
  tbl.glUnlockArraysEXT = error_glUnlockArraysEXT;

  // GL_EXT_convolution

  tbl.glConvolutionFilter1DEXT = error_glConvolutionFilter1DEXT;
  tbl.glConvolutionFilter2DEXT = error_glConvolutionFilter2DEXT;
  tbl.glConvolutionParameterfEXT = error_glConvolutionParameterfEXT;
  tbl.glConvolutionParameterfvEXT = error_glConvolutionParameterfvEXT;
  tbl.glConvolutionParameteriEXT = error_glConvolutionParameteriEXT;
  tbl.glConvolutionParameterivEXT = error_glConvolutionParameterivEXT;
  tbl.glCopyConvolutionFilter1DEXT = error_glCopyConvolutionFilter1DEXT;
  tbl.glCopyConvolutionFilter2DEXT = error_glCopyConvolutionFilter2DEXT;
  tbl.glGetConvolutionFilterEXT = error_glGetConvolutionFilterEXT;
  tbl.glGetConvolutionParameterfvEXT = error_glGetConvolutionParameterfvEXT;
  tbl.glGetConvolutionParameterivEXT = error_glGetConvolutionParameterivEXT;
  tbl.glGetSeparableFilterEXT = error_glGetSeparableFilterEXT;
  tbl.glSeparableFilter2DEXT = error_glSeparableFilter2DEXT;

  // GL_EXT_coordinate_frame

  tbl.glBinormal3bEXT = error_glBinormal3bEXT;
  tbl.glBinormal3bvEXT = error_glBinormal3bvEXT;
  tbl.glBinormal3dEXT = error_glBinormal3dEXT;
  tbl.glBinormal3dvEXT = error_glBinormal3dvEXT;
  tbl.glBinormal3fEXT = error_glBinormal3fEXT;
  tbl.glBinormal3fvEXT = error_glBinormal3fvEXT;
  tbl.glBinormal3iEXT = error_glBinormal3iEXT;
  tbl.glBinormal3ivEXT = error_glBinormal3ivEXT;
  tbl.glBinormal3sEXT = error_glBinormal3sEXT;
  tbl.glBinormal3svEXT = error_glBinormal3svEXT;
  tbl.glBinormalPointerEXT = error_glBinormalPointerEXT;
  tbl.glTangent3bEXT = error_glTangent3bEXT;
  tbl.glTangent3bvEXT = error_glTangent3bvEXT;
  tbl.glTangent3dEXT = error_glTangent3dEXT;
  tbl.glTangent3dvEXT = error_glTangent3dvEXT;
  tbl.glTangent3fEXT = error_glTangent3fEXT;
  tbl.glTangent3fvEXT = error_glTangent3fvEXT;
  tbl.glTangent3iEXT = error_glTangent3iEXT;
  tbl.glTangent3ivEXT = error_glTangent3ivEXT;
  tbl.glTangent3sEXT = error_glTangent3sEXT;
  tbl.glTangent3svEXT = error_glTangent3svEXT;
  tbl.glTangentPointerEXT = error_glTangentPointerEXT;

  // GL_EXT_copy_texture

  tbl.glCopyTexImage1DEXT = error_glCopyTexImage1DEXT;
  tbl.glCopyTexImage2DEXT = error_glCopyTexImage2DEXT;
  tbl.glCopyTexSubImage1DEXT = error_glCopyTexSubImage1DEXT;
  tbl.glCopyTexSubImage2DEXT = error_glCopyTexSubImage2DEXT;
  tbl.glCopyTexSubImage3DEXT = error_glCopyTexSubImage3DEXT;

  // GL_EXT_cull_vertex

  tbl.glCullParameterdvEXT = error_glCullParameterdvEXT;
  tbl.glCullParameterfvEXT = error_glCullParameterfvEXT;

  // GL_EXT_debug_label

  tbl.glGetObjectLabelEXT = error_glGetObjectLabelEXT;
  tbl.glLabelObjectEXT = error_glLabelObjectEXT;

  // GL_EXT_debug_marker

  tbl.glInsertEventMarkerEXT = error_glInsertEventMarkerEXT;
  tbl.glPopGroupMarkerEXT = error_glPopGroupMarkerEXT;
  tbl.glPushGroupMarkerEXT = error_glPushGroupMarkerEXT;

  // GL_EXT_depth_bounds_test

  tbl.glDepthBoundsEXT = error_glDepthBoundsEXT;

  // GL_EXT_direct_state_access

  tbl.glBindMultiTextureEXT = error_glBindMultiTextureEXT;
  tbl.glCheckNamedFramebufferStatusEXT = error_glCheckNamedFramebufferStatusEXT;
  tbl.glClientAttribDefaultEXT = error_glClientAttribDefaultEXT;
  tbl.glCompressedMultiTexImage1DEXT = error_glCompressedMultiTexImage1DEXT;
  tbl.glCompressedMultiTexImage2DEXT = error_glCompressedMultiTexImage2DEXT;
  tbl.glCompressedMultiTexImage3DEXT = error_glCompressedMultiTexImage3DEXT;
  tbl.glCompressedMultiTexSubImage1DEXT = error_glCompressedMultiTexSubImage1DEXT;
  tbl.glCompressedMultiTexSubImage2DEXT = error_glCompressedMultiTexSubImage2DEXT;
  tbl.glCompressedMultiTexSubImage3DEXT = error_glCompressedMultiTexSubImage3DEXT;
  tbl.glCompressedTextureImage1DEXT = error_glCompressedTextureImage1DEXT;
  tbl.glCompressedTextureImage2DEXT = error_glCompressedTextureImage2DEXT;
  tbl.glCompressedTextureImage3DEXT = error_glCompressedTextureImage3DEXT;
  tbl.glCompressedTextureSubImage1DEXT = error_glCompressedTextureSubImage1DEXT;
  tbl.glCompressedTextureSubImage2DEXT = error_glCompressedTextureSubImage2DEXT;
  tbl.glCompressedTextureSubImage3DEXT = error_glCompressedTextureSubImage3DEXT;
  tbl.glCopyMultiTexImage1DEXT = error_glCopyMultiTexImage1DEXT;
  tbl.glCopyMultiTexImage2DEXT = error_glCopyMultiTexImage2DEXT;
  tbl.glCopyMultiTexSubImage1DEXT = error_glCopyMultiTexSubImage1DEXT;
  tbl.glCopyMultiTexSubImage2DEXT = error_glCopyMultiTexSubImage2DEXT;
  tbl.glCopyMultiTexSubImage3DEXT = error_glCopyMultiTexSubImage3DEXT;
  tbl.glCopyTextureImage1DEXT = error_glCopyTextureImage1DEXT;
  tbl.glCopyTextureImage2DEXT = error_glCopyTextureImage2DEXT;
  tbl.glCopyTextureSubImage1DEXT = error_glCopyTextureSubImage1DEXT;
  tbl.glCopyTextureSubImage2DEXT = error_glCopyTextureSubImage2DEXT;
  tbl.glCopyTextureSubImage3DEXT = error_glCopyTextureSubImage3DEXT;
  tbl.glDisableClientStateIndexedEXT = error_glDisableClientStateIndexedEXT;
  tbl.glDisableClientStateiEXT = error_glDisableClientStateiEXT;
  tbl.glDisableVertexArrayAttribEXT = error_glDisableVertexArrayAttribEXT;
  tbl.glDisableVertexArrayEXT = error_glDisableVertexArrayEXT;
  tbl.glEnableClientStateIndexedEXT = error_glEnableClientStateIndexedEXT;
  tbl.glEnableClientStateiEXT = error_glEnableClientStateiEXT;
  tbl.glEnableVertexArrayAttribEXT = error_glEnableVertexArrayAttribEXT;
  tbl.glEnableVertexArrayEXT = error_glEnableVertexArrayEXT;
  tbl.glFlushMappedNamedBufferRangeEXT = error_glFlushMappedNamedBufferRangeEXT;
  tbl.glFramebufferDrawBufferEXT = error_glFramebufferDrawBufferEXT;
  tbl.glFramebufferDrawBuffersEXT = error_glFramebufferDrawBuffersEXT;
  tbl.glFramebufferReadBufferEXT = error_glFramebufferReadBufferEXT;
  tbl.glGenerateMultiTexMipmapEXT = error_glGenerateMultiTexMipmapEXT;
  tbl.glGenerateTextureMipmapEXT = error_glGenerateTextureMipmapEXT;
  tbl.glGetCompressedMultiTexImageEXT = error_glGetCompressedMultiTexImageEXT;
  tbl.glGetCompressedTextureImageEXT = error_glGetCompressedTextureImageEXT;
  tbl.glGetDoubleIndexedvEXT = error_glGetDoubleIndexedvEXT;
  tbl.glGetDoublei_vEXT = error_glGetDoublei_vEXT;
  tbl.glGetFloatIndexedvEXT = error_glGetFloatIndexedvEXT;
  tbl.glGetFloati_vEXT = error_glGetFloati_vEXT;
  tbl.glGetFramebufferParameterivEXT = error_glGetFramebufferParameterivEXT;
  tbl.glGetMultiTexEnvfvEXT = error_glGetMultiTexEnvfvEXT;
  tbl.glGetMultiTexEnvivEXT = error_glGetMultiTexEnvivEXT;
  tbl.glGetMultiTexGendvEXT = error_glGetMultiTexGendvEXT;
  tbl.glGetMultiTexGenfvEXT = error_glGetMultiTexGenfvEXT;
  tbl.glGetMultiTexGenivEXT = error_glGetMultiTexGenivEXT;
  tbl.glGetMultiTexImageEXT = error_glGetMultiTexImageEXT;
  tbl.glGetMultiTexLevelParameterfvEXT = error_glGetMultiTexLevelParameterfvEXT;
  tbl.glGetMultiTexLevelParameterivEXT = error_glGetMultiTexLevelParameterivEXT;
  tbl.glGetMultiTexParameterIivEXT = error_glGetMultiTexParameterIivEXT;
  tbl.glGetMultiTexParameterIuivEXT = error_glGetMultiTexParameterIuivEXT;
  tbl.glGetMultiTexParameterfvEXT = error_glGetMultiTexParameterfvEXT;
  tbl.glGetMultiTexParameterivEXT = error_glGetMultiTexParameterivEXT;
  tbl.glGetNamedBufferParameterivEXT = error_glGetNamedBufferParameterivEXT;
  tbl.glGetNamedBufferPointervEXT = error_glGetNamedBufferPointervEXT;
  tbl.glGetNamedBufferSubDataEXT = error_glGetNamedBufferSubDataEXT;
  tbl.glGetNamedFramebufferAttachmentParameterivEXT = error_glGetNamedFramebufferAttachmentParameterivEXT;
  tbl.glGetNamedProgramLocalParameterIivEXT = error_glGetNamedProgramLocalParameterIivEXT;
  tbl.glGetNamedProgramLocalParameterIuivEXT = error_glGetNamedProgramLocalParameterIuivEXT;
  tbl.glGetNamedProgramLocalParameterdvEXT = error_glGetNamedProgramLocalParameterdvEXT;
  tbl.glGetNamedProgramLocalParameterfvEXT = error_glGetNamedProgramLocalParameterfvEXT;
  tbl.glGetNamedProgramStringEXT = error_glGetNamedProgramStringEXT;
  tbl.glGetNamedProgramivEXT = error_glGetNamedProgramivEXT;
  tbl.glGetNamedRenderbufferParameterivEXT = error_glGetNamedRenderbufferParameterivEXT;
  tbl.glGetPointerIndexedvEXT = error_glGetPointerIndexedvEXT;
  tbl.glGetPointeri_vEXT = error_glGetPointeri_vEXT;
  tbl.glGetTextureImageEXT = error_glGetTextureImageEXT;
  tbl.glGetTextureLevelParameterfvEXT = error_glGetTextureLevelParameterfvEXT;
  tbl.glGetTextureLevelParameterivEXT = error_glGetTextureLevelParameterivEXT;
  tbl.glGetTextureParameterIivEXT = error_glGetTextureParameterIivEXT;
  tbl.glGetTextureParameterIuivEXT = error_glGetTextureParameterIuivEXT;
  tbl.glGetTextureParameterfvEXT = error_glGetTextureParameterfvEXT;
  tbl.glGetTextureParameterivEXT = error_glGetTextureParameterivEXT;
  tbl.glGetVertexArrayIntegeri_vEXT = error_glGetVertexArrayIntegeri_vEXT;
  tbl.glGetVertexArrayIntegervEXT = error_glGetVertexArrayIntegervEXT;
  tbl.glGetVertexArrayPointeri_vEXT = error_glGetVertexArrayPointeri_vEXT;
  tbl.glGetVertexArrayPointervEXT = error_glGetVertexArrayPointervEXT;
  tbl.glMapNamedBufferEXT = error_glMapNamedBufferEXT;
  tbl.glMapNamedBufferRangeEXT = error_glMapNamedBufferRangeEXT;
  tbl.glMatrixFrustumEXT = error_glMatrixFrustumEXT;
  tbl.glMatrixLoadIdentityEXT = error_glMatrixLoadIdentityEXT;
  tbl.glMatrixLoadTransposedEXT = error_glMatrixLoadTransposedEXT;
  tbl.glMatrixLoadTransposefEXT = error_glMatrixLoadTransposefEXT;
  tbl.glMatrixLoaddEXT = error_glMatrixLoaddEXT;
  tbl.glMatrixLoadfEXT = error_glMatrixLoadfEXT;
  tbl.glMatrixMultTransposedEXT = error_glMatrixMultTransposedEXT;
  tbl.glMatrixMultTransposefEXT = error_glMatrixMultTransposefEXT;
  tbl.glMatrixMultdEXT = error_glMatrixMultdEXT;
  tbl.glMatrixMultfEXT = error_glMatrixMultfEXT;
  tbl.glMatrixOrthoEXT = error_glMatrixOrthoEXT;
  tbl.glMatrixPopEXT = error_glMatrixPopEXT;
  tbl.glMatrixPushEXT = error_glMatrixPushEXT;
  tbl.glMatrixRotatedEXT = error_glMatrixRotatedEXT;
  tbl.glMatrixRotatefEXT = error_glMatrixRotatefEXT;
  tbl.glMatrixScaledEXT = error_glMatrixScaledEXT;
  tbl.glMatrixScalefEXT = error_glMatrixScalefEXT;
  tbl.glMatrixTranslatedEXT = error_glMatrixTranslatedEXT;
  tbl.glMatrixTranslatefEXT = error_glMatrixTranslatefEXT;
  tbl.glMultiTexBufferEXT = error_glMultiTexBufferEXT;
  tbl.glMultiTexCoordPointerEXT = error_glMultiTexCoordPointerEXT;
  tbl.glMultiTexEnvfEXT = error_glMultiTexEnvfEXT;
  tbl.glMultiTexEnvfvEXT = error_glMultiTexEnvfvEXT;
  tbl.glMultiTexEnviEXT = error_glMultiTexEnviEXT;
  tbl.glMultiTexEnvivEXT = error_glMultiTexEnvivEXT;
  tbl.glMultiTexGendEXT = error_glMultiTexGendEXT;
  tbl.glMultiTexGendvEXT = error_glMultiTexGendvEXT;
  tbl.glMultiTexGenfEXT = error_glMultiTexGenfEXT;
  tbl.glMultiTexGenfvEXT = error_glMultiTexGenfvEXT;
  tbl.glMultiTexGeniEXT = error_glMultiTexGeniEXT;
  tbl.glMultiTexGenivEXT = error_glMultiTexGenivEXT;
  tbl.glMultiTexImage1DEXT = error_glMultiTexImage1DEXT;
  tbl.glMultiTexImage2DEXT = error_glMultiTexImage2DEXT;
  tbl.glMultiTexImage3DEXT = error_glMultiTexImage3DEXT;
  tbl.glMultiTexParameterIivEXT = error_glMultiTexParameterIivEXT;
  tbl.glMultiTexParameterIuivEXT = error_glMultiTexParameterIuivEXT;
  tbl.glMultiTexParameterfEXT = error_glMultiTexParameterfEXT;
  tbl.glMultiTexParameterfvEXT = error_glMultiTexParameterfvEXT;
  tbl.glMultiTexParameteriEXT = error_glMultiTexParameteriEXT;
  tbl.glMultiTexParameterivEXT = error_glMultiTexParameterivEXT;
  tbl.glMultiTexRenderbufferEXT = error_glMultiTexRenderbufferEXT;
  tbl.glMultiTexSubImage1DEXT = error_glMultiTexSubImage1DEXT;
  tbl.glMultiTexSubImage2DEXT = error_glMultiTexSubImage2DEXT;
  tbl.glMultiTexSubImage3DEXT = error_glMultiTexSubImage3DEXT;
  tbl.glNamedBufferDataEXT = error_glNamedBufferDataEXT;
  tbl.glNamedBufferSubDataEXT = error_glNamedBufferSubDataEXT;
  tbl.glNamedCopyBufferSubDataEXT = error_glNamedCopyBufferSubDataEXT;
  tbl.glNamedFramebufferRenderbufferEXT = error_glNamedFramebufferRenderbufferEXT;
  tbl.glNamedFramebufferTexture1DEXT = error_glNamedFramebufferTexture1DEXT;
  tbl.glNamedFramebufferTexture2DEXT = error_glNamedFramebufferTexture2DEXT;
  tbl.glNamedFramebufferTexture3DEXT = error_glNamedFramebufferTexture3DEXT;
  tbl.glNamedFramebufferTextureEXT = error_glNamedFramebufferTextureEXT;
  tbl.glNamedFramebufferTextureFaceEXT = error_glNamedFramebufferTextureFaceEXT;
  tbl.glNamedFramebufferTextureLayerEXT = error_glNamedFramebufferTextureLayerEXT;
  tbl.glNamedProgramLocalParameter4dEXT = error_glNamedProgramLocalParameter4dEXT;
  tbl.glNamedProgramLocalParameter4dvEXT = error_glNamedProgramLocalParameter4dvEXT;
  tbl.glNamedProgramLocalParameter4fEXT = error_glNamedProgramLocalParameter4fEXT;
  tbl.glNamedProgramLocalParameter4fvEXT = error_glNamedProgramLocalParameter4fvEXT;
  tbl.glNamedProgramLocalParameterI4iEXT = error_glNamedProgramLocalParameterI4iEXT;
  tbl.glNamedProgramLocalParameterI4ivEXT = error_glNamedProgramLocalParameterI4ivEXT;
  tbl.glNamedProgramLocalParameterI4uiEXT = error_glNamedProgramLocalParameterI4uiEXT;
  tbl.glNamedProgramLocalParameterI4uivEXT = error_glNamedProgramLocalParameterI4uivEXT;
  tbl.glNamedProgramLocalParameters4fvEXT = error_glNamedProgramLocalParameters4fvEXT;
  tbl.glNamedProgramLocalParametersI4ivEXT = error_glNamedProgramLocalParametersI4ivEXT;
  tbl.glNamedProgramLocalParametersI4uivEXT = error_glNamedProgramLocalParametersI4uivEXT;
  tbl.glNamedProgramStringEXT = error_glNamedProgramStringEXT;
  tbl.glNamedRenderbufferStorageEXT = error_glNamedRenderbufferStorageEXT;
  tbl.glNamedRenderbufferStorageMultisampleCoverageEXT = error_glNamedRenderbufferStorageMultisampleCoverageEXT;
  tbl.glNamedRenderbufferStorageMultisampleEXT = error_glNamedRenderbufferStorageMultisampleEXT;
  tbl.glProgramUniform1dEXT = error_glProgramUniform1dEXT;
  tbl.glProgramUniform1dvEXT = error_glProgramUniform1dvEXT;
  tbl.glProgramUniform1fEXT = error_glProgramUniform1fEXT;
  tbl.glProgramUniform1fvEXT = error_glProgramUniform1fvEXT;
  tbl.glProgramUniform1iEXT = error_glProgramUniform1iEXT;
  tbl.glProgramUniform1ivEXT = error_glProgramUniform1ivEXT;
  tbl.glProgramUniform1uiEXT = error_glProgramUniform1uiEXT;
  tbl.glProgramUniform1uivEXT = error_glProgramUniform1uivEXT;
  tbl.glProgramUniform2dEXT = error_glProgramUniform2dEXT;
  tbl.glProgramUniform2dvEXT = error_glProgramUniform2dvEXT;
  tbl.glProgramUniform2fEXT = error_glProgramUniform2fEXT;
  tbl.glProgramUniform2fvEXT = error_glProgramUniform2fvEXT;
  tbl.glProgramUniform2iEXT = error_glProgramUniform2iEXT;
  tbl.glProgramUniform2ivEXT = error_glProgramUniform2ivEXT;
  tbl.glProgramUniform2uiEXT = error_glProgramUniform2uiEXT;
  tbl.glProgramUniform2uivEXT = error_glProgramUniform2uivEXT;
  tbl.glProgramUniform3dEXT = error_glProgramUniform3dEXT;
  tbl.glProgramUniform3dvEXT = error_glProgramUniform3dvEXT;
  tbl.glProgramUniform3fEXT = error_glProgramUniform3fEXT;
  tbl.glProgramUniform3fvEXT = error_glProgramUniform3fvEXT;
  tbl.glProgramUniform3iEXT = error_glProgramUniform3iEXT;
  tbl.glProgramUniform3ivEXT = error_glProgramUniform3ivEXT;
  tbl.glProgramUniform3uiEXT = error_glProgramUniform3uiEXT;
  tbl.glProgramUniform3uivEXT = error_glProgramUniform3uivEXT;
  tbl.glProgramUniform4dEXT = error_glProgramUniform4dEXT;
  tbl.glProgramUniform4dvEXT = error_glProgramUniform4dvEXT;
  tbl.glProgramUniform4fEXT = error_glProgramUniform4fEXT;
  tbl.glProgramUniform4fvEXT = error_glProgramUniform4fvEXT;
  tbl.glProgramUniform4iEXT = error_glProgramUniform4iEXT;
  tbl.glProgramUniform4ivEXT = error_glProgramUniform4ivEXT;
  tbl.glProgramUniform4uiEXT = error_glProgramUniform4uiEXT;
  tbl.glProgramUniform4uivEXT = error_glProgramUniform4uivEXT;
  tbl.glProgramUniformMatrix2dvEXT = error_glProgramUniformMatrix2dvEXT;
  tbl.glProgramUniformMatrix2fvEXT = error_glProgramUniformMatrix2fvEXT;
  tbl.glProgramUniformMatrix2x3dvEXT = error_glProgramUniformMatrix2x3dvEXT;
  tbl.glProgramUniformMatrix2x3fvEXT = error_glProgramUniformMatrix2x3fvEXT;
  tbl.glProgramUniformMatrix2x4dvEXT = error_glProgramUniformMatrix2x4dvEXT;
  tbl.glProgramUniformMatrix2x4fvEXT = error_glProgramUniformMatrix2x4fvEXT;
  tbl.glProgramUniformMatrix3dvEXT = error_glProgramUniformMatrix3dvEXT;
  tbl.glProgramUniformMatrix3fvEXT = error_glProgramUniformMatrix3fvEXT;
  tbl.glProgramUniformMatrix3x2dvEXT = error_glProgramUniformMatrix3x2dvEXT;
  tbl.glProgramUniformMatrix3x2fvEXT = error_glProgramUniformMatrix3x2fvEXT;
  tbl.glProgramUniformMatrix3x4dvEXT = error_glProgramUniformMatrix3x4dvEXT;
  tbl.glProgramUniformMatrix3x4fvEXT = error_glProgramUniformMatrix3x4fvEXT;
  tbl.glProgramUniformMatrix4dvEXT = error_glProgramUniformMatrix4dvEXT;
  tbl.glProgramUniformMatrix4fvEXT = error_glProgramUniformMatrix4fvEXT;
  tbl.glProgramUniformMatrix4x2dvEXT = error_glProgramUniformMatrix4x2dvEXT;
  tbl.glProgramUniformMatrix4x2fvEXT = error_glProgramUniformMatrix4x2fvEXT;
  tbl.glProgramUniformMatrix4x3dvEXT = error_glProgramUniformMatrix4x3dvEXT;
  tbl.glProgramUniformMatrix4x3fvEXT = error_glProgramUniformMatrix4x3fvEXT;
  tbl.glPushClientAttribDefaultEXT = error_glPushClientAttribDefaultEXT;
  tbl.glTextureBufferEXT = error_glTextureBufferEXT;
  tbl.glTextureImage1DEXT = error_glTextureImage1DEXT;
  tbl.glTextureImage2DEXT = error_glTextureImage2DEXT;
  tbl.glTextureImage3DEXT = error_glTextureImage3DEXT;
  tbl.glTextureParameterIivEXT = error_glTextureParameterIivEXT;
  tbl.glTextureParameterIuivEXT = error_glTextureParameterIuivEXT;
  tbl.glTextureParameterfEXT = error_glTextureParameterfEXT;
  tbl.glTextureParameterfvEXT = error_glTextureParameterfvEXT;
  tbl.glTextureParameteriEXT = error_glTextureParameteriEXT;
  tbl.glTextureParameterivEXT = error_glTextureParameterivEXT;
  tbl.glTextureRenderbufferEXT = error_glTextureRenderbufferEXT;
  tbl.glTextureSubImage1DEXT = error_glTextureSubImage1DEXT;
  tbl.glTextureSubImage2DEXT = error_glTextureSubImage2DEXT;
  tbl.glTextureSubImage3DEXT = error_glTextureSubImage3DEXT;
  tbl.glUnmapNamedBufferEXT = error_glUnmapNamedBufferEXT;
  tbl.glVertexArrayColorOffsetEXT = error_glVertexArrayColorOffsetEXT;
  tbl.glVertexArrayEdgeFlagOffsetEXT = error_glVertexArrayEdgeFlagOffsetEXT;
  tbl.glVertexArrayFogCoordOffsetEXT = error_glVertexArrayFogCoordOffsetEXT;
  tbl.glVertexArrayIndexOffsetEXT = error_glVertexArrayIndexOffsetEXT;
  tbl.glVertexArrayMultiTexCoordOffsetEXT = error_glVertexArrayMultiTexCoordOffsetEXT;
  tbl.glVertexArrayNormalOffsetEXT = error_glVertexArrayNormalOffsetEXT;
  tbl.glVertexArraySecondaryColorOffsetEXT = error_glVertexArraySecondaryColorOffsetEXT;
  tbl.glVertexArrayTexCoordOffsetEXT = error_glVertexArrayTexCoordOffsetEXT;
  tbl.glVertexArrayVertexAttribIOffsetEXT = error_glVertexArrayVertexAttribIOffsetEXT;
  tbl.glVertexArrayVertexAttribOffsetEXT = error_glVertexArrayVertexAttribOffsetEXT;
  tbl.glVertexArrayVertexOffsetEXT = error_glVertexArrayVertexOffsetEXT;

  // GL_EXT_discard_framebuffer

  tbl.glDiscardFramebufferEXT = error_glDiscardFramebufferEXT;

  // GL_EXT_disjoint_timer_query

  tbl.glGetQueryObjectivEXT = error_glGetQueryObjectivEXT;
  tbl.glQueryCounterEXT = error_glQueryCounterEXT;

  // GL_EXT_draw_buffers2

  tbl.glColorMaskIndexedEXT = error_glColorMaskIndexedEXT;
  tbl.glDisableIndexedEXT = error_glDisableIndexedEXT;
  tbl.glEnableIndexedEXT = error_glEnableIndexedEXT;
  tbl.glGetBooleanIndexedvEXT = error_glGetBooleanIndexedvEXT;
  tbl.glGetIntegerIndexedvEXT = error_glGetIntegerIndexedvEXT;
  tbl.glIsEnabledIndexedEXT = error_glIsEnabledIndexedEXT;

  // GL_EXT_draw_instanced

  tbl.glDrawArraysInstancedEXT = error_glDrawArraysInstancedEXT;
  tbl.glDrawElementsInstancedEXT = error_glDrawElementsInstancedEXT;

  // GL_EXT_draw_range_elements

  tbl.glDrawRangeElementsEXT = error_glDrawRangeElementsEXT;

  // GL_EXT_fog_coord

  tbl.glFogCoordPointerEXT = error_glFogCoordPointerEXT;
  tbl.glFogCoorddEXT = error_glFogCoorddEXT;
  tbl.glFogCoorddvEXT = error_glFogCoorddvEXT;
  tbl.glFogCoordfEXT = error_glFogCoordfEXT;
  tbl.glFogCoordfvEXT = error_glFogCoordfvEXT;

  // GL_EXT_fragment_lighting

  tbl.glFragmentColorMaterialEXT = error_glFragmentColorMaterialEXT;
  tbl.glFragmentLightModelfEXT = error_glFragmentLightModelfEXT;
  tbl.glFragmentLightModelfvEXT = error_glFragmentLightModelfvEXT;
  tbl.glFragmentLightModeliEXT = error_glFragmentLightModeliEXT;
  tbl.glFragmentLightModelivEXT = error_glFragmentLightModelivEXT;
  tbl.glFragmentLightfEXT = error_glFragmentLightfEXT;
  tbl.glFragmentLightfvEXT = error_glFragmentLightfvEXT;
  tbl.glFragmentLightiEXT = error_glFragmentLightiEXT;
  tbl.glFragmentLightivEXT = error_glFragmentLightivEXT;
  tbl.glFragmentMaterialfEXT = error_glFragmentMaterialfEXT;
  tbl.glFragmentMaterialfvEXT = error_glFragmentMaterialfvEXT;
  tbl.glFragmentMaterialiEXT = error_glFragmentMaterialiEXT;
  tbl.glFragmentMaterialivEXT = error_glFragmentMaterialivEXT;
  tbl.glGetFragmentLightfvEXT = error_glGetFragmentLightfvEXT;
  tbl.glGetFragmentLightivEXT = error_glGetFragmentLightivEXT;
  tbl.glGetFragmentMaterialfvEXT = error_glGetFragmentMaterialfvEXT;
  tbl.glGetFragmentMaterialivEXT = error_glGetFragmentMaterialivEXT;
  tbl.glLightEnviEXT = error_glLightEnviEXT;

  // GL_EXT_framebuffer_blit

  tbl.glBlitFramebufferEXT = error_glBlitFramebufferEXT;

  // GL_EXT_framebuffer_multisample

  tbl.glRenderbufferStorageMultisampleEXT = error_glRenderbufferStorageMultisampleEXT;

  // GL_EXT_framebuffer_object

  tbl.glBindFramebufferEXT = error_glBindFramebufferEXT;
  tbl.glBindRenderbufferEXT = error_glBindRenderbufferEXT;
  tbl.glCheckFramebufferStatusEXT = error_glCheckFramebufferStatusEXT;
  tbl.glDeleteFramebuffersEXT = error_glDeleteFramebuffersEXT;
  tbl.glDeleteRenderbuffersEXT = error_glDeleteRenderbuffersEXT;
  tbl.glFramebufferRenderbufferEXT = error_glFramebufferRenderbufferEXT;
  tbl.glFramebufferTexture1DEXT = error_glFramebufferTexture1DEXT;
  tbl.glFramebufferTexture2DEXT = error_glFramebufferTexture2DEXT;
  tbl.glFramebufferTexture3DEXT = error_glFramebufferTexture3DEXT;
  tbl.glGenFramebuffersEXT = error_glGenFramebuffersEXT;
  tbl.glGenRenderbuffersEXT = error_glGenRenderbuffersEXT;
  tbl.glGenerateMipmapEXT = error_glGenerateMipmapEXT;
  tbl.glGetFramebufferAttachmentParameterivEXT = error_glGetFramebufferAttachmentParameterivEXT;
  tbl.glGetRenderbufferParameterivEXT = error_glGetRenderbufferParameterivEXT;
  tbl.glIsFramebufferEXT = error_glIsFramebufferEXT;
  tbl.glIsRenderbufferEXT = error_glIsRenderbufferEXT;
  tbl.glRenderbufferStorageEXT = error_glRenderbufferStorageEXT;

  // GL_EXT_geometry_shader4

  tbl.glFramebufferTextureEXT = error_glFramebufferTextureEXT;
  tbl.glFramebufferTextureFaceEXT = error_glFramebufferTextureFaceEXT;
  tbl.glProgramParameteriEXT = error_glProgramParameteriEXT;

  // GL_EXT_gpu_program_parameters

  tbl.glProgramEnvParameters4fvEXT = error_glProgramEnvParameters4fvEXT;
  tbl.glProgramLocalParameters4fvEXT = error_glProgramLocalParameters4fvEXT;

  // GL_EXT_gpu_shader4

  tbl.glBindFragDataLocationEXT = error_glBindFragDataLocationEXT;
  tbl.glGetFragDataLocationEXT = error_glGetFragDataLocationEXT;
  tbl.glGetUniformuivEXT = error_glGetUniformuivEXT;
  tbl.glGetVertexAttribIivEXT = error_glGetVertexAttribIivEXT;
  tbl.glGetVertexAttribIuivEXT = error_glGetVertexAttribIuivEXT;
  tbl.glUniform1uiEXT = error_glUniform1uiEXT;
  tbl.glUniform1uivEXT = error_glUniform1uivEXT;
  tbl.glUniform2uiEXT = error_glUniform2uiEXT;
  tbl.glUniform2uivEXT = error_glUniform2uivEXT;
  tbl.glUniform3uiEXT = error_glUniform3uiEXT;
  tbl.glUniform3uivEXT = error_glUniform3uivEXT;
  tbl.glUniform4uiEXT = error_glUniform4uiEXT;
  tbl.glUniform4uivEXT = error_glUniform4uivEXT;
  tbl.glVertexAttribI1iEXT = error_glVertexAttribI1iEXT;
  tbl.glVertexAttribI1ivEXT = error_glVertexAttribI1ivEXT;
  tbl.glVertexAttribI1uiEXT = error_glVertexAttribI1uiEXT;
  tbl.glVertexAttribI1uivEXT = error_glVertexAttribI1uivEXT;
  tbl.glVertexAttribI2iEXT = error_glVertexAttribI2iEXT;
  tbl.glVertexAttribI2ivEXT = error_glVertexAttribI2ivEXT;
  tbl.glVertexAttribI2uiEXT = error_glVertexAttribI2uiEXT;
  tbl.glVertexAttribI2uivEXT = error_glVertexAttribI2uivEXT;
  tbl.glVertexAttribI3iEXT = error_glVertexAttribI3iEXT;
  tbl.glVertexAttribI3ivEXT = error_glVertexAttribI3ivEXT;
  tbl.glVertexAttribI3uiEXT = error_glVertexAttribI3uiEXT;
  tbl.glVertexAttribI3uivEXT = error_glVertexAttribI3uivEXT;
  tbl.glVertexAttribI4bvEXT = error_glVertexAttribI4bvEXT;
  tbl.glVertexAttribI4iEXT = error_glVertexAttribI4iEXT;
  tbl.glVertexAttribI4ivEXT = error_glVertexAttribI4ivEXT;
  tbl.glVertexAttribI4svEXT = error_glVertexAttribI4svEXT;
  tbl.glVertexAttribI4ubvEXT = error_glVertexAttribI4ubvEXT;
  tbl.glVertexAttribI4uiEXT = error_glVertexAttribI4uiEXT;
  tbl.glVertexAttribI4uivEXT = error_glVertexAttribI4uivEXT;
  tbl.glVertexAttribI4usvEXT = error_glVertexAttribI4usvEXT;
  tbl.glVertexAttribIPointerEXT = error_glVertexAttribIPointerEXT;

  // GL_EXT_histogram

  tbl.glGetHistogramEXT = error_glGetHistogramEXT;
  tbl.glGetHistogramParameterfvEXT = error_glGetHistogramParameterfvEXT;
  tbl.glGetHistogramParameterivEXT = error_glGetHistogramParameterivEXT;
  tbl.glGetMinmaxEXT = error_glGetMinmaxEXT;
  tbl.glGetMinmaxParameterfvEXT = error_glGetMinmaxParameterfvEXT;
  tbl.glGetMinmaxParameterivEXT = error_glGetMinmaxParameterivEXT;
  tbl.glHistogramEXT = error_glHistogramEXT;
  tbl.glMinmaxEXT = error_glMinmaxEXT;
  tbl.glResetHistogramEXT = error_glResetHistogramEXT;
  tbl.glResetMinmaxEXT = error_glResetMinmaxEXT;

  // GL_EXT_index_func

  tbl.glIndexFuncEXT = error_glIndexFuncEXT;

  // GL_EXT_index_material

  tbl.glIndexMaterialEXT = error_glIndexMaterialEXT;

  // GL_EXT_light_texture

  tbl.glApplyTextureEXT = error_glApplyTextureEXT;
  tbl.glTextureLightEXT = error_glTextureLightEXT;
  tbl.glTextureMaterialEXT = error_glTextureMaterialEXT;

  // GL_EXT_map_buffer_range

  tbl.glFlushMappedBufferRangeEXT = error_glFlushMappedBufferRangeEXT;
  tbl.glMapBufferRangeEXT = error_glMapBufferRangeEXT;

  // GL_EXT_multi_draw_arrays

  tbl.glMultiDrawArraysEXT = error_glMultiDrawArraysEXT;
  tbl.glMultiDrawElementsEXT = error_glMultiDrawElementsEXT;

  // GL_EXT_multisample

  tbl.glSampleMaskEXT = error_glSampleMaskEXT;
  tbl.glSamplePatternEXT = error_glSamplePatternEXT;

  // GL_EXT_multisampled_render_to_texture

  tbl.glFramebufferTexture2DMultisampleEXT = error_glFramebufferTexture2DMultisampleEXT;

  // GL_EXT_multiview_draw_buffers

  tbl.glDrawBuffersIndexedEXT = error_glDrawBuffersIndexedEXT;
  tbl.glGetIntegeri_vEXT = error_glGetIntegeri_vEXT;
  tbl.glReadBufferIndexedEXT = error_glReadBufferIndexedEXT;

  // GL_EXT_occlusion_query_boolean

  tbl.glBeginQueryEXT = error_glBeginQueryEXT;
  tbl.glDeleteQueriesEXT = error_glDeleteQueriesEXT;
  tbl.glEndQueryEXT = error_glEndQueryEXT;
  tbl.glGenQueriesEXT = error_glGenQueriesEXT;
  tbl.glGetQueryObjectuivEXT = error_glGetQueryObjectuivEXT;
  tbl.glGetQueryivEXT = error_glGetQueryivEXT;
  tbl.glIsQueryEXT = error_glIsQueryEXT;

  // GL_EXT_paletted_texture

  tbl.glColorTableEXT = error_glColorTableEXT;
  tbl.glGetColorTableEXT = error_glGetColorTableEXT;
  tbl.glGetColorTableParameterfvEXT = error_glGetColorTableParameterfvEXT;
  tbl.glGetColorTableParameterivEXT = error_glGetColorTableParameterivEXT;

  // GL_EXT_pixel_transform

  tbl.glGetPixelTransformParameterfvEXT = error_glGetPixelTransformParameterfvEXT;
  tbl.glGetPixelTransformParameterivEXT = error_glGetPixelTransformParameterivEXT;
  tbl.glPixelTransformParameterfEXT = error_glPixelTransformParameterfEXT;
  tbl.glPixelTransformParameterfvEXT = error_glPixelTransformParameterfvEXT;
  tbl.glPixelTransformParameteriEXT = error_glPixelTransformParameteriEXT;
  tbl.glPixelTransformParameterivEXT = error_glPixelTransformParameterivEXT;

  // GL_EXT_point_parameters

  tbl.glPointParameterfEXT = error_glPointParameterfEXT;
  tbl.glPointParameterfvEXT = error_glPointParameterfvEXT;

  // GL_EXT_polygon_offset

  tbl.glPolygonOffsetEXT = error_glPolygonOffsetEXT;

  // GL_EXT_provoking_vertex

  tbl.glProvokingVertexEXT = error_glProvokingVertexEXT;

  // GL_EXT_robustness

  tbl.glGetnUniformfvEXT = error_glGetnUniformfvEXT;
  tbl.glGetnUniformivEXT = error_glGetnUniformivEXT;
  tbl.glReadnPixelsEXT = error_glReadnPixelsEXT;

  // GL_EXT_scene_marker

  tbl.glBeginSceneEXT = error_glBeginSceneEXT;
  tbl.glEndSceneEXT = error_glEndSceneEXT;

  // GL_EXT_secondary_color

  tbl.glSecondaryColor3bEXT = error_glSecondaryColor3bEXT;
  tbl.glSecondaryColor3bvEXT = error_glSecondaryColor3bvEXT;
  tbl.glSecondaryColor3dEXT = error_glSecondaryColor3dEXT;
  tbl.glSecondaryColor3dvEXT = error_glSecondaryColor3dvEXT;
  tbl.glSecondaryColor3fEXT = error_glSecondaryColor3fEXT;
  tbl.glSecondaryColor3fvEXT = error_glSecondaryColor3fvEXT;
  tbl.glSecondaryColor3iEXT = error_glSecondaryColor3iEXT;
  tbl.glSecondaryColor3ivEXT = error_glSecondaryColor3ivEXT;
  tbl.glSecondaryColor3sEXT = error_glSecondaryColor3sEXT;
  tbl.glSecondaryColor3svEXT = error_glSecondaryColor3svEXT;
  tbl.glSecondaryColor3ubEXT = error_glSecondaryColor3ubEXT;
  tbl.glSecondaryColor3ubvEXT = error_glSecondaryColor3ubvEXT;
  tbl.glSecondaryColor3uiEXT = error_glSecondaryColor3uiEXT;
  tbl.glSecondaryColor3uivEXT = error_glSecondaryColor3uivEXT;
  tbl.glSecondaryColor3usEXT = error_glSecondaryColor3usEXT;
  tbl.glSecondaryColor3usvEXT = error_glSecondaryColor3usvEXT;
  tbl.glSecondaryColorPointerEXT = error_glSecondaryColorPointerEXT;

  // GL_EXT_separate_shader_objects

  tbl.glActiveProgramEXT = error_glActiveProgramEXT;
  tbl.glCreateShaderProgramEXT = error_glCreateShaderProgramEXT;
  tbl.glUseShaderProgramEXT = error_glUseShaderProgramEXT;

  // GL_EXT_shader_image_load_store

  tbl.glBindImageTextureEXT = error_glBindImageTextureEXT;
  tbl.glMemoryBarrierEXT = error_glMemoryBarrierEXT;

  // GL_EXT_stencil_clear_tag

  tbl.glStencilClearTagEXT = error_glStencilClearTagEXT;

  // GL_EXT_stencil_two_side

  tbl.glActiveStencilFaceEXT = error_glActiveStencilFaceEXT;

  // GL_EXT_subtexture

  tbl.glTexSubImage1DEXT = error_glTexSubImage1DEXT;
  tbl.glTexSubImage2DEXT = error_glTexSubImage2DEXT;
  tbl.glTexSubImage3DEXT = error_glTexSubImage3DEXT;

  // GL_EXT_texture3D

  tbl.glTexImage3DEXT = error_glTexImage3DEXT;

  // GL_EXT_texture_array

  tbl.glFramebufferTextureLayerEXT = error_glFramebufferTextureLayerEXT;

  // GL_EXT_texture_buffer_object

  tbl.glTexBufferEXT = error_glTexBufferEXT;

  // GL_EXT_texture_integer

  tbl.glClearColorIiEXT = error_glClearColorIiEXT;
  tbl.glClearColorIuiEXT = error_glClearColorIuiEXT;
  tbl.glGetTexParameterIivEXT = error_glGetTexParameterIivEXT;
  tbl.glGetTexParameterIuivEXT = error_glGetTexParameterIuivEXT;
  tbl.glTexParameterIivEXT = error_glTexParameterIivEXT;
  tbl.glTexParameterIuivEXT = error_glTexParameterIuivEXT;

  // GL_EXT_texture_object

  tbl.glAreTexturesResidentEXT = error_glAreTexturesResidentEXT;
  tbl.glBindTextureEXT = error_glBindTextureEXT;
  tbl.glDeleteTexturesEXT = error_glDeleteTexturesEXT;
  tbl.glGenTexturesEXT = error_glGenTexturesEXT;
  tbl.glIsTextureEXT = error_glIsTextureEXT;
  tbl.glPrioritizeTexturesEXT = error_glPrioritizeTexturesEXT;

  // GL_EXT_texture_perturb_normal

  tbl.glTextureNormalEXT = error_glTextureNormalEXT;

  // GL_EXT_texture_storage

  tbl.glTexStorage1DEXT = error_glTexStorage1DEXT;
  tbl.glTexStorage2DEXT = error_glTexStorage2DEXT;
  tbl.glTexStorage3DEXT = error_glTexStorage3DEXT;

  // GL_EXT_timer_query

  tbl.glGetQueryObjecti64vEXT = error_glGetQueryObjecti64vEXT;
  tbl.glGetQueryObjectui64vEXT = error_glGetQueryObjectui64vEXT;

  // GL_EXT_transform_feedback

  tbl.glBeginTransformFeedbackEXT = error_glBeginTransformFeedbackEXT;
  tbl.glBindBufferBaseEXT = error_glBindBufferBaseEXT;
  tbl.glBindBufferOffsetEXT = error_glBindBufferOffsetEXT;
  tbl.glBindBufferRangeEXT = error_glBindBufferRangeEXT;
  tbl.glEndTransformFeedbackEXT = error_glEndTransformFeedbackEXT;
  tbl.glGetTransformFeedbackVaryingEXT = error_glGetTransformFeedbackVaryingEXT;
  tbl.glTransformFeedbackVaryingsEXT = error_glTransformFeedbackVaryingsEXT;

  // GL_EXT_vertex_array

  tbl.glArrayElementEXT = error_glArrayElementEXT;
  tbl.glColorPointerEXT = error_glColorPointerEXT;
  tbl.glDrawArraysEXT = error_glDrawArraysEXT;
  tbl.glEdgeFlagPointerEXT = error_glEdgeFlagPointerEXT;
  tbl.glGetPointervEXT = error_glGetPointervEXT;
  tbl.glIndexPointerEXT = error_glIndexPointerEXT;
  tbl.glNormalPointerEXT = error_glNormalPointerEXT;
  tbl.glTexCoordPointerEXT = error_glTexCoordPointerEXT;
  tbl.glVertexPointerEXT = error_glVertexPointerEXT;

  // GL_EXT_vertex_attrib_64bit

  tbl.glGetVertexAttribLdvEXT = error_glGetVertexAttribLdvEXT;
  tbl.glVertexArrayVertexAttribLOffsetEXT = error_glVertexArrayVertexAttribLOffsetEXT;
  tbl.glVertexAttribL1dEXT = error_glVertexAttribL1dEXT;
  tbl.glVertexAttribL1dvEXT = error_glVertexAttribL1dvEXT;
  tbl.glVertexAttribL2dEXT = error_glVertexAttribL2dEXT;
  tbl.glVertexAttribL2dvEXT = error_glVertexAttribL2dvEXT;
  tbl.glVertexAttribL3dEXT = error_glVertexAttribL3dEXT;
  tbl.glVertexAttribL3dvEXT = error_glVertexAttribL3dvEXT;
  tbl.glVertexAttribL4dEXT = error_glVertexAttribL4dEXT;
  tbl.glVertexAttribL4dvEXT = error_glVertexAttribL4dvEXT;
  tbl.glVertexAttribLPointerEXT = error_glVertexAttribLPointerEXT;

  // GL_EXT_vertex_shader

  tbl.glBeginVertexShaderEXT = error_glBeginVertexShaderEXT;
  tbl.glBindLightParameterEXT = error_glBindLightParameterEXT;
  tbl.glBindMaterialParameterEXT = error_glBindMaterialParameterEXT;
  tbl.glBindParameterEXT = error_glBindParameterEXT;
  tbl.glBindTexGenParameterEXT = error_glBindTexGenParameterEXT;
  tbl.glBindTextureUnitParameterEXT = error_glBindTextureUnitParameterEXT;
  tbl.glBindVertexShaderEXT = error_glBindVertexShaderEXT;
  tbl.glDeleteVertexShaderEXT = error_glDeleteVertexShaderEXT;
  tbl.glDisableVariantClientStateEXT = error_glDisableVariantClientStateEXT;
  tbl.glEnableVariantClientStateEXT = error_glEnableVariantClientStateEXT;
  tbl.glEndVertexShaderEXT = error_glEndVertexShaderEXT;
  tbl.glExtractComponentEXT = error_glExtractComponentEXT;
  tbl.glGenSymbolsEXT = error_glGenSymbolsEXT;
  tbl.glGenVertexShadersEXT = error_glGenVertexShadersEXT;
  tbl.glGetInvariantBooleanvEXT = error_glGetInvariantBooleanvEXT;
  tbl.glGetInvariantFloatvEXT = error_glGetInvariantFloatvEXT;
  tbl.glGetInvariantIntegervEXT = error_glGetInvariantIntegervEXT;
  tbl.glGetLocalConstantBooleanvEXT = error_glGetLocalConstantBooleanvEXT;
  tbl.glGetLocalConstantFloatvEXT = error_glGetLocalConstantFloatvEXT;
  tbl.glGetLocalConstantIntegervEXT = error_glGetLocalConstantIntegervEXT;
  tbl.glGetVariantBooleanvEXT = error_glGetVariantBooleanvEXT;
  tbl.glGetVariantFloatvEXT = error_glGetVariantFloatvEXT;
  tbl.glGetVariantIntegervEXT = error_glGetVariantIntegervEXT;
  tbl.glGetVariantPointervEXT = error_glGetVariantPointervEXT;
  tbl.glInsertComponentEXT = error_glInsertComponentEXT;
  tbl.glIsVariantEnabledEXT = error_glIsVariantEnabledEXT;
  tbl.glSetInvariantEXT = error_glSetInvariantEXT;
  tbl.glSetLocalConstantEXT = error_glSetLocalConstantEXT;
  tbl.glShaderOp1EXT = error_glShaderOp1EXT;
  tbl.glShaderOp2EXT = error_glShaderOp2EXT;
  tbl.glShaderOp3EXT = error_glShaderOp3EXT;
  tbl.glSwizzleEXT = error_glSwizzleEXT;
  tbl.glVariantPointerEXT = error_glVariantPointerEXT;
  tbl.glVariantbvEXT = error_glVariantbvEXT;
  tbl.glVariantdvEXT = error_glVariantdvEXT;
  tbl.glVariantfvEXT = error_glVariantfvEXT;
  tbl.glVariantivEXT = error_glVariantivEXT;
  tbl.glVariantsvEXT = error_glVariantsvEXT;
  tbl.glVariantubvEXT = error_glVariantubvEXT;
  tbl.glVariantuivEXT = error_glVariantuivEXT;
  tbl.glVariantusvEXT = error_glVariantusvEXT;
  tbl.glWriteMaskEXT = error_glWriteMaskEXT;

  // GL_EXT_vertex_weighting

  tbl.glVertexWeightPointerEXT = error_glVertexWeightPointerEXT;
  tbl.glVertexWeightfEXT = error_glVertexWeightfEXT;
  tbl.glVertexWeightfvEXT = error_glVertexWeightfvEXT;

  // GL_EXT_x11_sync_object

  tbl.glImportSyncEXT = error_glImportSyncEXT;

  // GL_GREMEDY_frame_terminator

  tbl.glFrameTerminatorGREMEDY = error_glFrameTerminatorGREMEDY;

  // GL_GREMEDY_string_marker

  tbl.glStringMarkerGREMEDY = error_glStringMarkerGREMEDY;

  // GL_HP_image_transform

  tbl.glGetImageTransformParameterfvHP = error_glGetImageTransformParameterfvHP;
  tbl.glGetImageTransformParameterivHP = error_glGetImageTransformParameterivHP;
  tbl.glImageTransformParameterfHP = error_glImageTransformParameterfHP;
  tbl.glImageTransformParameterfvHP = error_glImageTransformParameterfvHP;
  tbl.glImageTransformParameteriHP = error_glImageTransformParameteriHP;
  tbl.glImageTransformParameterivHP = error_glImageTransformParameterivHP;

  // GL_IBM_multimode_draw_arrays

  tbl.glMultiModeDrawArraysIBM = error_glMultiModeDrawArraysIBM;
  tbl.glMultiModeDrawElementsIBM = error_glMultiModeDrawElementsIBM;

  // GL_IBM_vertex_array_lists

  tbl.glColorPointerListIBM = error_glColorPointerListIBM;
  tbl.glEdgeFlagPointerListIBM = error_glEdgeFlagPointerListIBM;
  tbl.glFogCoordPointerListIBM = error_glFogCoordPointerListIBM;
  tbl.glIndexPointerListIBM = error_glIndexPointerListIBM;
  tbl.glNormalPointerListIBM = error_glNormalPointerListIBM;
  tbl.glSecondaryColorPointerListIBM = error_glSecondaryColorPointerListIBM;
  tbl.glTexCoordPointerListIBM = error_glTexCoordPointerListIBM;
  tbl.glVertexPointerListIBM = error_glVertexPointerListIBM;

  // GL_IMG_multisampled_render_to_texture

  tbl.glFramebufferTexture2DMultisampleIMG = error_glFramebufferTexture2DMultisampleIMG;
  tbl.glRenderbufferStorageMultisampleIMG = error_glRenderbufferStorageMultisampleIMG;

  // GL_INGR_blend_func_separate

  tbl.glBlendFuncSeparateINGR = error_glBlendFuncSeparateINGR;

  // GL_INTEL_map_texture

  tbl.glMapTexture2DINTEL = error_glMapTexture2DINTEL;
  tbl.glSyncTextureINTEL = error_glSyncTextureINTEL;
  tbl.glUnmapTexture2DINTEL = error_glUnmapTexture2DINTEL;

  // GL_INTEL_parallel_arrays

  tbl.glColorPointervINTEL = error_glColorPointervINTEL;
  tbl.glNormalPointervINTEL = error_glNormalPointervINTEL;
  tbl.glTexCoordPointervINTEL = error_glTexCoordPointervINTEL;
  tbl.glVertexPointervINTEL = error_glVertexPointervINTEL;

  // GL_INTEL_texture_scissor

  tbl.glTexScissorFuncINTEL = error_glTexScissorFuncINTEL;
  tbl.glTexScissorINTEL = error_glTexScissorINTEL;

  // GL_KHR_debug

  tbl.glDebugMessageCallback = error_glDebugMessageCallback;
  tbl.glDebugMessageControl = error_glDebugMessageControl;
  tbl.glDebugMessageInsert = error_glDebugMessageInsert;
  tbl.glGetDebugMessageLog = error_glGetDebugMessageLog;
  tbl.glGetObjectLabel = error_glGetObjectLabel;
  tbl.glGetObjectPtrLabel = error_glGetObjectPtrLabel;
  tbl.glObjectLabel = error_glObjectLabel;
  tbl.glObjectPtrLabel = error_glObjectPtrLabel;
  tbl.glPopDebugGroup = error_glPopDebugGroup;
  tbl.glPushDebugGroup = error_glPushDebugGroup;

  // GL_KTX_buffer_region

  tbl.glBufferRegionEnabled = error_glBufferRegionEnabled;
  tbl.glDeleteBufferRegion = error_glDeleteBufferRegion;
  tbl.glDrawBufferRegion = error_glDrawBufferRegion;
  tbl.glNewBufferRegion = error_glNewBufferRegion;
  tbl.glReadBufferRegion = error_glReadBufferRegion;

  // GL_MESA_resize_buffers

  tbl.glResizeBuffersMESA = error_glResizeBuffersMESA;

  // GL_MESA_window_pos

  tbl.glWindowPos2dMESA = error_glWindowPos2dMESA;
  tbl.glWindowPos2dvMESA = error_glWindowPos2dvMESA;
  tbl.glWindowPos2fMESA = error_glWindowPos2fMESA;
  tbl.glWindowPos2fvMESA = error_glWindowPos2fvMESA;
  tbl.glWindowPos2iMESA = error_glWindowPos2iMESA;
  tbl.glWindowPos2ivMESA = error_glWindowPos2ivMESA;
  tbl.glWindowPos2sMESA = error_glWindowPos2sMESA;
  tbl.glWindowPos2svMESA = error_glWindowPos2svMESA;
  tbl.glWindowPos3dMESA = error_glWindowPos3dMESA;
  tbl.glWindowPos3dvMESA = error_glWindowPos3dvMESA;
  tbl.glWindowPos3fMESA = error_glWindowPos3fMESA;
  tbl.glWindowPos3fvMESA = error_glWindowPos3fvMESA;
  tbl.glWindowPos3iMESA = error_glWindowPos3iMESA;
  tbl.glWindowPos3ivMESA = error_glWindowPos3ivMESA;
  tbl.glWindowPos3sMESA = error_glWindowPos3sMESA;
  tbl.glWindowPos3svMESA = error_glWindowPos3svMESA;
  tbl.glWindowPos4dMESA = error_glWindowPos4dMESA;
  tbl.glWindowPos4dvMESA = error_glWindowPos4dvMESA;
  tbl.glWindowPos4fMESA = error_glWindowPos4fMESA;
  tbl.glWindowPos4fvMESA = error_glWindowPos4fvMESA;
  tbl.glWindowPos4iMESA = error_glWindowPos4iMESA;
  tbl.glWindowPos4ivMESA = error_glWindowPos4ivMESA;
  tbl.glWindowPos4sMESA = error_glWindowPos4sMESA;
  tbl.glWindowPos4svMESA = error_glWindowPos4svMESA;

  // GL_NVX_conditional_render

  tbl.glBeginConditionalRenderNVX = error_glBeginConditionalRenderNVX;
  tbl.glEndConditionalRenderNVX = error_glEndConditionalRenderNVX;

  // GL_NV_bindless_texture

  tbl.glGetImageHandleNV = error_glGetImageHandleNV;
  tbl.glGetTextureHandleNV = error_glGetTextureHandleNV;
  tbl.glGetTextureSamplerHandleNV = error_glGetTextureSamplerHandleNV;
  tbl.glIsImageHandleResidentNV = error_glIsImageHandleResidentNV;
  tbl.glIsTextureHandleResidentNV = error_glIsTextureHandleResidentNV;
  tbl.glMakeImageHandleNonResidentNV = error_glMakeImageHandleNonResidentNV;
  tbl.glMakeImageHandleResidentNV = error_glMakeImageHandleResidentNV;
  tbl.glMakeTextureHandleNonResidentNV = error_glMakeTextureHandleNonResidentNV;
  tbl.glMakeTextureHandleResidentNV = error_glMakeTextureHandleResidentNV;
  tbl.glProgramUniformHandleui64NV = error_glProgramUniformHandleui64NV;
  tbl.glProgramUniformHandleui64vNV = error_glProgramUniformHandleui64vNV;
  tbl.glUniformHandleui64NV = error_glUniformHandleui64NV;
  tbl.glUniformHandleui64vNV = error_glUniformHandleui64vNV;

  // GL_NV_blend_equation_advanced

  tbl.glBlendBarrierNV = error_glBlendBarrierNV;
  tbl.glBlendParameteriNV = error_glBlendParameteriNV;

  // GL_NV_conditional_render

  tbl.glBeginConditionalRenderNV = error_glBeginConditionalRenderNV;
  tbl.glEndConditionalRenderNV = error_glEndConditionalRenderNV;

  // GL_NV_copy_buffer

  tbl.glCopyBufferSubDataNV = error_glCopyBufferSubDataNV;

  // GL_NV_copy_image

  tbl.glCopyImageSubDataNV = error_glCopyImageSubDataNV;

  // GL_NV_coverage_sample

  tbl.glCoverageMaskNV = error_glCoverageMaskNV;
  tbl.glCoverageOperationNV = error_glCoverageOperationNV;

  // GL_NV_depth_buffer_float

  tbl.glClearDepthdNV = error_glClearDepthdNV;
  tbl.glDepthBoundsdNV = error_glDepthBoundsdNV;
  tbl.glDepthRangedNV = error_glDepthRangedNV;

  // GL_NV_draw_buffers

  tbl.glDrawBuffersNV = error_glDrawBuffersNV;

  // GL_NV_draw_texture

  tbl.glDrawTextureNV = error_glDrawTextureNV;

  // GL_NV_evaluators

  tbl.glEvalMapsNV = error_glEvalMapsNV;
  tbl.glGetMapAttribParameterfvNV = error_glGetMapAttribParameterfvNV;
  tbl.glGetMapAttribParameterivNV = error_glGetMapAttribParameterivNV;
  tbl.glGetMapControlPointsNV = error_glGetMapControlPointsNV;
  tbl.glGetMapParameterfvNV = error_glGetMapParameterfvNV;
  tbl.glGetMapParameterivNV = error_glGetMapParameterivNV;
  tbl.glMapControlPointsNV = error_glMapControlPointsNV;
  tbl.glMapParameterfvNV = error_glMapParameterfvNV;
  tbl.glMapParameterivNV = error_glMapParameterivNV;

  // GL_NV_explicit_multisample

  tbl.glGetMultisamplefvNV = error_glGetMultisamplefvNV;
  tbl.glSampleMaskIndexedNV = error_glSampleMaskIndexedNV;
  tbl.glTexRenderbufferNV = error_glTexRenderbufferNV;

  // GL_NV_fence

  tbl.glDeleteFencesNV = error_glDeleteFencesNV;
  tbl.glFinishFenceNV = error_glFinishFenceNV;
  tbl.glGenFencesNV = error_glGenFencesNV;
  tbl.glGetFenceivNV = error_glGetFenceivNV;
  tbl.glIsFenceNV = error_glIsFenceNV;
  tbl.glSetFenceNV = error_glSetFenceNV;
  tbl.glTestFenceNV = error_glTestFenceNV;

  // GL_NV_fragment_program

  tbl.glGetProgramNamedParameterdvNV = error_glGetProgramNamedParameterdvNV;
  tbl.glGetProgramNamedParameterfvNV = error_glGetProgramNamedParameterfvNV;
  tbl.glProgramNamedParameter4dNV = error_glProgramNamedParameter4dNV;
  tbl.glProgramNamedParameter4dvNV = error_glProgramNamedParameter4dvNV;
  tbl.glProgramNamedParameter4fNV = error_glProgramNamedParameter4fNV;
  tbl.glProgramNamedParameter4fvNV = error_glProgramNamedParameter4fvNV;

  // GL_NV_framebuffer_blit

  tbl.glBlitFramebufferNV = error_glBlitFramebufferNV;

  // GL_NV_framebuffer_multisample_coverage

  tbl.glRenderbufferStorageMultisampleCoverageNV = error_glRenderbufferStorageMultisampleCoverageNV;

  // GL_NV_geometry_program4

  tbl.glProgramVertexLimitNV = error_glProgramVertexLimitNV;

  // GL_NV_gpu_program4

  tbl.glGetProgramEnvParameterIivNV = error_glGetProgramEnvParameterIivNV;
  tbl.glGetProgramEnvParameterIuivNV = error_glGetProgramEnvParameterIuivNV;
  tbl.glGetProgramLocalParameterIivNV = error_glGetProgramLocalParameterIivNV;
  tbl.glGetProgramLocalParameterIuivNV = error_glGetProgramLocalParameterIuivNV;
  tbl.glProgramEnvParameterI4iNV = error_glProgramEnvParameterI4iNV;
  tbl.glProgramEnvParameterI4ivNV = error_glProgramEnvParameterI4ivNV;
  tbl.glProgramEnvParameterI4uiNV = error_glProgramEnvParameterI4uiNV;
  tbl.glProgramEnvParameterI4uivNV = error_glProgramEnvParameterI4uivNV;
  tbl.glProgramEnvParametersI4ivNV = error_glProgramEnvParametersI4ivNV;
  tbl.glProgramEnvParametersI4uivNV = error_glProgramEnvParametersI4uivNV;
  tbl.glProgramLocalParameterI4iNV = error_glProgramLocalParameterI4iNV;
  tbl.glProgramLocalParameterI4ivNV = error_glProgramLocalParameterI4ivNV;
  tbl.glProgramLocalParameterI4uiNV = error_glProgramLocalParameterI4uiNV;
  tbl.glProgramLocalParameterI4uivNV = error_glProgramLocalParameterI4uivNV;
  tbl.glProgramLocalParametersI4ivNV = error_glProgramLocalParametersI4ivNV;
  tbl.glProgramLocalParametersI4uivNV = error_glProgramLocalParametersI4uivNV;

  // GL_NV_gpu_shader5

  tbl.glGetUniformi64vNV = error_glGetUniformi64vNV;
  tbl.glProgramUniform1i64NV = error_glProgramUniform1i64NV;
  tbl.glProgramUniform1i64vNV = error_glProgramUniform1i64vNV;
  tbl.glProgramUniform1ui64NV = error_glProgramUniform1ui64NV;
  tbl.glProgramUniform1ui64vNV = error_glProgramUniform1ui64vNV;
  tbl.glProgramUniform2i64NV = error_glProgramUniform2i64NV;
  tbl.glProgramUniform2i64vNV = error_glProgramUniform2i64vNV;
  tbl.glProgramUniform2ui64NV = error_glProgramUniform2ui64NV;
  tbl.glProgramUniform2ui64vNV = error_glProgramUniform2ui64vNV;
  tbl.glProgramUniform3i64NV = error_glProgramUniform3i64NV;
  tbl.glProgramUniform3i64vNV = error_glProgramUniform3i64vNV;
  tbl.glProgramUniform3ui64NV = error_glProgramUniform3ui64NV;
  tbl.glProgramUniform3ui64vNV = error_glProgramUniform3ui64vNV;
  tbl.glProgramUniform4i64NV = error_glProgramUniform4i64NV;
  tbl.glProgramUniform4i64vNV = error_glProgramUniform4i64vNV;
  tbl.glProgramUniform4ui64NV = error_glProgramUniform4ui64NV;
  tbl.glProgramUniform4ui64vNV = error_glProgramUniform4ui64vNV;
  tbl.glUniform1i64NV = error_glUniform1i64NV;
  tbl.glUniform1i64vNV = error_glUniform1i64vNV;
  tbl.glUniform1ui64NV = error_glUniform1ui64NV;
  tbl.glUniform1ui64vNV = error_glUniform1ui64vNV;
  tbl.glUniform2i64NV = error_glUniform2i64NV;
  tbl.glUniform2i64vNV = error_glUniform2i64vNV;
  tbl.glUniform2ui64NV = error_glUniform2ui64NV;
  tbl.glUniform2ui64vNV = error_glUniform2ui64vNV;
  tbl.glUniform3i64NV = error_glUniform3i64NV;
  tbl.glUniform3i64vNV = error_glUniform3i64vNV;
  tbl.glUniform3ui64NV = error_glUniform3ui64NV;
  tbl.glUniform3ui64vNV = error_glUniform3ui64vNV;
  tbl.glUniform4i64NV = error_glUniform4i64NV;
  tbl.glUniform4i64vNV = error_glUniform4i64vNV;
  tbl.glUniform4ui64NV = error_glUniform4ui64NV;
  tbl.glUniform4ui64vNV = error_glUniform4ui64vNV;

  // GL_NV_half_float

  tbl.glColor3hNV = error_glColor3hNV;
  tbl.glColor3hvNV = error_glColor3hvNV;
  tbl.glColor4hNV = error_glColor4hNV;
  tbl.glColor4hvNV = error_glColor4hvNV;
  tbl.glFogCoordhNV = error_glFogCoordhNV;
  tbl.glFogCoordhvNV = error_glFogCoordhvNV;
  tbl.glMultiTexCoord1hNV = error_glMultiTexCoord1hNV;
  tbl.glMultiTexCoord1hvNV = error_glMultiTexCoord1hvNV;
  tbl.glMultiTexCoord2hNV = error_glMultiTexCoord2hNV;
  tbl.glMultiTexCoord2hvNV = error_glMultiTexCoord2hvNV;
  tbl.glMultiTexCoord3hNV = error_glMultiTexCoord3hNV;
  tbl.glMultiTexCoord3hvNV = error_glMultiTexCoord3hvNV;
  tbl.glMultiTexCoord4hNV = error_glMultiTexCoord4hNV;
  tbl.glMultiTexCoord4hvNV = error_glMultiTexCoord4hvNV;
  tbl.glNormal3hNV = error_glNormal3hNV;
  tbl.glNormal3hvNV = error_glNormal3hvNV;
  tbl.glSecondaryColor3hNV = error_glSecondaryColor3hNV;
  tbl.glSecondaryColor3hvNV = error_glSecondaryColor3hvNV;
  tbl.glTexCoord1hNV = error_glTexCoord1hNV;
  tbl.glTexCoord1hvNV = error_glTexCoord1hvNV;
  tbl.glTexCoord2hNV = error_glTexCoord2hNV;
  tbl.glTexCoord2hvNV = error_glTexCoord2hvNV;
  tbl.glTexCoord3hNV = error_glTexCoord3hNV;
  tbl.glTexCoord3hvNV = error_glTexCoord3hvNV;
  tbl.glTexCoord4hNV = error_glTexCoord4hNV;
  tbl.glTexCoord4hvNV = error_glTexCoord4hvNV;
  tbl.glVertex2hNV = error_glVertex2hNV;
  tbl.glVertex2hvNV = error_glVertex2hvNV;
  tbl.glVertex3hNV = error_glVertex3hNV;
  tbl.glVertex3hvNV = error_glVertex3hvNV;
  tbl.glVertex4hNV = error_glVertex4hNV;
  tbl.glVertex4hvNV = error_glVertex4hvNV;
  tbl.glVertexAttrib1hNV = error_glVertexAttrib1hNV;
  tbl.glVertexAttrib1hvNV = error_glVertexAttrib1hvNV;
  tbl.glVertexAttrib2hNV = error_glVertexAttrib2hNV;
  tbl.glVertexAttrib2hvNV = error_glVertexAttrib2hvNV;
  tbl.glVertexAttrib3hNV = error_glVertexAttrib3hNV;
  tbl.glVertexAttrib3hvNV = error_glVertexAttrib3hvNV;
  tbl.glVertexAttrib4hNV = error_glVertexAttrib4hNV;
  tbl.glVertexAttrib4hvNV = error_glVertexAttrib4hvNV;
  tbl.glVertexAttribs1hvNV = error_glVertexAttribs1hvNV;
  tbl.glVertexAttribs2hvNV = error_glVertexAttribs2hvNV;
  tbl.glVertexAttribs3hvNV = error_glVertexAttribs3hvNV;
  tbl.glVertexAttribs4hvNV = error_glVertexAttribs4hvNV;
  tbl.glVertexWeighthNV = error_glVertexWeighthNV;
  tbl.glVertexWeighthvNV = error_glVertexWeighthvNV;

  // GL_NV_non_square_matrices

  tbl.glUniformMatrix2x3fvNV = error_glUniformMatrix2x3fvNV;
  tbl.glUniformMatrix2x4fvNV = error_glUniformMatrix2x4fvNV;
  tbl.glUniformMatrix3x2fvNV = error_glUniformMatrix3x2fvNV;
  tbl.glUniformMatrix3x4fvNV = error_glUniformMatrix3x4fvNV;
  tbl.glUniformMatrix4x2fvNV = error_glUniformMatrix4x2fvNV;
  tbl.glUniformMatrix4x3fvNV = error_glUniformMatrix4x3fvNV;

  // GL_NV_occlusion_query

  tbl.glBeginOcclusionQueryNV = error_glBeginOcclusionQueryNV;
  tbl.glDeleteOcclusionQueriesNV = error_glDeleteOcclusionQueriesNV;
  tbl.glEndOcclusionQueryNV = error_glEndOcclusionQueryNV;
  tbl.glGenOcclusionQueriesNV = error_glGenOcclusionQueriesNV;
  tbl.glGetOcclusionQueryivNV = error_glGetOcclusionQueryivNV;
  tbl.glGetOcclusionQueryuivNV = error_glGetOcclusionQueryuivNV;
  tbl.glIsOcclusionQueryNV = error_glIsOcclusionQueryNV;

  // GL_NV_parameter_buffer_object

  tbl.glProgramBufferParametersIivNV = error_glProgramBufferParametersIivNV;
  tbl.glProgramBufferParametersIuivNV = error_glProgramBufferParametersIuivNV;
  tbl.glProgramBufferParametersfvNV = error_glProgramBufferParametersfvNV;

  // GL_NV_path_rendering

  tbl.glCopyPathNV = error_glCopyPathNV;
  tbl.glCoverFillPathInstancedNV = error_glCoverFillPathInstancedNV;
  tbl.glCoverFillPathNV = error_glCoverFillPathNV;
  tbl.glCoverStrokePathInstancedNV = error_glCoverStrokePathInstancedNV;
  tbl.glCoverStrokePathNV = error_glCoverStrokePathNV;
  tbl.glDeletePathsNV = error_glDeletePathsNV;
  tbl.glGenPathsNV = error_glGenPathsNV;
  tbl.glGetPathColorGenfvNV = error_glGetPathColorGenfvNV;
  tbl.glGetPathColorGenivNV = error_glGetPathColorGenivNV;
  tbl.glGetPathCommandsNV = error_glGetPathCommandsNV;
  tbl.glGetPathCoordsNV = error_glGetPathCoordsNV;
  tbl.glGetPathDashArrayNV = error_glGetPathDashArrayNV;
  tbl.glGetPathLengthNV = error_glGetPathLengthNV;
  tbl.glGetPathMetricRangeNV = error_glGetPathMetricRangeNV;
  tbl.glGetPathMetricsNV = error_glGetPathMetricsNV;
  tbl.glGetPathParameterfvNV = error_glGetPathParameterfvNV;
  tbl.glGetPathParameterivNV = error_glGetPathParameterivNV;
  tbl.glGetPathSpacingNV = error_glGetPathSpacingNV;
  tbl.glGetPathTexGenfvNV = error_glGetPathTexGenfvNV;
  tbl.glGetPathTexGenivNV = error_glGetPathTexGenivNV;
  tbl.glInterpolatePathsNV = error_glInterpolatePathsNV;
  tbl.glIsPathNV = error_glIsPathNV;
  tbl.glIsPointInFillPathNV = error_glIsPointInFillPathNV;
  tbl.glIsPointInStrokePathNV = error_glIsPointInStrokePathNV;
  tbl.glPathColorGenNV = error_glPathColorGenNV;
  tbl.glPathCommandsNV = error_glPathCommandsNV;
  tbl.glPathCoordsNV = error_glPathCoordsNV;
  tbl.glPathCoverDepthFuncNV = error_glPathCoverDepthFuncNV;
  tbl.glPathDashArrayNV = error_glPathDashArrayNV;
  tbl.glPathFogGenNV = error_glPathFogGenNV;
  tbl.glPathGlyphRangeNV = error_glPathGlyphRangeNV;
  tbl.glPathGlyphsNV = error_glPathGlyphsNV;
  tbl.glPathParameterfNV = error_glPathParameterfNV;
  tbl.glPathParameterfvNV = error_glPathParameterfvNV;
  tbl.glPathParameteriNV = error_glPathParameteriNV;
  tbl.glPathParameterivNV = error_glPathParameterivNV;
  tbl.glPathStencilDepthOffsetNV = error_glPathStencilDepthOffsetNV;
  tbl.glPathStencilFuncNV = error_glPathStencilFuncNV;
  tbl.glPathStringNV = error_glPathStringNV;
  tbl.glPathSubCommandsNV = error_glPathSubCommandsNV;
  tbl.glPathSubCoordsNV = error_glPathSubCoordsNV;
  tbl.glPathTexGenNV = error_glPathTexGenNV;
  tbl.glPointAlongPathNV = error_glPointAlongPathNV;
  tbl.glStencilFillPathInstancedNV = error_glStencilFillPathInstancedNV;
  tbl.glStencilFillPathNV = error_glStencilFillPathNV;
  tbl.glStencilStrokePathInstancedNV = error_glStencilStrokePathInstancedNV;
  tbl.glStencilStrokePathNV = error_glStencilStrokePathNV;
  tbl.glTransformPathNV = error_glTransformPathNV;
  tbl.glWeightPathsNV = error_glWeightPathsNV;

  // GL_NV_pixel_data_range

  tbl.glFlushPixelDataRangeNV = error_glFlushPixelDataRangeNV;
  tbl.glPixelDataRangeNV = error_glPixelDataRangeNV;

  // GL_NV_point_sprite

  tbl.glPointParameteriNV = error_glPointParameteriNV;
  tbl.glPointParameterivNV = error_glPointParameterivNV;

  // GL_NV_present_video

  tbl.glGetVideoi64vNV = error_glGetVideoi64vNV;
  tbl.glGetVideoivNV = error_glGetVideoivNV;
  tbl.glGetVideoui64vNV = error_glGetVideoui64vNV;
  tbl.glGetVideouivNV = error_glGetVideouivNV;
  tbl.glPresentFrameDualFillNV = error_glPresentFrameDualFillNV;
  tbl.glPresentFrameKeyedNV = error_glPresentFrameKeyedNV;

  // GL_NV_primitive_restart

  tbl.glPrimitiveRestartIndexNV = error_glPrimitiveRestartIndexNV;
  tbl.glPrimitiveRestartNV = error_glPrimitiveRestartNV;

  // GL_NV_read_buffer

  tbl.glReadBufferNV = error_glReadBufferNV;

  // GL_NV_register_combiners

  tbl.glCombinerInputNV = error_glCombinerInputNV;
  tbl.glCombinerOutputNV = error_glCombinerOutputNV;
  tbl.glCombinerParameterfNV = error_glCombinerParameterfNV;
  tbl.glCombinerParameterfvNV = error_glCombinerParameterfvNV;
  tbl.glCombinerParameteriNV = error_glCombinerParameteriNV;
  tbl.glCombinerParameterivNV = error_glCombinerParameterivNV;
  tbl.glFinalCombinerInputNV = error_glFinalCombinerInputNV;
  tbl.glGetCombinerInputParameterfvNV = error_glGetCombinerInputParameterfvNV;
  tbl.glGetCombinerInputParameterivNV = error_glGetCombinerInputParameterivNV;
  tbl.glGetCombinerOutputParameterfvNV = error_glGetCombinerOutputParameterfvNV;
  tbl.glGetCombinerOutputParameterivNV = error_glGetCombinerOutputParameterivNV;
  tbl.glGetFinalCombinerInputParameterfvNV = error_glGetFinalCombinerInputParameterfvNV;
  tbl.glGetFinalCombinerInputParameterivNV = error_glGetFinalCombinerInputParameterivNV;

  // GL_NV_register_combiners2

  tbl.glCombinerStageParameterfvNV = error_glCombinerStageParameterfvNV;
  tbl.glGetCombinerStageParameterfvNV = error_glGetCombinerStageParameterfvNV;

  // GL_NV_shader_buffer_load

  tbl.glGetBufferParameterui64vNV = error_glGetBufferParameterui64vNV;
  tbl.glGetIntegerui64vNV = error_glGetIntegerui64vNV;
  tbl.glGetNamedBufferParameterui64vNV = error_glGetNamedBufferParameterui64vNV;
  tbl.glGetUniformui64vNV = error_glGetUniformui64vNV;
  tbl.glIsBufferResidentNV = error_glIsBufferResidentNV;
  tbl.glIsNamedBufferResidentNV = error_glIsNamedBufferResidentNV;
  tbl.glMakeBufferNonResidentNV = error_glMakeBufferNonResidentNV;
  tbl.glMakeBufferResidentNV = error_glMakeBufferResidentNV;
  tbl.glMakeNamedBufferNonResidentNV = error_glMakeNamedBufferNonResidentNV;
  tbl.glMakeNamedBufferResidentNV = error_glMakeNamedBufferResidentNV;
  tbl.glProgramUniformui64NV = error_glProgramUniformui64NV;
  tbl.glProgramUniformui64vNV = error_glProgramUniformui64vNV;
  tbl.glUniformui64NV = error_glUniformui64NV;
  tbl.glUniformui64vNV = error_glUniformui64vNV;

  // GL_NV_texture_barrier

  tbl.glTextureBarrierNV = error_glTextureBarrierNV;

  // GL_NV_texture_multisample

  tbl.glTexImage2DMultisampleCoverageNV = error_glTexImage2DMultisampleCoverageNV;
  tbl.glTexImage3DMultisampleCoverageNV = error_glTexImage3DMultisampleCoverageNV;
  tbl.glTextureImage2DMultisampleCoverageNV = error_glTextureImage2DMultisampleCoverageNV;
  tbl.glTextureImage2DMultisampleNV = error_glTextureImage2DMultisampleNV;
  tbl.glTextureImage3DMultisampleCoverageNV = error_glTextureImage3DMultisampleCoverageNV;
  tbl.glTextureImage3DMultisampleNV = error_glTextureImage3DMultisampleNV;

  // GL_NV_transform_feedback

  tbl.glActiveVaryingNV = error_glActiveVaryingNV;
  tbl.glBeginTransformFeedbackNV = error_glBeginTransformFeedbackNV;
  tbl.glBindBufferBaseNV = error_glBindBufferBaseNV;
  tbl.glBindBufferOffsetNV = error_glBindBufferOffsetNV;
  tbl.glBindBufferRangeNV = error_glBindBufferRangeNV;
  tbl.glEndTransformFeedbackNV = error_glEndTransformFeedbackNV;
  tbl.glGetActiveVaryingNV = error_glGetActiveVaryingNV;
  tbl.glGetTransformFeedbackVaryingNV = error_glGetTransformFeedbackVaryingNV;
  tbl.glGetVaryingLocationNV = error_glGetVaryingLocationNV;
  tbl.glTransformFeedbackAttribsNV = error_glTransformFeedbackAttribsNV;
  tbl.glTransformFeedbackVaryingsNV = error_glTransformFeedbackVaryingsNV;

  // GL_NV_transform_feedback2

  tbl.glBindTransformFeedbackNV = error_glBindTransformFeedbackNV;
  tbl.glDeleteTransformFeedbacksNV = error_glDeleteTransformFeedbacksNV;
  tbl.glDrawTransformFeedbackNV = error_glDrawTransformFeedbackNV;
  tbl.glGenTransformFeedbacksNV = error_glGenTransformFeedbacksNV;
  tbl.glIsTransformFeedbackNV = error_glIsTransformFeedbackNV;
  tbl.glPauseTransformFeedbackNV = error_glPauseTransformFeedbackNV;
  tbl.glResumeTransformFeedbackNV = error_glResumeTransformFeedbackNV;

  // GL_NV_vdpau_interop

  tbl.glVDPAUFiniNV = error_glVDPAUFiniNV;
  tbl.glVDPAUGetSurfaceivNV = error_glVDPAUGetSurfaceivNV;
  tbl.glVDPAUInitNV = error_glVDPAUInitNV;
  tbl.glVDPAUIsSurfaceNV = error_glVDPAUIsSurfaceNV;
  tbl.glVDPAUMapSurfacesNV = error_glVDPAUMapSurfacesNV;
  tbl.glVDPAURegisterOutputSurfaceNV = error_glVDPAURegisterOutputSurfaceNV;
  tbl.glVDPAURegisterVideoSurfaceNV = error_glVDPAURegisterVideoSurfaceNV;
  tbl.glVDPAUSurfaceAccessNV = error_glVDPAUSurfaceAccessNV;
  tbl.glVDPAUUnmapSurfacesNV = error_glVDPAUUnmapSurfacesNV;
  tbl.glVDPAUUnregisterSurfaceNV = error_glVDPAUUnregisterSurfaceNV;

  // GL_NV_vertex_array_range

  tbl.glFlushVertexArrayRangeNV = error_glFlushVertexArrayRangeNV;
  tbl.glVertexArrayRangeNV = error_glVertexArrayRangeNV;

  // GL_NV_vertex_attrib_integer_64bit

  tbl.glGetVertexAttribLi64vNV = error_glGetVertexAttribLi64vNV;
  tbl.glGetVertexAttribLui64vNV = error_glGetVertexAttribLui64vNV;
  tbl.glVertexAttribL1i64NV = error_glVertexAttribL1i64NV;
  tbl.glVertexAttribL1i64vNV = error_glVertexAttribL1i64vNV;
  tbl.glVertexAttribL1ui64NV = error_glVertexAttribL1ui64NV;
  tbl.glVertexAttribL1ui64vNV = error_glVertexAttribL1ui64vNV;
  tbl.glVertexAttribL2i64NV = error_glVertexAttribL2i64NV;
  tbl.glVertexAttribL2i64vNV = error_glVertexAttribL2i64vNV;
  tbl.glVertexAttribL2ui64NV = error_glVertexAttribL2ui64NV;
  tbl.glVertexAttribL2ui64vNV = error_glVertexAttribL2ui64vNV;
  tbl.glVertexAttribL3i64NV = error_glVertexAttribL3i64NV;
  tbl.glVertexAttribL3i64vNV = error_glVertexAttribL3i64vNV;
  tbl.glVertexAttribL3ui64NV = error_glVertexAttribL3ui64NV;
  tbl.glVertexAttribL3ui64vNV = error_glVertexAttribL3ui64vNV;
  tbl.glVertexAttribL4i64NV = error_glVertexAttribL4i64NV;
  tbl.glVertexAttribL4i64vNV = error_glVertexAttribL4i64vNV;
  tbl.glVertexAttribL4ui64NV = error_glVertexAttribL4ui64NV;
  tbl.glVertexAttribL4ui64vNV = error_glVertexAttribL4ui64vNV;
  tbl.glVertexAttribLFormatNV = error_glVertexAttribLFormatNV;

  // GL_NV_vertex_buffer_unified_memory

  tbl.glBufferAddressRangeNV = error_glBufferAddressRangeNV;
  tbl.glColorFormatNV = error_glColorFormatNV;
  tbl.glEdgeFlagFormatNV = error_glEdgeFlagFormatNV;
  tbl.glFogCoordFormatNV = error_glFogCoordFormatNV;
  tbl.glGetIntegerui64i_vNV = error_glGetIntegerui64i_vNV;
  tbl.glIndexFormatNV = error_glIndexFormatNV;
  tbl.glNormalFormatNV = error_glNormalFormatNV;
  tbl.glSecondaryColorFormatNV = error_glSecondaryColorFormatNV;
  tbl.glTexCoordFormatNV = error_glTexCoordFormatNV;
  tbl.glVertexAttribFormatNV = error_glVertexAttribFormatNV;
  tbl.glVertexAttribIFormatNV = error_glVertexAttribIFormatNV;
  tbl.glVertexFormatNV = error_glVertexFormatNV;

  // GL_NV_vertex_program

  tbl.glAreProgramsResidentNV = error_glAreProgramsResidentNV;
  tbl.glBindProgramNV = error_glBindProgramNV;
  tbl.glDeleteProgramsNV = error_glDeleteProgramsNV;
  tbl.glExecuteProgramNV = error_glExecuteProgramNV;
  tbl.glGenProgramsNV = error_glGenProgramsNV;
  tbl.glGetProgramParameterdvNV = error_glGetProgramParameterdvNV;
  tbl.glGetProgramParameterfvNV = error_glGetProgramParameterfvNV;
  tbl.glGetProgramStringNV = error_glGetProgramStringNV;
  tbl.glGetProgramivNV = error_glGetProgramivNV;
  tbl.glGetTrackMatrixivNV = error_glGetTrackMatrixivNV;
  tbl.glGetVertexAttribPointervNV = error_glGetVertexAttribPointervNV;
  tbl.glGetVertexAttribdvNV = error_glGetVertexAttribdvNV;
  tbl.glGetVertexAttribfvNV = error_glGetVertexAttribfvNV;
  tbl.glGetVertexAttribivNV = error_glGetVertexAttribivNV;
  tbl.glIsProgramNV = error_glIsProgramNV;
  tbl.glLoadProgramNV = error_glLoadProgramNV;
  tbl.glProgramParameter4dNV = error_glProgramParameter4dNV;
  tbl.glProgramParameter4dvNV = error_glProgramParameter4dvNV;
  tbl.glProgramParameter4fNV = error_glProgramParameter4fNV;
  tbl.glProgramParameter4fvNV = error_glProgramParameter4fvNV;
  tbl.glProgramParameters4dvNV = error_glProgramParameters4dvNV;
  tbl.glProgramParameters4fvNV = error_glProgramParameters4fvNV;
  tbl.glRequestResidentProgramsNV = error_glRequestResidentProgramsNV;
  tbl.glTrackMatrixNV = error_glTrackMatrixNV;
  tbl.glVertexAttrib1dNV = error_glVertexAttrib1dNV;
  tbl.glVertexAttrib1dvNV = error_glVertexAttrib1dvNV;
  tbl.glVertexAttrib1fNV = error_glVertexAttrib1fNV;
  tbl.glVertexAttrib1fvNV = error_glVertexAttrib1fvNV;
  tbl.glVertexAttrib1sNV = error_glVertexAttrib1sNV;
  tbl.glVertexAttrib1svNV = error_glVertexAttrib1svNV;
  tbl.glVertexAttrib2dNV = error_glVertexAttrib2dNV;
  tbl.glVertexAttrib2dvNV = error_glVertexAttrib2dvNV;
  tbl.glVertexAttrib2fNV = error_glVertexAttrib2fNV;
  tbl.glVertexAttrib2fvNV = error_glVertexAttrib2fvNV;
  tbl.glVertexAttrib2sNV = error_glVertexAttrib2sNV;
  tbl.glVertexAttrib2svNV = error_glVertexAttrib2svNV;
  tbl.glVertexAttrib3dNV = error_glVertexAttrib3dNV;
  tbl.glVertexAttrib3dvNV = error_glVertexAttrib3dvNV;
  tbl.glVertexAttrib3fNV = error_glVertexAttrib3fNV;
  tbl.glVertexAttrib3fvNV = error_glVertexAttrib3fvNV;
  tbl.glVertexAttrib3sNV = error_glVertexAttrib3sNV;
  tbl.glVertexAttrib3svNV = error_glVertexAttrib3svNV;
  tbl.glVertexAttrib4dNV = error_glVertexAttrib4dNV;
  tbl.glVertexAttrib4dvNV = error_glVertexAttrib4dvNV;
  tbl.glVertexAttrib4fNV = error_glVertexAttrib4fNV;
  tbl.glVertexAttrib4fvNV = error_glVertexAttrib4fvNV;
  tbl.glVertexAttrib4sNV = error_glVertexAttrib4sNV;
  tbl.glVertexAttrib4svNV = error_glVertexAttrib4svNV;
  tbl.glVertexAttrib4ubNV = error_glVertexAttrib4ubNV;
  tbl.glVertexAttrib4ubvNV = error_glVertexAttrib4ubvNV;
  tbl.glVertexAttribPointerNV = error_glVertexAttribPointerNV;
  tbl.glVertexAttribs1dvNV = error_glVertexAttribs1dvNV;
  tbl.glVertexAttribs1fvNV = error_glVertexAttribs1fvNV;
  tbl.glVertexAttribs1svNV = error_glVertexAttribs1svNV;
  tbl.glVertexAttribs2dvNV = error_glVertexAttribs2dvNV;
  tbl.glVertexAttribs2fvNV = error_glVertexAttribs2fvNV;
  tbl.glVertexAttribs2svNV = error_glVertexAttribs2svNV;
  tbl.glVertexAttribs3dvNV = error_glVertexAttribs3dvNV;
  tbl.glVertexAttribs3fvNV = error_glVertexAttribs3fvNV;
  tbl.glVertexAttribs3svNV = error_glVertexAttribs3svNV;
  tbl.glVertexAttribs4dvNV = error_glVertexAttribs4dvNV;
  tbl.glVertexAttribs4fvNV = error_glVertexAttribs4fvNV;
  tbl.glVertexAttribs4svNV = error_glVertexAttribs4svNV;
  tbl.glVertexAttribs4ubvNV = error_glVertexAttribs4ubvNV;

  // GL_NV_video_capture

  tbl.glBeginVideoCaptureNV = error_glBeginVideoCaptureNV;
  tbl.glBindVideoCaptureStreamBufferNV = error_glBindVideoCaptureStreamBufferNV;
  tbl.glBindVideoCaptureStreamTextureNV = error_glBindVideoCaptureStreamTextureNV;
  tbl.glEndVideoCaptureNV = error_glEndVideoCaptureNV;
  tbl.glGetVideoCaptureStreamdvNV = error_glGetVideoCaptureStreamdvNV;
  tbl.glGetVideoCaptureStreamfvNV = error_glGetVideoCaptureStreamfvNV;
  tbl.glGetVideoCaptureStreamivNV = error_glGetVideoCaptureStreamivNV;
  tbl.glGetVideoCaptureivNV = error_glGetVideoCaptureivNV;
  tbl.glVideoCaptureNV = error_glVideoCaptureNV;
  tbl.glVideoCaptureStreamParameterdvNV = error_glVideoCaptureStreamParameterdvNV;
  tbl.glVideoCaptureStreamParameterfvNV = error_glVideoCaptureStreamParameterfvNV;
  tbl.glVideoCaptureStreamParameterivNV = error_glVideoCaptureStreamParameterivNV;

  // GL_OES_blend_equation_separate

  tbl.glBlendEquationSeparateOES = error_glBlendEquationSeparateOES;

  // GL_OES_blend_func_separate

  tbl.glBlendFuncSeparateOES = error_glBlendFuncSeparateOES;

  // GL_OES_blend_subtract

  tbl.glBlendEquationOES = error_glBlendEquationOES;

  // GL_OES_framebuffer_object

  tbl.glBindFramebufferOES = error_glBindFramebufferOES;
  tbl.glBindRenderbufferOES = error_glBindRenderbufferOES;
  tbl.glCheckFramebufferStatusOES = error_glCheckFramebufferStatusOES;
  tbl.glDeleteFramebuffersOES = error_glDeleteFramebuffersOES;
  tbl.glDeleteRenderbuffersOES = error_glDeleteRenderbuffersOES;
  tbl.glFramebufferRenderbufferOES = error_glFramebufferRenderbufferOES;
  tbl.glFramebufferTexture2DOES = error_glFramebufferTexture2DOES;
  tbl.glGenFramebuffersOES = error_glGenFramebuffersOES;
  tbl.glGenRenderbuffersOES = error_glGenRenderbuffersOES;
  tbl.glGenerateMipmapOES = error_glGenerateMipmapOES;
  tbl.glGetFramebufferAttachmentParameterivOES = error_glGetFramebufferAttachmentParameterivOES;
  tbl.glGetRenderbufferParameterivOES = error_glGetRenderbufferParameterivOES;
  tbl.glIsFramebufferOES = error_glIsFramebufferOES;
  tbl.glIsRenderbufferOES = error_glIsRenderbufferOES;
  tbl.glRenderbufferStorageOES = error_glRenderbufferStorageOES;

  // GL_OES_get_program_binary

  tbl.glGetProgramBinaryOES = error_glGetProgramBinaryOES;
  tbl.glProgramBinaryOES = error_glProgramBinaryOES;

  // GL_OES_mapbuffer

  tbl.glGetBufferPointervOES = error_glGetBufferPointervOES;
  tbl.glMapBufferOES = error_glMapBufferOES;
  tbl.glUnmapBufferOES = error_glUnmapBufferOES;

  // GL_OES_matrix_palette

  tbl.glCurrentPaletteMatrixOES = error_glCurrentPaletteMatrixOES;
  tbl.glMatrixIndexPointerOES = error_glMatrixIndexPointerOES;
  tbl.glWeightPointerOES = error_glWeightPointerOES;

  // GL_OES_single_precision

  tbl.glClearDepthfOES = error_glClearDepthfOES;
  tbl.glClipPlanefOES = error_glClipPlanefOES;
  tbl.glDepthRangefOES = error_glDepthRangefOES;
  tbl.glFrustumfOES = error_glFrustumfOES;
  tbl.glGetClipPlanefOES = error_glGetClipPlanefOES;
  tbl.glOrthofOES = error_glOrthofOES;

  // GL_OES_texture_3D

  tbl.glCompressedTexImage3DOES = error_glCompressedTexImage3DOES;
  tbl.glCompressedTexSubImage3DOES = error_glCompressedTexSubImage3DOES;
  tbl.glCopyTexSubImage3DOES = error_glCopyTexSubImage3DOES;
  tbl.glFramebufferTexture3DOES = error_glFramebufferTexture3DOES;
  tbl.glTexImage3DOES = error_glTexImage3DOES;
  tbl.glTexSubImage3DOES = error_glTexSubImage3DOES;

  // GL_OES_texture_cube_map

  tbl.glGetTexGenfvOES = error_glGetTexGenfvOES;
  tbl.glGetTexGenivOES = error_glGetTexGenivOES;
  tbl.glGetTexGenxvOES = error_glGetTexGenxvOES;
  tbl.glTexGenfOES = error_glTexGenfOES;
  tbl.glTexGenfvOES = error_glTexGenfvOES;
  tbl.glTexGeniOES = error_glTexGeniOES;
  tbl.glTexGenivOES = error_glTexGenivOES;
  tbl.glTexGenxOES = error_glTexGenxOES;
  tbl.glTexGenxvOES = error_glTexGenxvOES;

  // GL_OES_vertex_array_object

  tbl.glBindVertexArrayOES = error_glBindVertexArrayOES;
  tbl.glDeleteVertexArraysOES = error_glDeleteVertexArraysOES;
  tbl.glGenVertexArraysOES = error_glGenVertexArraysOES;
  tbl.glIsVertexArrayOES = error_glIsVertexArrayOES;

  // GL_PGI_misc_hints

  tbl.glHintPGI = error_glHintPGI;

  // GL_QCOM_alpha_test

  tbl.glAlphaFuncQCOM = error_glAlphaFuncQCOM;

  // GL_QCOM_driver_control

  tbl.glDisableDriverControlQCOM = error_glDisableDriverControlQCOM;
  tbl.glEnableDriverControlQCOM = error_glEnableDriverControlQCOM;
  tbl.glGetDriverControlStringQCOM = error_glGetDriverControlStringQCOM;
  tbl.glGetDriverControlsQCOM = error_glGetDriverControlsQCOM;

  // GL_QCOM_extended_get

  tbl.glExtGetBufferPointervQCOM = error_glExtGetBufferPointervQCOM;
  tbl.glExtGetBuffersQCOM = error_glExtGetBuffersQCOM;
  tbl.glExtGetFramebuffersQCOM = error_glExtGetFramebuffersQCOM;
  tbl.glExtGetRenderbuffersQCOM = error_glExtGetRenderbuffersQCOM;
  tbl.glExtGetTexLevelParameterivQCOM = error_glExtGetTexLevelParameterivQCOM;
  tbl.glExtGetTexSubImageQCOM = error_glExtGetTexSubImageQCOM;
  tbl.glExtGetTexturesQCOM = error_glExtGetTexturesQCOM;
  tbl.glExtTexObjectStateOverrideiQCOM = error_glExtTexObjectStateOverrideiQCOM;

  // GL_QCOM_extended_get2

  tbl.glExtGetProgramBinarySourceQCOM = error_glExtGetProgramBinarySourceQCOM;
  tbl.glExtGetProgramsQCOM = error_glExtGetProgramsQCOM;
  tbl.glExtGetShadersQCOM = error_glExtGetShadersQCOM;
  tbl.glExtIsProgramBinaryQCOM = error_glExtIsProgramBinaryQCOM;

  // GL_QCOM_tiled_rendering

  tbl.glEndTilingQCOM = error_glEndTilingQCOM;
  tbl.glStartTilingQCOM = error_glStartTilingQCOM;

  // GL_REGAL_ES1_0_compatibility

  tbl.glAlphaFuncx = error_glAlphaFuncx;
  tbl.glClearColorx = error_glClearColorx;
  tbl.glClearDepthx = error_glClearDepthx;
  tbl.glColor4x = error_glColor4x;
  tbl.glDepthRangex = error_glDepthRangex;
  tbl.glFogx = error_glFogx;
  tbl.glFogxv = error_glFogxv;
  tbl.glFrustumf = error_glFrustumf;
  tbl.glFrustumx = error_glFrustumx;
  tbl.glLightModelx = error_glLightModelx;
  tbl.glLightModelxv = error_glLightModelxv;
  tbl.glLightx = error_glLightx;
  tbl.glLightxv = error_glLightxv;
  tbl.glLineWidthx = error_glLineWidthx;
  tbl.glLoadMatrixx = error_glLoadMatrixx;
  tbl.glMaterialx = error_glMaterialx;
  tbl.glMaterialxv = error_glMaterialxv;
  tbl.glMultMatrixx = error_glMultMatrixx;
  tbl.glMultiTexCoord4x = error_glMultiTexCoord4x;
  tbl.glNormal3x = error_glNormal3x;
  tbl.glOrthof = error_glOrthof;
  tbl.glOrthox = error_glOrthox;
  tbl.glPointSizex = error_glPointSizex;
  tbl.glPolygonOffsetx = error_glPolygonOffsetx;
  tbl.glRotatex = error_glRotatex;
  tbl.glSampleCoveragex = error_glSampleCoveragex;
  tbl.glScalex = error_glScalex;
  tbl.glTexEnvx = error_glTexEnvx;
  tbl.glTexEnvxv = error_glTexEnvxv;
  tbl.glTexParameterx = error_glTexParameterx;
  tbl.glTranslatex = error_glTranslatex;

  // GL_REGAL_ES1_1_compatibility

  tbl.glClipPlanef = error_glClipPlanef;
  tbl.glClipPlanex = error_glClipPlanex;
  tbl.glGetClipPlanef = error_glGetClipPlanef;
  tbl.glGetClipPlanex = error_glGetClipPlanex;
  tbl.glGetFixedv = error_glGetFixedv;
  tbl.glGetLightxv = error_glGetLightxv;
  tbl.glGetMaterialxv = error_glGetMaterialxv;
  tbl.glGetTexEnvxv = error_glGetTexEnvxv;
  tbl.glGetTexParameterxv = error_glGetTexParameterxv;
  tbl.glPointParameterx = error_glPointParameterx;
  tbl.glPointParameterxv = error_glPointParameterxv;
  tbl.glPointSizePointerOES = error_glPointSizePointerOES;
  tbl.glTexParameterxv = error_glTexParameterxv;

  // GL_REGAL_log

  tbl.glLogMessageCallbackREGAL = error_glLogMessageCallbackREGAL;

  // GL_SGIS_detail_texture

  tbl.glDetailTexFuncSGIS = error_glDetailTexFuncSGIS;
  tbl.glGetDetailTexFuncSGIS = error_glGetDetailTexFuncSGIS;

  // GL_SGIS_fog_function

  tbl.glFogFuncSGIS = error_glFogFuncSGIS;
  tbl.glGetFogFuncSGIS = error_glGetFogFuncSGIS;

  // GL_SGIS_multisample

  tbl.glSampleMaskSGIS = error_glSampleMaskSGIS;
  tbl.glSamplePatternSGIS = error_glSamplePatternSGIS;

  // GL_SGIS_pixel_texture

  tbl.glGetPixelTexGenParameterfvSGIS = error_glGetPixelTexGenParameterfvSGIS;
  tbl.glGetPixelTexGenParameterivSGIS = error_glGetPixelTexGenParameterivSGIS;
  tbl.glPixelTexGenParameterfSGIS = error_glPixelTexGenParameterfSGIS;
  tbl.glPixelTexGenParameterfvSGIS = error_glPixelTexGenParameterfvSGIS;
  tbl.glPixelTexGenParameteriSGIS = error_glPixelTexGenParameteriSGIS;
  tbl.glPixelTexGenParameterivSGIS = error_glPixelTexGenParameterivSGIS;

  // GL_SGIS_point_parameters

  tbl.glPointParameterfSGIS = error_glPointParameterfSGIS;
  tbl.glPointParameterfvSGIS = error_glPointParameterfvSGIS;

  // GL_SGIS_sharpen_texture

  tbl.glGetSharpenTexFuncSGIS = error_glGetSharpenTexFuncSGIS;
  tbl.glSharpenTexFuncSGIS = error_glSharpenTexFuncSGIS;

  // GL_SGIS_texture4D

  tbl.glTexImage4DSGIS = error_glTexImage4DSGIS;
  tbl.glTexSubImage4DSGIS = error_glTexSubImage4DSGIS;

  // GL_SGIS_texture_color_mask

  tbl.glTextureColorMaskSGIS = error_glTextureColorMaskSGIS;

  // GL_SGIS_texture_filter4

  tbl.glGetTexFilterFuncSGIS = error_glGetTexFilterFuncSGIS;
  tbl.glTexFilterFuncSGIS = error_glTexFilterFuncSGIS;

  // GL_SGIX_async

  tbl.glAsyncMarkerSGIX = error_glAsyncMarkerSGIX;
  tbl.glDeleteAsyncMarkersSGIX = error_glDeleteAsyncMarkersSGIX;
  tbl.glFinishAsyncSGIX = error_glFinishAsyncSGIX;
  tbl.glGenAsyncMarkersSGIX = error_glGenAsyncMarkersSGIX;
  tbl.glIsAsyncMarkerSGIX = error_glIsAsyncMarkerSGIX;
  tbl.glPollAsyncSGIX = error_glPollAsyncSGIX;

  // GL_SGIX_flush_raster

  tbl.glFlushRasterSGIX = error_glFlushRasterSGIX;

  // GL_SGIX_fog_texture

  tbl.glTextureFogSGIX = error_glTextureFogSGIX;

  // GL_SGIX_fragment_lighting

  tbl.glFragmentColorMaterialSGIX = error_glFragmentColorMaterialSGIX;
  tbl.glFragmentLightModelfSGIX = error_glFragmentLightModelfSGIX;
  tbl.glFragmentLightModelfvSGIX = error_glFragmentLightModelfvSGIX;
  tbl.glFragmentLightModeliSGIX = error_glFragmentLightModeliSGIX;
  tbl.glFragmentLightModelivSGIX = error_glFragmentLightModelivSGIX;
  tbl.glFragmentLightfSGIX = error_glFragmentLightfSGIX;
  tbl.glFragmentLightfvSGIX = error_glFragmentLightfvSGIX;
  tbl.glFragmentLightiSGIX = error_glFragmentLightiSGIX;
  tbl.glFragmentLightivSGIX = error_glFragmentLightivSGIX;
  tbl.glFragmentMaterialfSGIX = error_glFragmentMaterialfSGIX;
  tbl.glFragmentMaterialfvSGIX = error_glFragmentMaterialfvSGIX;
  tbl.glFragmentMaterialiSGIX = error_glFragmentMaterialiSGIX;
  tbl.glFragmentMaterialivSGIX = error_glFragmentMaterialivSGIX;
  tbl.glGetFragmentLightfvSGIX = error_glGetFragmentLightfvSGIX;
  tbl.glGetFragmentLightivSGIX = error_glGetFragmentLightivSGIX;
  tbl.glGetFragmentMaterialfvSGIX = error_glGetFragmentMaterialfvSGIX;
  tbl.glGetFragmentMaterialivSGIX = error_glGetFragmentMaterialivSGIX;
  tbl.glLightEnviSGIX = error_glLightEnviSGIX;

  // GL_SGIX_framezoom

  tbl.glFrameZoomSGIX = error_glFrameZoomSGIX;

  // GL_SGIX_igloo_interface

  tbl.glIglooInterfaceSGIX = error_glIglooInterfaceSGIX;

  // GL_SGIX_instruments

  tbl.glGetInstrumentsSGIX = error_glGetInstrumentsSGIX;
  tbl.glInstrumentsBufferSGIX = error_glInstrumentsBufferSGIX;
  tbl.glPollInstrumentsSGIX = error_glPollInstrumentsSGIX;
  tbl.glReadInstrumentsSGIX = error_glReadInstrumentsSGIX;
  tbl.glStartInstrumentsSGIX = error_glStartInstrumentsSGIX;
  tbl.glStopInstrumentsSGIX = error_glStopInstrumentsSGIX;

  // GL_SGIX_list_priority

  tbl.glGetListParameterfvSGIX = error_glGetListParameterfvSGIX;
  tbl.glGetListParameterivSGIX = error_glGetListParameterivSGIX;
  tbl.glListParameterfSGIX = error_glListParameterfSGIX;
  tbl.glListParameterfvSGIX = error_glListParameterfvSGIX;
  tbl.glListParameteriSGIX = error_glListParameteriSGIX;
  tbl.glListParameterivSGIX = error_glListParameterivSGIX;

  // GL_SGIX_pixel_texture

  tbl.glPixelTexGenSGIX = error_glPixelTexGenSGIX;

  // GL_SGIX_polynomial_ffd

  tbl.glDeformSGIX = error_glDeformSGIX;
  tbl.glDeformationMap3dSGIX = error_glDeformationMap3dSGIX;
  tbl.glDeformationMap3fSGIX = error_glDeformationMap3fSGIX;
  tbl.glLoadIdentityDeformationMapSGIX = error_glLoadIdentityDeformationMapSGIX;

  // GL_SGIX_reference_plane

  tbl.glReferencePlaneSGIX = error_glReferencePlaneSGIX;

  // GL_SGIX_sprite

  tbl.glSpriteParameterfSGIX = error_glSpriteParameterfSGIX;
  tbl.glSpriteParameterfvSGIX = error_glSpriteParameterfvSGIX;
  tbl.glSpriteParameteriSGIX = error_glSpriteParameteriSGIX;
  tbl.glSpriteParameterivSGIX = error_glSpriteParameterivSGIX;

  // GL_SGIX_tag_sample_buffer

  tbl.glTagSampleBufferSGIX = error_glTagSampleBufferSGIX;

  // GL_SGI_color_table

  tbl.glColorTableParameterfvSGI = error_glColorTableParameterfvSGI;
  tbl.glColorTableParameterivSGI = error_glColorTableParameterivSGI;
  tbl.glColorTableSGI = error_glColorTableSGI;
  tbl.glCopyColorTableSGI = error_glCopyColorTableSGI;
  tbl.glGetColorTableParameterfvSGI = error_glGetColorTableParameterfvSGI;
  tbl.glGetColorTableParameterivSGI = error_glGetColorTableParameterivSGI;
  tbl.glGetColorTableSGI = error_glGetColorTableSGI;

  // GL_SUNX_constant_data

  tbl.glFinishTextureSUNX = error_glFinishTextureSUNX;

  // GL_SUN_global_alpha

  tbl.glGlobalAlphaFactorbSUN = error_glGlobalAlphaFactorbSUN;
  tbl.glGlobalAlphaFactordSUN = error_glGlobalAlphaFactordSUN;
  tbl.glGlobalAlphaFactorfSUN = error_glGlobalAlphaFactorfSUN;
  tbl.glGlobalAlphaFactoriSUN = error_glGlobalAlphaFactoriSUN;
  tbl.glGlobalAlphaFactorsSUN = error_glGlobalAlphaFactorsSUN;
  tbl.glGlobalAlphaFactorubSUN = error_glGlobalAlphaFactorubSUN;
  tbl.glGlobalAlphaFactoruiSUN = error_glGlobalAlphaFactoruiSUN;
  tbl.glGlobalAlphaFactorusSUN = error_glGlobalAlphaFactorusSUN;

  // GL_SUN_mesh_array

  tbl.glDrawMeshArraysSUN = error_glDrawMeshArraysSUN;

  // GL_SUN_read_video_pixels

  tbl.glReadVideoPixelsSUN = error_glReadVideoPixelsSUN;

  // GL_SUN_triangle_list

  tbl.glReplacementCodePointerSUN = error_glReplacementCodePointerSUN;
  tbl.glReplacementCodeubSUN = error_glReplacementCodeubSUN;
  tbl.glReplacementCodeubvSUN = error_glReplacementCodeubvSUN;
  tbl.glReplacementCodeuiSUN = error_glReplacementCodeuiSUN;
  tbl.glReplacementCodeuivSUN = error_glReplacementCodeuivSUN;
  tbl.glReplacementCodeusSUN = error_glReplacementCodeusSUN;
  tbl.glReplacementCodeusvSUN = error_glReplacementCodeusvSUN;

  // GL_SUN_vertex

  tbl.glColor3fVertex3fSUN = error_glColor3fVertex3fSUN;
  tbl.glColor3fVertex3fvSUN = error_glColor3fVertex3fvSUN;
  tbl.glColor4fNormal3fVertex3fSUN = error_glColor4fNormal3fVertex3fSUN;
  tbl.glColor4fNormal3fVertex3fvSUN = error_glColor4fNormal3fVertex3fvSUN;
  tbl.glColor4ubVertex2fSUN = error_glColor4ubVertex2fSUN;
  tbl.glColor4ubVertex2fvSUN = error_glColor4ubVertex2fvSUN;
  tbl.glColor4ubVertex3fSUN = error_glColor4ubVertex3fSUN;
  tbl.glColor4ubVertex3fvSUN = error_glColor4ubVertex3fvSUN;
  tbl.glNormal3fVertex3fSUN = error_glNormal3fVertex3fSUN;
  tbl.glNormal3fVertex3fvSUN = error_glNormal3fVertex3fvSUN;
  tbl.glReplacementCodeuiColor3fVertex3fSUN = error_glReplacementCodeuiColor3fVertex3fSUN;
  tbl.glReplacementCodeuiColor3fVertex3fvSUN = error_glReplacementCodeuiColor3fVertex3fvSUN;
  tbl.glReplacementCodeuiColor4fNormal3fVertex3fSUN = error_glReplacementCodeuiColor4fNormal3fVertex3fSUN;
  tbl.glReplacementCodeuiColor4fNormal3fVertex3fvSUN = error_glReplacementCodeuiColor4fNormal3fVertex3fvSUN;
  tbl.glReplacementCodeuiColor4ubVertex3fSUN = error_glReplacementCodeuiColor4ubVertex3fSUN;
  tbl.glReplacementCodeuiColor4ubVertex3fvSUN = error_glReplacementCodeuiColor4ubVertex3fvSUN;
  tbl.glReplacementCodeuiNormal3fVertex3fSUN = error_glReplacementCodeuiNormal3fVertex3fSUN;
  tbl.glReplacementCodeuiNormal3fVertex3fvSUN = error_glReplacementCodeuiNormal3fVertex3fvSUN;
  tbl.glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN = error_glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN;
  tbl.glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN = error_glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN;
  tbl.glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN = error_glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN;
  tbl.glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN = error_glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN;
  tbl.glReplacementCodeuiTexCoord2fVertex3fSUN = error_glReplacementCodeuiTexCoord2fVertex3fSUN;
  tbl.glReplacementCodeuiTexCoord2fVertex3fvSUN = error_glReplacementCodeuiTexCoord2fVertex3fvSUN;
  tbl.glReplacementCodeuiVertex3fSUN = error_glReplacementCodeuiVertex3fSUN;
  tbl.glReplacementCodeuiVertex3fvSUN = error_glReplacementCodeuiVertex3fvSUN;
  tbl.glTexCoord2fColor3fVertex3fSUN = error_glTexCoord2fColor3fVertex3fSUN;
  tbl.glTexCoord2fColor3fVertex3fvSUN = error_glTexCoord2fColor3fVertex3fvSUN;
  tbl.glTexCoord2fColor4fNormal3fVertex3fSUN = error_glTexCoord2fColor4fNormal3fVertex3fSUN;
  tbl.glTexCoord2fColor4fNormal3fVertex3fvSUN = error_glTexCoord2fColor4fNormal3fVertex3fvSUN;
  tbl.glTexCoord2fColor4ubVertex3fSUN = error_glTexCoord2fColor4ubVertex3fSUN;
  tbl.glTexCoord2fColor4ubVertex3fvSUN = error_glTexCoord2fColor4ubVertex3fvSUN;
  tbl.glTexCoord2fNormal3fVertex3fSUN = error_glTexCoord2fNormal3fVertex3fSUN;
  tbl.glTexCoord2fNormal3fVertex3fvSUN = error_glTexCoord2fNormal3fVertex3fvSUN;
  tbl.glTexCoord2fVertex3fSUN = error_glTexCoord2fVertex3fSUN;
  tbl.glTexCoord2fVertex3fvSUN = error_glTexCoord2fVertex3fvSUN;
  tbl.glTexCoord4fColor4fNormal3fVertex4fSUN = error_glTexCoord4fColor4fNormal3fVertex4fSUN;
  tbl.glTexCoord4fColor4fNormal3fVertex4fvSUN = error_glTexCoord4fColor4fNormal3fVertex4fvSUN;
  tbl.glTexCoord4fVertex4fSUN = error_glTexCoord4fVertex4fSUN;
  tbl.glTexCoord4fVertex4fvSUN = error_glTexCoord4fVertex4fvSUN;

  // GL_WIN_swap_hint

  tbl.glAddSwapHintRectWIN = error_glAddSwapHintRectWIN;

}

REGAL_NAMESPACE_END

#endif
